function ddlm_dic() { this._dict =
[ [ '@comment',
    '#############################################################################' ],
  [ '@comment',
    '                                                                            #' ],
  [ '@comment',
    '                      DDLm REFERENCE DICTIONARY                             #' ],
  [ '@comment',
    '                                                                            #' ],
  [ '@comment',
    '#############################################################################' ],
  [ 'data_',
    'DDL_DIC',
    [ [ 'item_', '_dictionary.title', 'DDL_DIC' ],
      [ 'item_', '_dictionary.class', 'Reference' ],
      [ 'item_', '_dictionary.version', '3.11.03' ],
      [ 'item_', '_dictionary.date', '2013-04-24' ],
      [ 'item_', '_dictionary.uri', 'www.iucr.org/cif/dic/ddl.dic' ],
      [ 'item_', '_dictionary.ddl_conformance', '3.11.03' ],
      [ 'item_', '_dictionary.namespace', 'DdlDic' ],
      [ 'item_',
        '_description.text',
        '\n     This dictionary contains the definitions of attributes that\n     make up the DDLm dictionary definition language.  It provides\n     the meta meta data for all CIF dictionaries.' ],
      [ 'save_',
        'ATTRIBUTES',
        [ [ 'item_', '_definition.id', 'ATTRIBUTES' ],
          [ 'item_', '_definition.scope', 'Category' ],
          [ 'item_', '_definition.class', 'Head' ],
          [ 'item_', '_definition.update', '2011-07-27' ],
          [ 'item_',
            '_description.text',
            '\n     This category is parent of all other categories in the DDLm\n     dictionary.' ],
          [ 'item_', '_name.object_id', 'ATTRIBUTES' ],
          [ '@comment',
            '============================================================================' ],
          [ 'save_',
            'ALIAS',
            [ [ 'item_', '_definition.id', 'ALIAS' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Loop' ],
              [ 'item_', '_definition.update', '2011-06-07' ],
              [ 'item_',
                '_description.text',
                '\n     The attributes used to specify the aliased names of definitions.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'ALIAS' ],
              [ 'item_', '_category.key_id', '_alias.definition_id' ],
              [ 'save_',
                'alias.definition_id',
                [ [ 'item_', '_definition.id', '_alias.definition_id' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Identifier tag of an aliased definition.' ],
                  [ 'item_', '_name.category_id', 'alias' ],
                  [ 'item_', '_name.object_id', 'definition_id' ],
                  [ 'item_', '_type.purpose', 'Key' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Tag' ] ] ],
              [ 'save_',
                'alias.dictionary_uri',
                [ [ 'item_', '_definition.id', '_alias.dictionary_uri' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Dictionary URI in which the aliased definition belongs.' ],
                  [ 'item_', '_name.category_id', 'alias' ],
                  [ 'item_', '_name.object_id', 'dictionary_uri' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Uri' ] ] ] ] ],
          [ '@comment', '------ close of ALIAS category' ],
          [ '@comment',
            '============================================================================' ],
          [ 'save_',
            'CATEGORY',
            [ [ 'item_', '_definition.id', 'CATEGORY' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2006-11-16' ],
              [ 'item_',
                '_description.text',
                '\n     The attributes used to specify the properties of a\n     "category" of data items.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'CATEGORY' ],
              [ 'save_',
                'category.key_id',
                [ [ 'item_', '_definition.id', '_category.key_id' ],
                  [ 'item_', '_definition.update', '2011-07-27' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Tag of a data item in a Loop category which is the generic key\n     to access other items in the category. The value of this\n     item must be unique in order to provide unambiguous access to\n     a packet (row) in the table of values.' ],
                  [ 'item_', '_name.category_id', 'category' ],
                  [ 'item_', '_name.object_id', 'key_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Tag' ] ] ] ] ],
          [ '@comment', '------ close of CATEGORY category' ],
          [ '@comment',
            '============================================================================' ],
          [ 'save_',
            'DEFINITION',
            [ [ 'item_', '_definition.id', 'DEFINITION' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     The attributes for classifying dictionary definitions.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'DEFINITION' ],
              [ 'save_',
                'definition.class',
                [ [ 'item_', '_definition.id', '_definition.class' ],
                  [ 'item_', '_definition.update', '2013-03-08' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The nature and the function of a definition or definitions.' ],
                  [ 'item_', '_name.category_id', 'definition' ],
                  [ 'item_', '_name.object_id', 'class' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Attribute',
                      '                 Item used as an attribute in the definition\n                  of other data items in DDLm dictionaries.\n                  These items never appear in data instance files.',
                      'Functions',
                      '                 Category of items that are transient function\n                  definitions used only in dREL methods scripts.\n                  These items never appear in data instance files.',
                      'Datum',
                      '                 Item defined in a domain-specific dictionary.\n                  These items appear only in data instance files.',
                      'Head',
                      '                 Category of items that is the parent of\n                  all other categories in the dictionary.',
                      'Loop',
                      '                 Category of items that in a data file must\n                  reside in a loop-list with a key item defined.',
                      'Set',
                      '                 Category of items that form a set (but not a\n                  loopable list). These items may be referenced\n                  as a class of items in a dREL methods expression.',
                      'Ref-loop',
                      '                 A category containing one item that identifies the\n                  a category of items that is repeated in a sequence\n                  of save frames. The item, which is specifies as a\n                  as a Ref-table value (see type.container), is looped.\n                  This construction is for loop categories that contain\n                  child categories.\n                  If in the instance file, the child items have only\n                  one set of values, the Ref-loop item need not be used\n                  and child items need not be placed in a save frame.' ] ],
                  [ 'item_', '_enumeration.default', 'Datum' ] ] ],
              [ 'save_',
                'definition.id',
                [ [ 'item_', '_definition.id', '_definition.id' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Identifier name of the Item or Category definition contained\n     within a save frame.' ],
                  [ 'item_', '_name.category_id', 'definition' ],
                  [ 'item_', '_name.object_id', 'id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Tag' ] ] ],
              [ 'save_',
                'definition.scope',
                [ [ 'item_', '_definition.id', '_definition.scope' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The extent to which a definition affects other definitions.' ],
                  [ 'item_', '_name.category_id', 'definition' ],
                  [ 'item_', '_name.object_id', 'scope' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Dictionary',
                      'applies to all defined items in the dictionary',
                      'Category',
                      'applies to all defined items in the category',
                      'Item',
                      'applies to a single item definition' ] ],
                  [ 'item_', '_enumeration.default', 'Item' ] ] ],
              [ 'save_',
                'definition.update',
                [ [ 'item_', '_definition.id', '_definition.update' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The date that a definition was last changed.' ],
                  [ 'item_', '_name.category_id', 'definition' ],
                  [ 'item_', '_name.object_id', 'update' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Date' ] ] ],
              [ 'save_',
                'definition.xref_code',
                [ [ 'item_', '_definition.id', '_definition.xref_code' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Code identifying the equivalent definition in the dictionary\n     referenced by the DICTIONARY_XREF attributes.' ],
                  [ 'item_', '_name.category_id', 'definition' ],
                  [ 'item_', '_name.object_id', 'xref_code' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
          [ '@comment', '------ close the DEFINITION category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'DESCRIPTION',
            [ [ 'item_', '_definition.id', 'DESCRIPTION' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     The attributes of descriptive (non-machine parseable) parts of\n     definitions.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'DESCRIPTION' ],
              [ 'save_',
                'description.key_words',
                [ [ 'item_', '_definition.id', '_description.key_words' ],
                  [ 'item_', '_definition.update', '2013-03-06' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     List of key-words categorising the item.' ],
                  [ 'item_', '_description.common', 'key words' ],
                  [ 'item_', '_name.category_id', 'description' ],
                  [ 'item_', '_name.object_id', 'key_words' ],
                  [ 'item_', '_type.purpose', 'Encode' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Text' ] ] ],
              [ 'save_',
                'description.common',
                [ [ 'item_', '_definition.id', '_description.common' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Commonly-used identifying name for the item.' ],
                  [ 'item_', '_description.common', 'common name' ],
                  [ 'item_', '_name.category_id', 'description' ],
                  [ 'item_', '_name.object_id', 'common' ],
                  [ 'item_', '_type.purpose', 'Describe' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Text' ] ] ],
              [ 'save_',
                'description.text',
                [ [ 'item_', '_definition.id', '_description.text' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The text description of the defined item.' ],
                  [ 'item_', '_description.common', 'description' ],
                  [ 'item_', '_name.category_id', 'description' ],
                  [ 'item_', '_name.object_id', 'text' ],
                  [ 'item_', '_type.purpose', 'Describe' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Text' ] ] ],
              [ '@comment',
                '----------------------------------------------------------------------------' ],
              [ 'save_',
                'DESCRIPTION_EXAMPLE',
                [ [ 'item_', '_definition.id', 'DESCRIPTION_EXAMPLE' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Loop' ],
                  [ 'item_', '_definition.update', '2011-06-20' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The attributes of descriptive (non-machine parseable) examples of\n     values of the defined items.' ],
                  [ 'item_', '_name.category_id', 'DESCRIPTION' ],
                  [ 'item_', '_name.object_id', 'EXAMPLE' ],
                  [ 'item_', '_category.key_id', '_description_example.case' ],
                  [ 'save_',
                    'description_example.case',
                    [ [ 'item_', '_definition.id', '_description_example.case' ],
                      [ 'item_', '_definition.update', '2013-03-08' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     An example case of the defined item.' ],
                      [ 'item_', '_name.category_id', 'example' ],
                      [ 'item_', '_name.object_id', 'case' ],
                      [ 'item_', '_type.purpose', 'Key' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Implied' ] ] ],
                  [ 'save_',
                    'description_example.detail',
                    [ [ 'item_', '_definition.id', '_description_example.detail' ],
                      [ 'item_', '_definition.update', '2006-11-16' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     A description of an example case for the defined item.' ],
                      [ 'item_', '_name.category_id', 'example' ],
                      [ 'item_', '_name.object_id', 'detail' ],
                      [ 'item_', '_type.purpose', 'Describe' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
              [ '@comment', '----- close the DESCRIPTION_EXAMPLE category' ] ] ],
          [ '@comment', '----- close the DESCRIPTION category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'DICTIONARY',
            [ [ 'item_', '_definition.id', 'DICTIONARY' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     Attributes for identifying and registering the dictionary. The items\n     in this category are NOT used as attributes of INDIVIDUAL data items.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'DICTIONARY' ],
              [ 'save_',
                'dictionary.class',
                [ [ 'item_', '_definition.id', '_dictionary.class' ],
                  [ 'item_', '_definition.update', '2012-05-07' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The nature, or field of interest, of data items defined in the dictionary.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'class' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Reference',
                      'DDLm reference attribute definitions',
                      'Instance',
                      'domain-specific data instance definitions',
                      'Template',
                      'domain-specific attribute/enumeration templates',
                      'Function',
                      'domain-specific method function scripts' ] ],
                  [ 'item_', '_enumeration.default', 'Instance' ] ] ],
              [ 'save_',
                'dictionary.date',
                [ [ 'item_', '_definition.id', '_dictionary.date' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The date that the last dictionary revision took place.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'date' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Date' ] ] ],
              [ 'save_',
                'dictionary.ddl_conformance',
                [ [ 'item_', '_definition.id', '_dictionary.ddl_conformance' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The version number of the DDL dictionary that this dictionary\n     conforms to.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'ddl_conformance' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Version' ] ] ],
              [ 'save_',
                'dictionary.namespace',
                [ [ 'item_', '_definition.id', '_dictionary.namespace' ],
                  [ 'item_', '_definition.update', '2006-12-05' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The namespace code that may be prefixed (with a trailing colon\n     ":") to an item tag defined in the defining dictionary when used\n     in particular applications. Because tags must be unique, namespace\n     codes are unlikely to be used in data files.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'namespace' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ] ] ],
              [ 'save_',
                'dictionary.title',
                [ [ 'item_', '_definition.id', '_dictionary.title' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The common title of the dictionary. Will usually match the name\n     attached to the data_ statement of the dictionary file.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'title' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ] ] ],
              [ 'save_',
                'dictionary.uri',
                [ [ 'item_', '_definition.id', '_dictionary.uri' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The universal resource indicator of this dictionary.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'uri' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Uri' ] ] ],
              [ 'save_',
                'dictionary.version',
                [ [ 'item_', '_definition.id', '_dictionary.version' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     A unique version identifier for the dictionary.' ],
                  [ 'item_', '_name.category_id', 'dictionary' ],
                  [ 'item_', '_name.object_id', 'version' ],
                  [ 'item_', '_type.purpose', 'Audit' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Version' ] ] ],
              [ '@comment',
                '----------------------------------------------------------------------------' ],
              [ 'save_',
                'DICTIONARY_AUDIT',
                [ [ 'item_', '_definition.id', 'DICTIONARY_AUDIT' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Loop' ],
                  [ 'item_', '_definition.update', '2011-06-20' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Attributes for identifying and registering the dictionary. The items\n     in this category are NOT used as attributes of individual data items.' ],
                  [ 'item_', '_name.category_id', 'DICTIONARY' ],
                  [ 'item_', '_name.object_id', 'AUDIT' ],
                  [ 'item_', '_category.key_id', '_dictionary_audit.version' ],
                  [ 'save_',
                    'dictionary_audit.date',
                    [ [ 'item_', '_definition.id', '_dictionary_audit.date' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The date of each dictionary revision.' ],
                      [ 'item_', '_name.category_id', 'audit' ],
                      [ 'item_', '_name.object_id', 'date' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Date' ] ] ],
                  [ 'save_',
                    'dictionary_audit.revision',
                    [ [ 'item_', '_definition.id', '_dictionary_audit.revision' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     A description of the revision applied for the _dictionary_audit.version.' ],
                      [ 'item_', '_name.category_id', 'audit' ],
                      [ 'item_', '_name.object_id', 'revision' ],
                      [ 'item_', '_type.purpose', 'Describe' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Text' ] ] ],
                  [ 'save_',
                    'dictionary_audit.version',
                    [ [ 'item_', '_definition.id', '_dictionary_audit.version' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     A unique version identifier for each revision of the dictionary.' ],
                      [ 'item_', '_name.category_id', 'audit' ],
                      [ 'item_', '_name.object_id', 'version' ],
                      [ 'item_', '_type.purpose', 'Key' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Version' ] ] ] ] ],
              [ '@comment', '------- close the DICTIONARY_AUDIT category' ],
              [ '@comment',
                '-----------------------------------------------------------------------------' ],
              [ 'save_',
                'DICTIONARY_VALID',
                [ [ 'item_', '_definition.id', 'DICTIONARY_VALID' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Loop' ],
                  [ 'item_', '_definition.update', '2011-06-21' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Data items which are used to specify the contents of definitions in\n     the dictionary in terms of the _definition.scope     and the required\n     and prohibited attributes.' ],
                  [ 'item_', '_name.category_id', 'DICTIONARY' ],
                  [ 'item_', '_name.object_id', 'VALID' ],
                  [ 'item_', '_category.key_id', '_dictionary_valid.application' ],
                  [ 'save_',
                    'dictionary_valid.attributes',
                    [ [ 'item_', '_definition.id', '_dictionary_valid.attributes' ],
                      [ 'item_', '_definition.update', '2013-03-06' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     A list of the attribute names and categories that are assessed\n     for application in the item, category and dictionary definitions.' ],
                      [ 'item_', '_name.category_id', 'valid' ],
                      [ 'item_', '_name.object_id', 'attributes' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'List' ],
                      [ 'item_', '_type.contents', 'Name' ],
                      [ 'item_', '_type.dimension', [] ] ] ],
                  [ 'save_',
                    'dictionary_valid.option',
                    [ [ 'item_', '_definition.id', '_dictionary_valid.option' ],
                      [ 'item_', '_definition.update', '2013-03-06' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Option codes for applicability of attributes in definitions.' ],
                      [ 'item_', '_name.category_id', 'valid' ],
                      [ 'item_', '_name.object_id', 'option' ],
                      [ 'item_', '_type.purpose', 'State' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ],
                      [ 'loop_',
                        [ '_enumeration_set.state', '_enumeration_set.detail' ],
                        [ 'Mandatory',
                          'attribute must be present in definition frame',
                          'Recommended',
                          'attribute is usually in definition frame',
                          'Prohibited',
                          'attribute must not be used in definition frame' ] ],
                      [ 'item_', '_enumeration.default', 'Recommended' ] ] ],
                  [ 'save_',
                    'dictionary_valid.application',
                    [ [ 'item_', '_definition.id', '_dictionary_valid.application' ],
                      [ 'item_', '_definition.update', '2013-02-12' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Provides the information identifying the definition scope (\n     from the _definition.scope enumeration list) and the validity\n     options (from the _dictionary_valid.option enumeration list),\n     as a two element list. This list signals the validity of applying\n     the attributes given in _dictionary_valid.attributes.' ],
                      [ 'item_', '_name.category_id', 'valid' ],
                      [ 'item_', '_name.object_id', 'application' ],
                      [ 'item_', '_type.purpose', 'Key' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'List' ],
                      [ 'item_', '_type.contents', 'Code' ],
                      [ 'item_', '_type.dimension', [ '2' ] ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Definition',
                          '\n     _dictionary_valid.application\n                      = [_definition.scope,_dictionary_valid.option]' ] ] ] ] ] ],
              [ '@comment', '------- close the DICTIONARY_VALID category' ],
              [ '@comment',
                '-----------------------------------------------------------------------------' ],
              [ 'save_',
                'DICTIONARY_XREF',
                [ [ 'item_', '_definition.id', 'DICTIONARY_XREF' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Loop' ],
                  [ 'item_', '_definition.update', '2011-06-20' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Data items which are used to cross reference other dictionaries that\n     have defined the same data items. Data items in this category are NOT\n    o used as attributes of individual data items.' ],
                  [ 'item_', '_name.category_id', 'DICTIONARY' ],
                  [ 'item_', '_name.object_id', 'XREF' ],
                  [ 'item_', '_category.key_id', '_dictionary_xref.code' ],
                  [ 'save_',
                    'dictionary_xref.code',
                    [ [ 'item_', '_definition.id', '_dictionary_xref.code' ],
                      [ 'item_', '_definition.update', '2006-11-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     A code identifying the cross-referenced dictionary.' ],
                      [ 'item_', '_name.category_id', 'xref' ],
                      [ 'item_', '_name.object_id', 'code' ],
                      [ 'item_', '_type.purpose', 'Key' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ] ] ],
                  [ 'save_',
                    'dictionary_xref.date',
                    [ [ 'item_', '_definition.id', '_dictionary_xref.date' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Date of the cross-referenced dictionary.' ],
                      [ 'item_', '_name.category_id', 'xref' ],
                      [ 'item_', '_name.object_id', 'date' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Date' ] ] ],
                  [ 'save_',
                    'dictionary_xref.format',
                    [ [ 'item_', '_definition.id', '_dictionary_xref.format' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Format of the cross referenced dictionary.' ],
                      [ 'item_', '_name.category_id', 'xref' ],
                      [ 'item_', '_name.object_id', 'format' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Text' ] ] ],
                  [ 'save_',
                    'dictionary_xref.name',
                    [ [ 'item_', '_definition.id', '_dictionary_xref.name' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The name and description of the cross-referenced dictionary.' ],
                      [ 'item_', '_name.category_id', 'xref' ],
                      [ 'item_', '_name.object_id', 'name' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Text' ] ] ],
                  [ 'save_',
                    'dictionary_xref.uri',
                    [ [ 'item_', '_definition.id', '_dictionary_xref.uri' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The source URI of the cross referenced dictionary data.' ],
                      [ 'item_', '_name.category_id', 'xref' ],
                      [ 'item_', '_name.object_id', 'uri' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Uri' ] ] ] ] ],
              [ '@comment', '------- close the DICTIONARY_XREF category' ] ] ],
          [ '@comment', '------- close the DICTIONARY category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'ENUMERATION',
            [ [ 'item_', '_definition.id', 'ENUMERATION' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     The attributes for restricting the values of defined data items.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'ENUMERATION' ],
              [ 'save_',
                'enumeration.default',
                [ [ 'item_', '_definition.id', '_enumeration.default' ],
                  [ 'item_', '_definition.update', '2013-03-08' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The default value for the defined item if it is not specified explicitly.' ],
                  [ 'item_', '_name.category_id', 'enumeration' ],
                  [ 'item_', '_name.object_id', 'default' ],
                  [ 'item_', '_type.purpose', 'Encode' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Implied' ] ] ],
              [ 'save_',
                'enumeration.def_index_id',
                [ [ 'item_', '_definition.id', '_enumeration.def_index_id' ],
                  [ 'item_', '_definition.update', '2012-05-07' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Specifies the data name with a value used as an index to the\n     DEFAULT enumeration list (in category enumeration_default)\n     in order to select the default enumeration value for the\n     defined item. The value of the identified data item must match\n     one of the _enumeration_default.index values.' ],
                  [ 'item_', '_name.category_id', 'enumeration' ],
                  [ 'item_', '_name.object_id', 'def_index_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Tag' ] ] ],
              [ 'save_',
                'enumeration.range',
                [ [ 'item_', '_definition.id', '_enumeration.range' ],
                  [ 'item_', '_definition.update', '2013-04-17' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The inclusive range of values "from:to" allowed for the defined item.' ],
                  [ 'item_', '_name.category_id', 'enumeration' ],
                  [ 'item_', '_name.object_id', 'range' ],
                  [ 'item_', '_type.purpose', 'Encode' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Range' ] ] ],
              [ 'save_',
                'enumeration.mandatory',
                [ [ 'item_', '_definition.id', '_enumeration.mandatory' ],
                  [ 'item_', '_definition.update', '2012-05-07' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Yes or No flag on whether the enumerate states specified for an\n     item in the current definition (in which item appears) MUST be\n     used on instantiation.' ],
                  [ 'item_', '_name.category_id', 'enumeration' ],
                  [ 'item_', '_name.object_id', 'mandatory' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Yes',
                      'Use of state is mandatory',
                      'No',
                      'Use of state is unnecessary' ] ],
                  [ 'item_', '_enumeration.default', 'Yes' ] ] ],
              [ '@comment',
                '-----------------------------------------------------------------------------' ],
              [ 'save_',
                'ENUMERATION_DEFAULT',
                [ [ 'item_', '_definition.id', 'ENUMERATION_DEFAULT' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Loop' ],
                  [ 'item_', '_definition.update', '2011-06-20' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Loop of pre-determined default enumeration values indexed to a\n     data item by the item _enumeration.def_index_id.' ],
                  [ 'item_', '_name.category_id', 'ENUMERATION' ],
                  [ 'item_', '_name.object_id', 'DEFAULT' ],
                  [ 'item_', '_category.key_id', '_enumeration_default.index' ],
                  [ 'save_',
                    'enumeration_default.index',
                    [ [ 'item_', '_definition.id', '_enumeration_default.index' ],
                      [ 'item_', '_definition.update', '2013-04-17' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Index key in the list default values referenced to by the value\n     of _enumeration.def_index_id .' ],
                      [ 'item_', '_name.category_id', 'default' ],
                      [ 'item_', '_name.object_id', 'index' ],
                      [ 'item_', '_type.purpose', 'Key' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ] ] ],
                  [ 'save_',
                    'enumeration_default.value',
                    [ [ 'item_', '_definition.id', '_enumeration_default.value' ],
                      [ 'item_', '_definition.update', '2013-04-17' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Default enumeration value in the list referenced by the value of\n     _enumeration.def_index_id. The reference index key is given by\n     the value of _enumeration_default.index value.' ],
                      [ 'item_', '_name.category_id', 'default' ],
                      [ 'item_', '_name.object_id', 'value' ],
                      [ 'item_', '_type.purpose', 'Encode' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Implied' ] ] ] ] ],
              [ '@comment', '------- close the ENUMERATION_DEFAULT category' ],
              [ '@comment',
                '-----------------------------------------------------------------------------' ],
              [ 'save_',
                'ENUMERATION_SET',
                [ [ 'item_', '_definition.id', 'ENUMERATION_SET' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Loop' ],
                  [ 'item_', '_definition.update', '2011-06-20' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Attributes of data items which are used to define a\n     set of unique pre-determined values.' ],
                  [ 'item_', '_name.category_id', 'ENUMERATION' ],
                  [ 'item_', '_name.object_id', 'SET' ],
                  [ 'item_', '_category.key_id', '_enumeration_set.state' ],
                  [ 'save_',
                    'enumeration_set.state',
                    [ [ 'item_', '_definition.id', '_enumeration_set.state' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Permitted value state for the defined item.' ],
                      [ 'item_', '_name.category_id', 'set' ],
                      [ 'item_', '_name.object_id', 'state' ],
                      [ 'item_', '_type.purpose', 'Key' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ] ] ],
                  [ 'save_',
                    'enumeration_set.table_id',
                    [ [ 'item_', '_definition.id', '_enumeration_set.table_id' ],
                      [ 'item_', '_definition.update', '2011-08-02' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Permitted id codes in the defined TABLE item {"<id>:<val>,...}.' ],
                      [ 'item_', '_name.category_id', 'set' ],
                      [ 'item_', '_name.object_id', 'table_id' ],
                      [ 'item_', '_type.purpose', 'Encode' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ] ] ],
                  [ 'save_',
                    'enumeration_set.detail',
                    [ [ 'item_', '_definition.id', '_enumeration_set.detail' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The meaning of the code (identified by _enumeration_set.state)\n     in terms of the value of the quantity it describes.' ],
                      [ 'item_', '_name.category_id', 'set' ],
                      [ 'item_', '_name.object_id', 'detail' ],
                      [ 'item_', '_type.purpose', 'Describe' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Text' ] ] ],
                  [ 'save_',
                    'enumeration_set.xref_code',
                    [ [ 'item_', '_definition.id', '_enumeration_set.xref_code' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Identity of the equivalent item in the dictionary\n     referenced by the DICTIONARY_XREF attributes.' ],
                      [ 'item_', '_name.category_id', 'set' ],
                      [ 'item_', '_name.object_id', 'xref_code' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ] ] ],
                  [ 'save_',
                    'enumeration_set.xref_dictionary',
                    [ [ 'item_', '_definition.id', '_enumeration_set.xref_dictionary' ],
                      [ 'item_', '_definition.update', '2011-06-27' ],
                      [ 'item_', '_definition.class', 'Attribute' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Code identifying the dictionary in the DICTIONARY_XREF\n     list.' ],
                      [ 'item_', '_name.category_id', 'set' ],
                      [ 'item_', '_name.object_id', 'xref_dictionary' ],
                      [ 'item_', '_type.purpose', 'Audit' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
              [ '@comment', '------- close the ENUMERATION_SET category' ] ] ],
          [ '@comment', '------- close the ENUMERATION category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'IMPORT',
            [ [ 'item_', '_definition.id', 'IMPORT' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-27' ],
              [ 'item_',
                '_description.text',
                '\n     Used to import the values of specific attributes from other dictionary\n     definitions within and without the current dictionary.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'IMPORT' ],
              [ 'save_',
                'import.file_id',
                [ [ 'item_', '_definition.id', '_import.file_id' ],
                  [ 'item_', '_definition.update', '2011-06-27' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The file name/URI of the source dictionary' ],
                  [ 'item_', '_name.category_id', 'import' ],
                  [ 'item_', '_name.object_id', 'file_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Uri' ] ] ],
              [ 'save_',
                'import.frame_id',
                [ [ 'item_', '_definition.id', '_import.frame_id' ],
                  [ 'item_', '_definition.update', '2011-06-27' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The framecode of the definition frame to be imported.' ],
                  [ 'item_', '_name.category_id', 'import' ],
                  [ 'item_', '_name.object_id', 'frame_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ] ] ],
              [ 'save_',
                'import.mode',
                [ [ 'item_', '_definition.id', '_import.mode' ],
                  [ 'item_', '_definition.update', '2011-10-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Code identifying how a definition save frame is to be imported.\n     "Full" imports the entire definition frame including the leading\n            and trailing save statements.\n     "Contents" imports only the lines within the save frame.' ],
                  [ 'item_', '_name.category_id', 'import' ],
                  [ 'item_', '_name.object_id', 'mode' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Full',
                      'import requested definition with frame',
                      'Contents',
                      'import contents of requested defn frame' ] ],
                  [ 'item_', '_enumeration.default', 'Contents' ] ] ],
              [ 'save_',
                'import.if_dupl',
                [ [ 'item_', '_definition.id', '_import.if_dupl' ],
                  [ 'item_', '_definition.update', '2012-10-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Code identifying the action taken if the requested definition block\n     already exists within the importing dictionary.' ],
                  [ 'item_', '_name.category_id', 'import' ],
                  [ 'item_', '_name.object_id', 'if_dupl' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Ignore',
                      'ignore imported definitions if id conflict',
                      'Replace',
                      'replace existing with imported definitions',
                      'Exit',
                      'issue error exception and exit' ] ],
                  [ 'item_', '_enumeration.default', 'Exit' ] ] ],
              [ 'save_',
                'import.if_miss',
                [ [ 'item_', '_definition.id', '_import.if_miss' ],
                  [ 'item_', '_definition.update', '2012-10-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Code identifying the action taken if the requested definition block\n     is missing from the source dictionary.' ],
                  [ 'item_', '_name.category_id', 'import' ],
                  [ 'item_', '_name.object_id', 'if_miss' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Ignore',
                      'ignore import',
                      'Exit',
                      'issue error exception and exit' ] ],
                  [ 'item_', '_enumeration.default', 'Exit' ] ] ],
              [ 'save_',
                'import.get',
                [ [ 'item_', '_definition.id', '_import.get' ],
                  [ 'item_', '_definition.update', '2013-03-08' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     A table of attributes defined individually in the category IMPORT,\n     used to import definitions from other dictionaries.' ],
                  [ 'item_', '_name.category_id', 'import' ],
                  [ 'item_', '_name.object_id', 'get' ],
                  [ 'item_', '_type.purpose', 'Import' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Table' ],
                  [ 'item_', '_type.contents', 'List(Code)' ],
                  [ 'item_', '_type.dimension', [ {} ] ],
                  [ 'loop_',
                    [ '_enumeration_set.state',
                      '_enumeration_set.table_id',
                      '_enumeration_set.detail' ],
                    [ '1',
                      'file',
                      'filename/URI of source dictionary',
                      '2',
                      'save',
                      'save framecode of source definition',
                      '3',
                      'mode',
                      'mode for including save frames',
                      '4',
                      'dupl',
                      'option for duplicate entries',
                      '5',
                      'miss',
                      'option for missing duplicate entries' ] ],
                  [ 'loop_',
                    [ '_method.purpose', '_method.expression' ],
                    [ 'Evaluation',
                      '\n     With  i  as  import\n \n    _import.get = [{"file":i.file_id, "save":i.frame_id, "mode":i.mode,\n                    "dupl":i.if_dupl, "miss":i.if_miss}]' ] ] ] ] ] ],
          [ '@comment', '----- close the IMPORT category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'LOOP',
            [ [ 'item_', '_definition.id', 'LOOP' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     Attributes for looped lists.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'LOOP' ],
              [ 'save_',
                'loop.level',
                [ [ 'item_', '_definition.id', '_loop.level' ],
                  [ 'item_', '_definition.update', '2012-05-07' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Specifies the level of the loop structure in which a defined\n     item must reside if it used in a looped list.' ],
                  [ 'item_', '_name.category_id', 'loop' ],
                  [ 'item_', '_name.object_id', 'level' ],
                  [ 'item_', '_type.purpose', 'Number' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Index' ],
                  [ 'item_', '_enumeration.range', '1:' ],
                  [ 'item_', '_enumeration.default', '1' ] ] ] ] ],
          [ '@comment', '----- close the LOOP category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'METHOD',
            [ [ 'item_', '_definition.id', 'METHOD' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Loop' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     Methods used for evaluating, validating and defining items.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'METHOD' ],
              [ 'item_', '_category.key_id', '_method.purpose' ],
              [ 'save_',
                'method.purpose',
                [ [ 'item_', '_definition.id', '_method.purpose' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The purpose and scope of the method expression.' ],
                  [ 'item_', '_name.category_id', 'method' ],
                  [ 'item_', '_name.object_id', 'purpose' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Evaluation',
                      'method evaluates an item from related item values',
                      'Definition',
                      'method generates attribute value(s) in the definition',
                      'Validation',
                      'method compares an evaluation with existing item value' ] ],
                  [ 'item_', '_enumeration.default', 'Evaluation' ] ] ],
              [ 'save_',
                'method.expression',
                [ [ 'item_', '_definition.id', '_method.expression' ],
                  [ 'item_', '_definition.update', '2006-11-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The method expression for the defined item.' ],
                  [ 'item_', '_name.category_id', 'method' ],
                  [ 'item_', '_name.object_id', 'expression' ],
                  [ 'item_', '_type.purpose', 'Method' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
          [ '@comment', '----- close the METHOD category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'NAME',
            [ [ 'item_', '_definition.id', 'NAME' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-20' ],
              [ 'item_',
                '_description.text',
                '\n     Attributes for identifying items and item categories.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'NAME' ],
              [ 'save_',
                'name.object_id',
                [ [ 'item_', '_definition.id', '_name.object_id' ],
                  [ 'item_', '_definition.update', '2011-07-27' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The object name of a category or name unique within the\n     category or family of categories.' ],
                  [ 'item_', '_name.category_id', 'name' ],
                  [ 'item_', '_name.object_id', 'object_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Name' ] ] ],
              [ 'save_',
                'name.category_id',
                [ [ 'item_', '_definition.id', '_name.category_id' ],
                  [ 'item_', '_definition.update', '2011-07-27' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The name of the category in which a category or item resides.' ],
                  [ 'item_', '_name.category_id', 'name' ],
                  [ 'item_', '_name.object_id', 'category_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Name' ] ] ],
              [ 'save_',
                'name.linked_item_id',
                [ [ 'item_', '_definition.id', '_name.linked_item_id' ],
                  [ 'item_', '_definition.update', '2011-12-08' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Dataname of an equivalent item in another category which has a\n     common set of values, or, in the definition of a type Su\n     item is the name of the associated Measurement item to\n     which the standard uncertainty applies.' ],
                  [ 'item_', '_name.category_id', 'name' ],
                  [ 'item_', '_name.object_id', 'linked_item_id' ],
                  [ 'item_', '_type.purpose', 'Identify' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Tag' ] ] ] ] ],
          [ '@comment', '----- close the NAME category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'TYPE',
            [ [ 'item_', '_definition.id', 'TYPE' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2011-06-26' ],
              [ 'item_',
                '_description.text',
                '\n    Attributes which specify the \'typing\' of data items.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'TYPE' ],
              [ 'save_',
                'type.container',
                [ [ 'item_', '_definition.id', '_type.container' ],
                  [ 'item_', '_definition.update', '2013-04-07' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The CONTAINER type of the defined data item value.' ],
                  [ 'item_', '_name.category_id', 'type' ],
                  [ 'item_', '_name.object_id', 'container' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Single',
                      'single value',
                      'Multiple',
                      'values as List or by boolean ,|&!* or range : ops',
                      'List',
                      'ordered set of values bounded by [] and separated by\n                   commas. Elements need not be of same contents type.',
                      'Array',
                      'ordered set of numerical values bounded by [] and\n                   separated by commas. Operations across arrays are\n                   equivalent to operations across elements of the Array.',
                      'Matrix',
                      'ordered set of numerical values for a tensor bounded by\n                   [] and separated by commas. Tensor operations such as\n                   dot and cross products, are valid cross matrix objects.',
                      'Table',
                      'id:value elements bounded by {}; separated by commas',
                      'Ref-table',
                      'a STAR construction with key:value elements bounded\n                     by ${..}$ and separated by commas.\n                     The id tags below are privileged and optional.\n                        source  - filename or URI\n                        block   - data blockname\n                        frame   - framecode or [framecode,framecode,..]\n                        item    - dataname or [dataname,dataname,..]\n                        key     - key value if item is in a list      ' ] ],
                  [ 'item_', '_enumeration.default', 'Single' ] ] ],
              [ 'save_',
                'type.contents',
                [ [ 'item_', '_definition.id', '_type.contents' ],
                  [ 'item_', '_definition.update', '2013-04-24' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     Syntax of the value elements within the container type.\n     This may be a single enumerated code, or, in the case of a list,\n     a comma-delimited sequence of codes, or, if there are alternate\n     types, a boolean-linked (or range) sequence of codes.\n     The typing of elements is determined by the replication\n     of the minimum set of states declared.' ],
                  [ 'item_', '_name.category_id', 'type' ],
                  [ 'item_', '_name.object_id', 'contents' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Multiple' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Text',
                      'case-sens strings or lines of STAR characters',
                      'Code',
                      'case-insens contig. string of STAR characters',
                      'Name',
                      'case-insens contig. string of alpha-num chars or underscore',
                      'Tag',
                      'case-insens contig. STAR string with leading underscore',
                      'Filename',
                      'case-sens string indentifying an external file',
                      'Uri',
                      'case-sens string as universal resource indicator of a file',
                      'Date',
                      'ISO standard date format <yyyy>-<mm>-<dd>',
                      'Version',
                      'version digit string of the form <major>.<version>.<update>',
                      'Dimension',
                      'integer limits of an Array/Matrix/List in square brackets',
                      'Range',
                      'inclusive range of numerical values min:max',
                      'Count',
                      'unsigned integer number',
                      'Index',
                      'unsigned non-zero integer number',
                      'Integer',
                      'positive or negative integer number',
                      'Real',
                      'floating-point real number',
                      'Imag',
                      'floating-point imaginary number',
                      'Complex',
                      'complex number <R>+j<I>',
                      'Binary',
                      'binary number \\b<N>',
                      'Hexadecimal',
                      'hexadecimal number \\x<N>',
                      'Octal',
                      'octal number \\o<N>',
                      'Implied',
                      'implied by the context of the attribute' ] ],
                  [ 'item_', '_enumeration.default', 'Text' ],
                  [ 'loop_',
                    [ '_description_example.case', '_description_example.detail' ],
                    [ 'Integer',
                      'content is a single or multiple integer(s)',
                      'Real,Integer',
                      'List elements of a real number and an integer',
                      'List(Real,Code)',
                      'List of Lists of a real number and a code',
                      'Text|Real',
                      'content is either text OR a real number' ] ] ] ],
              [ 'save_',
                'type.purpose',
                [ [ 'item_', '_definition.id', '_type.purpose' ],
                  [ 'item_', '_definition.update', '2013-03-06' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The primary purpose or function the defined data item serves in a\n     dictionary or a specific data instance.' ],
                  [ 'item_', '_name.category_id', 'type' ],
                  [ 'item_', '_name.object_id', 'purpose' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Import',
                      '                  >>> Applied ONLY in the DDLm Reference Dictionary <<<\n                   Used to type the SPECIAL attribute "_import.get" that\n                   is present in dictionaries to instigate the importation\n                   of external dictionary definitions.',
                      'Method',
                      '                  >>> Applied ONLY in the DDLm Reference Dictionary <<<\n                   Used to type the attribute "_method.expression" that\n                   is present in dictionary definitions to provide the\n                   text method expressing the defined item in terms of\n                   other defined items.',
                      'Audit',
                      '                  >>> Applied ONLY in the DDLm Reference Dictionary <<<\n                   Used to type attributes employed to record the audit\n                   definition information (creation date, update version and\n                   cross reference codes) of items, categories and files.',
                      'Identify',
                      '                  >>> Applied ONLY in the DDLm Reference Dictionary <<<\n                   Used to type attributes that identify an item tag (or\n                   part thereof), save frame or the URI of an external file.',
                      [ '@comment',
                        '...............the PURPOSE types used in all dictionaries ...........' ],
                      'Extend',
                      '                  *** Used to EXTEND the DDLm Reference Dictionary ***\n                   Used in a definition, residing in the "extensions"\n                   save frame of a domain dictionary, to specify a new\n                   enumeration state using an Evaluation method.',
                      'Describe',
                      '                  Used to type items with values that are descriptive\n                   text intended for human interpretation.',
                      'Encode',
                      '                  Used to type items with values that are text or codes\n                   that are formatted to be machine parsible.',
                      'State',
                      '                  Used to type items with values that are restricted to\n                   codes present in their "enumeration_set.state" lists.',
                      'Key',
                      '                  Used to type an item with a value that is unique within\n                   the looped list of these items, and may be used as a\n                   reference "key" to identify a specific packet of items\n                   within the category.',
                      'Link',
                      '                  Used to type an item with a value that is unique within\n                   a looped list of items belonging to another category.\n                   The definition of this item must contain the attribute\n                   "_name.linked_item_id" specifying the data name of the\n                   key item for this list. The defined item represents a\n                   a foreign key linking packets in this category list to\n                   packets in another category.',
                      'Composite',
                      '                  Used to type items with value strings composed of\n                   separate parts. These will usually need to be separated\n                   and parsed for complete interpretation and application.',
                      'Number',
                      '                  Used to type items that are numerical and exact (i.e.\n                   no standard uncertainty value).',
                      'Measurand',
                      '                  Used to type an item with a numerically estimated value\n                   that has been recorded by measurement or derivation. This\n                   value must be accompanied by its standard uncertainty\n                   (SU) value, expressed either as:\n                     1) appended integers, in parentheses (), at the\n                        precision of the trailing digits,       or\n                     2) a separately defined item with the same name as the\n                        measurand item but with an additional suffix \'_su\'.',
                      'SU',
                      '                  Used to type an item with a numerical value that is the\n                   standard uncertainty of an item with the identical name\n                   except for the suffix \'_su\'. The definition of an SU item\n                   must include the attribute "_name.linked_item_id" which\n                   explicitly identifies the associated measurand item.' ] ],
                  [ 'item_', '_enumeration.default', 'Describe' ] ] ],
              [ 'save_',
                'type.source',
                [ [ 'item_', '_definition.id', '_type.source' ],
                  [ 'item_', '_definition.update', '2013-04-16' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The origin or source of the defined data item, indicating by what\n     recording process it has been added to the domain instance.' ],
                  [ 'item_', '_name.category_id', 'type' ],
                  [ 'item_', '_name.object_id', 'source' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'Recorded',
                      '               A value (numerical or otherwise) recorded by\n                observation or measurement during the experimental\n                collection of data. This item is PRIMITIVE.',
                      'Assigned',
                      '               A value (numerical or otherwise) assigned as part of\n                the data collection, analysis or modelling required\n                for a specific domain instance. These assignments\n                often represent a decision made that determines the\n                course of the experiment (and therefore may be deemed\n                PRIMITIVE) or a particular choice in the way the data\n                was analysed (and therefore may be considered NOT\n                PRIMITIVE).',
                      'Related',
                      '               A value or tag used in the construction of looped\n                lists of data. Typically identifying an item whose\n                unique value is the reference key for a loop category\n                and/or an item which as values in common with those\n                of another loop category and is considered a Link\n                between these lists.',
                      'Derived',
                      '               A quantity derived from other data items within the\n                domain instance. This item is NOT PRIMITIVE.' ] ],
                  [ 'item_', '_enumeration.default', 'Selected' ] ] ],
              [ 'save_',
                'type.dimension',
                [ [ 'item_', '_definition.id', '_type.dimension' ],
                  [ 'item_', '_definition.update', '2013-04-17' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     The dimensions of a list or matrix of elements as a text string\n     within bounding square brackets.' ],
                  [ 'item_', '_name.category_id', 'type' ],
                  [ 'item_', '_name.object_id', 'dimension' ],
                  [ 'item_', '_type.purpose', 'Encode' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Dimension' ],
                  [ 'loop_',
                    [ '_description_example.case', '_description_example.detail' ],
                    [ '[3,3]',
                      '3x3 matrix of elements',
                      '[6]',
                      'list of 6 elements',
                      '[]',
                      'unknown number of list elements' ] ] ] ] ] ],
          [ '@comment', '-------- close the TYPE category' ],
          [ '@comment',
            '----------------------------------------------------------------------------' ],
          [ 'save_',
            'UNITS',
            [ [ 'item_', '_definition.id', 'UNITS' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Set' ],
              [ 'item_', '_definition.update', '2013-03-06' ],
              [ 'item_',
                '_description.text',
                '\n    The attributes for specifying units of measure.' ],
              [ 'item_', '_name.category_id', 'ATTRIBUTES' ],
              [ 'item_', '_name.object_id', 'UNITS' ],
              [ 'save_',
                'units.code',
                [ [ 'item_', '_definition.id', '_units.code' ],
                  [ 'item_', '_definition.update', '2012-01-25' ],
                  [ 'item_', '_definition.class', 'Attribute' ],
                  [ 'item_',
                    '_description.text',
                    '\n     A code which identifies the units of measurement.' ],
                  [ 'item_', '_name.category_id', 'units' ],
                  [ 'item_', '_name.object_id', 'code' ],
                  [ 'item_', '_type.purpose', 'State' ],
                  [ 'item_', '_type.source', 'Assigned' ],
                  [ 'item_', '_type.container', 'Single' ],
                  [ 'item_', '_type.contents', 'Code' ],
                  [ 'loop_',
                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                    [ 'none',
                      'dimensionless - e.g. a ratio, factor, weight or scale',
                      'coulomb',
                      'electronic charge in Coulombs',
                      'centimetres',
                      'length    \'centimetres (meters * 10^( -2))\'',
                      'millimetres',
                      'length    \'millimetres (meters * 10^( -3))\'',
                      'nanometres',
                      'length    \'nanometres  (meters * 10^( -9))\'',
                      'angstroms',
                      'length    \'angstroms   (meters * 10^(-10))\'',
                      'picometres',
                      'length    \'picometres  (meters * 10^(-12))\'',
                      'femtometres',
                      'length    \'femtometres (meters * 10^(-15))\'',
                      'reciprocal_centimetres',
                      'per_length \'reciprocal centimetres (meters * 10^( -2)^-1)\'',
                      'reciprocal_millimetres',
                      'per_length \'reciprocal millimetres (meters * 10^( -3)^-1)\'',
                      'reciprocal_nanometres',
                      'per-length \'reciprocal nanometres  (meters * 10^( -9)^-1)\'',
                      'reciprocal_angstroms',
                      'per-length \'reciprocal angstroms   (meters * 10^(-10)^-1)\'',
                      'reciprocal_picometres',
                      'per-length \'reciprocal picometres  (meters * 10^(-12)^-1)\'',
                      'nanometre_squared',
                      'length_squared \'nanometres squared (meters * 10^( -9))^2\'',
                      'angstrom_squared',
                      'length_squared \'angstroms squared  (meters * 10^(-10))^2\'',
                      '8pi_angstroms_squared',
                      'length_squared \'8pi^2 * angstroms squared (meters * 10^(-10))^2\'',
                      'picometre_squared',
                      'length_squared \'picometres squared (meters * 10^(-12))^2\'',
                      'femtometre_squared',
                      'length_squared \'femtometres squared (meters * 10^(-12))^2\'',
                      'nanometre_cubed',
                      'length_cubed \'nanometres cubed (meters * 10^( -9))^3\'',
                      'angstrom_cubed',
                      'length_cubed \'angstroms cubed  (meters * 10^(-10))^3\'',
                      'picometre_cubed',
                      'length_cubed \'picometres cubed (meters * 10^(-12))^3\'',
                      'grams_per_centimetre_cubed',
                      'density \'grams per cubic centimetre\'',
                      'kilograms_per_metre_cubed',
                      'density \'kilograms per cubic metre\'',
                      'megagrams_per_metre_cubed',
                      'density \'megagrams per cubic metre\'',
                      'kilopascals',
                      'pressure      \'kilopascals\'',
                      'gigapascals',
                      'pressure      \'gigapascals\'',
                      'hours',
                      'time      \'hours\'',
                      'minutes',
                      'time      \'minutes\'',
                      'seconds',
                      'time      \'seconds\'',
                      'microseconds',
                      'time      \'microseconds\'',
                      'degrees',
                      'angle      \'degrees (of arc)\'',
                      'degree_per_minute',
                      'rotation_per_time  \'degrees (of arc) per minute\'',
                      'celsius',
                      'temperature     \'degrees (of temperature) Celsius\'',
                      'kelvins',
                      'temperature     \'degrees (of temperature) Kelvin\'',
                      'electrons',
                      'electrons              \'electrons\'',
                      'electron_squared',
                      'electrons-squared    \'electrons squared\'',
                      'electrons_per_nanometre_cubed',
                      'electron-density \'electrons per nanometres cubed (meters * 10^( -9))^3\'',
                      'electrons_per_angstrom_cubed',
                      'electron-density \'electrons per angstroms  cubed (meters * 10^(-10))^3\'',
                      'electrons_per_picometre_cubed',
                      'electron-density \'electrons per picometres cubed (meters * 10^(-12))^3\'',
                      'dalton',
                      'standard atomic mass unit',
                      'pixel_per_millimetre',
                      'area resolution unit',
                      'kilowatts',
                      'power       \'kilowatts\'',
                      'milliamperes',
                      'current     \'milliamperes\'',
                      'kilovolts',
                      'emf         \'kilovolts\'',
                      'volt_squared',
                      'emf         \'volts squared\'',
                      'arbitrary',
                      'arbitrary    \'arbitrary system of units\'' ] ],
                  [ 'item_', '_enumeration.default', 'Arbitrary' ] ] ] ] ],
          [ '@comment', '--------- close the UNITS category' ] ] ],
      [ '@comment', '--------- close the ATTRIBUTES category' ],
      [ '@comment',
        '=============================================================================' ],
      [ '@comment',
        '  The attribute validation criteria for application to a domain dictionary' ],
      [ '@comment',
        '============================================================================' ],
      [ 'loop_',
        [ '_dictionary_valid.application',
          '_dictionary_valid.attributes' ],
        [ [ 'Dictionary', 'Mandatory' ],
          [ '_dictionary.title',
            '_dictionary.class',
            '_dictionary.version',
            '_dictionary.date',
            '_dictionary.uri',
            '_dictionary.ddl_conformance',
            '_dictionary.namespace' ],
          [ 'Dictionary', 'Recommended' ],
          [ '_description.text',
            '_dictionary_audit.version',
            '_dictionary_audit.date',
            '_dictionary_audit.revision' ],
          [ 'Dictionary', 'Prohibited' ],
          [ 'ALIAS',
            'CATEGORY',
            'DEFINITION',
            'ENUMERATION',
            'LOOP',
            'METHOD',
            'NAME',
            'TYPE',
            'UNITS' ],
          [ 'Category', 'Mandatory' ],
          [ '_definition.id',
            '_definition.scope',
            '_definition.class',
            '_name.category_id',
            '_name.object_id' ],
          [ 'Category', 'Recommended' ],
          [ '_category.key_id', '_description.text' ],
          [ 'Category', 'Prohibited' ],
          [ 'ALIAS',
            'DICTIONARY',
            'ENUMERATION',
            'IMPORT',
            'LOOP',
            'TYPE',
            'UNITS' ],
          [ 'Item', 'Mandatory' ],
          [ '_definition.id',
            '_definition.update',
            '_name.object_id',
            '_name.category_id',
            '_type.purpose',
            '_type.source',
            '_type.container',
            '_type.contents' ],
          [ 'Item', 'Recommended' ],
          [ '_definition.scope',
            '_definition.class',
            '_type.source',
            '_description.text',
            '_description.common' ],
          [ 'Item', 'Prohibited' ],
          [ 'CATEGORY', 'DICTIONARY' ],
          [ '@comment',
            '=============================================================================' ],
          [ '@comment',
            '  The dictionary\'s audit trail and creation history.' ],
          [ '@comment',
            '============================================================================' ] ] ],
      [ 'loop_',
        [ '_dictionary_audit.version',
          '_dictionary_audit.date',
          '_dictionary_audit.revision' ],
        [ '3.3.00',
          '2004-11-09',
          '\n   Change definition.import_id to definition_import.id in many defs.\n   Insert category DEFINITION_IMPORT and the items .id, .conflict,\n   .protocol and .source.',
          '3.3.01',
          '2004-11-10',
          '\n   Make further changes to the DEFINITION_IMPORT definitions and\n   introduce the DEFINITION_TEMPLATE category.',
          '3.3.02',
          '2004-11-11',
          '\n   Introduce an IMPORT category containing IMPORT_DICTIONARY,\n   IMPORT_DEFINITION, IMPORT_CATEGORY, IMPORT_ATTRIBUTE.\n   Change DEFINITION_TEMPLATE to IMPORT_TEMPLATE.',
          '3.3.03',
          '2004-11-12',
          '\n   Major changes to all the new attributes. Introduce categories\n   DEFINITION_CONTEXT.',
          '3.3.04',
          '2004-11-13',
          '\n   Cleaned up the IMPORT changes and cases of enumerates.',
          '3.3.05',
          '2004-11-16',
          '\n   Further changes to IMPORT definitions.',
          '3.3.06',
          '2004-11-18',
          '\n  Some minor correction of typos',
          '3.3.07',
          '2005-11-22',
          '\n  Changed _dictionary.name to _dictionary.filename\n  Changed _dictionary_xref.name to _dictionary_xref.filename\n  Added _dictionary.title to describe the common name of the dictionary',
          '3.3.08',
          '2005-12-12',
          '\n  Changed ddl to ddl_attr\n  Added Template and Function to _dictionary.class',
          '3.3.09',
          '2006-02-02',
          '\n  Add the definition of _dictionary_xref.source.',
          '3.3.10',
          '2006-02-07',
          '\n  Add import attribute definitions',
          '3.4.01',
          '2006-02-12',
          '\n  Remove save frames from dictionary attributes.\n  Change the attribute _dictionary.parent_name to _dictionary.parent_id',
          '3.4.02',
          '2006-02-16',
          '\n  In the import_*.conflict definitions change the enumeration state Unique\n  to Ignore, and change the default state to Error.\n  In the import_*.missing definitions change default enumeration state to\n  Error.',
          '3.5.01',
          '2006-03-07',
          '\n  Structural changes to the file to conform with the import model 3.\n  Move the template file for *.relational_id to com_att.dic\n  Change all references to *.relational_id into the tuple format.\n  Move the _codes_ddl.units_code to enum_set.dic and insert the\n  import_enum_set.id tuples.',
          '3.5.02',
          '2006-03-22',
          '\n  Rename _enumeration.default_index_id to _enumeration.def_index_id.\n  Correct the attributes _enumeration_default.index and *.value.',
          '3.5.03',
          '2006-05-09',
          '\n  Reword many of the import attributes.\n  Correct the tuple description for import_dictionary.\n  Insert all of the definitions for import_defaults attributes.\n  Update _dictionary.class definition - change "Template" to "Import".\n  Remove _enumeration.scope "open" from _definition_context.domain.',
          '3.6.01',
          '2006-06-16',
          '\n  Major revamp of TYPE attributes... changed:\n     _type.value to _type.contents and expand enumeration list.\n     _type.purpose has new role and different enumeration states.\n  _name.object_id changed to _name.object_id.\n  _enumeration_set.code becomes _enumeration_set.state.\n  Changed the _type.value (now .contents) states to match expanded list.\n  Added _dictionary.ddl_conformance attribute.\n  Changed _category.join_set_id to _category.join_cat_id.\n  Remove _enumeration.scope definition.',
          '3.6.02',
          '2006-06-17',
          '\n  Change the states of _type.purpose.',
          '3.6.03',
          '2006-06-18',
          '\n  Correct _type.contents value in import_dictionary.id.',
          '3.6.04',
          '2006-06-20',
          '\n  Change state \'Point\' to \'Link\' in _type.contents definition.\n  Add Formula to _type.contents',
          '3.6.05',
          '2006-06-27',
          '\n  Change all IMPORT attributes and apply.\n  Add _dictionary.namespace attribute and apply.\n  Add states to _definition.class and apply.\n  Add _enumeration_set.scope.\n  Add .context to ENUMERATE_SET, ENUMERATE_DEFAULT, DESCRIPTION_EXAMPLE',
          '3.6.06',
          '2006-07-18',
          '\n  Change the descriptions of the _type.container states.\n  The _enumeration_set.scope removed (enumeration.mandatory used).\n  In _type_array.dimension change _type.contents to List.',
          '3.6.07',
          '2006-08-30',
          '\n  Change \'att\' to \'sta\' in the imports of _type.contents and _units.code.\n  Replace states \'vector\' and \'matrix\' in _type.container with \'array\'.\n  In _type.purpose change \'model\' to \'assigned\'; \'observe\' to \'observed\';\n  and \'measure\' to \'measured\'.',
          '3.6.08',
          '2006-08-31',
          '\n  Remove the category TYPE_ARRAY and insert _type.dimension\n  Replace _description.compact with _description.common\n  Replace _description.abbreviated with _description.key_words',
          '3.6.09',
          '2006-10-31',
          '\n  Remove all attributes and categories referring to \'context\'.',
          '3.6.10',
          '2006-11-09',
          '\n  Replace _method.id with method.purpose.\n  Redefine the DICTIONARY_VALID values.',
          '3.7.01',
          '2006-11-16',
          '\n  Apply _definition.scope changes.\n  Add _category.parent_join.\n  Add _dictionary.xref_code.\n  Add _enumeration_set.xref_dictionary.\n  Remove all relational keys.',
          '3.7.02',
          '2006-12-05',
          '\n  Rewording of description.text in DDL_ATTR and definition.namespace\n  Rewording of category_mandatory.item_id\n  Reworded descriptions of definition.class descriptions.\n  Removed dictionary.filename.\n  Corrected examples in type.dimension.\n  Remove dictionary.parent_id and dictionary.parent_uri.',
          '3.7.03',
          '2006-12-21',
          '\n  Default for _category.parent_join is now "No"',
          '3.7.04',
          '2007-02-06',
          '\n  Change _category_key.item_id to _category_key.generic\n  Add _category_key.primitive',
          '3.7.05',
          '2007-02-08',
          '\n  Change the _type.purpose of _category_key.generic and .primitive\n  to Identify',
          '3.7.06',
          '2007-03-18',
          '\n  Change the description for _name.linked_item_id',
          '3.7.07',
          '2007-10-11',
          '\n  Correct the _type.dimension assignments to [n[m]].\n  Remove _type_array.dimension from _type.dimension definition.',
          '3.7.08',
          '2008-01-17',
          '\n  Change \'Definition\' to \'Evaluation\' in import_list.id.\n  Changed import.scope entries to leading uc character.',
          '3.7.09',
          '2008-02-12',
          '\n  Change \'Itm\' to \'Def\' in import.scope.',
          '3.7.10',
          '2008-03-28',
          '\n  Update the definition of _type.dimension.',
          '3.7.11',
          '2008-05-18',
          '\n  Changed 2 type.contents values from "Implied" to "Inherited"\n  Change import_list.id to be ((.....))\n ',
          '3.7.12',
          '2008-08-05',
          '\n  Correct _type.dimension definition.',
          '3.7.13',
          '2011-01-27',
          '\n  Change definition scope of Head category to "Dictionary"\n  Remove all tabs and replace with blank string',
          '3.7.14',
          '2011-03-25',
          '\n  In the attribute import_list.id\n  Change _type.contents  Tuple(Code,Tag,Uri,Code,Code)\n  To     _type.contents  Tuple(Code,Ctag,Uri,Code,Code)\n In the attribute import.block\n  Change _type.contents    Tag\n  To     _type.contents    Ctag\n  And change the case examples',
          '3.8.01',
          '2011-06-07',
          '\n  Remove the Tuple and Array enumerations from _type.container\n  Change category class enumeration from List to Loop; and change\n  all invocations of _category.class in the definitions\n  Introduce nested save frames for expressing nested categories.',
          '3.8.02',
          '2011-06-21',
          '\nReconfigure _dictionary_valid attribures into lists, and reset the\nattribute application criteria at the rear of the DDL dictionary.',
          '3.8.03',
          '2011-06-22',
          '\nChange IMPORT_LIST to IMPORT_TABLE. Change the IMPORT arguments to\nmatch this. Change the import_list.id invocations to import_table\nequivalents. Add _enumeration_set.table_tag.',
          '3.8.04',
          '2011-06-23',
          '\nRemove IMPORT_TABLE. Change the IMPORT to a set category.\nInsert a import.get attribute to replace import_table.id\nRename the DDL_ATTR category as ATTRIBUTES',
          '3.8.05',
          '2011-06-27',
          '\nChange the _name.category_id value to reflect the parent category.',
          '3.8.06',
          '2011-06-29',
          '\nChange Reference in _type.purpose to Ref-key',
          '3.8.07',
          '2011-06-30',
          '\nChange Reference in _definition.class to Ref-loop.\nRemove import from type.contents and insert enumeration_set list.\nInsert name.category_id into every category definition.',
          '3.8.08',
          '2011-07-28',
          '\nAdd name.category_id and name.object_id to category definitions.\nRemove category.parent_id from category definitions.\nRemove definitions for category.parent_id and the CATEGORY_KEY\nand CATEGORY_MANDATORY definitions. Define category.key_id',
          '3.8.08',
          '2011-08-15',
          '\nAdd the state "Extend" to the type.purpose" attribute.',
          '3.9.01',
          '2011-12-08',
          '\nAdd types "Array" and "Matrix" to type.container attribute definition.\nAdd type "Su" to the type.purpose attribute definition.',
          '3.9.02',
          '2012-01-25',
          '\nFor import.get change the key "fram" to "save".',
          '3.10.01',
          '2012-05-07',
          '\nRevamp the type.purpose states. Remove state "Limit"\nAdd the new attribute type.source\nChange dictionary.class "Attribute" to "Reference"\nRemoved attribute enumeration_set.construct',
          '3.10.02',
          '2012-10-16',
          '\nCorrect enum states for type.contents and type.container',
          '3.10.03',
          '2012-11-20',
          '\nRemove "Implied" as an enumeration state for type.contents',
          '3.10.04',
          '2013-02-12',
          '\nAdded missing loop statement to methods of dictionary_valid.application.\nCorrected the definition of the enumeration state \'Code\' in type.contents.',
          '3.10.05',
          '2013-02-22',
          '\nAdd state value to enum_set loop of import.get defn as the key',
          '3.10.06',
          '2013-02-25',
          '\nRemove the quotes from Multiple string in type.container definition\nAdd \'Functions\' to the enumeration states of definition.class',
          '3.10.07',
          '2013-03-03',
          '\nAdded type.contents enum state "Implied" for category key definitions',
          '3.10.08',
          '2013-03-06',
          '\nAdded various attributes to conform with ALIGN requirements',
          '3.11.01',
          '2013-04-11',
          '\nAdded type.source to all definitions\nChange type.contents state "Table" to "Pairs"',
          '3.11.02',
          '2013-04-16',
          '\nRemoved \'Measured\' as a state for type.source',
          '3.11.03',
          '2013-04-24',
          '\n   Changed type.source \'Quantity\' to \'Number\' or \'Encode\'\n   State \'Float\' in type.contents removed.' ] ] ] ] ]

  ; }

function cif_dict() {  return new ddlm_dic(); }

if (typeof require !== 'undefined' && typeof exports !== 'undefined') {
   exports.ddlm_dic = ddlm_dic;
   exports.cif_dict = cif_dict;
}
