c
                         PROGRAM ALIGN
c
c      Version 19 April 2013   Author: sydney.hall@uwa.edu.au
c
c----- Align the tags & values in a Star file with definitions in  
c      an input reference dictionary. Additionally, write an aligned' 
c      star file as *.aln. The input star file may also be a dictionary.
c
      include 'align.cmn'
c
      character pcodes*20,c*1
c
      case=ichar('a')-ichar('A')
      tab=char(05)
      if(case.lt.0) goto 2  
      tab=char(09)
2     continue
c
      maxc=256
c------------------------- read control print codes & excluded states
c
      open(7,file='XALIGN',status='old',form='formatted')
      read(7,'(a20)',end=50) pcodes
      do 4 i=1,10
4     read(7,'(a20)',end=50) xstat(i)
c
      o=.false.
      t=.false.
      d=.false.
      r=.false.
      g=.false.
      s=.false.
      p=.false.
      w=.false.
      u=.false.
      do 10 i=1,20
      c=pcodes(i:i)
      if(c.eq.'o') o=.true.
      if(c.eq.'t') t=.true.
      if(c.eq.'d') d=.true.
      if(c.eq.'r') r=.true.
      if(c.eq.'g') g=.true.
      if(c.eq.'s') s=.true.
      if(c.eq.'p') p=.true.
      if(c.eq.'w') w=.true.
      if(c.eq.'u') u=.true.
10    continue
      close(7)
c                                   get current date/time
      call date_and_time(DATE=date,TIME=time)
      date=date(1:4)//'-'//date(5:6)//'-'//date(7:8)
      time=time(1:2)//':'//time(3:4)
c
50    write(*,'(/4(1H<),3a,4(1H>)/)')
     * ' ALIGN - Align STAR file with dictionary definitions   ',
     * time(1:6),date(1:11)

c-------------------------- read dic file; extract tags & properties
c
      open(2,file='alidict',status='old',form='formatted')
c
      mode=1
      call DICT
c
      close(2)
c
c-------------------------- read star file; align tags & values       
c
      open(2,file='alistar',status='old',form='formatted')
      if(o) open(7,file='alostar',status='new',form='formatted')
c
      mode=2
      call CHECK
c
      close(2)
      close(7)
      end
c
c***************************************************************************
      subroutine DICT
c***************************************************************************
c
c ---- read, parse and store the dictionary classes and items
c
      include 'align.cmn'
c
      integer i,j,k,l,n,m,enumc,enums,aliasc,aliast
      integer enu1,enu2
      character*60 name1,name2,class,att(50)
      character*256 lcase,c
c
      natt=0
      ikey=0
      slev=0
      n=0
      m=0
      flag=0
      nsav=0
      ncat=0
      catf=0
      ichr=maxc
      enum=0
      vnum=0
      enumc=0
      enums=0
      enum=0
      enu1=0
      enu2=0
      tvord=0
      aliasc=0
      aliast=0
      state=' '
      do 1 i=1,900
      cnam(i)=' '
      knam(i)=' '
      pnam(i)=' '
      clen(i)=0
1     continue
      do 3 i=1,2000
      purp(i)=' '
      tent(i)=' '
      tain(i)=' '
      sour(i)=' '
      dimn(i)=' '
      edef(i)=' '
      unit(i)=' '
      meth(i)=' '
      endi(i)=' '
      emin(i)=-9.e+10
      emax(i)=+9.e+10
      do 2 j=1,10
2     dtag(i,j)=' '
3     continue
c
c==================== get and store attribute values for all tags
c
10    call GETTOK
      if(ieof.eq.1) goto 600 
c
      if(token.ne.'tag') goto 100
c
c ++++++++++++++++++++++ TAGS +++++++++++++++++++++++++
c
c                      if enum_set find .state order in loop
c
11    if(stri(1:16).ne.'_enumeration_set') goto 12
      flag=13
      enumc=enumc+1
      if(stri(17:22).eq.'.state') enums=enumc
      goto 10
12    if(flag.eq.13) flag=0
c
c                      if alias. find .definition_id order in loop
c
      if(stri(1:6).ne.'_alias')  goto 14
      flag=14
      aliasc=aliasc+1
      if(stri(7:20).eq.'.definition_id') aliast=aliasc
      goto 10
14    if(flag.eq.14) flag=0
c
50    continue
      if(stri(1:17).eq.'_definition.scope')     flag=1
      if(stri(1:14).eq.'_definition.id')        flag=2
      if(stri(1:17).eq.'_definition.class')     flag=3
      if(stri(1:15).eq.'_name.object_id')       flag=4
      if(stri(1:16).eq.'_category.key_id')      flag=5
      if(stri(1:17).eq.'_name.category_id')     flag=6
      if(stri(1:14).eq.'_type.contents')        flag=7
      if(stri(1:15).eq.'_type.container')       flag=8
      if(stri(1:13).eq.'_type.purpose')         flag=9
      if(stri(1:17).eq.'_dictionary.title')     flag=10
      if(stri(1:19).eq.'_dictionary.version')   flag=11
      if(stri(1:16).eq.'_dictionary.date')      flag=12
c                                                      see above 13, 14
      if(stri(1:12).eq.'_type.source')          flag=15
      if(stri(1:20).eq.'_enumeration.default')  flag=16
      if(stri(1:18).eq.'_enumeration.range')    flag=17
      if(stri(1:11).eq.'_units.code')           flag=18
      if(stri(1:11).eq.'_import.get')           flag=19
      if(stri(1:15).eq.'_type.dimension')       flag=20
      if(stri(1:18).eq.'_method.expression')    flag=21
      if(stri(1:25).eq.'_enumeration.def_index_id') flag=22
c
c                       check for duplicate attribute tags
c
      c=stri(1:nchr)
      do 60 i=1,natt
60    if(c.eq.att(i)) goto 65
      natt=natt+1
      att(natt)=c
      goto 10
65    write(6,'(a,i5,2a)')' line',line,
     * ' *** Duplicate attribute flag in dictionary  ',c
      stop
c
c
c +++++++++++++++ VALUES +++++++++++++++++++++++++
c
100   if(flag.eq.0) goto 10
      lstr=lcase(stri(1:nchr),nchr)
c
c ------------------------------------1 defn scope (dic, cat or item)
      if(flag.ne.1) goto 130
      if(lstr(1:10).eq.'dictionary') catf=2
      if(lstr(1: 8).eq.'category')   catf=1
      if(catf.eq.0) goto 500
      ncat=ncat+1 
      if(ncat.le.900) goto 120
      write(6,'(a)')' ALIGN arrays for categories > 900; recompile'
      stop
120   pnam(ncat)=' '
      ikey=0
      goto 500
c
c ------------------------------------2 defined item name
130   if(flag.ne.2) goto 140
      ntag(nsav)=1
      name2=lstr
      jchr=nchr
      goto 500
c
c ------------------------------------3 definition class
140   if(flag.ne.3) goto 160
      class=lstr 
      goto 500
c
c ------------------------------------4 object id
160   if(flag.ne.4) goto 180
      scat(nsav)=ncat
      dtag(nsav,1)=name2
      ltag(nsav,1)=jchr
      name1=name2(2:jchr)
      if(catf.eq.0) goto 164
      cnam(ncat)=lstr(1:nchr)
      clen(ncat)=nchr
      clas(ncat)=class
      name1=name2
164   l=ltag(nsav,1)
      if(snam(nsav)(1:l).eq.name1) goto 500
      write(6,'(a,3(i5,x,a))')" save-name mismatch defn id ",
     * slen(nsav),snam(nsav)(1:l),l,name1(1:l),catf
      goto 500
c
c ------------------------------------5 cat key name
180   if(flag.ne.5) goto 190
      if(clas(ncat).eq.'loop')     goto 185
      if(clas(ncat).eq.'ref-loop') goto 185
      write(6,'(a,i5,a/)')' line',line,
     * '  ** Only loop and ref-loop categories require key tag'
      stop
185   ikey=1
      knam(ncat)=lstr(1:nchr)
      goto 500
c
c ------------------------------------6 cat name
190   if(flag.ne.6) goto 210
      if(catf.eq.0) goto 500
      pnam(ncat)=lstr 
      goto 500
c
c ------------------------------------7 type contents          
210   if(flag.ne.7) goto 215   
      tent(nsav)=lstr
      goto 500
c
c ------------------------------------8 type container         
215   if(flag.ne.8) goto 220   
      tain(nsav)=lstr
      goto 500
c
c ------------------------------------9 type purpose        
220   if(flag.ne.9) goto 230   
      purp(nsav)=lstr
      goto 500
c
c ------------------------------------10 dictionary title  
230   if(flag.ne.10) goto 240   
      dnam=stri(1:nchr)
      goto 500
c
c ------------------------------------11 dictionary version
240   if(flag.ne.11) goto 250   
      dver=stri(1:nchr)
      goto 500
c
c ------------------------------------12 dictionary date  
250   if(flag.ne.12) goto 260   
      ddat=stri(1:nchr)
      write(6,'(a,3(x,a)/)')
     * '---- Loading the reference dictionary',dnam,dver,ddat
      goto 500
c
c ------------------------------------13 enumeration_set
260   if(flag.ne.13) goto 280  
      if(vnum.eq.enumc) vnum=0
      vnum=vnum+1
      if(vnum.ne.enums) goto 10
      enum=enum+1
      enu1=enu2+1
      enu2=enu2+nchr+1      
      if(enu2.le.10000) goto 270
      write(6,'(a)')' ALIGN array for states > 10000; recompile'
      stop
270   stat1(enum)=enu1
      stat2(enum)=enu2
      state(enu1:enu2)=lstr(1:nchr)
cdbg  write(6,'(a,4i5,x,a)')'&&&&',nsav,enumc,enu1,enu2,lstr(1:nchr)
      goto 10
c
c ---------------------------------- 14 alias definition id
280   if(flag.ne.14) goto 290
      n=n+1
      if(n.gt.aliasc) n=1
      if(n.ne.aliast) goto 10
      m=ntag(nsav)+1
      if(m.le.10)   goto 282
      write(6,'(a,i5,a/)')' line',line,
     * '  ** ALIGN can process only 9 aliases per definition'
      goto 10
282   ntag(nsav)=m
      dtag(nsav,m)=lstr(1:nchr)
      ltag(nsav,m)=nchr
      goto 10
c
c ------------------------------------15 type source        
290   if(flag.ne.15) goto 300   
      sour(nsav)=lstr
      goto 500
c
c ------------------------------------16 enumeration default
300   if(flag.ne.16) goto 320   
      edef(nsav)=lstr
      if(type.ne.'text') goto 500
      write(6,'(a,i5,a/)')' line',line,
     *"  ** Default must be 'code' or 'number', not 'text'"
      goto 500
c
c ------------------------------------17 enumeration range 
320   if(flag.ne.17) goto 340   
      call RANGE(lstr,emin(nsav),emax(nsav))
      goto 500
c
c ------------------------------------18 units code        
340   if(flag.ne.18) goto 360   
      unit(nsav)=lstr
      if(type.eq.'code') goto 500
      write(6,'(a,i5,a/)')' line',line,
     *"  ** _units.code must be a 'code' string, not 'text'"
      goto 500
c
c ------------------------------------19 import.get       
360   if(flag.ne.19) goto 380   
      write(6,'(a,i5,3x,a/)')' line',line,
     *' *** _import.get detected: MUST use expanded dictionary'
      goto 500
c
c ------------------------------------20 type dimension
380   if(flag.ne.20) goto 400
      dimn(nsav)=lstr
      goto 500
c
c ------------------------------------21 first method.purpose
400   if(flag.ne.21) goto 420
      meth(nsav)=lstr
      goto 500
c
c ------------------------------------22 enum default_index    
420   if(flag.ne.22) goto 440
      if(type.eq.'name') goto 425
      write(6,'(a,i5,a/)')' line',line,
     *"  ** _enumeration.def_index_id must be a data name",lstr(1:nchr)
425   endi(nsav)=lstr
      goto 500
c
440   continue
c
c==================================================================
c
500   continue
      flag=0
      m=0
      n=0
      aliasc=0
      aliast=0
      enumc=0
      enums=0
      vnum=0
      goto 10
c
600   continue
c
      write(6,'(5x,a/)')'Checking attributes in reference dictionary'
      if(slev.eq.0) goto 700
      write(6,'(a,i5,a,i3/)')' line',line,
     * '  ** Save frame count at close of dictionary nonzero',slev
      stop
c======================  check stored dic info for missing attributes
700   continue
      j=0
      k=0
      do 800 i=1,nsav
      c=dtag(i,1)
      l=ltag(i,1)
      if(c(1:1).ne.'_')      goto 800
      if(purp(i).ne.' ')     goto 710
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _type.purpose'
c
710   if(cnam(1)(1:4).eq.'attr') goto 720
      if(sour(i).ne.' ')      goto 720
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _type.source'
c
720   if(tain(i).ne.' ')      goto 730
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _type.container'
c
730   if(tent(i).ne.' ')         goto 740
      if(sour(i).eq.'assembled') goto 740
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _type.content'
c
740   if(tain(i).eq.'list')   goto 750
      if(tain(i).eq.'matrix') goto 750
      if(tain(i).ne.'table')  goto 760
750   if(dimn(i).ne.' ')      goto 760
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _type.dimension'
c
760   if(purp(i).eq.'state')  goto 765
      if(tent(i).eq.'real')   goto 765
      if(tent(i).eq.'count')  goto 765
      if(tent(i).eq.'integer')goto 765
      if(tent(i).ne.'index')  goto 770
765   if(tain(i).eq.'list')   goto 770
      if(tain(i).eq.'matrix') goto 770
      if(tain(i).eq.'table')  goto 770
      if(edef(i).ne.' ')      goto 770
      if(meth(i).ne.' ')      goto 770
      if(endi(i).ne.' ')      goto 770
      if(emin(i).ge.-8.e+10)  goto 770
      if(emax(i).le.+8.e+10)  goto 770
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _enumeration.default'
c
770   if(tent(i).ne.'real')   goto 780
      if(unit(i).ne.' ')      goto 780
      if(tain(i).eq.'matrix') goto 780
      if(tain(i).eq.'table')  goto 780
      if(meth(i)(1:1).eq.'d') goto 780
      j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _units.code'          
c
780   if(tent(i).eq.'real')   goto 785
      if(tent(i).eq.'count')  goto 785
      if(tent(i).eq.'integer')goto 785
      if(tent(i).ne.'index')  goto 795
785   if(tain(i).eq.'list')   goto 795
      if(tain(i).eq.'matrix') goto 795
      if(tain(i).eq.'table')  goto 795
      if(emin(i).gt.-8.e+10)  goto 795
      if(emax(i).le.+8.e+10)  goto 795
      if(endi(i).ne.' ')      goto 795
      if(edef(i).ne.' ')      goto 795
790   j=j+1
      write(6,'(x,2a)')c(1:l),'  defn is missing a _enumeration.range'   
c
795   if(j.gt.k) write(6,'(x)') 
      k=j
800   continue
      if(k.gt.0) write(6,'(i9,a/)')k,' dictionary alerts issued!'
c
c======================  check stored dic categories for consistency
      do 900 i=1,ncat
      c=cnam(i)
      l=clen(i)
      if(clas(i).eq.'loop')       goto 860
      if(clas(i).ne.'ref-loop')   goto 870
860   if(knam(i)(1:1).ne.' ')     goto 870
      write(6,'(2a/)')'  ** Key missing Loop/Refloop from ',c(1:l)      
c
870   if(knam(i)(1:1).eq.' ')     goto 900
      c=knam(i)
      do 890 j=1,nsav
      l=ltag(j,1)
      if(c.ne.dtag(j,1)(1:l))     goto 890
      kcat(j)=i
      goto 900
890   continue
      write(6,'(2a/)')' ** Key tag undefined in dictionary: ',c(1:40)
900   continue
c
c=======================================================================
c
1000  continue
      if(d)write(6,'(3i3,x,a,x,a,x,a)')(i,scat(i),slen(i),snam(i)(1:40),
     * cnam(scat(i))(1:30),pnam(scat(i))(1:30),i=1,nsav)
      if(d)write(6,'(5(x,a))')((dtag(i,j)(1:30),j=1,5),i=1,nsav)
      if(d)write(6,'(a)') state(1:enu2)
      if(d)write(6,'(3i5)')(i,stat1(i),stat2(i),i=1,enum)
      if(d)write(6,'(/3a/)')' ntag ncat statp     definition tag     ',
     *'TYPES.. purpose  container  content     source    dimension ',
     *' en.default   units    e.min en.max   key meth def-i'
      if(d)write(6,'(3i5,x,a,x,a,x,a,x,a,x,a,x,a,x,a,x,a,2f6.1,
     * i6,x,a3,x,a3)')
     * (i,scat(i),statp(i),dtag(i,1)(1:30),purp(i)(1:10),
     * tain(i)(1:10),tent(i)(1:10),sour(i)(1:10),dimn(i)(1:10),
     * edef(i)(1:10),unit(i)(1:10),emin(i),emax(i),kcat(i),
     * meth(i),endi(i),i=1,nsav)
      if(d)write(6,'(2i5,x,a,x,a,x,a,x,a)')(i,clen(i),pnam(i)(1:20),
     * cnam(i)(1:20),clas(i)(1:10),knam(i)(1:30),i=1,ncat)
c
      return
      end
c
c
c
c
c
c
c
c
c
c
c
c
c***************************************************************************
      subroutine CHECK
c***************************************************************************
c
c ---- convert input star file into fully aligned star file
c
      include 'align.cmn'
      integer i,j,k,l,n,m,loopl(100),iloop,jloop,loopt(100),loopc(100)
      integer tp1,tp2,ita,ite,iso,ipu,mcat,mdef,metd,mval,mdfn,meva,imet
      integer popcc(15,25),popsp(15,25),popcp(15,25)
      character*60 ktag,sval,att(1000),dt
      character*256 lcase,c
      character alf*37,ver*11,ran*14,num*16,su*3,dash*20
      character ta*28,te*84,so*20,pu*56,te1*48,te2*36,pu1*36,pu2*20
      character xcc(22)*7,xsp(15)*4,tem*100,xcp(22)*15,puc(15)*5
      character*10 taa(8),tee(22),soo(5),puu(15)
      data alf/'abcdefghijklmnopqrstuvwxyz_0123456789'/
      data ver/'0123456789.'/
      data ran/'0123456789+-.:'/,num/'0123456789+-.e()'/
      data ta /'singmultlistarramatrtablref-'/
      data te1/'textcodenametag fileuri dateversdimerangcouninde'/
      data te2/'interealimagcompbinahexaoctaimplsymo'/
      data so /'recoassireladeri    '/     
      data pu1/'impomethaudiidenextedescencostatkey '/
      data pu2/'linkcompnumbmeassu  '/
      data taa/' Single   ','Multiple  ','  List    ','  Array   ',
     *         ' Matrix   ','  Table   ','Ref-table ',' TOTAL    '/
      data tee/'      Text','      Code','      Name','       Tag',
     *         '  Filename','       Uri','      Date',
     *         '   Version',' Dimension','     Range','     Count',
     *         '     Index','   Integer','      Real',
     *         '      Imag','   Complex','    Binary','Hexadecima',
     *         '     Octal','   Implied','~~~~ Symop','     TOTAL'/
      data soo/'Recorded  ',' Assigned ','  Related ',
     *         '  Derived ',' TOTAL    '/
      data puu/'    Import','    Method','     Audit','  Identity',
     *         '    Extend','  Describe','    Encode','     State',
     *         '       Key','      Link',' Composite','    Number',
     *         ' Measurand','        SU','     TOTAL'/
      data puc/' Impo',' Meth',' Audt',' Iden',' Exte',
     *         ' Desc',' Ncod',' Stat','  Key',' Link',
     *         ' Comp',' Numb',' Meas','   SU',' TOTL'/
      data xcc/'1110000','1110011','1110011','1110000','1000000',
     *         '1000000','1000000','1000000','1000000',
     *         '1000000','1000000','1010000','1011111',
     *         '1011111','1011111','1011111','1011111','1011111',
     *         '1011111','1000000','1000000','1111111'/
      data xsp/'0100','0100','0100','0100','0100',
     *         '1100','1100','0100','0110','0110',
     *         '1101','1101','1001','1001','1111'/
      data xcp/'011011100000001','101110111110001','001110001100001',
     *         '001110001100001','001110001100001','001110001100001',
     *         '001010100000001','001010101000001',
     *         '000010101000001','000010100000001','000010000011111',
     *         '000010000111111','000010000011111',
     *         '000010000011111','000010000011111','000010000011111',
     *         '000010000011111','000010000011111','000010000011111',
     *         '000011111111111','000000000010001','111111111111111'/
      data dash /'--------------------'/
c
      te=te1//te2
      pu=pu1//pu2
      ita=0
      ite=0
      iso=0
      ipu=0
      do 2 i=1,15
      do 2 j=1,25
      popcc(i,j)=0
      popcp(i,j)=0
2     popsp(i,j)=0
      infile='inst'
      ichr=maxc
      ieof=0
      natt=0
      line=0
      ksum=0
      slev=0
      flag=0
      mdef=0
      mcat=0
      metd=0
      mval=0
      mdfn=0
      meva=0
      mimp=0
      tvord=0
      iloop=0
      write(6,'(/a/)')'---- Loading STAR file and starting checks'
      write(6,'(a/4(5x,a/))')
     *"     Alerts, with line numbers, indicate...",
     *"        *  is low level warning eg. value mismatches item type",
     *"       **  is med level warning eg. data tag not in dictionary",
     *"      ***  is top level warning eg. duplicated data tag in cell",
     *"     ****  is FATAL error in Star syntax or in file structure  "
c
c========================= read the star file and check the values   
c
10    call GETTOK
      if(ieof.eq.1)      goto 2000
c
      if(infile.ne.'dict')    goto 20
      if(token.ne.'   ')      goto 20
c
      if(ita.eq.0.or.ite.eq.0)      goto 12
      if(xcc(ite)(ita:ita).eq.'0')  write(6,'(i5,a/)')line,
     * ' *** TYPE container-content combination in defn unexpected'
      popcc(ita,ite)=popcc(ita,ite)+1
      popcc(  8,ite)=popcc(  8,ite)+1
      popcc(ita, 22)=popcc(ita, 22)+1
      popcc(  8, 22)=popcc(  8, 22)+1
c
12    if(iso.eq.0.or.ipu.eq.0)      goto 14
      if(xsp(ipu)(iso:iso).eq.'0')  write(6,'(i5,a/)')line,
     * ' *** TYPE source-purpose combination in defn unexpected'
      popsp(iso,ipu)=popsp(iso,ipu)+1
      popsp(  5,ipu)=popsp(  5,ipu)+1
      popsp(iso, 15)=popsp(iso, 15)+1
      popsp(  5, 15)=popsp(  5, 15)+1
c
14    if(ite.eq.0.or.ipu.eq.0)      goto 16
      if(xcp(ite)(ipu:ipu).eq.'0')  write(6,'(i5,a/)')line,
     * ' *** TYPE content-purpose combination in defn unexpected'
      popcp(ipu,ite)=popcp(ipu,ite)+1
      popcp( 15,ite)=popcp( 15,ite)+1
      popcp(ipu, 22)=popcp(ipu, 22)+1
      popcp( 15, 22)=popcp( 15, 22)+1
16    continue
      ita=0
      ite=0
      iso=0
      ipu=0
      imet=0
      goto 10
c
20    if(token.ne.'tag') goto 500
c
c ++++++++++++++++++++++ TAGS +++++++++++++++++++++++++
c
c                           is the star file also a dictionary?
      if(stri(1:11).eq.'_import.get'   )    mimp=mimp+1
      if(stri(1:14).eq.'_definition.id')    mdef=mdef+1
      if(stri(1:17).eq.'_definition.scope') mcat=mcat+1
      if(stri(1:15).ne.'_method.purpose')   goto 25
      metd=metd+1
      imet=1
c
25    if(infile.eq.'dict')    goto 30
      if(stri(1:17).eq.'_dictionary.title')    flag=1  
      if(stri(1:19).eq.'_dictionary.version')  flag=2  
      if(stri(1:16).eq.'_dictionary.date')     flag=3  
c
c--------------------------------------- is tag in dictionary?
c
30    lstr=lcase(stri(1:nchr),nchr)
      c=lstr(1:nchr)
      l=nchr
      su='no'
      tp1=ibuf
      tp2=jbuf-1
32    continue
      do 50 i=1,nsav
      if(l.ne.ltag(i,1))                 goto 35
      if(c(1:l).ne.dtag(i,1)(1:nchr))    goto 35
      goto 100
c                              tag not found; check aliases
35    n=ntag(i)
      do 40 j=2,n
      if(l.ne.ltag(i,j))                 goto 40
      if(c(1:l).ne.dtag(i,j)(1:nchr))    goto 40
      goto 90
40    continue
50    continue
c                      also not an alias tag; check if <tag>_su
      if(su.eq.'yes')             goto 70
      if(c(nchr-2:nchr).ne.'_su') goto 70
      su='yes'
      c=lstr(1:nchr-3)
      l=nchr-3
      goto 32
c
70    it=0
      write(6,'(i5,2a/)')line,
     * ' *** Tag not defined in dictionary  ',lstr(1:nchr)
      goto 200
c                                              alias replaced!      
90    if(su.eq.'yes') goto 100
      l=ltag(i,1)
      write(6,'(i5,4a/)')line,
     *'  ** Alias tag ',c(1:nchr),'  replaced by  ',dtag(i,1)(1:l)
      nchr=ltag(i,1)
      lstr(1:nchr)=dtag(i,1)
c                                          also overwrite buffer
      k=jbuf-lbuf
      if(k.lt.l)    goto 95
      buf(ibuf:jbuf-1)=dtag(i,1)
      goto 100
95    buf(ibuf:ibuf+l-1)=dtag(i,1)
      ichr=ibuf+l
c                                   save tag and cat pointers to dic
100   it=i
      if(su.eq.'no')              goto 200
      if(purp(it).eq.'measurand') goto 200
      write(6,'(i5,2a/)')line,
     *" *** SU tag not defined as 'measurand'  ",lstr(1:nchr)
c
c                                      are these tags in a loop?
200   if(loop.lt.2)         goto 300
      iloop=iloop+1
      loopt(iloop)=it
      ksum=ksum+kcat(it)
      ic=scat(it)
cdbg  write(6,'(4i5,a,x,a)')iloop,it,ic,jc,clas(ic)(1:9),c(1:l)
      if(clas(ic).eq.'loop')        goto 210
      if(clas(ic).eq.'ref-loop')    goto 210
      write(6,'(i5,2a/)')line,
     *" *** Item in loop_ not defined in 'loop' cat   ",lstr(1:nchr)
210   continue
      if(iloop.eq.1) jc=ic
      if(ic.eq.jc)             goto 400
      write(6,'(i5,2a/)')line,
     *" *** Items in loop_ defined in different cats  ",lstr(1:nchr)
      goto 400
c
c                                item not in loop; check if should be!
300   continue
      ic=scat(it)
      if(clas(ic).eq.'loop')        goto 310
      if(clas(ic).ne.'ref-loop')    goto 400
310   write(6,'(i5,2a/)')line,
     *" *** Unlooped item is defined in 'loop' cat   ",lstr(1:nchr)
c
c                                        check for duplicate tags
400   c=lstr(1:nchr)
      do 410 i=1,natt
410   if(c.eq.att(i)) goto 420
      natt=natt+1
      if(natt.le.1000) goto 415
      write(6,'(a)')' ALIGN array for star tags > 1000; recompile'
      stop
415   att(natt)=c
      goto 10
420   write(6,'(i5,2a/)')line,
     * ' *** Duplicate tag in the input Star file  ',c(1:nchr)
      goto 10
c
c
c ++++++++++++++++++++++ VALUES +++++++++++++++++++++++++
c
500   continue              
      lstr=lcase(stri(1:nchr),nchr)
c
      if(imet.eq.0.or.type.ne.'code')  goto 501
      if(lstr(1:10).eq.'evaluation') meva=meva+1
      if(lstr(1:10).eq.'validation') mval=mval+1
      if(lstr(1:10).eq.'definition') mdfn=mdfn+1
c       
c                              if file is dic extract details
501   if(infile.eq.'dict')   goto 502
      if(flag.eq.1) dnam=stri(1:nchr)
      if(flag.eq.2) dver=stri(1:nchr)
      if(flag.ne.3)          goto 502
      ddat=stri(1:nchr)
      infile='dict'
c
c                              in loops, 'it' is used to id tags
502   flag=0
      if(type.ne.'loop') goto 505
      iloop=0
      jloop=0
      goto 10
505   if(loop.eq.0)       goto 510
      if(jloop.eq.iloop) jloop=0
      jloop=jloop+1
      it=loopt(jloop)
cdbg  write(6,'(a,3i5,x,a)')' loop....',iloop,jloop,it,dtag(it,1)
c
c           test value against its defined TYPE  
c
510   if(it.eq.0)          goto 10
      if(stri(1:1).eq.'?') goto 10
c
c================================================  TYPE.PURPOSE
      sval=purp(it)
      c=lstr(1:nchr)
c                                           +++++++ if 'state'
      if(sval.ne.'state')  goto 570
      if(infile.eq.'inst') goto 550
c
c     --------------------------------- get dic state pointers
      dt=dtag(it,1)
520   if(dt.ne.'_type.container') goto 525
      ita=(index(ta,c(1:4))+3)/4
      if(ita.ne.0)                goto 540
      write(6,'(i5,2a/)')line,
     * "   * TYPE container value not recognised   ", c(1:12)
      goto 540
525   if(dt.ne.'_type.contents')  goto 530
      j=1
      if(c(1:4).eq.'list') j=6
      if(c(1:4).eq.'matr') j=8
      ite=(index(te,c(j:j+3))+3)/4
      if(ite.ne.0)                goto 540
      write(6,'(i5,2a/)')line,
     * "   * TYPE contents value not recognised   ", c(1:12)
      goto 540
530   if(dt.ne.'_type.source')    goto 535
      iso=(index(so,c(1:4))+3)/4
      if(iso.ne.0)                goto 540
      write(6,'(i5,2a/)')line,
     * "   * TYPE source value not recognised   ", c(1:12)
      goto 540
535   if(dt.ne.'_type.purpose')   goto 540
      ipu=(index(pu,c(1:4))+3)/4
      if(ipu.ne.0)                goto 540
      write(6,'(i5,2a/)')line,
     * "   * TYPE purpose value not recognised   ", c(1:12)
540   continue
cdbg  write(6,'(4i3,x,a,x,a)') ita,ite,iso,ipu,dt(1:20),c(1:10)
c
550   continue
      do 555 i=1,nchr
      if(lstr(i:i).eq.',') goto 600
555   if(lstr(i:i).eq.'(') goto 600
      is=statp(it-1)+1
      ie=statp(it)
      do 560 i=is,ie
      j=stat1(i)
      k=stat2(i)-1
cdbg  write(6,'(4i5,2(x,a))')it,i,j,k,state(j:k),c
      if(state(j:k).eq.c) goto 600
560   continue
      do 565 i=1,10
565   if(c(1:20).eq.xstat(i)(1:20)) goto 600
      write(6,'(i5,2a/)')line,
     * ' *** Enumeration state not in dict    ',c(1:nchr)
      goto 600
c
c                                          +++++++ if 'describe'
570   if(sval.ne.'describe') goto 580
      if(type.eq.'text')     goto 600
      if(type.eq.'code')     goto 600
      write(6,'(i5,2a/)')line,
     * "   * TYPE describe value must be 'text' or 'code'   ",type            
      goto 600
c
c                                          +++++++  if 'key'
580   if(sval.ne.'key')      goto 590
      ic=scat(it)
      ktag=knam(ic)
      goto 600
c
c                                          +++++++ if 'measurand'
590   if(sval.ne.'measurand') goto 600
      if(type.eq.'numb')      goto 600                
      write(6,'(i5,2a/)')line,
     * '  ** TYPE measurand value must be number; found   ',c(1:nchr)
      goto 600
c
c================================================  TYPE.CONTAINER
600   continue
      sval=tain(it)
      l=nchr
c
      if(sval.eq.'list')     goto 610
      if(sval.eq.'matrix')   goto 610
      if(sval.eq.'array')    goto 610
      if(sval.ne.'table')    goto 620
610   if(type.eq.'list')     goto 620
      write(6,'(i5,2a/)')line,
     * '  ** Value defined as list/matrix/table; found ',type
      goto 650
c
620   if(sval.eq.'ref-table')goto 625
      if(sval.ne.'table')    goto 630
625   if(lstr(l:l).eq.'}')   goto 650
      write(6,'(i5,a/)')line,
     * "  ** Table value must terminate with '}'"
      goto 650
c
630   if(sval.eq.'list')     goto 640
      if(sval.eq.'matrix')   goto 640
      if(sval.ne.'array')    goto 650
640   if(lstr(l:l).eq.']')   goto 650
      write(6,'(i5,a/)')line,
     * "  ** TYPE List/matrix/array value must terminate with ']'"
      goto 650
c
c================================================  TYPE.CONTENTS 
650   continue
      if(sval.eq.'list')     goto 1000
      if(sval.eq.'matrix')   goto 1000
      if(sval.eq.'array')    goto 1000
      if(sval.eq.'table')    goto 1000
c
      sval=tent(it)
      c=lstr(1:nchr)
      l=nchr
c
      if(sval.eq.'implied')  goto 1500
c
      if(sval.ne.'text')     goto 655
      if(type.eq.'text')     goto 655
      if(type.eq.'code')     goto 655
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'text' value found to be type    ",type
      goto 1000
c
655   if(sval.ne.'code')     goto 660
      if(type.eq.'code')     goto 660
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'code' value found to be type    ",type
      goto 1000
c
660   if(sval.ne.'name')     goto 665
      if(type.eq.'code')     goto 665
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'name' value found to be type    ",type
      goto 1000
c
665   if(sval.ne.'name')        goto 675
      do 670 i=1,l
670   if(index(alf,c(i:i)).eq.0) goto 672
      goto 1000
672   write(6,'(i5,2a/)')line,
     * "   * TYPE 'name' value contains illegal chars   ",c(1:l)
      goto 1000
c
675   if(sval.ne.'tag')      goto 680
      if(type.eq.'name')     goto 680
      if(type.eq.'code')     goto 680
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'tag' value found to be type    ",type
      goto 1000
c
680   if(sval.ne.'date')     goto 700
      if(type.eq.'numb')     goto 685
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'date' value found to be type    ",type
      goto 1500
685   if(c(5:5).ne.'-')      goto 690
      if(c(8:8).eq.'-')      goto 1500
690   write(6,'(i5,2a/)')line,
     * "   * TYPE 'date' contains illegal chars    ",c(1:l)
      goto 1500
c
700   if(sval.ne.'version')  goto 720
      if(type.eq.'numb')     goto 705 
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'version' value found to be type    ",type
      goto 1500
705   do 710 i=1,l
710   if(index(ver,c(i:i)).eq.0) goto 715
      goto 1500
715   write(6,'(i5,2a/)')line,
     * "   * TYPE 'version' value contains illegal chars   ",c(1:l)
      goto 1500
c
720   if(sval.ne.'dimension') goto 725
      if(type.eq.'list')      goto 725
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'dimension' value found to be type    ",type
      goto 1000
c
725   if(sval.ne.'dimension')  goto 730
      if(c(1:1).ne.'[')        goto 727
      if(c(l:l).eq.']')        goto 730
727   write(6,'(i5,2a/)')line,
     * "   * TYPE 'dimension' value must be bounded by []   ",c(1:l)
      goto 1000
c
730   if(sval.ne.'table')      goto 735
      if(c(1:1).ne.'{')        goto 732
      if(c(l:l).eq.'}')        goto 735
732   write(6,'(i5,2a/)')line,
     * "   * TYPE 'table' value must be bounded by {}   ",c(1:l) 
      goto 1000
c
735   if(sval.ne.'range')     goto 740
      if(type.eq.'numb')      goto 740
      if(c(1:1).eq.':')       goto 740
      write(6,'(i5,2a/)')line,
     * "   * TYPE 'range' value unexpected construction   ",c(1:l)
      goto 1000
c
740   if(sval.ne.'range')        goto 755
      do 745 i=1,l
745   if(index(ran,c(i:i)).eq.0) goto 750
      goto 1500
750   write(6,'(i5,2a/)')line,
     * "   * TYPE 'range' value contains illegal chars   ",c(1:l)
      goto 1500
c
755   if(sval.eq.'count')    goto 760
      if(sval.eq.'index')    goto 760
      if(sval.eq.'integer')  goto 760
      if(sval.eq.'real')     goto 760
      if(sval.eq.'imag')     goto 760
      if(sval.ne.'complex')  goto 850
760   if(type.eq.'numb')     goto 765
      if(type.eq.'list')     goto 765
      write(6,'(i5,2a/)')line,
     * "  ** Item defined as a number but found as   ",type
      goto 1000
c
765   if(sval.ne.'count')              goto 780
      do 770 i=1,l
770   if(index(num(1:10),c(i:i)).eq.0) goto 775
      goto 812
775   write(6,'(i5,2a/)')line,
     * "  ** TYPE 'count' value contains illegal chars   ",c(1:l)
      goto 1000
c
780   if(sval.ne.'index')              goto 795
      do 785 i=1,l
785   if(index(num(2:10),c(i:i)).eq.0) goto 790
      goto 812
790   write(6,'(i5,2a/)')line,
     * "  ** TYPE 'index' value contains illegal chars   ",c(1:l)
      goto 1000
c
795   if(sval.ne.'integer')            goto 810
      do 800 i=1,l
800   if(index(num(1:12),c(i:i)).eq.0) goto 805
      goto 812
805   write(6,'(i5,2a/)')line,
     * "  ** TYPE 'integer' value contains illegal chars   ",c(1:l)
      goto 1000
c
810   if(sval.eq.'real')               goto 812
      if(sval.ne.'imag')               goto 812
812   do 815 i=1,l
815   if(index(num,c(i:i)).eq.0)       goto 820
      call NUMBER(c(1:l),val,suv)
cdbg  write(6,'(a,2f10.6,x,a,x,a)')' NUMB:',val,suv,purp(it)(:9),c(1:l)
      if(suv.lt.0.)                    goto 850
      if(purp(it)(1:9).eq.'measurand') goto 825
      write(6,'(i5,2a/)')line,
     * " *** An SU value detected for a non-measurand item  ",c(1:l)
      goto 1000
820   write(6,'(i5,2a/)')line,
     * "  ** TYPE 'Real' number contains illegal chars   ",c(1:l)
      goto 1000
c
c ------------------------------- output tag and tag_su separate lines
825   if(.not.u)         goto 1000
      if(.not.o)         goto 1000
cdbg  write(6,'(a,5i5)')' =========SUV1:',tp1,tp2,ibuf,jbuf,mchr
      if(loop.ne.0)      goto 850
      write(buf(ibuf:ibuf+19),'(f20.5)') val
cdbg  write(6,'(a,x,a)')' =========SUV2:',buf(1:80)
      write(7,'(a)') buf(1:80)
      buf(tp2+1:tp2+3)='_su'
      write(buf(ibuf:ibuf+19),'(f20.5)') suv
cdbg  write(6,'(a,x,a)')' =========SUV3:',buf(1:80)
      mchr=80
      ichr=maxc
      goto 1000
c
850   continue
c
c================================================  enumeration.range
1000  continue
      if(type.ne.'numb')      goto 1020
      if(tent(it).eq.'real')   goto 1010
      if(tent(it).eq.'imag')   goto 1010
      if(tent(it).eq.'count')  goto 1010
      if(tent(it).eq.'integer')goto 1010
      if(tent(it).eq.'index')  goto 1010
      write(6,'(i5,2a/)')line,
     * "  ** Number found when text/code value expected  ",c(1:l)
      goto 1020
1010  if(tain(it).eq.'list')   goto 1020
      if(tain(it).eq.'matrix') goto 1020
      if(tain(it).eq.'table')  goto 1020
      if(emin(it).gt.-8.e+10)  goto 1015
      if(emax(it).gt.+8.e+10)  goto 1020
1015  continue
cdbg  write(6,'(3f20.4)')val,emin(it),emax(it)
      if(val.ge.emin(it).and.val.le.emax(it)) goto 1020
      write(6,'(i5,2a/)')line,
     * "  ** Number found outside enumeration.range defn  ",c(1:l)
c
1020  continue
c
1500  continue
      goto 10
c
2000  continue
      if(slev.gt.0) write(6,'(i5,a,i3/)')line,
     * '**** Save frame imbalance at eof: too many opens',slev
      if(slev.lt.0) write(6,'(i5,a,i3/)')line,
     * '**** Save frame imbalance at eof: too many closes',slev
c
c --------------------------------print TYPE combination populations
2100  continue
      if(infile.ne.'dict')    goto 2500
      write(6,'(/a,3(x,a)/)')'---- Input STAR file is the dictionary',
     * dnam,dver,ddat
      write(6,'(i16,a )') mdef,'  Definitions composed of...'
      write(6,'(i22,a )') mcat,     '   Categories '
      write(6,'(i22,a/)') mdef-mcat,'   Items '
      write(6,'(i22,a )') metd,'  Method Loops containing...'
      write(6,'(i28,a )') meva,     '   Evaluation scripts'
      write(6,'(i28,a )') mdfn,     '   Definition scripts'
      write(6,'(i28,a/)') mval,     '   Validation scripts'
      if(mimp.gt.0)write(6,'(i22,a/)') mimp,'  *** Import statements'
c
      write(6,'(/2a/)') '---- Analysis of TYPE state combinations ',
     *" ('.' inapplicable; '~~' special; '**' unexpected)"
      write(6,'(17x,25(1h-),a,25(1h-)/a)') ' TYPE container ',
     *' TYPE contents'
      write(6,'(15x,8a)')   (taa(i),i=1,8)
      do 2110 j=1,22
      if(popcc(8,j).eq.0) goto 2110
      write(tem,'(a,8i10)') tee(j),(popcc(i,j),i=1,8)
      do 2105 k=1,7
      if(xcc(j)(k:k).eq.'1') goto 2105
      if(popcc(k,j).eq.0) tem(k*10+1:k*10+10)='         .'
      if(popcc(k,j).gt.0) tem(k*10+4:k*10+ 7)='****'
2105  continue
      write(6,'(a)') tem
2110  continue
c
      write(6,'(//16x,12(1h-),a,12(1h-))') ' TYPE source '
      write(6,'(a)')' TYPE purpose'
      write(6,'(15x,8a)')  (soo(i),i=1,5)
      do 2120 j=1,15
      if(popsp(5,j).eq.0) goto 2120
      write(tem,'(a,8i10)') puu(j),(popsp(i,j),i=1,5)
      do 2115 k=1,4
      if(xsp(j)(k:k).eq.'1') goto 2115
      if(popsp(k,j).eq.0) tem(k*10+1:k*10+10)='         .'
      if(popsp(k,j).gt.0) tem(k*10+4:k*10+07)='****'
2115  continue
      write(6,'(a)') tem
2120  continue
c
      write(6,'(//17x,26(1h-),a,26(1h-))') ' TYPE purpose '
      write(6,'(a)')' TYPE contents'
      write(6,'(15x,15a)')  (puc(i),i=1,15)
      do 2140 j=1,22
      if(popcp(15,j).eq.0) goto 2140
      write(tem,'(a,4x,15i5)') tee(j),(popcp(i,j),i=1,15)
      do 2135 l=1,14
      if(xcp(j)(l:l).eq.'1') goto 2135
      if(popcp(l,j).eq.0) tem(l*5+10:l*5+15)='    .'
      if(popcp(l,j).gt.0) tem(l*5+11:l*5+12)='**'
2135  continue
      write(6,'(a)') tem
2140  continue
c
2500  continue
      return
      end
c
c***************************************************************************
      character*256 function LCASE(icase,n)
c***************************************************************************
c
c---- convert character string to lower case

      integer n
      character*256 icase
      character*1 a

      lcase=' '
      do 100 i = 1,n 
      a = icase(i:i)
      if(a.eq.' ') goto 100
      j = ichar(a)
      if(j.lt.65.or.j.gt.90) goto 100
      a=char(j+32)
100   lcase(i:i)=a
150   continue
      end
c
c***************************************************************************
      subroutine NUMBER(string,val,suv)
c***************************************************************************
c
c---- convert 'numb' string into real number and su values 
c
      include 'align.cmn'
c
      real val,suva,pow
      character*20 string
c
      suv=-1.e-10
      j=0
      k=0
      l=0
      do 100 i=1,nchr
      if(string(i:i).eq.'(') j=i
      if(string(i:i).eq.'.') k=i
      if(string(i:i).eq.'e') l=i
100   continue
      if(j.gt.0)   goto 120
c                                real number; no su appended
      read(string(1:nchr),'(f20.0)') val    
      goto 200
c                                real number; su appended
120   if(l.gt.0)   goto 140 
      read(string(1:j-1),     '(f20.0)') val    
      read(string(j+1:nchr-1),'(f20.0)') suv    
      suv=suv/(10**(j-k-1))
      goto 200
c                          real with exponent; su appended
140   continue              
      read(string(1:j-1),     '(f20.0)') val    
      read(string(j+1:nchr-1),'(f20.0)') suv    
      read(string(l+1:j-1),   '(f5.0)')  pow    
      suv=(suv*(10**pow))/(10**(l-k-1))
c
200   continue
      return
      end
c
c***************************************************************************
      subroutine RANGE(string,min,max)        
c***************************************************************************
c
c---- convert 'range' string into min and max real values
c
      include 'align.cmn'
c
      real min,max
      character*20 string
c
cdbg  write(6,'(a,2i9,x,a)')' RANGE: ',nsav,nchr,string(1:nchr)
      do 100 i=1,nchr      
100   if(string(i:i).eq.':') goto 150
      write(6,'(i5,a,3x,a/)')line,
     * ' *** Enumeration range must contain colon ',string(1:nchr)
      i=nchr+1
c
150   if(i.gt.1) goto 160
      min=-9.e+10
      goto 170
160   continue
cdbg  write(6,'(a,2i9,x,a/)')' RANGE: ',i-1,nchr-i,string(1:nchr)
      read(string(1:i-1),'(f20.0)')    min
170   max=+9.e+10
      if(i.ge.nchr) goto 200
      read(string(i+1:nchr),'(f20.0)') max
c
200   continue
      return
      end
c
c***************************************************************************
      subroutine CATKEY
c***************************************************************************
c
c---- Ensure that the declared category key tag is the tag to be
c     applied. That is, if it is *.key it is equivalenced in the
c     evaluation method of the *.key definition. IKEY is used to 
c     signal the different stages of this process...
c          IKEY = 0 no cat key; or the key tag is now resolved
c          IKEY =+1 cat key detected but tag not yet resolved
c          IKEY =-1 cat key confirmed to exist but is *.key tag
c          IKEY =-2 cat key strg detected in *.key eval method
c          IKEY =-3 '=' character located in *.key eval method
c
      include 'align.cmn'
c
      integer       i,j,k,l,n,m
c
      j=1
cdbg  if(d)write(6,'(a,2i3,x,a,x,a)')' enter CATKEY: ',ikey,cdot,
cdbg * knam(ncat)(1:30),buf(1:50)
c                                 search if this is the key item
      if(ikey.ne.1) goto 20
      l=slen(nsav)
      if(snam(nsav)(1:l-1).ne.knam(ncat)(2:l)) goto 100
      if(snam(nsav)(cdot:l-1).eq.'key')        goto 15
      ikey=0
      goto 100
15    ikey=-1
      lkey=l
      goto 100
c                                  search eval method for key name
20    if(ikey.ne.-1) goto 35
      l=lkey
      do 25 i=1,125-l
25    if(buf(i:i+l-1).eq.knam(ncat)(1:l)) goto 30
      goto 100
30    ikey=-2
      j=i+l-1
c                                  key name found in method, now find =
35    if(ikey.ne.-2) goto 50
      do 40 i=j,125
40    if(buf(i:i).eq.'=') goto 45
      goto 100
45    ikey=-3
      j=i+1
c                                 = found; take next strg as new key tag
50    if(ikey.ne.-3) goto 100
      do 55 i=j,125
55    if(buf(i:i).eq.'_') goto 60
      goto 100
60    n=i
      do 65 i=n,125
65    if(buf(i:i).eq.' ') goto 70
      goto 100
70    knam(ncat)=buf(n:i-1)
      ikey=0
c
100   continue
cdbg  write(6,'(a,i5)')'&&&&&&&& exit from catkey subroutine',ikey
      return
      end
c
c***************************************************************************
      subroutine RWLINE
c***************************************************************************
c
c     rwline reads a line but first write the previous buffer
c
      include 'align.cmn'
c
c     -------------------------------------- write prev buffer to file7
c
10    continue
      if(.not.o)                  goto 20
      if(line.eq.0.or.mode.eq.1)  goto 20
15    write(7,'(a)') buf(1:mchr)
      if(w)write(6,'(a,i5,x,a)')' WRITstar ****',mchr,buf(1:mchr)
c
c     -------------------------------------- read a new line on ndev
20    read(2,'(a)',end=100) buf(1:maxc)
      line=line+1
      do 30 i=maxc,2,-1
30    if(buf(i:i).ne.' ') goto 40
40    mchr=i+1
      ichr=1
      if(mode.eq.1) goto 50
      if(p)write(6,'(a,i5,x,a)') ' READstar {{{{',mchr,buf(1:mchr)
      goto 200
50    if(r)write(6,'(a,i5,x,a)') ' READdict {{{{',mchr,buf(1:mchr)
      goto 200
c
100   ieof=1
c
200   continue
      return
      end
c
c***************************************************************************
      subroutine GETTOK
c***************************************************************************
c
c     Extracts a string of characters delimited by blanks, tabs, quotes.
c     Identification of exported strings i.e. tokens if via two keys...
c     TOKEN  TYPE   applied to:
c       tag  name   raw character strings starting with an underscore _
c       val  name   quoted strings starting with an underscore _
c       val  code   any string not containing white space
c       val  numb   raw string containg numbers , . + - e i ( ) :
c       val  text   characters & whitespace bounded by ' " ''' """ ;
c       val  loop   loop_ string
c            data   data_* string
c            save   save_* or save_ strings
c
c    LOOP =2 process loop tags; =1 process loop vals; =0 no loop
c
      include 'align.cmn'
c
      integer       i,lbra
      character c*1,x*1,z*1,num*18,ccc*3
      character*256 lcase
      data num/'0123456789+-.ei():'/
c
c---------------------------------- incr char on current line
10    ichr=ichr+1
      if(ichr.le.mchr)        goto 30
c---------------------------------- get a new line from device ndev
15    call RWLINE
      if(ieof.eq.1) goto 300
c---------------------------------- is this semicolon delimited block
      if(buf(1:1).ne.';')     goto 30
      type='text'
20    if(ikey.lt.0) call CATKEY
      call RWLINE
      if(ieof.eq.0) goto 24
22    write(6,'(i5,a/)')line,
     * ' **** semicolon-delimited block not closed!'             
      stop
24    if(buf(1:5).eq.'save_') goto 22
      if(buf(1:5).eq.'data_') goto 22
      if(buf(1:1).ne.';')     goto 20
      ichr=1   
      i=2      
      goto 100
c---------------------------------- test for delimiter character
30    c=buf(ichr:ichr)
      token='val'
      if(c.eq.' ')       goto 10
      if(c.eq.tab)       goto 10
      if(c.eq.'#')       goto 15
      if(c.eq.'''')      goto 60
      if(c.eq.'"')       goto 60
      if(c.eq.'[')       goto 70
      if(c.eq.'{')       goto 70
c---------------------------------- test for data name
      if(c.ne.'_')       goto 40
      token='tag'
      if(loop.eq.1) loop=0
      goto 45
c---------------------------------- test for number or character data
40    type='numb'
      if(loop.ne.2)       goto 42
      loop=1
      if(mode.eq.1)       goto 42
      if(ksum.gt.0)       goto 42
      write(6,'(i5,a/)')line,
     * ' *** Category key tag not present in loop list'
42    ksum=0
CCCC  if(index(num,c).eq.0) type='code'
c---------------------------------- get blank-limited char string
45    do 50 i=ichr,mchr
      if(buf(i:i).eq.' ')       goto 100
      if(buf(i:i).eq.tab)       goto 100
      if(buf(i:i).eq.'.')       cdot=i-ichr
      if(index(num,buf(i:i)).eq.0) type='code'
50    continue
      i=mchr+1
      goto 100
c---------------------------------- scan single & triple quoted string
60    type='text'
      if(loop.eq.2) loop=1
      ccc=c//c//c
      if(buf(ichr:ichr+2).ne.ccc) goto 65
      ichr=ichr+3
c                                           triple quotes
61    do 62 i=ichr,mchr-2
      if(buf(i:i+2).eq.ccc)       goto 64
62    continue
      call RWLINE
      if(ieof.eq.1)           goto 63    
      if(buf(1:5).eq.'save_') goto 63
      if(buf(1:5).ne.'data_') goto 61
63    write(6,'(i5,2a)')line,
     * ' *** Triple-quoted string not closed   ',buf(ichr:mchr)             
      stop
64    i=i+3
      goto 100
c                                            single quotes
65    type='code'
      do 66 i=ichr+1,mchr
      if(buf(i:i).eq.c)     goto 68
      if(buf(i:i).eq.' ')   type='text' 
      if(buf(i:i).eq.TAB)   type='text'
66    continue
      write(6,'(i5,2a)')line,
     * ' *** single-quoted string not closed   ',buf(ichr:mchr)             
      stop
68    nchr=i-ichr-1
      ichr=i
      jbuf=i+1
      goto 110
c
c---------------------------------- get brace-delimited string
70    type='list'
      if(loop.eq.2) loop=1
      k=0
      if(c.eq.'[') z=']'
      if(c.eq.'{') z='}'
c                                  find balancing open brace [ {
72    do 74 i=ichr,mchr
      if(buf(i:i).eq.c) k=k+1
      if(buf(i:i).eq.z) k=k-1
      if(k.eq.0)              goto 76
      if(k.lt.0)              goto 75
74    continue
      call RWLINE
      if(ieof.eq.1)           goto 75
      if(buf(1:5).eq.'save_') goto 75
      if(buf(1:5).ne.'data_') goto 72
75    write(6,'(i5,2a)')line,
     * ' ** List or matrix incorrectly closed   ',buf(ichr:mchr)   
      stop
76    i=i+1
c    
c    
c******************************************** count & store string
c
100   ibuf=ichr
      jbuf=i
      nchr=i-ichr
      ichr=i-1
110   stri(1:nchr)=buf(i-nchr:i-1)
      if(stri(1:1).eq.'_') type='name'
c    
c------------------------------------------------ str is save_
140   if(stri(1:5).ne.'save_') goto 150
      token=' '
      type='save'
      statp(nsav)=enum
cdbg  write(6,'(a,3i3)')'save',nsav,enum,statp(nsav)
      loop=0
      if(ikey.lt.0) ikey=0
      if(nchr.ne.5) goto 145
      slev=slev-1
      if(slev.ge.0) goto 400
      write(6,'(i5,a/)')line,
     * ' **** Save frame imbalance: check save_ nesting'
      stop
145   slev=slev+1
      catf=0
      natt=0
      nsav=nsav+1
      if(nsav.le.2000) goto 147
      write(6,'(a)')' ALIGN arrays for data names > 2000; recompile'
      stop
147   cdot=cdot-3
      slen(nsav)=nchr-4
      snam(nsav)=lcase(stri(6:nchr),nchr-5)
cdbg  write(6,'(a,3i4,x,a)')'save:',nsav,cdot,slev,snam(nsav)
      if(ikey.eq.1) call CATKEY
      goto 400
c
c------------------------------------------------ str is data_
150   if(stri(1:5).ne.'data_') goto 200
      token=' '
      type='data'
      loop=0
      natt=0
      if(slev.eq.0) goto 400
      write(6,'(i5,a,i5/)')line,
     * ' **** Save frame imbalance: save_ level gt zero',slev
      stop
      goto 400
c
c------------------------------------------------ str is loop_
200   if(stri(1:5).ne.'loop_') goto 400
      type='loop'
      loop=2     
      flag=0
      goto 400
c
c-----------------------------------eof encountered
300   continue
      ichr=maxc
      loop=0
      goto 1000
c
c----------------------------------- check on tag-value order
c
400   if(loop.ne.0)      goto 440
      if(token.eq.'   ') goto 440
      if(token.eq.'val') goto 420
      tvord=tvord+1
      if(tvord.eq.1)     goto 440
      write(6,'(i5,2a)')line,
     * ' **** Tag-Value imbalance: too many tags  ',stri(1:nchr)
      stop
420   tvord=tvord-1
      if(tvord.eq.0)     goto 440
      write(6,'(i5,2a)')line,
     * ' **** Tag-Value imbalance: too many values  ',stri(1:nchr)
      stop
c
c--------------------------------------------return a typed string
440   continue
      if(mode.eq.1) goto 450
      if(g)write(6,'(a,i2,3(x,a))')'GETTOK ::::',loop,token,
     * type,stri(1:nchr)
      goto 500 
450   if(t)write(6,'(a,i2,3(x,a))')'GETTOK ::::',loop,token,
     * type,stri(1:nchr)
500   continue
c
1000  continue
      return
      end
c
c***************************************************************************
