function cif_dict() { this._dict =
[ [ '@comment',
    '#############################################################################' ],
  [ '@comment',
    '                                                                            #' ],
  [ '@comment',
    '                     MAIN CIF DICTIONARY SHELL                              #' ],
  [ '@comment',
    '                                                                            #' ],
  [ '@comment',
    '#############################################################################' ],
  [ 'data_',
    'CIF_DIC',
    [ [ 'item_', '_dictionary.title', 'CIF_DIC' ],
      [ 'item_', '_dictionary.class', 'Instance' ],
      [ 'item_', '_dictionary.version', '1.4.05' ],
      [ 'item_', '_dictionary.date', '2013-04-24' ],
      [ 'item_', '_dictionary.uri', 'www.iucr.org/cif/dic/cif.dic' ],
      [ 'item_', '_dictionary.ddl_conformance', '3.11.03' ],
      [ 'item_', '_dictionary.namespace', 'CifDic' ],
      [ 'item_',
        '_description.text',
        '\n     Dictionary shell for the complete set of COMCIFS-approved data-item\n     definitions for use within the Crystallographic Information Framework.' ],
      [ 'save_',
        'CIF_DIC',
        [ [ 'item_', '_definition.id', 'CIF_DIC' ],
          [ 'item_', '_definition.scope', 'Category' ],
          [ 'item_', '_definition.class', 'Head' ],
          [ 'item_', '_definition.update', '2013-01-25' ],
          [ 'item_',
            '_description.text',
            '\n     The DICTIONARY group encompassing all data items defined and\n     used with in the Crystallographic Information Framework (CIF).' ],
          [ 'item_', '_name.category_id', 'DDL_DIC' ],
          [ 'item_', '_name.object_id', 'CIF_DIC' ],
          [ 'save_',
            'CIF_CORE',
            [ [ 'item_', '_definition.id', 'CIF_CORE' ],
              [ 'item_', '_definition.scope', 'Category' ],
              [ 'item_', '_definition.class', 'Head' ],
              [ 'item_', '_definition.update', '2012-12-18' ],
              [ 'item_',
                '_description.text',
                '\n     The DICTIONARY group encompassing all CORE data items defined and\n     used with in the Crystallographic Information Framework (CIF).' ],
              [ 'item_', '_name.category_id', 'CIF_DIC' ],
              [ 'item_', '_name.object_id', 'CIF_CORE' ],
              [ 'save_',
                'EXPERIMENTAL',
                [ [ 'item_', '_definition.id', 'EXPERIMENTAL' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Head' ],
                  [ 'item_', '_definition.update', '2012-11-22' ],
                  [ 'item_',
                    '_description.text',
                    '\n    The DICTIONARY group encompassing the CORE experimental data defined\n    and used with in the Crystallographic Information Framework (CIF).' ],
                  [ 'item_', '_name.category_id', 'CIF_CORE' ],
                  [ 'item_', '_name.object_id', 'EXPERIMENTAL' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'EXPERIMENTS',
                    [ [ 'item_', '_definition.id', 'EXPERIMENTS' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Ref-loop' ],
                      [ 'item_', '_definition.update', '2012-11-22' ],
                      [ 'item_',
                        '_description.text',
                        '\n    This category is designed specifically to facilitate studies\n    involving multiple sets of experiments and their associated data\n    values. The data items are defined within the EXPTL category.\n    This category class is only used in an instance document when\n    there is more than one experiment encompassed by the category\n    of EXPTL items. When this is the case each set of EXPTL data,\n    one set per experiment, is enclosed in its own save frame.\n    In the instance document these are referred to as a loop of\n    the item _experiments.key.  See a typical example below.\n    When only one set of experimental data exists the EXPTL items\n    need not be enclosed in a save frame and the reference loop is\n    unnecessary.' ],
                      [ 'item_', '_name.category_id', 'EXPERIMENTAL' ],
                      [ 'item_', '_name.object_id', 'EXPERIMENTS' ],
                      [ 'item_', '_category.key_id', '_experiments.key' ],
                      [ 'loop_',
                        [ '_description_example.case' ],
                        [ '\n     In an instance document this category is typically invoked as\n \n            loop_ _experiments.key\n                           ${"frame":"exptl_blue"}$\n                           ${"frame":"exptl_red"}$' ] ],
                      [ 'save_',
                        'experiments.key',
                        [ [ 'item_', '_definition.id', '_experiments.key' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Unique key to a set of save frames in a looped list.' ],
                          [ 'item_', '_name.category_id', 'experiments' ],
                          [ 'item_', '_name.object_id', 'key' ],
                          [ 'item_', '_type.purpose', 'Key' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Ref-table' ],
                          [ 'item_', '_type.contents', 'Name' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ '${"frame":phase1}$' ] ] ] ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'EXPTL',
                        [ [ 'item_', '_definition.id', 'EXPTL' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify the experimental work\n     prior to diffraction measurements. These include crystallization\n     crystal measurements and absorption-correction techniques used..' ],
                          [ 'item_', '_name.category_id', 'EXPERIMENTS' ],
                          [ 'item_', '_name.object_id', 'EXPTL' ],
                          [ 'save_',
                            'exptl.id',
                            [ [ 'item_', '_definition.id', '_exptl.id' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying an experiment if there are multiple sets of\n     experimental data. See _experiments.key.' ],
                              [ 'item_', '_name.category_id', 'exptl' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'exptl.crystals_number',
                            [ [ 'item_', '_definition.id', '_exptl.crystals_number' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_exptl_crystals_number' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Total number of crystals used in the measurement of intensities.' ],
                              [ 'item_', '_name.category_id', 'exptl' ],
                              [ 'item_', '_name.object_id', 'crystals_number' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '1:' ],
                              [ 'item_', '_enumeration.default', '1' ] ] ],
                          [ 'save_',
                            'exptl.special_details',
                            [ [ 'item_', '_definition.id', '_exptl.special_details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_exptl_special_details', '_exptl.details' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Details of the experiment prior to intensity measurement.\n     See also _exptl_crystal.preparation' ],
                              [ 'item_', '_name.category_id', 'exptl' ],
                              [ 'item_', '_name.object_id', 'special_details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'exptl.transmission_factor_max',
                            [ [ 'item_', '_definition.id', '_exptl.transmission_factor_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_exptl_transmission_factor_max' ] ],
                              [ 'item_', '_definition.update', '2013-04-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The calculated maximum value of the transmission factor for\n     the specimen. Its value does not include the effects of\n     absorption in the specimen mount. The presence of this\n     item does not imply that the structure factors have been\n     corrected for absorption. For the applied correction see\n     _exptl_absorpt.correction_T_max.' ],
                              [ 'item_', '_name.category_id', 'exptl' ],
                              [ 'item_', '_name.object_id', 'transmission_factor_max' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'exptl.transmission_factor_min',
                            [ [ 'item_', '_definition.id', '_exptl.transmission_factor_min' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_exptl_transmission_factor_min' ] ],
                              [ 'item_', '_definition.update', '2013-04-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The calculated minimum value of the transmission factor for\n     the specimen. Its value does not include the effects of\n     absorption in the specimen mount. The presence of this\n     item does not imply that the structure factors have been\n     corrected for absorption. For the applied correction see\n     _exptl_absorpt.correction_T_max.' ],
                              [ 'item_', '_name.category_id', 'exptl' ],
                              [ 'item_', '_name.object_id', 'transmission_factor_min' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'EXPTL_CRYSTALS',
                            [ [ 'item_', '_definition.id', 'EXPTL_CRYSTALS' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Ref-loop' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n    This category is designed specifically to facilitate studies\n    involving multiple sets of experiments and their associated data\n    values. The data items are defined in the EXPTL_CRYSTAL category.\n    This category class is only used in an instance document when\n    there is more than one experiment encompassed by the category of\n    EXPTL items. When this is the case each set of EXPTL_CRYSTALa\n    data, one set per experiment, is enclosed in its own save frame.\n    In the instance document these are referred to as a loop of\n    the item _experiments.key.  See a typical example below.\n    When only one set of experimental data exists the EXPTL items\n    need not be enclosed in a save frame and the reference loop is\n    unnecessary.' ],
                              [ 'item_', '_name.category_id', 'EXPTL' ],
                              [ 'item_', '_name.object_id', 'CRYSTALS' ],
                              [ 'item_', '_category.key_id', '_exptl_crystals.key' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '\n     In an instance document this category is typically invoked as\n \n            loop_ _exptl_crystals.key\n                           ${"frame":"crystal_1"}$\n                           ${"frame":"crystal_2"}$' ] ],
                              [ 'save_',
                                'exptl_crystals.key',
                                [ [ 'item_', '_definition.id', '_exptl_crystals.key' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Unique key code to a set of EXPTL_CRYSTAL items in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'crystals' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Ref-table' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ '       ${"frame":c1}$       ' ] ] ] ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'EXPTL_CRYSTAL',
                                [ [ 'item_', '_definition.id', 'EXPTL_CRYSTAL' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to specify information about a\n     crystal used in the diffraction measurements.' ],
                                  [ 'item_', '_name.category_id', 'EXPTL_CRYSTALS' ],
                                  [ 'item_', '_name.object_id', 'CRYSTAL' ],
                                  [ 'save_',
                                    'exptl_crystal.id',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.id' ],
                                      [ 'loop_', [ '_alias.definition_id' ], [ '_exptl_crystal_id' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Code identifying a crystal if multiple crystals are used.\n     See _exptl_crystals.key.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'id' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Code' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.colour',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.colour' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_colour' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Colour description of a crystal as a list of the allowed\n     exptl_crystal_appearance states for general, intensity and hue.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'colour' ],
                                      [ 'item_', '_type.purpose', 'Composite' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'List' ],
                                      [ 'item_', '_type.contents', 'Code' ],
                                      [ 'item_', '_type.dimension', [ '3' ] ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ '[transluscent, pale, green]' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n     With  c  as  exptl_crystal_appearance\n \n      _exptl_crystal.colour = [ c.general, c.intensity, c.hue ]' ] ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_diffrn',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.density_diffrn' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_diffrn' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Crystal density calculated from crystal unit cell and atomic content.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_diffrn' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'megagrams_per_metre_cubed' ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    _exptl_crystal.density_diffrn = 1.6605 * _cell.atomic_mass / _cell.volume' ] ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_meas',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.density_meas' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_meas' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Crystal density measured using standard chemical and physical methods.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_meas' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'megagrams_per_metre_cubed' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_meas_gt',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.density_meas_gt' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_meas_gt' ] ],
                                      [ 'item_', '_definition.update', '2012-12-11' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The value above which the density measured using standard\n     chemical and physical methods lies. This item is used only\n     when _exptl_crystal.density_meas cannot be employed. It is\n     intended for use in reporting information in databases and\n     archives which would be misleading if reported otherwise.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_meas_gt' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'megagrams_per_metre_cubed' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_meas_lt',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.density_meas_lt' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_meas_lt' ] ],
                                      [ 'item_', '_definition.update', '2012-12-11' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The value below which the density measured using standard\n     chemical and physical methods lies. This item is used only\n     when _exptl_crystal.density_meas cannot be employed. It is\n     intended for use in reporting information in databases and\n     archives which would be misleading if reported otherwise.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_meas_lt' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'megagrams_per_metre_cubed' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_meas_temp',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.density_meas_temp' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_meas_temp' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Temperature at which _exptl_crystal.density_meas was determined.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_meas_temp' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_enumeration.default', '293.' ],
                                      [ 'item_', '_units.code', 'kelvins' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_meas_temp_gt',
                                    [ [ 'item_',
                                        '_definition.id',
                                        '_exptl_crystal.density_meas_temp_gt' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_meas_temp_gt' ] ],
                                      [ 'item_', '_definition.update', '2012-12-11' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Temperature above which the measured density was determined.\n     This item is used only when exptl_crystal.density_meas_temp\n     cannot be employed. It is intended for use in reporting values\n     from databases which would be misleading if reported otherwise.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_meas_temp_gt' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_enumeration.default', '293.' ],
                                      [ 'item_', '_units.code', 'kelvins' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_meas_temp_lt',
                                    [ [ 'item_',
                                        '_definition.id',
                                        '_exptl_crystal.density_meas_temp_lt' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_meas_temp_lt' ] ],
                                      [ 'item_', '_definition.update', '2012-12-11' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Temperature below which the measured density was determined.\n     This item is used only when exptl_crystal.density_meas_temp\n     cannot be employed. It is intended for use in reporting values\n     from databases which would be misleading if reported otherwise.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_meas_temp_lt' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_enumeration.default', '293.' ],
                                      [ 'item_', '_units.code', 'kelvins' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.density_method',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.density_method' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_density_method' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Description of method used to measure _exptl_crystal.density_meas.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'density_method' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'flotation in aqueous KI' ] ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.description',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.description' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_description' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Description of the quality and habit of the crystal. The crystal\n     dimensions should appear in the exptl_crystal_size category.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'description' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.F_000',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.F_000' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_F_000' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Number of electrons in the crystal unit cell contributing to F(000).\n     It may contain dispersion contributions, and is calculated as\n \n          F(000) = [ (sum f~r~)^2^ + (sum f~i~)^2^ ]^1/2^\n \n          f~r~   = real part of the scattering factors at theta = 0\n          f~i~   = imaginary part of the scattering factors at theta = 0\n \n                  the sum is taken over each atom in the unit cell\n \n     For X-rays, non-dispersive F(000) is a positive number and counts\n     the effective number of electrons in the unit cell; for neutrons,\n     non-dispersive F(000) (which may be negative) counts the total\n     nuclear scattering power in the unit cell. See\n        http://reference.iucr.org/dictionary/F(000)' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'F_000' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Definition',
                                          '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.preparation',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.preparation' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_preparation' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Details of crystal growth and preparation of the crystals\n     (e.g.  mounting) prior to the intensity measurements.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'preparation' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'mounted in an argon-filled quartz capillary' ] ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.pressure_history',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.pressure_history' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_pressure_history' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Details concerning the pressure history of the crystals.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'pressure_history' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.recrystallization_method',
                                    [ [ 'item_',
                                        '_definition.id',
                                        '_exptl_crystal.recrystallization_method' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_recrystallization_method' ] ],
                                      [ 'item_', '_definition.update', '2012-12-11' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Method used to recrystallize the sample. Sufficient details should\n     be given for the procedure to be repeated. Temperatures, solvents,\n     flux or carrier gases with concentrations or pressures and ambient\n     atmosphere details should be given.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'recrystallization_method' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.size_length',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.size_length' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_size_length' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The length of needle/cylindrical crystals.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'size_length' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.:' ],
                                      [ 'item_', '_units.code', 'millimetres' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.size_max',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.size_max' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_size_max' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The maximum dimension of a crystal.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'size_max' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.:' ],
                                      [ 'item_', '_units.code', 'millimetres' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.size_mid',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.size_mid' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_size_mid' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The median dimension of a crystal.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'size_mid' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.:' ],
                                      [ 'item_', '_units.code', 'millimetres' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.size_min',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.size_min' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_size_min' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The minimum dimension of a crystal.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'size_min' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.:' ],
                                      [ 'item_', '_units.code', 'millimetres' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.size_rad',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.size_rad' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_size_rad' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The radius of a spherical or cylindrical crystal.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'size_rad' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.:' ],
                                      [ 'item_', '_units.code', 'millimetres' ] ] ],
                                  [ 'save_',
                                    'exptl_crystal.thermal_history',
                                    [ [ 'item_', '_definition.id', '_exptl_crystal.thermal_history' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_crystal_thermal_history' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Details concerning the thermal history of the crystals.' ],
                                      [ 'item_', '_name.category_id', 'crystal' ],
                                      [ 'item_', '_name.object_id', 'thermal_history' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ] ] ],
                                  [ '@comment',
                                    '----------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'EXPTL_CRYSTAL_FACE',
                                    [ [ 'item_', '_definition.id', 'EXPTL_CRYSTAL_FACE' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Loop' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of data items which specify the dimensions of the\n     crystals used in the diffraction measurements.' ],
                                      [ 'item_', '_name.category_id', 'EXPTL_CRYSTAL' ],
                                      [ 'item_', '_name.object_id', 'FACE' ],
                                      [ 'item_', '_category.key_id', '_exptl_crystal_face.key' ],
                                      [ 'save_',
                                        'exptl_crystal_face.key',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.key' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Value is a unique key to a set of EXPTL_CRYSTAL items\n     in a looped list.' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'key' ],
                                          [ 'item_', '_type.purpose', 'Key' ],
                                          [ 'item_', '_type.source', 'Related' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Implied' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Definition',
                                              '              _type.contents = Type_Contents(exptl_crystal_face.id)',
                                              'Evaluation',
                                              '              _exptl_crystal_face.key = _exptl_crystal_face.id' ] ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.crystal_id',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.crystal_id' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Code identifying a crystal if multiple crystals are used.' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'crystal_id' ],
                                          [ 'item_', '_name.linked_item_id', '_exptl_crystal.id' ],
                                          [ 'item_', '_type.purpose', 'Link' ],
                                          [ 'item_', '_type.source', 'Related' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Code' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.diffr_chi',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.diffr_chi' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_diffr_chi' ] ],
                                          [ 'item_', '_definition.update', '2013-04-15' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n    Diffractometer angle setting when the perpendicular to the specified\n    crystal face is aligned along a specified direction (e.g. the\n    bisector of the incident and reflected beams in an optical goniometer.' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '-180.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'diffr_chi' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.diffr_kappa',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.diffr_kappa' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_diffr_kappa' ] ],
                                          [ 'item_', '_definition.update', '2013-04-15' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n    Diffractometer angle setting when the perpendicular to the specified\n    crystal face is aligned along a specified direction (e.g. the\n    bisector of the incident and reflected beams in an optical goniometer.' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '-180.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'diffr_kappa' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.diffr_phi',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.diffr_phi' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_diffr_phi' ] ],
                                          [ 'item_', '_definition.update', '2013-04-15' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n    Diffractometer angle setting when the perpendicular to the specified\n    crystal face is aligned along a specified direction (e.g. the\n    bisector of the incident and reflected beams in an optical goniometer.' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '-180.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'diffr_phi' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.diffr_psi',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.diffr_psi' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_diffr_psi' ] ],
                                          [ 'item_', '_definition.update', '2013-04-15' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n    Diffractometer angle setting when the perpendicular to the specified\n    crystal face is aligned along a specified direction (e.g. the\n    bisector of the incident and reflected beams in an optical goniometer.' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '-180.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'diffr_psi' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.hkl',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.hkl' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Miller indices of the crystal face.' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'hkl' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Matrix' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_type.dimension', [ '3' ] ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With f as exptl_crystal_face\n \n      _exptl_crystal_face.hkl = [f.index_h, f.index_h, f.index_l]' ] ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.index_h',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.index_h' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_index_h' ] ],
                                          [ 'item_', '_definition.update', '2013-04-16' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     The index of a reciprocal space vector.' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                                          [ 'item_', '_units.code', 'none' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'index_h' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.index_k',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.index_k' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_index_k' ] ],
                                          [ 'item_', '_definition.update', '2013-04-16' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     The index of a reciprocal space vector.' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                                          [ 'item_', '_units.code', 'none' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'index_k' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.index_l',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.index_l' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_index_l' ] ],
                                          [ 'item_', '_definition.update', '2013-04-16' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     The index of a reciprocal space vector.' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                                          [ 'item_', '_units.code', 'none' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'index_l' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.id',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.id' ],
                                          [ 'item_', '_definition.update', '2013-04-18' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Identifier which combines the crystal id and the face indices\n     as a list. This is normally the key item of the category.' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'id' ],
                                          [ 'item_', '_type.purpose', 'Composite' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'List' ],
                                          [ 'item_', '_type.contents', 'Code,Matrix(Index,Index,index)' ],
                                          [ 'item_', '_type.dimension', [ '1' ] ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With f as exptl_crystal_face\n \n        _exptl_crystal_face.id = [ f.crystal_id, f.hkl ]' ] ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_face.perp_dist',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_face.perp_dist' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_face_perp_dist' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Perpendicular distance of face to the centre of rotation of the crystal.' ],
                                          [ 'item_', '_name.category_id', 'face' ],
                                          [ 'item_', '_name.object_id', 'perp_dist' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.0:' ],
                                          [ 'item_', '_units.code', 'millimetres' ] ] ] ] ],
                                  [ '@comment',
                                    '----------- close of EXPTL_CRYSTAL_FACE category' ],
                                  [ '@comment',
                                    '-------------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'EXPTL_CRYSTAL_APPEARANCE',
                                    [ [ 'item_', '_definition.id', 'EXPTL_CRYSTAL_APPEARANCE' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Set' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of ENUMERATION items used to specify information about the\n     crystal colour and appearance.' ],
                                      [ 'item_', '_name.category_id', 'EXPTL_CRYSTAL' ],
                                      [ 'item_', '_name.object_id', 'APPEARANCE' ],
                                      [ 'save_',
                                        'exptl_crystal_appearance.general',
                                        [ [ 'item_',
                                            '_definition.id',
                                            '_exptl_crystal_appearance.general' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_colour_lustre' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Appearance of the crystal as prescribed state codes.' ],
                                          [ 'item_', '_name.category_id', 'appearance' ],
                                          [ 'item_', '_name.object_id', 'general' ],
                                          [ 'item_', '_type.purpose', 'State' ],
                                          [ 'item_', '_type.source', 'Assigned' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Code' ],
                                          [ 'loop_',
                                            [ '_enumeration_set.state' ],
                                            [ 'metallic',
                                              'lustrous',
                                              'transparent',
                                              'transluscent',
                                              'opaque',
                                              '.' ] ],
                                          [ 'item_', '_enumeration.default', '.' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_appearance.intensity',
                                        [ [ 'item_',
                                            '_definition.id',
                                            '_exptl_crystal_appearance.intensity' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_colour_modifier' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Colour intensity of the crystal as prescribed state codes.' ],
                                          [ 'item_', '_name.category_id', 'appearance' ],
                                          [ 'item_', '_name.object_id', 'intensity' ],
                                          [ 'item_', '_type.purpose', 'State' ],
                                          [ 'item_', '_type.source', 'Assigned' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Code' ],
                                          [ 'loop_',
                                            [ '_enumeration_set.state' ],
                                            [ 'dark',
                                              'light',
                                              'intense',
                                              'pale',
                                              'whitish',
                                              'blackish',
                                              'grayish',
                                              'brownish',
                                              'reddish',
                                              'pinkish',
                                              'orangish',
                                              'yellowish',
                                              'greenish',
                                              'bluish',
                                              '.' ] ],
                                          [ 'item_', '_enumeration.default', '.' ] ] ],
                                      [ 'save_',
                                        'exptl_crystal_appearance.hue',
                                        [ [ 'item_', '_definition.id', '_exptl_crystal_appearance.hue' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_exptl_crystal_colour_primary' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Colour hue of the crystals as prescribed state codes.' ],
                                          [ 'item_', '_name.category_id', 'appearance' ],
                                          [ 'item_', '_name.object_id', 'hue' ],
                                          [ 'item_', '_type.purpose', 'State' ],
                                          [ 'item_', '_type.source', 'Assigned' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Code' ],
                                          [ 'loop_',
                                            [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                            [ 'black',
                                              '[ 000, 000, 000 ]',
                                              'white',
                                              '[ 255, 255, 255 ]',
                                              'grey',
                                              '[ 192, 192, 192 ]',
                                              'grey_light',
                                              '[ 211, 211, 211 ]',
                                              'grey_slate',
                                              '[ 112, 128, 144 ]',
                                              'blue',
                                              '[ 000, 000, 255 ]',
                                              'blue_light',
                                              '[ 176, 224, 230 ]',
                                              'blue_medium',
                                              '[ 000, 000, 205 ]',
                                              'blue_dark',
                                              '[ 025, 025, 112 ]',
                                              'blue_navy',
                                              '[ 000, 000, 128 ]',
                                              'blue_royal',
                                              '[ 065, 105, 225 ]',
                                              'blue_sky',
                                              '[ 135, 206, 235 ]',
                                              'blue_steel',
                                              '[ 070, 130, 180 ]',
                                              'turquoise',
                                              '[ 064, 224, 208 ]',
                                              'cyan',
                                              '[ 000, 255, 255 ]',
                                              'cyan_light',
                                              '[ 224, 255, 255 ]',
                                              'green',
                                              '[ 000, 255, 000 ]',
                                              'green_light',
                                              '[ 152, 251, 152 ]',
                                              'green_dark',
                                              '[ 000, 100, 000 ]',
                                              'green_sea',
                                              '[ 046, 139, 087 ]',
                                              'green_lime',
                                              '[ 050, 205, 050 ]',
                                              'green_olive',
                                              '[ 107, 142, 035 ]',
                                              'green_khaki',
                                              '[ 240, 230, 140 ]',
                                              'yellow',
                                              '[ 255, 255, 000 ]',
                                              'yellow_light',
                                              '[ 255, 255, 224 ]',
                                              'yellow_gold',
                                              '[ 255, 215, 000 ]',
                                              'brown',
                                              '[ 165, 042, 042 ]',
                                              'brown_sienna',
                                              '[ 160, 082, 045 ]',
                                              'brown_beige',
                                              '[ 245, 245, 220 ]',
                                              'brown_tan',
                                              '[ 210, 180, 140 ]',
                                              'salmon',
                                              '[ 250, 128, 114 ]',
                                              'salmon_light',
                                              '[ 255, 160, 122 ]',
                                              'salmon_dark',
                                              '[ 233, 150, 122 ]',
                                              'orange',
                                              '[ 255, 165, 000 ]',
                                              'orange_dark',
                                              '[ 255, 140, 000 ]',
                                              'red',
                                              '[ 255, 000, 000 ]',
                                              'red_coral',
                                              '[ 255, 127, 080 ]',
                                              'red_tomato',
                                              '[ 255, 099, 071 ]',
                                              'red_orange',
                                              '[ 255, 069, 000 ]',
                                              'red_violet',
                                              '[ 219, 112, 147 ]',
                                              'red_maroon',
                                              '[ 176, 048, 096 ]',
                                              'pink',
                                              '[ 255, 192, 203 ]',
                                              'pink_light',
                                              '[ 255, 182, 193 ]',
                                              'pink_deep',
                                              '[ 255, 020, 147 ]',
                                              'pink_hot',
                                              '[ 255, 105, 180 ]',
                                              'violet',
                                              '[ 238, 130, 238 ]',
                                              'violet_red',
                                              '[ 208, 032, 144 ]',
                                              'violet_magenta',
                                              '[ 255, 000, 255 ]',
                                              'violet_dark',
                                              '[ 148, 000, 211 ]',
                                              'violet_blue',
                                              '[ 138, 043, 226 ]' ] ],
                                          [ 'item_', '_enumeration.default', 'white' ] ] ] ] ],
                                  [ '@comment', '------ close EXPTL_CRYSTAL_APPEARANCE category' ] ] ],
                              [ '@comment', '------ close EXPTL_CRYSTAL category' ],
                              [ '@comment',
                                '---------------------------------------------------------------------------' ],
                              [ 'save_',
                                'EXPTL_ABSORPT',
                                [ [ 'item_', '_definition.id', 'EXPTL_ABSORPT' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to specify the experimental details\n     of the  absorption measurements and corrections to the diffraction\n     data.' ],
                                  [ 'item_', '_name.category_id', 'EXPTL_CRYSTALS' ],
                                  [ 'item_', '_name.object_id', 'ABSORPT' ],
                                  [ 'save_',
                                    'exptl_absorpt.coefficient_mu',
                                    [ [ 'item_', '_definition.id', '_exptl_absorpt.coefficient_mu' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_absorpt_coefficient_mu',
                                          '_exptl.absorpt_coefficient_mu' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Absorption coefficient mu calculated from the atomic content of\n     the cell, the density and the radiation wavelength.' ],
                                      [ 'item_', '_name.category_id', 'absorpt' ],
                                      [ 'item_', '_name.object_id', 'coefficient_mu' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'reciprocal_millimetres' ] ] ],
                                  [ 'save_',
                                    'exptl_absorpt.correction_T_max',
                                    [ [ 'item_', '_definition.id', '_exptl_absorpt.correction_T_max' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_absorpt_correction_T_max',
                                          '_exptl.absorpt_correction_T_max' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Maximum transmission factor for the crystal and radiation applied\n     to the measured intensities, it includes the correction for\n     absorption by the specimen mount and diffractometer as well\n     as by the specimen itself. These values give the transmission (T)\n     factor by which measured intensities have been REDUCED due to\n     absorption. Sometimes referred to as absorption correction A or\n     1/A* (see "Crystal Structure Analysis for Chemists and Biologists"\n     by J.P. Glusker et al., Wiley)' ],
                                      [ 'item_', '_name.category_id', 'absorpt' ],
                                      [ 'item_', '_name.object_id', 'correction_T_max' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                      [ 'item_', '_units.code', 'none' ] ] ],
                                  [ 'save_',
                                    'exptl_absorpt.correction_T_min',
                                    [ [ 'item_', '_definition.id', '_exptl_absorpt.correction_T_min' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_absorpt_correction_T_min',
                                          '_exptl.absorpt_correction_T_min' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Maximum transmission factor for the crystal and radiation applied\n     to the measured intensities, it includes the correction for\n     absorption by the specimen mount and diffractometer as well\n     as by the specimen itself. These values give the transmission (T)\n     factor by which measured intensities have been REDUCED due to\n     absorption. Sometimes referred to as absorption correction A ori\n     1/A* (see "Crystal Structure Analysis for Chemists and Biologists"\n     by J.P. Glusker et al., Wiley)' ],
                                      [ 'item_', '_name.category_id', 'absorpt' ],
                                      [ 'item_', '_name.object_id', 'correction_T_min' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                      [ 'item_', '_units.code', 'none' ] ] ],
                                  [ 'save_',
                                    'exptl_absorpt.correction_type',
                                    [ [ 'item_', '_definition.id', '_exptl_absorpt.correction_type' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_absorpt_correction_type',
                                          '_exptl.absorpt_correction_type' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Code identifying the absorption correction type and method.\n     The \'empirical\' approach should NOT be used if more detailed\n     information on the crystal shape  is available.' ],
                                      [ 'item_', '_name.category_id', 'absorpt' ],
                                      [ 'item_', '_name.object_id', 'correction_type' ],
                                      [ 'item_', '_type.purpose', 'State' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Code' ],
                                      [ 'loop_',
                                        [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                        [ 'analytical',
                                          'analytical from crystal shape',
                                          'cylinder',
                                          'cylindrical',
                                          'empirical',
                                          'empirical from intensities',
                                          'gaussian',
                                          'Gaussian from crystal shape',
                                          'integration',
                                          'integration from crystal shape',
                                          'multi-scan',
                                          'symmetry-related measurements',
                                          'none',
                                          'no absorption correction applied',
                                          'numerical',
                                          'numerical from crystal shape',
                                          'psi-scan',
                                          'psi-scan corrections',
                                          'refdelf',
                                          'refined from delta-F',
                                          'sphere',
                                          'spherical' ] ],
                                      [ 'item_', '_enumeration.default', 'none' ] ] ],
                                  [ 'save_',
                                    'exptl_absorpt.process_details',
                                    [ [ 'item_', '_definition.id', '_exptl_absorpt.process_details' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_exptl_absorpt_process_details',
                                          '_exptl.absorpt_process_details' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Description of the absorption correction process applied to the\n     measured intensities. A literature reference should be supplied\n     for psi-scan or multi-scan techniques.' ],
                                      [ 'item_', '_name.category_id', 'absorpt' ],
                                      [ 'item_', '_name.object_id', 'process_details' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'Tompa analytical',
                                          'MolEN (Fair, 1990)',
                                          '(North, Phillips & Mathews, 1968)' ] ] ] ] ] ],
                              [ '@comment', '------ close EXPTL_ABSORPT category' ] ] ],
                          [ '@comment', '------ close EXPTL_CRYSTALS category' ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'CELL',
                            [ [ 'item_', '_definition.id', 'CELL' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to describe the parameters of\n     the crystal unit cell and their measurement.' ],
                              [ 'item_', '_name.category_id', 'EXPTL' ],
                              [ 'item_', '_name.object_id', 'CELL' ],
                              [ 'save_',
                                'cell.atomic_mass',
                                [ [ 'item_', '_definition.id', '_cell.atomic_mass' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Atomic mass of the contents of the unit cell. This calculated\n     from the atom sites present in the ATOM_TYPE list, rather than\n     the ATOM_SITE lists of atoms in the refined model.' ],
                                  [ 'item_', '_name.category_id', 'cell' ],
                                  [ 'item_', '_name.object_id', 'atomic_mass' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.:' ],
                                  [ 'item_', '_units.code', 'dalton' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    mass = 0.\n \n    Loop t as atom_type  {\n \n                   mass += t.number_in_cell * t.atomic_mass\n    }\n      _cell.atomic_mass = mass' ] ] ] ],
                              [ 'save_',
                                'cell.formula_units_Z',
                                [ [ 'item_', '_definition.id', '_cell.formula_units_Z' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_cell_formula_units_Z' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The number of the formula units in the unit cell as specified\n     by _chemical_formula.structural, _chemical_formula.moiety or\n     _chemical_formula.sum.' ],
                                  [ 'item_', '_name.category_id', 'cell' ],
                                  [ 'item_', '_name.object_id', 'formula_units_Z' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Count' ],
                                  [ 'item_', '_enumeration.range', '1:' ] ] ],
                              [ 'save_',
                                'cell.metric_tensor',
                                [ [ 'item_', '_definition.id', '_cell.metric_tensor' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The direct space (covariant) metric tensor used to transform\n     vectors and coordinates from real (direct) to reciprocal space.' ],
                                  [ 'item_', '_name.category_id', 'cell' ],
                                  [ 'item_', '_name.object_id', 'metric_tensor' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     with v  as  cell_vector\n \n           _cell.metric_tensor = [[ v.a*v.a, v.a*v.b, v.a*v.c ],\n                                  [ v.b*v.a, v.b*v.b, v.b*v.c ],\n                                  [ v.c*v.a, v.c*v.b, v.c*v.c ]]' ] ] ] ],
                              [ 'save_',
                                'cell.orthogonal_matrix',
                                [ [ 'item_', '_definition.id', '_cell.orthogonal_matrix' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Orthogonal matrix of the crystal unit cell. Definition uses\n     Rollet\'s axial assignments with cell vectors a,b,c aligned\n     with orthogonal axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_name.category_id', 'cell' ],
                                  [ 'item_', '_name.object_id', 'orthogonal_matrix' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With p  as  cell_length\n     With q  as  cell_angle\n     With r  as  cell_reciprocal_angle\n \n    _cell.orthogonal_matrix =   [\n          [  p.a*Sind(q.beta)*Sind(r.gamma),                 0,   0 ],\n          [ -p.a*Sind(q.beta)*Cosd(r.gamma), p.b*Sind(q.alpha),   0 ],\n          [  p.a*Cosd(q.beta),               p.b*Cosd(q.alpha), p.c ]]' ] ] ] ],
                              [ 'save_',
                                'cell.special_details',
                                [ [ 'item_', '_definition.id', '_cell.special_details' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_cell_special_details' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Description of special aspects of the cell choice, noting\n     possible alternative settings.' ],
                                  [ 'item_', '_name.category_id', 'cell' ],
                                  [ 'item_', '_name.object_id', 'special_details' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'cell.volume',
                                [ [ 'item_', '_definition.id', '_cell.volume' ],
                                  [ 'loop_', [ '_alias.definition_id' ], [ '_cell_volume' ] ],
                                  [ 'item_', '_definition.update', '2013-03-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Volume of the crystal unit cell.' ],
                                  [ 'item_', '_name.category_id', 'cell' ],
                                  [ 'item_', '_name.object_id', 'volume' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'angstrom_cubed' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n      With v  as  cell_vector\n \n      _cell.volume =  v.a * ( v.b ^ v.c )' ] ] ] ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CELL_ANGLE',
                                [ [ 'item_', '_definition.id', 'CELL_ANGLE' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to describe the angles between\n     the axes in the crystal unit cell.' ],
                                  [ 'item_', '_name.category_id', 'CELL' ],
                                  [ 'item_', '_name.object_id', 'ANGLE' ],
                                  [ 'save_',
                                    'cell_angle.alpha',
                                    [ [ 'item_', '_definition.id', '_cell_angle.alpha' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_angle_alpha', '_cell.angle_alpha' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The angle between the cell axes _cell_length.b and _cell_length.c.' ],
                                      [ 'item_', '_name.category_id', 'angle' ],
                                      [ 'item_', '_name.object_id', 'alpha' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:180.0' ],
                                      [ 'item_', '_enumeration.default', '90.0' ],
                                      [ 'item_', '_units.code', 'degrees' ] ] ],
                                  [ 'save_',
                                    'cell_angle.beta',
                                    [ [ 'item_', '_definition.id', '_cell_angle.beta' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_angle_beta', '_cell.angle_beta' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The angle between the cell axes _cell_length.a and _cell_length.c.' ],
                                      [ 'item_', '_name.category_id', 'angle' ],
                                      [ 'item_', '_name.object_id', 'beta' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:180.0' ],
                                      [ 'item_', '_enumeration.default', '90.0' ],
                                      [ 'item_', '_units.code', 'degrees' ] ] ],
                                  [ 'save_',
                                    'cell_angle.gamma',
                                    [ [ 'item_', '_definition.id', '_cell_angle.gamma' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_angle_gamma', '_cell.angle_gamma' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The angle between the cell axes _cell_length.a and _cell_length.b.' ],
                                      [ 'item_', '_name.category_id', 'angle' ],
                                      [ 'item_', '_name.object_id', 'gamma' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:180.0' ],
                                      [ 'item_', '_enumeration.default', '90.0' ],
                                      [ 'item_', '_units.code', 'degrees' ] ] ] ] ],
                              [ '@comment', '-------- close of CELL_ANGLE category' ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CELL_LENGTH',
                                [ [ 'item_', '_definition.id', 'CELL_LENGTH' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to describe the lengths of\n     the axes in the crystal unit cell.' ],
                                  [ 'item_', '_name.category_id', 'CELL' ],
                                  [ 'item_', '_name.object_id', 'LENGTH' ],
                                  [ 'save_',
                                    'cell_length.a',
                                    [ [ 'item_', '_definition.id', '_cell_length.a' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_length_a', '_cell.length_a' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The length of the crystal unit cell along the x-axis.' ],
                                      [ 'item_', '_name.category_id', 'length' ],
                                      [ 'item_', '_name.object_id', 'a' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '1.:' ],
                                      [ 'item_', '_units.code', 'angstroms' ] ] ],
                                  [ 'save_',
                                    'cell_length.b',
                                    [ [ 'item_', '_definition.id', '_cell_length.b' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_length_b', '_cell.length_b' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The length of the crystal unit cell along the y-axis.' ],
                                      [ 'item_', '_name.category_id', 'length' ],
                                      [ 'item_', '_name.object_id', 'b' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '1.:' ],
                                      [ 'item_', '_units.code', 'angstroms' ] ] ],
                                  [ 'save_',
                                    'cell_length.c',
                                    [ [ 'item_', '_definition.id', '_cell_length.c' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_length_c', '_cell.length_c' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The length of the crystal unit cell along the z-axis.' ],
                                      [ 'item_', '_name.category_id', 'length' ],
                                      [ 'item_', '_name.object_id', 'c' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '1.:' ],
                                      [ 'item_', '_units.code', 'angstroms' ] ] ] ] ],
                              [ '@comment', '-------- close of CELL_LENGTH category' ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CELL_VECTOR',
                                [ [ 'item_', '_definition.id', 'CELL_VECTOR' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to describe the axial vectors of\n     the crystal unit cell.' ],
                                  [ 'item_', '_name.category_id', 'CELL' ],
                                  [ 'item_', '_name.object_id', 'VECTOR' ],
                                  [ 'save_',
                                    'cell_vector.a',
                                    [ [ 'item_', '_definition.id', '_cell_vector.a' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The cell vector along the x axis.' ],
                                      [ 'item_', '_name.category_id', 'vector' ],
                                      [ 'item_', '_name.object_id', 'a' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    _cell_vector.a = _cell.orthogonal_matrix * Matrix([1,0,0])' ] ] ] ],
                                  [ 'save_',
                                    'cell_vector.b',
                                    [ [ 'item_', '_definition.id', '_cell_vector.b' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The cell vector along the y axis.' ],
                                      [ 'item_', '_name.category_id', 'vector' ],
                                      [ 'item_', '_name.object_id', 'b' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    _cell_vector.b = _cell.orthogonal_matrix * Matrix([0,1,0])' ] ] ] ],
                                  [ 'save_',
                                    'cell_vector.c',
                                    [ [ 'item_', '_definition.id', '_cell_vector.c' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The cell vector along the z axis.' ],
                                      [ 'item_', '_name.category_id', 'vector' ],
                                      [ 'item_', '_name.object_id', 'c' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    _cell_vector.c = _cell.orthogonal_matrix * Matrix([0,0,1])' ] ] ] ] ] ],
                              [ '@comment', '------- close of CELL_VECTOR category' ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CELL_MEASUREMENT',
                                [ [ 'item_', '_definition.id', 'CELL_MEASUREMENT' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to describe the angles between\n     the axes in the crystal unit cell.' ],
                                  [ 'item_', '_name.category_id', 'CELL' ],
                                  [ 'item_', '_name.object_id', 'MEASUREMENT' ],
                                  [ 'save_',
                                    'cell_measurement.pressure',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.pressure' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_pressure' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The pressure at which the unit-cell parameters were measured\n     (not the pressure used to synthesize the sample).' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'pressure' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'kilopascals' ] ] ],
                                  [ 'save_',
                                    'cell_measurement.radiation',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.radiation' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_radiation' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Description of the radiation used to measure the unit-cell data.' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'radiation' ],
                                      [ 'item_', '_type.purpose', 'Describe' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'neutron', 'X-ray tube', 'synchrotron' ] ] ] ],
                                  [ 'save_',
                                    'cell_measurement.reflns_used',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.reflns_used' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_reflns_used' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Total number of reflections used to determine the unit cell.\n     The reflections may be specified as cell_measurement_refln items.' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'reflns_used' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Count' ],
                                      [ 'item_', '_enumeration.range', '3:' ] ] ],
                                  [ 'save_',
                                    'cell_measurement.temperature',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.temperature' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_temperature' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The temperature at which the unit-cell parameters were measured\n     (not the temperature of synthesis).' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'temperature' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'kelvins' ] ] ],
                                  [ 'save_',
                                    'cell_measurement.theta_max',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.theta_max' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_theta_max' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Maximum theta scattering angle of reflections used to measure\n     the crystal unit cell.' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'theta_max' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:90.0' ],
                                      [ 'item_', '_units.code', 'degrees' ] ] ],
                                  [ 'save_',
                                    'cell_measurement.theta_min',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.theta_min' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_theta_min' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Minimum theta scattering angle of reflections used to measure\n     the crystal unit cell.' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'theta_min' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:90.0' ],
                                      [ 'item_', '_units.code', 'degrees' ] ] ],
                                  [ 'save_',
                                    'cell_measurement.wavelength',
                                    [ [ 'item_', '_definition.id', '_cell_measurement.wavelength' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_cell_measurement_wavelength' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Wavelength of the radiation used to measure the unit cell.\n     If this is not specified, the wavelength is assumed to be the\n     same as that given in _diffrn_radiation_wavelength.value' ],
                                      [ 'item_', '_name.category_id', 'measurement' ],
                                      [ 'item_', '_name.object_id', 'wavelength' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:' ],
                                      [ 'item_', '_units.code', 'angstroms' ] ] ],
                                  [ '@comment',
                                    '----------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'CELL_MEASUREMENT_REFLN',
                                    [ [ 'item_', '_definition.id', 'CELL_MEASUREMENT_REFLN' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Loop' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of data items used to describe the reflection data\n     used in the measurement of the crystal unit cell.' ],
                                      [ 'item_', '_name.category_id', 'CELL_MEASUREMENT' ],
                                      [ 'item_', '_name.object_id', 'REFLN' ],
                                      [ 'item_', '_category.key_id', '_cell_measurement_refln.key' ],
                                      [ 'save_',
                                        'cell_measurement_refln.key',
                                        [ [ 'item_', '_definition.id', '_cell_measurement_refln.key' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Value is a unique key to a set of CELL_MEASUREMENT_REFLN items\n     in a looped list.' ],
                                          [ 'item_', '_name.category_id', 'refln' ],
                                          [ 'item_', '_name.object_id', 'key' ],
                                          [ 'item_', '_type.purpose', 'Key' ],
                                          [ 'item_', '_type.source', 'Related' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Implied' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Definition',
                                              '          _type.contents = Type_Contents(cell_measurement_refln.hkl)',
                                              'Evaluation',
                                              '          _cell_measurement_refln.key = _cell_measurement_refln.hkl' ] ] ] ],
                                      [ 'save_',
                                        'cell_measurement_refln.hkl',
                                        [ [ 'item_', '_definition.id', '_cell_measurement_refln.hkl' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Miller indices of a reflection used to measure the unit cell.' ],
                                          [ 'item_', '_name.category_id', 'refln' ],
                                          [ 'item_', '_name.object_id', 'hkl' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Matrix' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_type.dimension', [ '3' ] ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c  as  cell_measurement_refln\n \n     _cell_measurement_refln.hkl = [c.index_h, c.index_k, c.index_l]' ] ] ] ],
                                      [ 'save_',
                                        'cell_measurement_refln.theta',
                                        [ [ 'item_', '_definition.id', '_cell_measurement_refln.theta' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_measurement_refln_theta' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Theta angle of reflection used to measure the crystal unit cell.' ],
                                          [ 'item_', '_name.category_id', 'refln' ],
                                          [ 'item_', '_name.object_id', 'theta' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.0:90.0' ],
                                          [ 'item_', '_units.code', 'degrees' ] ] ],
                                      [ 'save_',
                                        'cell_measurement_refln.index_h',
                                        [ [ 'item_', '_definition.id', '_cell_measurement_refln.index_h' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_measurement_refln_index_h' ] ],
                                          [ 'item_', '_definition.update', '2013-04-16' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     The index of a reciprocal space vector.' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                                          [ 'item_', '_units.code', 'none' ],
                                          [ 'item_', '_name.category_id', 'refln' ],
                                          [ 'item_', '_name.object_id', 'index_h' ] ] ],
                                      [ 'save_',
                                        'cell_measurement_refln.index_k',
                                        [ [ 'item_', '_definition.id', '_cell_measurement_refln.index_k' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_measurement_refln_index_k' ] ],
                                          [ 'item_', '_definition.update', '2013-04-16' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     The index of a reciprocal space vector.' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                                          [ 'item_', '_units.code', 'none' ],
                                          [ 'item_', '_name.category_id', 'refln' ],
                                          [ 'item_', '_name.object_id', 'index_k' ] ] ],
                                      [ 'save_',
                                        'cell_measurement_refln.index_l',
                                        [ [ 'item_', '_definition.id', '_cell_measurement_refln.index_l' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_measurement_refln_index_l' ] ],
                                          [ 'item_', '_definition.update', '2013-04-16' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     The index of a reciprocal space vector.' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Integer' ],
                                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                                          [ 'item_', '_units.code', 'none' ],
                                          [ 'item_', '_name.category_id', 'refln' ],
                                          [ 'item_', '_name.object_id', 'index_l' ] ] ] ] ],
                                  [ '@comment',
                                    '------- close of CELL_MEASUREMENT_REFLN category' ] ] ],
                              [ '@comment', '------- close of CELL_MEASUREMENT category' ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CELL_RECIPROCAL',
                                [ [ 'item_', '_definition.id', 'CELL_RECIPROCAL' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to describe the unit cell data\n     in reciprocal space.' ],
                                  [ 'item_', '_name.category_id', 'CELL' ],
                                  [ 'item_', '_name.object_id', 'RECIPROCAL' ],
                                  [ 'save_',
                                    'cell_reciprocal.convert_Uij_to_betaij',
                                    [ [ 'item_',
                                        '_definition.id',
                                        '_cell_reciprocal.convert_Uij_to_betaij' ],
                                      [ 'item_', '_definition.update', '2013-04-28' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The reciprocal space matrix for converting the U(ij) matrix of\n     atomic displacement parameters to a dimensionless beta(IJ) matrix.\n     The adp factor in a structure factor expression:\n \n     t = exp -2pi**2 ( U11    h h a* a* + ...... 2 U23    k l b* c* )\n     t = exp - 0.25  ( B11    h h a* a* + ...... 2 B23    k l b* c* )\n       = exp -       ( beta11 h h + ............ 2 beta23 k l )\n \n    The conversion of the U or B matrices to the beta matrix\n \n         beta =   C U C   =    C B C /8pi**2\n \n    where C is conversion matrix defined here.' ],
                                      [ 'item_', '_name.category_id', 'reciprocal' ],
                                      [ 'item_', '_name.object_id', 'convert_Uij_to_betaij' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    With r  as  cell_reciprocal_length\n \n    _cell_reciprocal.convert_Uij_to_betaij = \\\n                             1.4142 * Pi * Matrix([[ r.a, 0, 0 ],\n                                                   [ 0, r.b, 0 ],\n                                                   [ 0, 0, r.c ]])' ] ] ] ],
                                  [ 'save_',
                                    'cell_reciprocal.convert_Uiso_to_Uij',
                                    [ [ 'item_',
                                        '_definition.id',
                                        '_cell_reciprocal.convert_Uiso_to_Uij' ],
                                      [ 'item_', '_definition.update', '2013-04-28' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The reciprocal space matrix for converting the isotropic Uiso\n     atomic displacement parameter to the anisotropic matrix Uij.\n \n                       | 1            cos(gamma*)   cos(beta*)  |\n      U[i,j]  = Uiso * | cos(gamma*)  1             cos(alpha*) |\n                       | cos(beta*)   cos(alpha*)   1           |\n ' ],
                                      [ 'item_', '_name.category_id', 'reciprocal' ],
                                      [ 'item_', '_name.object_id', 'convert_Uiso_to_Uij' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    With r  as  cell_reciprocal_angle\n \n    _cell_reciprocal.convert_Uiso_to_Uij = \\\n                          [[ 1., Cosd(r.gamma), Cosd(r.beta)  ],\n                           [ Cosd(r.gamma), 1., Cosd(r.alpha) ],\n                           [ Cosd(r.beta), Cosd(r.alpha), 1.  ]]' ] ] ] ],
                                  [ 'save_',
                                    'cell_reciprocal.metric_tensor',
                                    [ [ 'item_', '_definition.id', '_cell_reciprocal.metric_tensor' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The reciprocal (contravariant) metric tensor used to transform\n     vectors and coordinates from reciprocal space to real (direct)\n     space.' ],
                                      [ 'item_', '_name.category_id', 'reciprocal' ],
                                      [ 'item_', '_name.object_id', 'metric_tensor' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n     with r  as  cell_reciprocal_vector\n \n    _cell_reciprocal.metric_tensor = [[ r.a*r.a, r.a*r.b, r.a*r.c ],\n                                      [ r.b*r.a, r.b*r.b, r.b*r.c ],\n                                      [ r.c*r.a, r.c*r.b, r.c*r.c ]]' ] ] ] ],
                                  [ 'save_',
                                    'cell_reciprocal.orthogonal_matrix',
                                    [ [ 'item_',
                                        '_definition.id',
                                        '_cell_reciprocal.orthogonal_matrix' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Orthogonal matrix of the reciprocal space. The matrix may be\n     used to transform the non-orthogonal vector h = (h,k,l) into\n     the orthogonal indices p = (p,q,r)\n \n                     M h = p' ],
                                      [ 'item_', '_name.category_id', 'reciprocal' ],
                                      [ 'item_', '_name.object_id', 'orthogonal_matrix' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    _cell_reciprocal.orthogonal_matrix  =  Inverse(\n \n                           Transpose( _cell.orthogonal_matrix ))' ] ] ] ],
                                  [ '@comment',
                                    '----------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'CELL_RECIPROCAL_ANGLE',
                                    [ [ 'item_', '_definition.id', 'CELL_RECIPROCAL_ANGLE' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Set' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of data items used to describe the unit cell angles\n     in reciprocal space.' ],
                                      [ 'item_', '_name.category_id', 'CELL_RECIPROCAL' ],
                                      [ 'item_', '_name.object_id', 'ANGLE' ],
                                      [ 'save_',
                                        'cell_reciprocal_angle.alpha',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_angle.alpha' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_reciprocal_angle_alpha' ] ],
                                          [ 'item_', '_definition.update', '2013-01-18' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the angle between _cell_length.b and _cell_length.c.\n     Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n          New York: John Wiley & Sons Inc.' ],
                                          [ 'item_', '_name.category_id', 'angle' ],
                                          [ 'item_', '_name.object_id', 'alpha' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c as cell_angle\n \n    _cell_reciprocal_angle.alpha = Acosd(\n    (Cosd(c.beta)*Cosd(c.gamma)-Cosd(c.alpha))/(Sind(c.beta)*Sind(c.gamma)))' ] ] ] ],
                                      [ 'save_',
                                        'cell_reciprocal_angle.beta',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_angle.beta' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_reciprocal_angle_beta' ] ],
                                          [ 'item_', '_definition.update', '2013-01-18' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the angle between _cell_length.a and _cell_length.c.\n     Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n          New York: John Wiley & Sons Inc.' ],
                                          [ 'item_', '_name.category_id', 'angle' ],
                                          [ 'item_', '_name.object_id', 'beta' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c as cell_angle\n \n    _cell_reciprocal_angle.beta = Acosd(\n    (Cosd(c.alpha)*Cosd(c.gamma)-Cosd(c.beta))/(Sind(c.alpha)*Sind(c.gamma)))' ] ] ] ],
                                      [ 'save_',
                                        'cell_reciprocal_angle.gamma',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_angle.gamma' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_reciprocal_angle_gamma' ] ],
                                          [ 'item_', '_definition.update', '2013-01-18' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the angle between _cell_length.a and _cell_length.b.\n     Ref: Buerger, M. J. (1942). X-ray Crystallography, p. 360.\n          New York: John Wiley & Sons Inc.' ],
                                          [ 'item_', '_name.category_id', 'angle' ],
                                          [ 'item_', '_name.object_id', 'gamma' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.:180.' ],
                                          [ 'item_', '_units.code', 'degrees' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c as cell_angle\n \n    _cell_reciprocal_angle.gamma = Acosd(\n    (Cosd(c.alpha)*Cosd(c.beta)-Cosd(c.gamma))/(Sind(c.alpha)*Sind(c.beta)))' ] ] ] ] ] ],
                                  [ '@comment',
                                    '--------- close of CELL_RECIPROCAL_ANGLE category' ],
                                  [ '@comment',
                                    '----------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'CELL_RECIPROCAL_LENGTH',
                                    [ [ 'item_', '_definition.id', 'CELL_RECIPROCAL_LENGTH' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Set' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of data items used to describe the unit cell lengths\n     in reciprocal space.' ],
                                      [ 'item_', '_name.category_id', 'CELL_RECIPROCAL' ],
                                      [ 'item_', '_name.object_id', 'LENGTH' ],
                                      [ 'save_',
                                        'cell_reciprocal_length.a',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_length.a' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_reciprocal_length_a' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the _cell_length.a.' ],
                                          [ 'item_', '_name.category_id', 'length' ],
                                          [ 'item_', '_name.object_id', 'a' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.:' ],
                                          [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n    _cell_reciprocal_length.a = Norm ( _cell_reciprocal_vector.a )' ] ] ] ],
                                      [ 'save_',
                                        'cell_reciprocal_length.b',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_length.b' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_reciprocal_length_b' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the _cell_length.b.' ],
                                          [ 'item_', '_name.category_id', 'length' ],
                                          [ 'item_', '_name.object_id', 'b' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.:' ],
                                          [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n    _cell_reciprocal_length.b = Norm ( _cell_reciprocal_vector.b )' ] ] ] ],
                                      [ 'save_',
                                        'cell_reciprocal_length.c',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_length.c' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_cell_reciprocal_length_c' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the _cell_length.c.' ],
                                          [ 'item_', '_name.category_id', 'length' ],
                                          [ 'item_', '_name.object_id', 'c' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_enumeration.range', '0.:' ],
                                          [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n    _cell_reciprocal_length.c = Norm ( _cell_reciprocal_vector.c )' ] ] ] ] ] ],
                                  [ '@comment',
                                    '--------- close of CELL_RECIPROCAL_LENGTH category' ],
                                  [ '@comment',
                                    '----------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'CELL_RECIPROCAL_VECTOR',
                                    [ [ 'item_', '_definition.id', 'CELL_RECIPROCAL_VECTOR' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Set' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of data items used to describe the unit cell vectors\n     in reciprocal space.' ],
                                      [ 'item_', '_name.category_id', 'CELL_RECIPROCAL' ],
                                      [ 'item_', '_name.object_id', 'VECTOR' ],
                                      [ 'save_',
                                        'cell_reciprocal_vector.a',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_vector.a' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the _cell_vector.a.' ],
                                          [ 'item_', '_name.category_id', 'vector' ],
                                          [ 'item_', '_name.object_id', 'a' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Matrix' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_type.dimension', [ '3' ] ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c  as  cell_vector\n \n    _cell_reciprocal_vector.a = c.b ^ c.c / _cell.volume' ] ] ] ],
                                      [ 'save_',
                                        'cell_reciprocal_vector.b',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_vector.b' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the _cell_vector.b.' ],
                                          [ 'item_', '_name.category_id', 'vector' ],
                                          [ 'item_', '_name.object_id', 'b' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Matrix' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_type.dimension', [ '3' ] ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c  as  cell_vector\n \n    _cell_reciprocal_vector.b = c.c ^ c.a / _cell.volume' ] ] ] ],
                                      [ 'save_',
                                        'cell_reciprocal_vector.c',
                                        [ [ 'item_', '_definition.id', '_cell_reciprocal_vector.c' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Reciprocal of the _cell_vector.c.' ],
                                          [ 'item_', '_name.category_id', 'vector' ],
                                          [ 'item_', '_name.object_id', 'c' ],
                                          [ 'item_', '_type.purpose', 'Measurand' ],
                                          [ 'item_', '_type.source', 'Derived' ],
                                          [ 'item_', '_type.container', 'Matrix' ],
                                          [ 'item_', '_type.contents', 'Real' ],
                                          [ 'item_', '_type.dimension', [ '3' ] ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Evaluation',
                                              '\n     With c  as  cell_vector\n \n    _cell_reciprocal_vector.c = c.a ^ c.b / _cell.volume' ] ] ] ] ] ],
                                  [ '@comment',
                                    '--------- close of CELL_RECIPROCAL_VECTOR category' ] ] ],
                              [ '@comment', '--------- close of CELL_RECIPROCAL category' ] ] ],
                          [ '@comment', '--------- close of CELL category' ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'CHEMICAL',
                            [ [ 'item_', '_definition.id', 'CHEMICAL' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which describe the composition and\n     chemical properties of the compound under study. The formula data\n     items must be consistent with the density, unit-cell and Z values.' ],
                              [ 'item_', '_name.category_id', 'EXPTL' ],
                              [ 'item_', '_name.object_id', 'CHEMICAL' ],
                              [ 'save_',
                                'chemical.absolute_configuration',
                                [ [ 'item_', '_definition.id', '_chemical.absolute_configuration' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_absolute_configuration' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Necessary conditions for this assignment are given by\n          Flack, H. D. & Bernardinelli, G. (1999). Acta Cryst. A55,\n                       908-915. (http://www.iucr.org/paper?sh0129)\n          Flack, H. D. & Bernardinelli, G. (2000). J. Appl. Cryst.\n                       33, 1143-1148. (http://www.iucr.org/paper?ks0021)' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'absolute_configuration' ],
                                  [ 'item_', '_type.purpose', 'State' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                    [ 'rm',
                                      '       \'reference molecule\' Absolute configuration established by\n         the structure determination of a compound containing a\n         chiral reference molecule of known absolute configuration.',
                                      'ad',
                                      '       \'anomalous dispersion\' Absolute configuration established by\n         a-d effects in diffraction measurements on the crystal.',
                                      'rmad',
                                      '       \'rm + ad\' Absolute configuration established by the structure\n         determination of a compound containing a chiral reference\n         molecule of known absolute configuration and confirmed by\n         a-d effects in diffraction measurements on the crystal.',
                                      'syn',
                                      '       \'synthetic\' Absolute configuration has not been established\n         by anomalous-dispersion effects in diffraction measurements on\n         the crystal. The enantiomer has been assigned by reference to\n         an unchanging chiral centre in the synthetic procedure.',
                                      'unk',
                                      '       \'unknown\' No firm chemical or a-d evidence for an assignment\n         is available. An arbitrary choice of enantiomer has been made.',
                                      '.',
                                      'inapplicable' ] ],
                                  [ 'item_', '_enumeration.default', '.' ] ] ],
                              [ 'save_',
                                'chemical.compound_source',
                                [ [ 'item_', '_definition.id', '_chemical.compound_source' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_compound_source' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Description of the source of the compound under study, or of the\n     parent  molecule if a simple derivative is studied. This includes\n     the place of  discovery for minerals or the actual source of a\n     natural product.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'compound_source' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'chemical.enantioexcess_bulk',
                                [ [ 'item_', '_definition.id', '_chemical.enantioexcess_bulk' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_enantioexcess_bulk' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The enantioexcess of the bulk material from which the crystals\n     were grown. A value of 0.0 indicates the racemate. A value of\n     1.0 indicates that the compound is enantiomerically pure.\n     Enantioexcess is defined in the IUPAC Recommendations\n     (Moss et al., 1996). The composition of the crystal\n     and bulk must be the same.\n     Ref: Moss G. P. et al. (1996). Basic Terminology of\n          Stereochemistry. Pure Appl. Chem., 68, 2193-2222.\n          http://www.chem.qmul.ac.uk/iupac/stereo/index.html' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'enantioexcess_bulk' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'chemical.enantioexcess_bulk_technique',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.enantioexcess_bulk_technique' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_enantioexcess_bulk_technique' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Technique used to determine the enantioexcess of the bulk compound.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'enantioexcess_bulk_technique' ],
                                  [ 'item_', '_type.purpose', 'State' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                    [ 'OA',
                                      '    Enantioexcess determined by measurement of the specific rotation\n     of the optical activity of the bulk compound in solution.',
                                      'CD',
                                      '    Enantioexcess determined by measurement of the visible/near UV\n     circular dichroism spectrum of the bulk compound in solution.',
                                      'EC',
                                      '    Enantioexcess determined by enantioselective chromatography of\n     the bulk compound in solution.',
                                      'other',
                                      '    Enantioexcess determined by a technique not in this list.' ] ],
                                  [ 'item_', '_enumeration.default', 'OA' ] ] ],
                              [ 'save_',
                                'chemical.enantioexcess_crystal',
                                [ [ 'item_', '_definition.id', '_chemical.enantioexcess_crystal' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_enantioexcess_crystal' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The enantioexcess of the crystal used for the diffraction\n     study. A value of 0.0 indicates the racemate. A value of\n     1.0 indicates that the crystal is enantiomerically pure.\n     Enantioexcess is defined in the IUPAC Recommendations\n     (Moss et al., 1996).\n     Ref: Moss G. P. et al. (1996). Basic Terminology of\n          Stereochemistry. Pure Appl. Chem., 68, 2193-2222.\n          http://www.chem.qmul.ac.uk/iupac/stereo/index.html' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'enantioexcess_crystal' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'chemical.enantioexcess_crystal_technique',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.enantioexcess_crystal_technique' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_enantioexcess_crystal_technique' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Technique used to determine the enantioexcess of the crystal.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'enantioexcess_crystal_technique' ],
                                  [ 'item_', '_type.purpose', 'State' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                    [ 'CD',
                                      '    Enantioexcess determined by measurement of the visible/near UV\n     circular dichroism spectrum of the crystal taken into solution.',
                                      'EC',
                                      '    Enantioexcess determined by enantioselective chromatography of\n     the crystal taken into solution.',
                                      'other',
                                      '    Enantioexcess determined by a technique not in this list.' ] ],
                                  [ 'item_', '_enumeration.default', 'CD' ] ] ],
                              [ 'save_',
                                'chemical.identifier_inchi',
                                [ [ 'item_', '_definition.id', '_chemical.identifier_inchi' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_identifier_inchi' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The IUPAC International Chemical Identifier (InChI) is a\n     textual identifier for chemical substances, designed to provide\n     a standard and human-readable way to encode molecular information\n     and to facilitate the search for such information in databases\n     and on the web.\n     Ref: McNaught, A. (2006). Chem. Int. (IUPAC), 28 (6), 12-14.\n          http://www.iupac.org/inchi/' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'identifier_inchi' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case', '_description_example.detail' ],
                                    [ 'InChI=1/C10H8/c1-2-6-10-8-4-3-7-9(10)5-1/h1-8H\'',
                                      'naphthalene' ] ] ] ],
                              [ 'save_',
                                'chemical.identifier_inchi_key',
                                [ [ 'item_', '_definition.id', '_chemical.identifier_inchi_key' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_identifier_inchi_key' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The InChIKey is a compact hashed version of the full InChI\n     (IUPAC International Chemical Identifier), designed to allow\n     for easy web searches of chemical compounds. See\n     http://www.iupac.org/inchi/' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'identifier_inchi_key' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case', '_description_example.detail' ],
                                    [ 'InChIKey=OROGSEYTTFOCAN-DNJOTXNNBG', 'codeine' ] ] ] ],
                              [ 'save_',
                                'chemical.identifier_inchi_version',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.identifier_inchi_version' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_identifier_inchi_version' ] ],
                                  [ 'item_', '_definition.update', '2013-01-18' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Version number of the InChI standard to which the associated\n     chemical identifier string applies.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'identifier_inchi_version' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_', [ '_description_example.case' ], [ '1.03' ] ] ] ],
                              [ 'save_',
                                'chemical.melting_point',
                                [ [ 'item_', '_definition.id', '_chemical.melting_point' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_melting_point' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature at which a crystalline solid changes to a liquid.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'melting_point' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.melting_point_gt',
                                [ [ 'item_', '_definition.id', '_chemical.melting_point_gt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_melting_point_gt' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     A temperature above which the melting point lies.\n     _chemical.melting_point should be used in preference where possible.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'melting_point_gt' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.melting_point_lt',
                                [ [ 'item_', '_definition.id', '_chemical.melting_point_lt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_melting_point_lt' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     A temperature below which the melting point lies.\n     _chemical.melting_point should be used in preference where possible.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'melting_point_lt' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.name_common',
                                [ [ 'item_', '_definition.id', '_chemical.name_common' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_name_common' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Trivial name by which the compound is commonly known.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'name_common' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'chemical.name_mineral',
                                [ [ 'item_', '_definition.id', '_chemical.name_mineral' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_name_mineral' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Mineral name accepted by the International Mineralogical Association.\n     Use only for natural minerals.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'name_mineral' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'chemical.name_structure_type',
                                [ [ 'item_', '_definition.id', '_chemical.name_structure_type' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_name_structure_type' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Commonly used structure-type name. Usually only applied to\n     minerals or inorganic compounds.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'name_structure_type' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'chemical.name_systematic',
                                [ [ 'item_', '_definition.id', '_chemical.name_systematic' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_name_systematic' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     IUPAC or Chemical Abstracts full name of compound.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'name_systematic' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'chemical.optical_rotation',
                                [ [ 'item_', '_definition.id', '_chemical.optical_rotation' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_optical_rotation' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The optical rotation in solution of the compound is\n     specified in the following format:\n \n        \'[\\a]^TEMP^~WAVE~ = SORT (c = CONC, SOLV)\'\n \n     where: TEMP is the temperature of the measurement in degrees Celsius,\n            WAVE is an indication of the wavelength of the light\n                 used for the measurement,\n            CONC is the concentration of the solution given as the\n                 mass of the substance in g in 100 ml of solution,\n            SORT is the signed value (preceded by a + or a - sign)\n                 of 100.\\a/(l.c), where \\a is the signed optical\n                 rotation in degrees measured in a cell of length l in\n                 dm and c is the value of CONC in g, and\n            SOLV is the chemical formula of the solvent.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'optical_rotation' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ '[\\a]^25^~D~ = +108 (c = 3.42, CHCl~3~)' ] ] ] ],
                              [ 'save_',
                                'chemical.properties_biological',
                                [ [ 'item_', '_definition.id', '_chemical.properties_biological' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_properties_biological' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n    A description of the biological properties of the material.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'properties_biological' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ '    diverse biological activities including use as a laxative\n     and strong antibacterial activity against S. aureus and weak\n     activity against cyclooxygenase-1 (COX-1)',
                                      '    antibiotic activity against Bacillus subtilis (ATCC 6051) but no\n     significant activity against Candida albicans (ATCC 14053),\n     Aspergillus flavus (NRRL 6541) & Fusarium verticillioides (NRRL 25457)',
                                      '    weakly potent lipoxygenase nonredox inhibitor',
                                      '    no influenza A virus sialidase inhibitory & plaque reduction activities',
                                      '    low toxicity against Drosophila melanogaster' ] ] ] ],
                              [ 'save_',
                                'chemical.properties_physical',
                                [ [ 'item_', '_definition.id', '_chemical.properties_physical' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_properties_physical' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n    A description of the physical properties of the material.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'properties_physical' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'air-sensitive',
                                      'moisture-sensitive',
                                      'hygroscopic',
                                      'deliquescent',
                                      'oxygen-sensitive',
                                      'photo-sensitive',
                                      'pyrophoric',
                                      'semiconductor',
                                      'ferromagnetic at low temperature',
                                      'paramagnetic and thermochromic' ] ] ] ],
                              [ 'save_',
                                'chemical.temperature_decomposition',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.temperature_decomposition' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_temperature_decomposition' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature at which a crystalline solid decomposes.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'temperature_decomposition' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.temperature_decomposition_gt',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.temperature_decomposition_gt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_temperature_decomposition_gt' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature above which a crystalline solid decomposes.\n    _chemical.temperature_decomposition should be used in preference.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'temperature_decomposition_gt' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.temperature_decomposition_lt',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.temperature_decomposition_lt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_temperature_decomposition_lt' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature below which a crystalline solid decomposes.\n    _chemical.temperature_decomposition should be used in preference.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'temperature_decomposition_lt' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.temperature_sublimation',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.temperature_sublimation' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_temperature_sublimation' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature at which a crystalline solid sublimates.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'temperature_sublimation' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.temperature_sublimation_gt',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.temperature_sublimation_gt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_temperature_sublimation_gt' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature above which a crystalline solid sublimates.\n    _chemical.temperature_sublimation should be used in preference.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'temperature_sublimation_gt' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ 'save_',
                                'chemical.temperature_sublimation_lt',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_chemical.temperature_sublimation_lt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_chemical_temperature_sublimation_lt' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The temperature below which a crystalline solid sublimates.\n    _chemical.temperature_sublimation should be used in preference.' ],
                                  [ 'item_', '_name.category_id', 'chemical' ],
                                  [ 'item_', '_name.object_id', 'temperature_sublimation_lt' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'kelvins' ] ] ],
                              [ '@comment',
                                '============================================================================' ],
                              [ 'save_',
                                'CHEMICAL_CONN_ATOM',
                                [ [ 'item_', '_definition.id', 'CHEMICAL_CONN_ATOM' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Loop' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items which describe the 2D chemical structure of\n     the molecular species. They allow a 2D chemical diagram to be\n     reconstructed for use in a publication or in a database search\n     for structural and substructural relationships. In particular,\n     the chemical_conn_atom data items provide information about the\n     chemical properties of the atoms in the structure. In cases\n     where crystallographic and molecular symmetry elements coincide\n     they must also contain symmetry-generated atoms, so as to describe\n     a complete chemical entity.\n ' ],
                                  [ 'item_', '_name.object_id', 'CONN_ATOM' ],
                                  [ 'item_', '_name.category_id', 'CHEMICAL' ],
                                  [ 'item_', '_category.key_id', '_chemical_conn_atom.key' ],
                                  [ 'save_',
                                    'chemical_conn_atom.key',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.key' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Value is a unique key to a set of CHEMICAL_CONN_ATOM items\n     in a looped list.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'key' ],
                                      [ 'item_', '_type.purpose', 'Key' ],
                                      [ 'item_', '_type.source', 'Related' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Implied' ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Definition',
                                          '         _type.contents = Type_Contents(chemical_conn_atom.number))',
                                          'Evaluation',
                                          '         _chemical_conn_atom.key = _chemical_conn_atom.number' ] ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.charge',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.charge' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_charge' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The net integer charge assigned to this atom. This is the\n     formal charge assignment normally found in chemical diagrams.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'charge' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Integer' ],
                                      [ 'item_', '_enumeration.range', '-6:6' ],
                                      [ 'item_', '_enumeration.default', '0' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.display_x',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.display_x' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_display_x' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Cartesian coordinate (x) of the atom site in a chemical diagram. The\n     coordinate origin is at the lower left corner, the x axis is horizontal.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'display_x' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                      [ 'item_', '_units.code', 'none' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.display_y',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.display_y' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_display_y' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Cartesian coordinate (y) of the atom site in a chemical diagram. The\n     coordinate origin is at the lower left corner, the y axis is vertical.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'display_y' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                      [ 'item_', '_units.code', 'none' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.NCA',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.NCA' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_NCA' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Total number of connected atoms excluding terminal hydrogen atoms.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'NCA' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Count' ],
                                      [ 'item_', '_enumeration.range', '0:' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.NH',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.NH' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_NH' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Total number of hydrogen atoms attached to this atom,\n     regardless of whether they are included in the refinement or\n     the atom_site list. This number will be the same as\n     _atom_site.attached_hydrogens only if none of the hydrogen\n     atoms appear in the atom_site list.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'NH' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Count' ],
                                      [ 'item_', '_enumeration.range', '0:' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.number',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.number' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_number' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The chemical sequence number to be associated with this atom.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'number' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Index' ],
                                      [ 'item_', '_enumeration.range', '1:' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_atom.type_symbol',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_atom.type_symbol' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_atom_type_symbol' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     A code identifying the atom type.' ],
                                      [ 'item_', '_name.category_id', 'conn_atom' ],
                                      [ 'item_', '_name.object_id', 'type_symbol' ],
                                      [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                                      [ 'item_', '_type.purpose', 'Link' ],
                                      [ 'item_', '_type.source', 'Related' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
                              [ '@comment', '------ close the CHEMICAL_CONN_ATOM category' ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CHEMICAL_CONN_BOND',
                                [ [ 'item_', '_definition.id', 'CHEMICAL_CONN_BOND' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Loop' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items which specify the connections between\n     the atoms sites in the chemical_conn_atom list and the nature\n     of the chemical bond between these atoms. These are details about\n     the two-dimensional (2D) chemical structure of the molecular species.\n     They allow a 2D chemical diagram to be reconstructed for use in a\n     publication or in a database search for structural and substructural\n     relationships.\n ' ],
                                  [ 'item_', '_name.category_id', 'CHEMICAL' ],
                                  [ 'item_', '_name.object_id', 'CONN_BOND' ],
                                  [ 'item_', '_category.key_id', '_chemical_conn_bond.key' ],
                                  [ 'save_',
                                    'chemical_conn_bond.key',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_bond.key' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Value is a unique key to a set of CHEMICAL_CONN_BOND items\n     in a looped list.' ],
                                      [ 'item_', '_name.category_id', 'conn_bond' ],
                                      [ 'item_', '_name.object_id', 'key' ],
                                      [ 'item_', '_type.purpose', 'Key' ],
                                      [ 'item_', '_type.source', 'Related' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Implied' ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Definition',
                                          '         _type.contents = Type_Contents(chemical_conn_bond.id)',
                                          'Evaluation',
                                          '         _chemical_conn_bond.key = _chemical_conn_bond.id' ] ] ] ],
                                  [ 'save_',
                                    'chemical_conn_bond.atom_1',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_bond.atom_1' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_bond_atom_1' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Index id of first atom in a bond connecting two atom sites.' ],
                                      [ 'item_', '_name.category_id', 'conn_bond' ],
                                      [ 'item_', '_name.object_id', 'atom_1' ],
                                      [ 'item_', '_name.linked_item_id', '_chemical_conn_atom.number' ],
                                      [ 'item_', '_type.purpose', 'Link' ],
                                      [ 'item_', '_type.source', 'Related' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Index' ],
                                      [ 'item_', '_enumeration.range', '1:' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_bond.atom_2',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_bond.atom_2' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_bond_atom_2' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Index id of second atom in a bond connecting two atom sites.' ],
                                      [ 'item_', '_name.category_id', 'conn_bond' ],
                                      [ 'item_', '_name.linked_item_id', '_chemical_conn_atom.number' ],
                                      [ 'item_', '_name.object_id', 'atom_2' ],
                                      [ 'item_', '_type.purpose', 'Link' ],
                                      [ 'item_', '_type.source', 'Related' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Index' ],
                                      [ 'item_', '_enumeration.range', '1:' ] ] ],
                                  [ 'save_',
                                    'chemical_conn_bond.id',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_bond.id' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Bond identifier composed of a list of two sequence indices\n     specified as _chemical_conn_atom.number values.' ],
                                      [ 'item_', '_name.category_id', 'conn_bond' ],
                                      [ 'item_', '_name.object_id', 'id' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'List' ],
                                      [ 'item_', '_type.contents', 'Index' ],
                                      [ 'item_', '_type.dimension', [ '2' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n    With  c  as  chemical_conn_bond\n \n    _chemical_conn_bond.id =  [ c.atom_1, c.atom_2 ]' ] ] ] ],
                                  [ 'save_',
                                    'chemical_conn_bond.type',
                                    [ [ 'item_', '_definition.id', '_chemical_conn_bond.type' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_conn_bond_type' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Code for the chemical bond type.' ],
                                      [ 'item_', '_name.category_id', 'conn_bond' ],
                                      [ 'item_', '_name.object_id', 'type' ],
                                      [ 'item_', '_type.purpose', 'State' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Code' ],
                                      [ 'loop_',
                                        [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                        [ 'sing',
                                          'single bond',
                                          'doub',
                                          'double bond',
                                          'trip',
                                          'triple bond',
                                          'quad',
                                          'quadruple bond',
                                          'arom',
                                          'aromatic bond',
                                          'poly',
                                          'polymeric bond',
                                          'delo',
                                          'delocalized double bond',
                                          'pi',
                                          'pi bond' ] ],
                                      [ 'item_', '_enumeration.default', 'sing' ] ] ] ] ],
                              [ '@comment', '------ close the CHEMICAL_CONN_BOND category' ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'CHEMICAL_FORMULA',
                                [ [ 'item_', '_definition.id', 'CHEMICAL_FORMULA' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items which specify the composition and chemical\n     properties of the compound. The formula data items must agree\n     with those that specify the density, unit-cell and Z values.\n \n     The following rules apply to the construction of the data items\n     _chemical_formula.analytical, *.structural and *.sum. For the\n     data item *.moiety the formula construction is broken up into\n     residues or moieties, i.e. groups of atoms that form a molecular\n     unit or molecular ion. The  rules given below apply within each\n     moiety but different requirements apply to the way that moieties\n     are connected (see _chemical_formula.moiety).\n \n     1. Only recognized element symbols may be used.\n \n     2. Each element symbol is followed by a \'count\' number. A count of\n        \'1\' may be omitted.\n \n     3. A space or parenthesis must separate each cluster of (element\n        symbol + count).\n \n     4. Where a group of elements is enclosed in parentheses, the\n        multiplier for the group must follow the closing parentheses.\n        That is, all element and group multipliers are assumed to be\n        printed as subscripted numbers. [An exception to this rule\n        exists for *.moiety formulae where pre- and post-multipliers\n        are permitted for molecular units].\n \n     5. Unless the elements are ordered in a manner that corresponds to\n        their chemical structure, as in _chemical_formula.structural,\n        the order of the elements within any group or moiety\n        depends on whether or not carbon is present. If carbon is\n        present, the order should be: C, then H, then the other\n        elements in alphabetical order of their symbol. If carbon is\n        not present, the elements are listed purely in alphabetic order\n        of their symbol. This is the \'Hill\' system used by Chemical\n        Abstracts. This ordering is used in _chemical_formula.moiety\n        and _chemical_formula.sum.\n \n           _chemical_formula.iupac      \'[Mo (C O)4 (C18 H33 P)2]\'\n           _chemical_formula.moiety     \'C40 H66 Mo O4 P2\'\n           _chemical_formula.structural \'((C O)4 (P (C6 H11)3)2)Mo\'\n           _chemical_formula.sum         \'C40 H66 Mo O4 P2\'\n           _chemical_formula.weight      768.81' ],
                                  [ 'item_', '_name.object_id', 'FORMULA' ],
                                  [ 'item_', '_name.category_id', 'CHEMICAL' ],
                                  [ 'save_',
                                    'chemical_formula.analytical',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.analytical' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_analytical' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Formula determined by standard chemical analysis including trace\n     elements. Parentheses are used only for standard uncertainties (su\'s).' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'analytical' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'Fe2.45(2)  Ni1.60(3)  S4' ] ] ] ],
                                  [ 'save_',
                                    'chemical_formula.iupac',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.iupac' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_iupac' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Formula expressed in conformance with IUPAC rules for inorganic\n     and metal-organic compounds where these conflict with the rules\n     for any other chemical_formula entries. Typically used for\n     formatting a formula in accordance with journal rules. This\n     should appear in the data block in addition to the most\n     appropriate of the other chemical_formula data names.\n     Ref: IUPAC (1990). Nomenclature of Inorganic Chemistry.\n          Oxford: Blackwell Scientific Publications.' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'iupac' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ '[Co Re (C12 H22 P)2 (C O)6].0.5C H3 O H' ] ] ] ],
                                  [ 'save_',
                                    'chemical_formula.moiety',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.moiety' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_moiety' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Formula with each discrete bonded residue or ion shown as a\n     separate moiety. See above CHEMICAL_FORMULA for rules\n     for writing chemical formulae. In addition to the general\n     formulae requirements, the following rules apply:\n        1. Moieties are separated by commas \',\'.\n        2. The order of elements within a moiety follows general rule\n           5 in CHEMICAL_FORMULA.\n        3. Parentheses are not used within moieties but may surround\n           a moiety. Parentheses may not be nested.\n        4. Charges should be placed at the end of the moiety. The\n           Singlege \'+\' or \'-\' may be preceded by a numerical multiplier\n           and should be separated from the last (element symbol +\n           count) by a space. Pre- or post-multipliers may be used for\n           individual moieties.' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'moiety' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'C7 H4 Cl Hg N O3 S',
                                          'C12 H17 N4 O S 1+, C6 H2 N3 O7 1-',
                                          'C12 H16 N2 O6, 5(H2 O1)',
                                          '(Cd 2+)3, (C6 N6 Cr 3-)2, 2(H2 O)' ] ] ] ],
                                  [ 'save_',
                                    'chemical_formula.structural',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.structural' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_structural' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     This formula should correspond to the structure as reported, i.e.\n     trace elements not included in atom type and atom site lists should\n     not be included. See category description for the rules for writing\n     chemical formulae for inorganics, organometallics, metal complexes\n     etc., in which  bonded groups are preserved as discrete entities\n     within parentheses, with post-multipliers as required. The order of\n     the elements should give as much information as possible about the\n     chemical structure.  Parentheses may be used and nested as required.\n     This formula should correspond to the structure as actually reported,\n     i.e. trace elements not included in atom-type and atom-site lists\n     should not be included (see also _chemical_formula.analytical).' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'structural' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ '(Pt (N H3)2 (C5 H7 N3 O)2) (Cl O4)2',
                                          'Ca ((Cl O3)2 O)2 (H2 O)6' ] ] ] ],
                                  [ 'save_',
                                    'chemical_formula.sum',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.sum' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_sum' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Chemical formulae in which all discrete bonded residues and ions are\n     summed over the constituent elements, following the ordering given\n     in rule 5 of the CATEGORY description. Parentheses normally not used.' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'sum' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'C18 H19 N7 O8 S' ] ] ] ],
                                  [ 'save_',
                                    'chemical_formula.weight',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.weight' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_weight' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Mass corresponding to the formulae _chemical_formula.structural,\n     *_iupac, *_moiety or *_sum and, together with the Z value and cell\n     parameters yield the density given as _exptl_crystal.density_diffrn.' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'weight' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '1.0:' ],
                                      [ 'item_', '_units.code', 'dalton' ] ] ],
                                  [ 'save_',
                                    'chemical_formula.weight_meas',
                                    [ [ 'item_', '_definition.id', '_chemical_formula.weight_meas' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_chemical_formula_weight_meas' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Formula mass measured by a non-diffraction experiment.' ],
                                      [ 'item_', '_name.category_id', 'formula' ],
                                      [ 'item_', '_name.object_id', 'weight_meas' ],
                                      [ 'item_', '_type.purpose', 'Measurand' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_enumeration.range', '1.0:' ],
                                      [ 'item_', '_units.code', 'dalton' ] ] ] ] ],
                              [ '@comment', '------ close the CHEMICAL_FORMULA category' ] ] ],
                          [ '@comment', '------ close the CHEMICAL category' ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'SPACE_GROUPS',
                            [ [ 'item_', '_definition.id', 'SPACE_GROUPS' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Ref-loop' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Contains all the data items that refer to the space group as a\n     whole, such as its name, crystal system etc. It may be looped,\n     for example, in a list of space groups and their properties.\n \n     Only a subset of the SPACE_GROUP category items appear in the\n     core dictionary.  The remainder are found in the cif_sym\n     dictionary.\n \n     Space group types are identified by their International Tables\n     for Crystallography Vol. A number. Specific settings of the\n     space groups can be identified either by their Hall symbol\n     or by specifying their symmetry operations.\n \n     The commonly-used Hermann-Mauguin symbol determines the\n     space group type uniquely but several different Hermann-Mauguin\n     symbols may refer to the same space group type. It contains\n     information on the choice of the basis, but not on the\n     choice of origin.  Different formats for the Hermann-Mauguin\n     symbol are found in the cif_sym dictionary.\n ' ],
                              [ 'item_', '_name.category_id', 'EXPTL' ],
                              [ 'item_', '_name.object_id', 'SPACE_GROUPS' ],
                              [ 'item_', '_category.key_id', '_space_groups.key' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '\n     In an instance document this category is typically invoked as\n \n            loop_ _exptl_crystals.key\n                           ${"frame":"space_group_1"}$\n                           ${"frame":"space_group_2"}$' ] ],
                              [ 'save_',
                                'space_groups.key',
                                [ [ 'item_', '_definition.id', '_space_groups.key' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Unique key code to a set of SPACE_GROUP items in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'space_groups' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Ref-table' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ '       ${"frame":"sg_set_1}$      ' ] ] ] ],
                              [ '@comment',
                                '----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'SPACE_GROUP',
                                [ [ 'item_', '_definition.id', 'SPACE_GROUP' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Set' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to specify space group\n     information about the crystal used in the diffraction measurements.' ],
                                  [ 'item_', '_name.category_id', 'SPACE_GROUPS' ],
                                  [ 'item_', '_name.object_id', 'SPACE_GROUP' ],
                                  [ 'save_',
                                    'space_group.id',
                                    [ [ 'item_', '_definition.id', '_space_group.id' ],
                                      [ 'loop_', [ '_alias.definition_id' ], [ '_space_group_id' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Code identifying a space group if multiple symmetries.\n     See _exptl_crystals.key.' ],
                                      [ 'item_', '_name.category_id', 'space_group' ],
                                      [ 'item_', '_name.object_id', 'id' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Code' ] ] ],
                                  [ 'save_',
                                    'space_group.IT_number',
                                    [ [ 'item_', '_definition.id', '_space_group.IT_number' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_space_group_IT_number' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The number as assigned in International Tables for Crystallography\n     Vol A, specifying the proper affine class (i.e. the orientation\n     preserving affine class) of space groups (crystallographic space\n     group type) to which the space group belongs. This number defines\n     the space group type but not the coordinate system expressed.' ],
                                      [ 'item_', '_name.category_id', 'space_group' ],
                                      [ 'item_', '_name.object_id', 'IT_number' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Integer' ],
                                      [ 'item_', '_enumeration.range', '1:' ] ] ],
                                  [ 'save_',
                                    'space_group.name_Hall',
                                    [ [ 'item_', '_definition.id', '_space_group.name_Hall' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_space_group_name_Hall' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Space group symbol defined by Hall. Each component of the\n     space group name is separated by a space or an underscore.\n     The use of space is strongly recommended because it specifies\n     the coordinate system. The underscore in the name is only\n     retained because it was used in earlier archived files. It\n     should not be used in new CIFs.\n     Ref: Hall, S. R. (1981). Acta Cryst. A37, 517-525\n          [See also International Tables for Crystallography,\n          Vol.B (1993) 1.4 Appendix B]' ],
                                      [ 'item_', '_name.category_id', 'space_group' ],
                                      [ 'item_', '_name.object_id', 'name_Hall' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case' ],
                                        [ 'P 2ac  2n', '-R 3 2"', 'P 61 2 2 (0 0 -1)' ] ] ] ],
                                  [ 'save_',
                                    'space_group.name_H_M_alt',
                                    [ [ 'item_', '_definition.id', '_space_group.name_H_M_alt' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_space_group_name_H-M_alt' ] ],
                                      [ 'item_', '_definition.update', '2013-03-09' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n    _space_group.name_H_M_alt allows for any Hermann-Mauguin symbol\n     to be given. The way in which this item is used is determined\n     by the user and in general is not intended to be interpreted by\n     computer. It may, for example, be used to give one of the\n     extended Hermann-Mauguin symbols given in Table 4.3.1 of\n     International Tables for Crystallography Vol. A (1995) or\n     a Hermann-Mauguin symbol for a conventional or unconventional\n     setting.\n     Each component of the space group name is separated by a\n     space or underscore. The use of space is strongly\n     recommended.  The underscore is only retained because it\n     was used in earlier archived files. It should not be\n     used in new CIFs. Subscripts should appear without special\n     symbols. Bars should be given as negative signs before the\n     numbers to which they apply.\n     The commonly used Hermann-Mauguin symbol determines the space\n     group type uniquely but a given space group type may be\n     described by more than one Hermann-Mauguin symbol. The space\n     group type is best described using _space_group_IT_number.\n     The Hermann-Mauguin symbol may contain information on the\n     choice of basis though not on the choice of origin. To\n     define the setting uniquely use _space_group.name_Hall or\n     list the symmetry operations.' ],
                                      [ 'item_', '_name.category_id', 'space_group' ],
                                      [ 'item_', '_name.object_id', 'name_H_M_alt' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_',
                                        [ '_description_example.case', '_description_example.detail' ],
                                        [ 'P 1 21/m 1',
                                          'space group No. 10',
                                          'P 2/n 2/n 2/n (origin at -1)',
                                          'space group No. 48 origin 2',
                                          'R -3 2/m',
                                          'space group No. 166 rhomb',
                                          '         loop_\n         _space_group.id\n         _space_group.name_H_M_alt\n                           1    \'C m c m\'\n                           2    \'C 2/c 2/m 21/m\'\n                           3    \'A m a m\'',
                                          'three examples for space group No. 63' ] ] ] ],
                                  [ '@comment',
                                    '-------------------------------------------------------------------------' ],
                                  [ 'save_',
                                    'SPACE_GROUP_SYMOP',
                                    [ [ 'item_', '_definition.id', 'SPACE_GROUP_SYMOP' ],
                                      [ 'item_', '_definition.scope', 'Category' ],
                                      [ 'item_', '_definition.class', 'Loop' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The CATEGORY of data items used to describe symmetry equivalent sites\n     in the crystal unit cell.' ],
                                      [ 'item_', '_name.category_id', 'SPACE_GROUP' ],
                                      [ 'item_', '_name.object_id', 'SYMOP' ],
                                      [ 'item_', '_category.key_id', '_space_group_symop.key' ],
                                      [ 'save_',
                                        'space_group_symop.key',
                                        [ [ 'item_', '_definition.id', '_space_group_symop.key' ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     Value is a unique key to a set of space_group_symop items\n     in a looped list.' ],
                                          [ 'item_', '_name.category_id', 'symop' ],
                                          [ 'item_', '_name.object_id', 'key' ],
                                          [ 'item_', '_type.purpose', 'Key' ],
                                          [ 'item_', '_type.source', 'Related' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Implied' ],
                                          [ 'loop_',
                                            [ '_method.purpose', '_method.expression' ],
                                            [ 'Definition',
                                              '         _type.contents = Type_Contents(_space_group_symop.id)',
                                              'Evaluation',
                                              '         _symmetry_equiv.key = _space_group_symop.id' ] ] ] ],
                                      [ 'save_',
                                        'space_group_symop.id',
                                        [ [ 'item_', '_definition.id', '_space_group_symop.id' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_space_group_symop_id', '_space_group_symop_sg_id' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     A sequential number that identifies each symmetry operation.\n     The identity operation (i.e. _space_group_symop.operation_xyz\n     set to \'x,y,z\') should be set to 1.' ],
                                          [ 'item_', '_name.category_id', 'symop' ],
                                          [ 'item_', '_name.object_id', 'id' ],
                                          [ 'item_', '_type.purpose', 'Number' ],
                                          [ 'item_', '_type.source', 'Assigned' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Index' ],
                                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                                      [ 'save_',
                                        'space_group_symop.operation_xyz',
                                        [ [ 'item_', '_definition.id', '_space_group_symop.operation_xyz' ],
                                          [ 'loop_',
                                            [ '_alias.definition_id' ],
                                            [ '_space_group_symop_operation_xyz' ] ],
                                          [ 'item_', '_definition.update', '2012-11-22' ],
                                          [ 'item_',
                                            '_description.text',
                                            '\n     A parsable string giving one of the symmetry operations of the\n     space group in algebraic form.  If W is a matrix representation\n     of the rotational part of the symmetry operation defined by the\n     positions and signs of x, y and z, and w is a column of\n     translations defined by fractions, an equivalent position\n     X\' is generated from a given position X by the equation\n \n               X\' = WX + w\n \n     (Note: X is used to represent bold_italics_x in International\n     Tables for Crystallography Vol. A, Part 5)\n \n     When a list of symmetry operations is given, it must contain\n     a complete set of coordinate representatives which generates\n     all the operations of the space group by the addition of\n     all primitive translations of the space group. Such\n     representatives are to be found as the coordinates of\n     the general-equivalent position in International Tables for\n     Crystallography Vol. A (2002), to which it is necessary to\n     add any centring translations shown above the\n     general-equivalent position.\n \n     That is to say, it is necessary to list explicitly all the\n     symmetry operations required to generate all the atoms in\n     the unit cell defined by the setting used.' ],
                                          [ 'item_', '_name.category_id', 'symop' ],
                                          [ 'item_', '_name.object_id', 'operation_xyz' ],
                                          [ 'item_', '_type.purpose', 'Encode' ],
                                          [ 'item_', '_type.source', 'Recorded' ],
                                          [ 'item_', '_type.container', 'Single' ],
                                          [ 'item_', '_type.contents', 'Text' ],
                                          [ 'loop_',
                                            [ '_description_example.case', '_description_example.detail' ],
                                            [ 'x,1/2-y,1/2+z',
                                              'glide reflection through the plane (x,1/4,z) with glide vector (1/2)c' ] ] ] ] ] ],
                                  [ '@comment', '------- close the SPACE_GROUP_SYMOP category' ] ] ],
                              [ '@comment', '------- close the SPACE_GROUP category' ] ] ],
                          [ '@comment', '------- close the SPACE_GROUPS category' ],
                          [ '@comment',
                            '=======================================================================' ],
                          [ 'save_',
                            'SYMMETRY',
                            [ [ 'item_', '_definition.id', 'SYMMETRY' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to describe symmetry information\n     used in crystallographic structure studies.' ],
                              [ 'item_', '_name.category_id', 'EXPTL' ],
                              [ 'item_', '_name.object_id', 'SYMMETRY' ],
                              [ 'save_',
                                'symmetry.cell_setting',
                                [ [ 'item_', '_definition.id', '_symmetry.cell_setting' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_symmetry_cell_setting', '_space_group_crystal_system' ] ],
                                  [ 'item_', '_definition.update', '2013-04-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Code for cell settings for this space-group symmetry.' ],
                                  [ 'item_', '_name.category_id', 'symmetry' ],
                                  [ 'item_', '_name.object_id', 'cell_setting' ],
                                  [ 'item_', '_type.purpose', 'State' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_enumeration_set.state' ],
                                    [ 'triclinic',
                                      'monoclinic',
                                      'orthorhombic',
                                      'tetragonal',
                                      'rhombohedral',
                                      'trigonal',
                                      'hexagonal',
                                      'cubic' ] ],
                                  [ 'item_', '_enumeration.default', 'triclinic' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Validation',
                                      '\n    setting = _symmetry.cell_setting\n    a   = _cell_length.a\n    b   = _cell_length.b\n    c   = _cell_length.c\n    d   = 0.01\n    alp = _cell_angle.alpha\n    bet = _cell_angle.beta\n    gam = _cell_angle.gamma\n    warn_len = \'Possible mismatch between cell lengths and cell setting\'\n    warn_ang = \'Possible mismatch between cell angles and cell setting\'\n \n    If(setting == \'triclinic\') {\n      If( Abs(a-b)<d || Abs(a-c)<d || Abs(b-c)<d )          Alert(\'B\', warn_len)\n      If( Abs(alp-90)<d || Abs(bet-90)<d || Abs(gam-90)<d ) Alert(\'B\', warn_ang)\n    }\n    Else If(setting == \'monoclinic\') {\n      If(( Abs(a-b)<d && Abs(a-c)<d ) ||\n         ( Abs(a-b)<d && Abs(b-c)<d ) ||\n         ( Abs(a-c)<d && Abs(b-c)<d ))                      Alert(\'B\', warn_len)\n      If( Abs(alp-90)<d && Abs(bet-90)<d && Abs(gam-90)<d ) Alert(\'B\', warn_ang)\n      If(( Abs(alp-90)>d && Abs(bet-90)>d ) ||\n         ( Abs(alp-90)>d && Abs(gam-90)>d ) ||\n         ( Abs(bet-90)>d && Abs(gam-90)>d ) )               Throw( warn_ang)\n    }\n    Else If(setting == \'orthorhombic\') {\n      If( Abs(a-b)<d || Abs(a-c)<d || Abs(b-c)<d )          Alert(\'B\',warn_len)\n      If( Abs(alp-90)>d || Abs(bet-90)>d || Abs(gam-90)>d ) Throw( warn_ang)\n    }\n    Else If(setting == \'tetragonal\') {\n      If( Abs(a-b)<d && Abs(a-c)<d && Abs(b-c)<d )          Alert(\'B\',warn_len)\n      If( Abs(a-b)>d && Abs(a-c)>d )                        Throw( warn_len)\n      If( Abs(alp-90)>d || Abs(bet-90)>d || Abs(gam-90)>d ) Throw( warn_ang)\n    }\n    Else If(setting == \'trigonal\' || setting == \'hexagonal\') {\n      If( Abs(a-b)<d && Abs(a-c)<d && Abs(b-c)<d )          Alert(\'B\', warn_len)\n      If( Abs(a-b)>d && Abs(a-c)>d )                        Throw( warn_len)\n      If( Abs(alp-90)<d && Abs(bet-90)<d && Abs(gam-90)<d ) Throw( warn_ang)\n      If( Abs(gam-120)>d || Abs(alp-90)>d || Abs(bet-90)>d) Throw( warn_ang)\n    }\n    Else If(setting == \'rhombohedral\') {\n      If( Abs(a-b)>d || Abs(a-c)>d || Abs(b-c)>d )          Throw( warn_len)\n      If( Abs(alp-90)<d || Abs(bet-90)<d || Abs(gam-90)<d ) Alert(\'B\', warn_ang)\n      If( Abs(alp-bet)>d || Abs(alp-gam)>d || Abs(bet-gam)>d) Throw( warn_ang)\n    }\n    Else If(setting == \'cubic\') {\n      If( Abs(a-b)>d || Abs(a-c)>d || Abs(b-c)>d )          Throw( warn_len)\n      If( Abs(alp-90)>d || Abs(bet-90)>d || Abs(gam-90)>d ) Throw( warn_ang)\n    }' ] ] ] ],
                              [ 'save_',
                                'symmetry.Int_Tables_number',
                                [ [ 'item_', '_definition.id', '_symmetry.Int_Tables_number' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_symmetry_Int_Tables_number' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Space-group number from International Tables for Cryst., Vol. A.' ],
                                  [ 'item_', '_name.category_id', 'symmetry' ],
                                  [ 'item_', '_name.object_id', 'Int_Tables_number' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Index' ],
                                  [ 'item_', '_enumeration.range', '1:230' ] ] ],
                              [ 'save_',
                                'symmetry.multiplicity',
                                [ [ 'item_', '_definition.id', '_symmetry.multiplicity' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Number of unique symmetry elements in the space group.' ],
                                  [ 'item_', '_name.category_id', 'symmetry' ],
                                  [ 'item_', '_name.object_id', 'multiplicity' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Count' ],
                                  [ 'item_', '_enumeration.range', '1:192' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     n =  0\n \n     Loop  s  as  symmetry_equiv  n +=  1\n \n      _symmetry.multiplicity  =   n' ] ] ] ],
                              [ 'save_',
                                'symmetry.space_group_name_Hall',
                                [ [ 'item_', '_definition.id', '_symmetry.space_group_name_Hall' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_symmetry_space_group_name_Hall' ] ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Space-group symbol as described by Hall. This symbol gives the\n     space-group setting explicitly. Leave spaces between the separate\n     components of the symbol.\n     Ref: Hall, S. R. (1981). Acta Cryst. A37, 517-525.' ],
                                  [ 'item_', '_name.category_id', 'symmetry' ],
                                  [ 'item_', '_name.object_id', 'space_group_name_Hall' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'P 2ac  2n', '-R 3 2"', 'P 61 2 2 (0 0 -1)' ] ] ] ],
                              [ 'save_',
                                'symmetry.space_group_name_H_M',
                                [ [ 'item_', '_definition.id', '_symmetry.space_group_name_H_M' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_symmetry_space_group_name_H-M',
                                      '_symmetry.space_group_name_H-M' ] ],
                                  [ 'item_', '_definition.update', '2013-04-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Hermann-Mauguin space-group symbol. Note that the H-M symbol does\n     not necessarily contain complete information about the symmetry\n     and the space-group origin. If used always supply the FULL symbol\n     from International Tables for Crystallography, Vol. A (1987) and\n     indicate the origin and the setting if it is not implicit. If\n     there is any doubt that the equivalent positions can be uniquely\n     deduced from this symbol specify the _symmetry_equiv.pos_as_xyz\n     or *_Hall data items as well. Leave spaces between symbols\n     referring to different axes.' ],
                                  [ 'item_', '_name.category_id', 'symmetry' ],
                                  [ 'item_', '_name.object_id', 'space_group_name_H_M' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'P 1 21/m 1', 'P 2/n 2/n 2/n (origin at -1)', 'R -3 2/m' ] ] ] ],
                              [ '@comment',
                                '-----------------------------------------------------------------------------' ],
                              [ 'save_',
                                'SYMMETRY_EQUIV',
                                [ [ 'item_', '_definition.id', 'SYMMETRY_EQUIV' ],
                                  [ 'item_', '_definition.scope', 'Category' ],
                                  [ 'item_', '_definition.class', 'Loop' ],
                                  [ 'item_', '_definition.update', '2012-11-22' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The CATEGORY of data items used to describe symmetry equivalent sites\n     in the crystal unit cell.' ],
                                  [ 'item_', '_name.category_id', 'SYMMETRY' ],
                                  [ 'item_', '_name.object_id', 'EQUIV' ],
                                  [ 'item_', '_category.key_id', '_symmetry_equiv.key' ],
                                  [ 'save_',
                                    'symmetry_equiv.key',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.key' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Value is a unique key to a set of SYMMETRY_EQUIV items\n     in a looped list.' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'key' ],
                                      [ 'item_', '_type.purpose', 'Key' ],
                                      [ 'item_', '_type.source', 'Related' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Implied' ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Definition',
                                          '         _type.contents = Type_Contents(symmetry_equiv.pos_site_id)',
                                          'Evaluation',
                                          '         _symmetry_equiv.key = _symmetry_equiv.pos_site_id' ] ] ] ],
                                  [ 'save_',
                                    'symmetry_equiv.pos_as_xyz',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.pos_as_xyz' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_symmetry_equiv_pos_as_xyz' ] ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Symmetry equivalent position in the \'xyz\' representation. Except\n     for the space group P1, this data will be repeated in a loop.\n     The format of the data item is as per International Tables for\n     Crystallography, Vol. A. (1987). All equivalent positions should\n     be entered, including those for lattice centring and a centre of\n     symmetry, if present.' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'pos_as_xyz' ],
                                      [ 'item_', '_type.purpose', 'Encode' ],
                                      [ 'item_', '_type.source', 'Recorded' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Text' ],
                                      [ 'loop_', [ '_description_example.case' ], [ '-y+x,-y,1/3+z' ] ] ] ],
                                  [ 'save_',
                                    'symmetry_equiv.pos_site_id',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.pos_site_id' ],
                                      [ 'loop_',
                                        [ '_alias.definition_id' ],
                                        [ '_symmetry_equiv_pos_site_id' ] ],
                                      [ 'item_', '_definition.update', '2012-12-30' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     Index identifying each entry in the _symmetry_equiv.pos_as_xyz\n     list. It is normally the sequence number of the entry in that\n     list, and should be identified with the code \'n\' in the geometry\n     symmetry codes of the form \'n_klm\'.' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'pos_site_id' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Assigned' ],
                                      [ 'item_', '_type.container', 'Single' ],
                                      [ 'item_', '_type.contents', 'Index' ],
                                      [ 'item_', '_enumeration.range', '1:' ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n     _symmetry_equiv.pos_site_id = Current_Row(_symmetry_equiv) + 1' ] ] ] ],
                                  [ 'save_',
                                    'symmetry_equiv.R',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.R' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     A matrix containing the symmetry rotation operations of a space group\n \n                    |  r11  r12  r13  |\n              R  =  |  r21  r22  r23  |\n                    |  r31  r32  r33  |' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'R' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n                       sm =  _symmetry_equiv.Seitz_matrix\n \n        _symmetry_equiv.R =  [[sm[0,0],sm[0,1],sm[0,2]],\n                              [sm[1,0],sm[1,1],sm[1,2]],\n                              [sm[2,0],sm[2,1],sm[2,2]]]' ] ] ] ],
                                  [ 'save_',
                                    'symmetry_equiv.RT',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.RT' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     The TRANSPOSE of the symmetry rotation matrix representing the point\n     group opertions of the space group\n \n                     |  r11  r21  r31  |\n              RT  =  |  r12  r22  r32  |\n                     |  r13  r23  r33  |' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'RT' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n        _symmetry_equiv.RT =  Transpose (_symmetry_equiv.R)' ] ] ] ],
                                  [ 'save_',
                                    'symmetry_equiv.Seitz_matrix',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.Seitz_matrix' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     A matrix containing the symmetry operations of a space group\n     in 4x4 Seitz format.\n \n                    |  r11  r12  r13  t1  |\n       | R  T |     |  r21  r22  r23  t2  |\n       | 0  1 |     |  r31  r32  r33  t3  |\n                    |   0    0    0    1  |' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'Seitz_matrix' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '4', '4' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n   _symmetry_equiv.Seitz_matrix =  SeitzFromJones (_symmetry_equiv.pos_as_xyz)' ] ] ] ],
                                  [ 'save_',
                                    'symmetry_equiv.T',
                                    [ [ 'item_', '_definition.id', '_symmetry_equiv.T' ],
                                      [ 'item_', '_definition.update', '2012-11-22' ],
                                      [ 'item_',
                                        '_description.text',
                                        '\n     A vector containing the symmetry translation operations of a space group.' ],
                                      [ 'item_', '_name.category_id', 'equiv' ],
                                      [ 'item_', '_name.object_id', 'T' ],
                                      [ 'item_', '_type.purpose', 'Number' ],
                                      [ 'item_', '_type.source', 'Derived' ],
                                      [ 'item_', '_type.container', 'Matrix' ],
                                      [ 'item_', '_type.contents', 'Real' ],
                                      [ 'item_', '_type.dimension', [ '3' ] ],
                                      [ 'loop_',
                                        [ '_method.purpose', '_method.expression' ],
                                        [ 'Evaluation',
                                          '\n                       sm =  _symmetry_equiv.Seitz_matrix\n \n        _symmetry_equiv.T =   [sm[0,3],sm[1,3],sm[2,3]]' ] ] ] ] ] ],
                              [ '@comment', '------- close the SYMMETRY_EQUIV category' ] ] ],
                          [ '@comment', '------- close the SYMMETRY category' ] ] ],
                      [ '@comment', '------- close the EXPTL category' ] ] ],
                  [ '@comment', '------- close the EXPERIMENTS category' ] ] ],
              [ '@comment', '------- close the EXPERIMENTAL category' ],
              [ 'save_',
                'DIFFRACTION',
                [ [ 'item_', '_definition.id', 'DIFFRACTION' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Head' ],
                  [ 'item_', '_definition.update', '2012-11-26' ],
                  [ 'item_',
                    '_description.text',
                    '\n    The DICTIONARY group encompassing the CORE DIFFRACTION data items defined\n    and used with in the Crystallographic Information Framework (CIF).' ],
                  [ 'item_', '_name.category_id', 'CIF_CORE' ],
                  [ 'item_', '_name.object_id', 'DIFFRACTION' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'DIFFRN',
                    [ [ 'item_', '_definition.id', 'DIFFRN' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-12-13' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to describe the diffraction experiment.' ],
                      [ 'item_', '_name.category_id', 'DIFFRACTION' ],
                      [ 'item_', '_name.object_id', 'DIFFRN' ],
                      [ 'save_',
                        'diffrn.ambient_environment',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_environment' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_environment' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The gas or liquid environment of the crystal sample, if not air.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_environment' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'He', 'vacuum', 'mother liquor' ] ] ] ],
                      [ 'save_',
                        'diffrn.ambient_pressure',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_pressure' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_pressure' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean hydrostatic  pressure at which intensities were measured.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_pressure' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'kilopascals' ] ] ],
                      [ 'save_',
                        'diffrn.ambient_pressure_gt',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_pressure_gt' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_pressure_gt' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean hydrostatic pressure above which intensities were measured.\n     These items allow for a pressure range to be given.\n    _diffrn.ambient_pressure should be used in preference to this\n     item when possible.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_pressure_gt' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'kilopascals' ] ] ],
                      [ 'save_',
                        'diffrn.ambient_pressure_lt',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_pressure_lt' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_pressure_lt' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean hydrostatic pressure below which intensities were measured.\n     These items allow for a pressure range to be given.\n    _diffrn.ambient_pressure should be used in preference to this\n     item when possible.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_pressure_lt' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'kilopascals' ] ] ],
                      [ 'save_',
                        'diffrn.ambient_temperature',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_temperature' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_temperature',
                              '_diffrn_ambient_temp',
                              '_diffrn.ambient_temp' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean temperature at which intensities were measured.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_temperature' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'kelvins' ] ] ],
                      [ 'save_',
                        'diffrn.ambient_temperature_gt',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_temperature_gt' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_temperature_gt' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean temperature above which intensities were measured.\n     These items allow for a temperature range to be given.\n    _diffrn.ambient_temperature should be used in preference to\n     this item when possible.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_temperature_gt' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'kelvins' ] ] ],
                      [ 'save_',
                        'diffrn.ambient_temperature_lt',
                        [ [ 'item_', '_definition.id', '_diffrn.ambient_temperature_lt' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_ambient_temperature_lt' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean temperature below which intensities were measured.\n     These items allow for a temperature range to be given.\n    _diffrn.ambient_temperature should be used in preference to\n     this item when possible.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'ambient_temperature_lt' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'kelvins' ] ] ],
                      [ 'save_',
                        'diffrn.crystal_treatment',
                        [ [ 'item_', '_definition.id', '_diffrn.crystal_treatment' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_crystal_treatment' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Remarks about how the crystal was treated prior to intensity measurement.\n     Particularly relevant when intensities were measured at low temperature.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'crystal_treatment' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'equilibrated in hutch for 24 hours',
                              'flash frozen in liquid nitrogen',
                              'slow cooled with direct air stream' ] ] ] ],
                      [ 'save_',
                        'diffrn.measured_fraction_theta_full',
                        [ [ 'item_',
                            '_definition.id',
                            '_diffrn.measured_fraction_theta_full' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_measured_fraction_theta_full' ] ],
                          [ 'item_', '_definition.update', '2013-01-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Fraction of unique (symmetry-independent) reflections measured\n     out to _diffrn_reflns.theta_full.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'measured_fraction_theta_full' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:1.0' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'diffrn.measured_fraction_theta_max',
                        [ [ 'item_',
                            '_definition.id',
                            '_diffrn.measured_fraction_theta_max' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_measured_fraction_theta_max' ] ],
                          [ 'item_', '_definition.update', '2013-01-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Fraction of unique (symmetry-independent) reflections measured\n     out to _diffrn_reflns.theta_max.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'measured_fraction_theta_max' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:1.0' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'diffrn.special_details',
                        [ [ 'item_', '_definition.id', '_diffrn.special_details' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_special_details', '_diffrn.details' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Special details of the diffraction measurement process. Should include\n     information about source instability, crystal motion, degradation, etc.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'special_details' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ '\n     The results may not be entirely reliable as the measurement was\n     made during a heat wave when the air-conditioning had failed.' ] ] ] ],
                      [ 'save_',
                        'diffrn.symmetry_description',
                        [ [ 'item_', '_definition.id', '_diffrn.symmetry_description' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_diffrn_symmetry_description' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Recorded diffraction point symmetry, systematic absences and possible\n     space group(s) or superspace group(s) compatible with these.' ],
                          [ 'item_', '_name.category_id', 'diffrn' ],
                          [ 'item_', '_name.object_id', 'symmetry_description' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_ATTENUATOR',
                        [ [ 'item_', '_definition.id', 'DIFFRN_ATTENUATOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the attenuators used in the\n     diffraction source.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'ATTENUATOR' ],
                          [ 'item_', '_category.key_id', '_diffrn_attenuator.key' ],
                          [ 'save_',
                            'diffrn_attenuator.key',
                            [ [ 'item_', '_definition.id', '_diffrn_attenuator.key' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of DIFFRN_ATTENUATOR items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'attenuator' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(diffrn_attenuator.code)',
                                  'Evaluation',
                                  '              _diffrn_attenuator.key = _diffrn_attenuator.code' ] ] ] ],
                          [ 'save_',
                            'diffrn_attenuator.code',
                            [ [ 'item_', '_definition.id', '_diffrn_attenuator.code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_attenuator_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying a particular attenuator setting; referenced by the\n     _diffrn_refln.attenuator_code which is stored with the intensities.' ],
                              [ 'item_', '_name.category_id', 'attenuator' ],
                              [ 'item_', '_name.object_id', 'code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'diffrn_attenuator.material',
                            [ [ 'item_', '_definition.id', '_diffrn_attenuator.material' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_attenuator_material' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the material from which the attenuator is made.' ],
                              [ 'item_', '_name.category_id', 'attenuator' ],
                              [ 'item_', '_name.object_id', 'material' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'diffrn_attenuator.scale',
                            [ [ 'item_', '_definition.id', '_diffrn_attenuator.scale' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_attenuator_scale' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The scale factor applied to a measured intensity if it is reduced by\n     an attenuator identified by _diffrn_attenuator.code.' ],
                              [ 'item_', '_name.category_id', 'attenuator' ],
                              [ 'item_', '_name.object_id', 'scale' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '1.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ] ] ],
                      [ '@comment', '------ close DIFFRN_ATTENUATOR category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_DETECTOR',
                        [ [ 'item_', '_definition.id', 'DIFFRN_DETECTOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the detectors used in the\n     in the measurement of diffraction intensities.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'DETECTOR' ],
                          [ 'save_',
                            'diffrn_detector.description',
                            [ [ 'item_', '_definition.id', '_diffrn_detector.description' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_detector',
                                  '_diffrn_detector',
                                  '_diffrn_detector.detector' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the type of diffraction radiation detector.' ],
                              [ 'item_', '_name.category_id', 'detector' ],
                              [ 'item_', '_name.object_id', 'description' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'photographic film',
                                  'scintillation counter',
                                  'CCD plate',
                                  'BF~3~ counter' ] ] ] ],
                          [ 'save_',
                            'diffrn_detector.area_resol_mean',
                            [ [ 'item_', '_definition.id', '_diffrn_detector.area_resol_mean' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_detector_area_resol_mean' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The resolution limit of an area diffraction radiation detector.' ],
                              [ 'item_', '_name.category_id', 'detector' ],
                              [ 'item_', '_name.object_id', 'area_resol_mean' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'pixel_per_millimetre' ] ] ],
                          [ 'save_',
                            'diffrn_detector.details',
                            [ [ 'item_', '_definition.id', '_diffrn_detector.details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_detector_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of special aspects of the radiation detector.' ],
                              [ 'item_', '_name.category_id', 'detector' ],
                              [ 'item_', '_name.object_id', 'details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'diffrn_detector.dtime',
                            [ [ 'item_', '_definition.id', '_diffrn_detector.dtime' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_detector_dtime',
                                  '_diffrn_radiation.detector_dtime',
                                  '_diffrn_radiation_detector_dtime' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The maximum time between two detector signals that cannot be resolved.' ],
                              [ 'item_', '_name.category_id', 'detector' ],
                              [ 'item_', '_name.object_id', 'dtime' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'microseconds' ] ] ],
                          [ 'save_',
                            'diffrn_detector.make',
                            [ [ 'item_', '_definition.id', '_diffrn_detector.make' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_detector_type', '_diffrn_detector.type' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The make, model or name of the diffraction radiation detector.' ],
                              [ 'item_', '_name.category_id', 'detector' ],
                              [ 'item_', '_name.object_id', 'make' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '------ close DIFFRN_DETECTOR category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_MEASUREMENT',
                        [ [ 'item_', '_definition.id', 'DIFFRN_MEASUREMENT' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the details of the\n     diffraction measurement.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'MEASUREMENT' ],
                          [ 'save_',
                            'diffrn_measurement.details',
                            [ [ 'item_', '_definition.id', '_diffrn_measurement.details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_measurement_details', '_diffrn.measurement_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of special aspects of the diffraction measurement.' ],
                              [ 'item_', '_name.category_id', 'measurement' ],
                              [ 'item_', '_name.object_id', 'details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '440 frames of 0.25\\%' ] ] ] ],
                          [ 'save_',
                            'diffrn_measurement.device_class',
                            [ [ 'item_', '_definition.id', '_diffrn_measurement.device_class' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_measurement_device',
                                  '_diffrn.measurement_device_class',
                                  '_diffrn.measurement.device' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Type of goniometer device used to mount and orient the specimen.' ],
                              [ 'item_', '_name.category_id', 'measurement' ],
                              [ 'item_', '_name.object_id', 'device_class' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'three-circle diffractometer',
                                  'four-circle diffractometer',
                                  '\\k-geometry diffractometer',
                                  'oscillation camera',
                                  'precession camera' ] ] ] ],
                          [ 'save_',
                            'diffrn_measurement.device_details',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_measurement.device_details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_measurement_device_details',
                                  '_diffrn.measurement_device_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Details of the goniometer device used in the diffraction experiment.' ],
                              [ 'item_', '_name.category_id', 'measurement' ],
                              [ 'item_', '_name.object_id', 'device_details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '                                commercial goniometer modified locally to\n                                 allow for 90\\% \\t arc' ] ] ] ],
                          [ 'save_',
                            'diffrn_measurement.device_make',
                            [ [ 'item_', '_definition.id', '_diffrn_measurement.device_make' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_measurement_device_type',
                                  '_diffrn.measurement_device_make',
                                  '_diffrn_measurement_device.type' ] ],
                              [ 'item_', '_definition.update', '2013-03-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The make, model or name of the goniometer device used.' ],
                              [ 'item_', '_name.category_id', 'measurement' ],
                              [ 'item_', '_name.object_id', 'device_make' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'diffrn_measurement.method',
                            [ [ 'item_', '_definition.id', '_diffrn_measurement.method' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_measurement_method', '_diffrn.measurement_method' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of scan method used to measure diffraction intensities.' ],
                              [ 'item_', '_name.category_id', 'measurement' ],
                              [ 'item_', '_name.object_id', 'method' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'profile data from \\q/2\\q scans' ] ] ] ],
                          [ 'save_',
                            'diffrn_measurement.specimen_support',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_measurement.specimen_support' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_measurement_specimen_support',
                                  '_diffrn.measurement_specimen_support' ] ],
                              [ 'item_', '_definition.update', '2013-01-23' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Mounting method for the crystal specimum during data collection.' ],
                              [ 'item_', '_name.category_id', 'measurement' ],
                              [ 'item_', '_name.object_id', 'specimen_support' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'glass capillary', 'quartz capillary', 'fiber', 'metal loop' ] ] ] ] ] ],
                      [ '@comment', '------ close DIFFRN_MEASUREMENT category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_ORIENT',
                        [ [ 'item_', '_definition.id', 'DIFFRN_ORIENT' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the orientation of the crystal\n     axes to the diffractometer goniometer.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'ORIENT' ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'DIFFRN_ORIENT_MATRIX',
                            [ [ 'item_', '_definition.id', 'DIFFRN_ORIENT_MATRIX' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which specify the matrix specifying the\n     orientation of the crystal axes to the diffractometer goniometer.' ],
                              [ 'item_', '_name.category_id', 'DIFFRN_ORIENT' ],
                              [ 'item_', '_name.object_id', 'MATRIX' ],
                              [ 'save_',
                                'diffrn_orient_matrix.type',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.type' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_type' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Description of orientation matrix and how it should be applied to define\n     the orientation of the crystal with respect to the diffractometer axes.' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'type' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UBIJ',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UBIJ' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The 3x3 matrix specifying the orientation of the crystal with\n     respect to the diffractometer axes.' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UBIJ' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With  o  as  diffrn_orient_matrix\n \n      _diffrn_orient_matrix.UBIJ  =   [[ o.ub_11, o.ub_12, o.ub_13 ],\n                                       [ o.ub_21, o.ub_22, o.ub_23 ],\n                                       [ o.ub_31, o.ub_32, o.ub_33 ]]' ] ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_11',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_11' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_11',
                                      '_diffrn_orient_matrix.UB[1][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_11' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_12',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_12' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_12',
                                      '_diffrn_orient_matrix.UB[1][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_12' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_13',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_13' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_13',
                                      '_diffrn_orient_matrix.UB[1][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_13' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_21',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_21' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_21',
                                      '_diffrn_orient_matrix.UB[2][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_21' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_22',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_22' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_22',
                                      '_diffrn_orient_matrix.UB[2][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_22' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_23',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_23' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_23',
                                      '_diffrn_orient_matrix.UB[2][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_23' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_31',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_31' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_31',
                                      '_diffrn_orient_matrix.UB[3][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_31' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_32',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_32' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_32',
                                      '_diffrn_orient_matrix.UB[3][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_32' ] ] ],
                              [ 'save_',
                                'diffrn_orient_matrix.UB_33',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_matrix.UB_33' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_matrix_UB_33',
                                      '_diffrn_orient_matrix.UB[3][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix of\n     the orientation of the crystal axes to the diffractometer goniometer.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'matrix' ],
                                  [ 'item_', '_name.object_id', 'UB_33' ] ] ] ] ],
                          [ '@comment', '------ close DIFFRN_ORIENT_MATRIX category' ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'DIFFRN_ORIENT_REFLN',
                            [ [ 'item_', '_definition.id', 'DIFFRN_ORIENT_REFLN' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which specify the reflections used to\n     calculate the matrix which gives the orientation of the crystal\n     axes to the diffractometer goniometer.' ],
                              [ 'item_', '_name.category_id', 'DIFFRN_ORIENT' ],
                              [ 'item_', '_name.object_id', 'REFLN' ],
                              [ 'item_', '_category.key_id', '_diffrn_orient_refln.key' ],
                              [ 'save_',
                                'diffrn_orient_refln.key',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.key' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of DIFFRN_ORIENT_REFLN items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '          _type.contents = Type_Contents(diffrn_orient_refln.hkl)',
                                      'Evaluation',
                                      '          _diffrn_orient_refln.key = _diffrn_orient_refln.hkl' ] ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.angle_chi',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.angle_chi' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_angle_chi' ] ],
                                  [ 'item_', '_definition.update', '2013-04-15' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Diffractometer angle of a reflection measured at the centre of the\n     diffraction peak and used to determine _diffrn_orient_matrix.UBIJ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '-180.:180.' ],
                                  [ 'item_', '_units.code', 'degrees' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'angle_chi' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.angle_kappa',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.angle_kappa' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_angle_kappa' ] ],
                                  [ 'item_', '_definition.update', '2013-04-15' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Diffractometer angle of a reflection measured at the centre of the\n     diffraction peak and used to determine _diffrn_orient_matrix.UBIJ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '-180.:180.' ],
                                  [ 'item_', '_units.code', 'degrees' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'angle_kappa' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.angle_omega',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.angle_omega' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_angle_omega' ] ],
                                  [ 'item_', '_definition.update', '2013-04-15' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Diffractometer angle of a reflection measured at the centre of the\n     diffraction peak and used to determine _diffrn_orient_matrix.UBIJ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '-180.:180.' ],
                                  [ 'item_', '_units.code', 'degrees' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'angle_omega' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.angle_phi',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.angle_phi' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_angle_phi' ] ],
                                  [ 'item_', '_definition.update', '2013-04-15' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Diffractometer angle of a reflection measured at the centre of the\n     diffraction peak and used to determine _diffrn_orient_matrix.UBIJ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '-180.:180.' ],
                                  [ 'item_', '_units.code', 'degrees' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'angle_phi' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.angle_psi',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.angle_psi' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_angle_psi' ] ],
                                  [ 'item_', '_definition.update', '2013-04-15' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Diffractometer angle of a reflection measured at the centre of the\n     diffraction peak and used to determine _diffrn_orient_matrix.UBIJ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '-180.:180.' ],
                                  [ 'item_', '_units.code', 'degrees' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'angle_psi' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.angle_theta',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.angle_theta' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_angle_theta' ] ],
                                  [ 'item_', '_definition.update', '2013-04-15' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Diffractometer angle of a reflection measured at the centre of the\n     diffraction peak and used to determine _diffrn_orient_matrix.UBIJ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '-180.:180.' ],
                                  [ 'item_', '_units.code', 'degrees' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'angle_theta' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.hkl',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.hkl' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Miller indices of a reflection used to define the orientation matrix.' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'hkl' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_type.dimension', [ '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a as diffrn_orient_refln\n \n       _diffrn_orient_refln.hkl =  [a.index_h, a.index_k, a.index_l]' ] ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.index_h',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.index_h' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_index_h' ] ],
                                  [ 'item_', '_definition.update', '2013-04-16' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The index of a reciprocal space vector.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_enumeration.range', '-1000:1000' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'index_h' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.index_k',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.index_k' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_index_k' ] ],
                                  [ 'item_', '_definition.update', '2013-04-16' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The index of a reciprocal space vector.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_enumeration.range', '-1000:1000' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'index_k' ] ] ],
                              [ 'save_',
                                'diffrn_orient_refln.index_l',
                                [ [ 'item_', '_definition.id', '_diffrn_orient_refln.index_l' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_orient_refln_index_l' ] ],
                                  [ 'item_', '_definition.update', '2013-04-16' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The index of a reciprocal space vector.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_enumeration.range', '-1000:1000' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'index_l' ] ] ] ] ],
                          [ '@comment', '------ close DIFFRN_ORIENT_REFLN category' ] ] ],
                      [ '@comment', '------ close DIFFRN_ORIENT category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_RADIATION',
                        [ [ 'item_', '_definition.id', 'DIFFRN_RADIATION' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the wavelength of the\n     radiation used in measuring diffraction intensities. Items may be\n     looped to identify and assign weights to distinct wavelength\n     components from a polychromatic beam.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'RADIATION' ],
                          [ 'save_',
                            'diffrn_radiation.collimation',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.collimation' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_collimation' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the collimation or focusing applied to the radiation.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'collimation' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '0.3 mm double-pinhole', '0.5 mm', 'focusing mirrors' ] ] ] ],
                          [ 'save_',
                            'diffrn_radiation.filter_edge',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.filter_edge' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_filter_edge' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Absorption edge of the radiation filter used.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'filter_edge' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'diffrn_radiation.inhomogeneity',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.inhomogeneity' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_inhomogeneity' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Half-width of the incident beam perpendicular to the diffraction plane.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'inhomogeneity' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'millimetres' ] ] ],
                          [ 'save_',
                            'diffrn_radiation.monochromator',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.monochromator' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_monochromator' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the method used to obtain monochromatic radiation.\n     If a monochromator crystal is used the material and the indices of\n     the Bragg reflection are specified.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'monochromator' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Zr filter', 'Ge 220', 'none', 'equatorial mounted graphite' ] ] ] ],
                          [ 'save_',
                            'diffrn_radiation.polarisn_norm',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.polarisn_norm' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_polarisn_norm' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The angle, as viewed from the specimen, between the perpendicular\n     component of the polarisation and the diffraction plane.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'polarisn_norm' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.0:180.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_radiation.polarisn_ratio',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.polarisn_ratio' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_polarisn_ratio' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Polarisation ratio of the diffraction beam incident on the crystal.\n     It is the ratio of the perpendicularly polarised to the parallel\n     polarised component of the radiation. The perpendicular component\n     forms an angle of _diffrn_radiation.polarisn_norm to the normal to\n     the diffraction plane of the sample (i.e. the plane containing the\n     incident and reflected beams).' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'polarisn_ratio' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_radiation.probe',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.probe' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_probe' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Enumerated code for the nature of radiation used (i.e. name of\n     subatomic particle or region of the electromagnetic spectrum).' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'probe' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state' ],
                                [ 'x-ray', 'neutron', 'electron', 'gamma' ] ],
                              [ 'item_', '_enumeration.default', 'x-ray' ] ] ],
                          [ 'save_',
                            'diffrn_radiation.type',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.type' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_type' ] ],
                              [ 'item_', '_definition.update', '2013-03-23' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Details of the radiation source or energy spectrum.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'type' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Mo K\\a', 'Cu K\\a', 'Cu K\\a~1~', 'Cu K-L~2,3~', 'white-beam' ] ] ] ],
                          [ 'save_',
                            'diffrn_radiation.xray_symbol',
                            [ [ 'item_', '_definition.id', '_diffrn_radiation.xray_symbol' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_radiation_xray_symbol' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     IUPAC symbol for the X-ray wavelength for probe radiation.' ],
                              [ 'item_', '_name.category_id', 'radiation' ],
                              [ 'item_', '_name.object_id', 'xray_symbol' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'K-L~3~',
                                  'K\\a~1~ in older Siegbahn notation',
                                  'K-L~2~',
                                  'K\\a~2~ in older Siegbahn notation',
                                  'K-M~3~',
                                  'K\\b~1~ in older Siegbahn notation',
                                  'K-L~2,3~',
                                  'use where K-L~3~ and K-L~2~ are not resolved' ] ],
                              [ 'item_', '_enumeration.default', 'K-L~3~' ] ] ],
                          [ '@comment',
                            '-----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'DIFFRN_RADIATION_WAVELENGTH',
                            [ [ 'item_', '_definition.id', 'DIFFRN_RADIATION_WAVELENGTH' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which specify the wavelength of the\n     radiation used in measuring diffraction intensities. Items may be\n     looped to identify and assign weights to distinct wavelength\n     components from a polychromatic beam.' ],
                              [ 'item_', '_name.category_id', 'DIFFRN_RADIATION' ],
                              [ 'item_', '_name.object_id', 'WAVELENGTH' ],
                              [ 'item_',
                                '_category.key_id',
                                '_diffrn_radiation_wavelength.key' ],
                              [ 'save_',
                                'diffrn_radiation_wavelength.key',
                                [ [ 'item_', '_definition.id', '_diffrn_radiation_wavelength.key' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of DIFFRN_RADIATION_WAVELENGTH items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'wavelength' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '      _type.contents = Type_Contents(diffrn_radiation_wavelength.id)',
                                      'Evaluation',
                                      '     _diffrn_radiation_wavelength.key = _diffrn_radiation_wavelength.id' ] ] ] ],
                              [ 'save_',
                                'diffrn_radiation_wavelength.value',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_diffrn_radiation_wavelength.value' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_radiation_wavelength',
                                      '_diffrn_radiation_wavelength.wavelength' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Wavelength of radiation used in diffraction measurements.' ],
                                  [ 'item_', '_name.category_id', 'wavelength' ],
                                  [ 'item_', '_name.object_id', 'value' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'angstroms' ] ] ],
                              [ 'save_',
                                'diffrn_radiation_wavelength.id',
                                [ [ 'item_', '_definition.id', '_diffrn_radiation_wavelength.id' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_radiation_wavelength_id',
                                      '_diffrn_radiation.wavelength_id' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Code identifying a radiation used in the diffraction measurements.\n     This is linked to _diffrn_refln.wavelength_id and _refln.wavelength_id' ],
                                  [ 'item_', '_name.category_id', 'wavelength' ],
                                  [ 'item_', '_name.object_id', 'id' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_', [ '_description_example.case' ], [ 'x2' ] ] ] ],
                              [ 'save_',
                                'diffrn_radiation_wavelength.details',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_diffrn_radiation_wavelength.details' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_radiation_wavelength_details',
                                      '_diffrn_radiation.wavelength_details' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Information about the determination of the radiation\n     wavelength that is not conveyed completely by an\n     enumerated value of _diffrn_radiation_wavelength.determination.' ],
                                  [ 'item_', '_name.category_id', 'wavelength' ],
                                  [ 'item_', '_name.object_id', 'details' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'diffrn_radiation_wavelength.determination',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_diffrn_radiation_wavelength.determination' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_radiation_wavelength_determination',
                                      '_diffrn_radiation.wavelength_determination' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Information about the determination of the radiation\n     wavelength that is not conveyed completely by an\n     enumerated value of _diffrn_radiation_wavelength.determination.' ],
                                  [ 'item_', '_name.category_id', 'wavelength' ],
                                  [ 'item_', '_name.object_id', 'determination' ],
                                  [ 'item_', '_type.purpose', 'State' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                    [ 'fundamental',
                                      'Fundamental property of matter e.g. MoK\\alpha',
                                      'estimated',
                                      'Estimated  e.g. from monochromator angle or time of flight',
                                      'refined',
                                      'Refined using a standard crystal with known cell parameters' ] ],
                                  [ 'item_', '_enumeration.default', 'fundamental' ] ] ],
                              [ 'save_',
                                'diffrn_radiation_wavelength.wt',
                                [ [ 'item_', '_definition.id', '_diffrn_radiation_wavelength.wt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_radiation_wavelength_wt' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Relative intensity of a radiation used in the diffraction measurements.' ],
                                  [ 'item_', '_name.category_id', 'wavelength' ],
                                  [ 'item_', '_name.object_id', 'wt' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:1.0' ],
                                  [ 'item_', '_enumeration.default', '1.0' ],
                                  [ 'item_', '_units.code', 'none' ] ] ] ] ],
                          [ '@comment',
                            '------ close DIFFRN_RADIATION_WAVELENGTH category' ] ] ],
                      [ '@comment', '------ close DIFFRN_RADIATION category' ],
                      [ '@comment',
                        '-----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_REFLN',
                        [ [ 'item_', '_definition.id', 'DIFFRN_REFLN' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the reflection measurements,\n     prior to data reduction and merging.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'REFLN' ],
                          [ 'item_', '_category.key_id', '_diffrn_refln.key' ],
                          [ 'save_',
                            'diffrn_refln.key',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.key' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of DIFFRN_REFLN items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '           _type.contents = Type_Contents(diffrn_refln.hkl)',
                                  'Evaluation',
                                  '           _diffrn_refln.key = _diffrn_refln.hkl' ] ] ] ],
                          [ 'save_',
                            'diffrn_refln.angle_chi',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.angle_chi' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_angle_chi' ] ],
                              [ 'item_', '_definition.update', '2013-04-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Diffractometer angle at which the intensity is measured. This was\n     calculated from the specified  orientation matrix and the original\n     measured cell dimensions before any subsequent transformations.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'item_', '_name.category_id', 'diffrn_refln' ],
                              [ 'item_', '_name.object_id', 'angle_chi' ] ] ],
                          [ 'save_',
                            'diffrn_refln.angle_kappa',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.angle_kappa' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_angle_kappa' ] ],
                              [ 'item_', '_definition.update', '2013-04-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Diffractometer angle at which the intensity is measured. This was\n     calculated from the specified  orientation matrix and the original\n     measured cell dimensions before any subsequent transformations.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'angle_kappa' ] ] ],
                          [ 'save_',
                            'diffrn_refln.angle_omega',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.angle_omega' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_angle_omega' ] ],
                              [ 'item_', '_definition.update', '2013-04-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Diffractometer angle at which the intensity is measured. This was\n     calculated from the specified  orientation matrix and the original\n     measured cell dimensions before any subsequent transformations.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'angle_omega' ] ] ],
                          [ 'save_',
                            'diffrn_refln.angle_phi',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.angle_phi' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_angle_phi' ] ],
                              [ 'item_', '_definition.update', '2013-04-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Diffractometer angle at which the intensity is measured. This was\n     calculated from the specified  orientation matrix and the original\n     measured cell dimensions before any subsequent transformations.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'angle_phi' ] ] ],
                          [ 'save_',
                            'diffrn_refln.angle_psi',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.angle_psi' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_angle_psi' ] ],
                              [ 'item_', '_definition.update', '2013-04-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Diffractometer angle at which the intensity is measured. This was\n     calculated from the specified  orientation matrix and the original\n     measured cell dimensions before any subsequent transformations.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'angle_psi' ] ] ],
                          [ 'save_',
                            'diffrn_refln.angle_theta',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.angle_theta' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_angle_theta' ] ],
                              [ 'item_', '_definition.update', '2013-04-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Diffractometer angle at which the intensity is measured. This was\n     calculated from the specified  orientation matrix and the original\n     measured cell dimensions before any subsequent transformations.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'angle_theta' ] ] ],
                          [ 'save_',
                            'diffrn_refln.attenuator_code',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.attenuator_code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_attenuator_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying any attenuator setting for this reflection.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'attenuator_code' ],
                              [ 'item_', '_name.linked_item_id', '_diffrn_attenuator.code' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'diffrn_refln.class_code',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.class_code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_class_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code for reflection class, if assigned. e.g. modulated structures' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'class_code' ],
                              [ 'item_', '_name.linked_item_id', '_diffrn_reflns_class.code' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'diffrn_refln.counts_bg_1',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.counts_bg_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_counts_bg_1' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the diffractometer counts.\n     Background counts before the peak, background after the peak,\n     net counts after background removed, counts for peak scan or position,\n     and the total counts (background plus peak).' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'counts_bg_1' ] ] ],
                          [ 'save_',
                            'diffrn_refln.counts_bg_2',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.counts_bg_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_counts_bg_2' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the diffractometer counts.\n     Background counts before the peak, background after the peak,\n     net counts after background removed, counts for peak scan or position,\n     and the total counts (background plus peak).' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'counts_bg_2' ] ] ],
                          [ 'save_',
                            'diffrn_refln.counts_net',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.counts_net' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_counts_net' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the diffractometer counts.\n     Background counts before the peak, background after the peak,\n     net counts after background removed, counts for peak scan or position,\n     and the total counts (background plus peak).' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'counts_net' ] ] ],
                          [ 'save_',
                            'diffrn_refln.counts_peak',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.counts_peak' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_counts_peak' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the diffractometer counts.\n     Background counts before the peak, background after the peak,\n     net counts after background removed, counts for peak scan or position,\n     and the total counts (background plus peak).' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'counts_peak' ] ] ],
                          [ 'save_',
                            'diffrn_refln.counts_total',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.counts_total' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_counts_total' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the diffractometer counts.\n     Background counts before the peak, background after the peak,\n     net counts after background removed, counts for peak scan or position,\n     and the total counts (background plus peak).' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'counts_total' ] ] ],
                          [ 'save_',
                            'diffrn_refln.crystal_id',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.crystal_id' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_crystal_id' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying each crystal if multiple crystals are used.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'crystal_id' ],
                              [ 'item_', '_name.linked_item_id', '_exptl_crystal.id' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'diffrn_refln.detect_slit_horiz',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.detect_slit_horiz' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_detect_slit_horiz' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Total slit aperture angle in the diffraction plane.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'detect_slit_horiz' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:90.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_refln.detect_slit_vert',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.detect_slit_vert' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_detect_slit_vert' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Total slit aperture angle perpendicular to the diffraction plane.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'detect_slit_vert' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:90.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_refln.elapsed_time',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.elapsed_time' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_elapsed_time' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Elapsed time from the start to the end of the intensity measurement.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'elapsed_time' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'minutes' ] ] ],
                          [ 'save_',
                            'diffrn_refln.hkl',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.hkl' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Miller indices of a measured reflection. These need not match the\n     _refln.hkl values if a transformation of the original measured\n     cell has taken place.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'hkl' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Matrix' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With a as diffrn_refln\n \n           _diffrn_refln.hkl =   [a.index_h, a.index_h, a.index_l]' ] ] ] ],
                          [ 'save_',
                            'diffrn_refln.index_h',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.index_h' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_index_h' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'index_h' ] ] ],
                          [ 'save_',
                            'diffrn_refln.index_k',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.index_k' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_index_k' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'index_k' ] ] ],
                          [ 'save_',
                            'diffrn_refln.index_l',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.index_l' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_index_l' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'index_l' ] ] ],
                          [ 'save_',
                            'diffrn_refln.intensity_net',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.intensity_net' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_intensity_net' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Net intensity calculated from the diffraction counts after the\n     attenuator and standard scales have been applied.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'intensity_net' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_refln.intensity_net_su',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.intensity_net_su' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_intensity_u', '_diffrn_refln_intensity_sigma' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Standard uncertainty of the net intensity calculated from the\n     diffraction counts after the attenuator and standard scales\n     have been applied.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'intensity_net_su' ],
                              [ 'item_', '_type.purpose', 'SU' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_refln.scale_group_code',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.scale_group_code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_scale_group_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying the scale applying to this reflection.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'scale_group_code' ],
                              [ 'item_', '_name.linked_item_id', '_diffrn_scale_group.code' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'diffrn_refln.scan_mode',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.scan_mode' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_scan_mode' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying the mode of scanning with a diffractometer.\n     See also  _diffrn_refln.scan_width and _diffrn_refln.scan_mode_backgd.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'scan_mode' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'om',
                                  'omega scan',
                                  'ot',
                                  'omega/2theta scan',
                                  'q',
                                  'Q-scans (arbitrary reciprocal directions)' ] ],
                              [ 'item_', '_enumeration.default', 'ot' ] ] ],
                          [ 'save_',
                            'diffrn_refln.scan_mode_backgd',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.scan_mode_backgd' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_scan_mode_backgd' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying mode of scanning to measure the background intensity.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'scan_mode_backgd' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'st',
                                  'stationary counter background',
                                  'mo',
                                  'moving counter background' ] ],
                              [ 'item_', '_enumeration.default', 'st' ] ] ],
                          [ 'save_',
                            'diffrn_refln.scan_rate',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.scan_rate' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_scan_rate' ] ],
                              [ 'item_', '_definition.update', '2013-03-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Angular rate of scanning a reflection to measure the intensity.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'scan_rate' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'degree_per_minute' ] ] ],
                          [ 'save_',
                            'diffrn_refln.scan_time_backgd',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.scan_time_backgd' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_scan_time_backgd' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Time spent measuring background counts.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'scan_time_backgd' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'seconds' ] ] ],
                          [ 'save_',
                            'diffrn_refln.scan_width',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.scan_width' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_scan_width' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Angular scan width when measuring the peak intensity.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'scan_width' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:90.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_refln.sin_theta_over_lambda',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_refln.sin_theta_over_lambda' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_sint/lambda',
                                  '_diffrn_refln_sint_over_lambda' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     (sin theta)/lambda value for this reflection.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'sin_theta_over_lambda' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'reciprocal_angstroms' ] ] ],
                          [ 'save_',
                            'diffrn_refln.standard_code',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.standard_code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_standard_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying reflections measured repeated as standard intensity.\n     Must match a _diffrn_standard_refln.code values OR set to \'.\' if\n     it was not used as a intensity standard.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'standard_code' ],
                              [ 'item_',
                                '_name.linked_item_id',
                                '_diffrn_standard_refln.code' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'diffrn_refln.wavelength',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.wavelength' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_wavelength' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Mean wavelength of radiation used to measure this intensity.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'wavelength' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'diffrn_refln.wavelength_id',
                            [ [ 'item_', '_definition.id', '_diffrn_refln.wavelength_id' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_refln_wavelength_id' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying the wavelength in the diffrn_radiation_wavelength list.' ],
                              [ 'item_', '_name.category_id', 'refln' ],
                              [ 'item_', '_name.object_id', 'wavelength_id' ],
                              [ 'item_',
                                '_name.linked_item_id',
                                '_diffrn_radiation_wavelength.id' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
                      [ '@comment', '------ close DIFFRN_REFLN category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'DIFFRN_REFLNS',
                        [ [ 'item_', '_definition.id', 'DIFFRN_REFLNS' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the overall reflection\n     measurement information.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'REFLNS' ],
                          [ 'save_',
                            'diffrn_reflns.av_R_equivalents',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.av_R_equivalents' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_av_R_equivalents' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The residual [sum av|del(I)| / sum |av(I)|] for symmetry-equivalent\n     reflections used to calculate the average intensity av(I). The\n     av|del(I)| term is the average absolute difference between av(I) and\n     the individual symmetry-equivalent intensities.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'av_R_equivalents' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.av_sunetI_over_netI',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_reflns.av_sunetI_over_netI' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_av_sigmaI_over_netI',
                                  '_diffrn_reflns_av_sigmaI/netI',
                                  '_diffrn_reflns_av_unetI/netI' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Recorded [sum |su(netI)| / sum |netI|] for all measured reflections.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'av_sunetI_over_netI' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.Laue_measured_fraction_full',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_reflns.Laue_measured_fraction_full' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_Laue_measured_fraction_full' ] ],
                              [ 'item_', '_definition.update', '2013-01-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Fraction of Laue_group unique reflections (symmetry-independent in\n     the Laue group) measured out to the resolution given in\n     _diffrn_reflns.resolution_full or _diffrn_reflns.theta_full.\n     The Laue group always contains a centre of symmetry so that\n     the reflection h,k,l is always equivalent to the reflection\n     -h,-k,-l even in space groups without a centre of symmetry.\n     This number should not be less than 0.95, since it represents\n     the fraction of reflections measured in the part of the\n     diffraction pattern that is essentially complete.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'Laue_measured_fraction_full' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.95:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.Laue_measured_fraction_max',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_reflns.Laue_measured_fraction_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_Laue_measured_fraction_max' ] ],
                              [ 'item_', '_definition.update', '2013-01-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Fraction of Laue-group unique reflections (symmetry-independent in\n     the Laue group) measured out to the resolution given in\n     _diffrn_reflns.resolution_max or _diffrn_reflns.theta_max.\n     The Laue group always contains a centre of symmetry so that the\n     reflection h,k,l is always equivalent to the reflection -h,-k,-l\n     even in space groups without a centre of symmetry.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'Laue_measured_fraction_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.point_measured_fraction_full',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_reflns.point_measured_fraction_full' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_point_group_measured_fraction_full' ] ],
                              [ 'item_', '_definition.update', '2013-01-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Fraction of crystal point-group unique reflections (i.e.\n     symmetry-independent in the crystal point group) measured\n     out to the resolution given in _diffrn_reflns.resolution_full\n     or _diffrn_reflns.theta_full. For space groups that do not\n     contain a centre of symmetry the reflections h,k,l and\n     -h,-k,-l are independent. This number should not be less\n     than 0.95, since it represents the fraction of reflections\n     measured in the part of the diffraction pattern that is\n     essentially complete.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'point_measured_fraction_full' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.95:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.point_measured_fraction_max',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_reflns.point_measured_fraction_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_point_group_measured_fraction_max' ] ],
                              [ 'item_', '_definition.update', '2013-01-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Fraction of crystal point-group unique reflections (i.e.\n     symmetry-independent in the crystal point group) measured\n     out to the resolution given in _diffrn_reflns.resolution_max\n     or _diffrn_reflns.theta_max. For space groups that do not\n     contain a centre of symmetry the reflections h,k,l and\n     -h,-k,-l are independent.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'point_measured_fraction_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.95:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_max',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_max' ],
                              [ 'item_', '_definition.update', '2013-01-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Maximum Miller indices of measured diffraction reflections.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Matrix' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With t as diffrn_reflns\n \n     _diffrn_reflns.limit_max = [t.limit_h_max,t.limit_k_max,t.limit_l_max]' ] ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_min',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_min' ],
                              [ 'item_', '_definition.update', '2013-01-15' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Minimum Miller indices of meas.ued diffraction reflections.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_min' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Matrix' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With t as diffrn_reflns\n \n     _diffrn_reflns.limit_min = [t.limit_h_min,t.limit_k_min,t.limit_l_min]' ] ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_h_max',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_h_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_limit_h_max' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_h_max' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_h_min',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_h_min' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_limit_h_min' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_h_min' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_k_max',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_k_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_limit_k_max' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_k_max' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_k_min',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_k_min' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_limit_k_min' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_k_min' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_l_max',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_l_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_limit_l_max' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_l_max' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.limit_l_min',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.limit_l_min' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_limit_l_min' ] ],
                              [ 'item_', '_definition.update', '2013-04-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The index of a reciprocal space vector.' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-1000:1000' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'limit_l_min' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.number',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.number' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_number' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Total number of measured intensities, excluding reflections that are\n     classed as systematically absent arising from translational symmetry\n     in the crystal unit cell.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'number' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.reduction_process',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.reduction_process' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_reduction_process' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     How intensities were reduced to structure-factor magnitudes.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'reduction_process' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'data averaged using Fisher test' ] ] ] ],
                          [ 'save_',
                            'diffrn_reflns.theta_full',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.theta_full' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_theta_full' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Theta angle at which the count of measured reflections is almost\n     complete.  The fraction of unique reflections measured out to\n     this angle is given by _diffrn.measured_fraction_theta_full.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'theta_full' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:90.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.theta_max',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.theta_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_theta_max' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Maximum theta angle of the measured reflections.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'theta_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:90.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.theta_min',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.theta_min' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_theta_min' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Minimum theta angle of the measured reflections.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'theta_min' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:90.0' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.resolution_full',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.resolution_full' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_resolution_full' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The resolution at which the measured reflection count is close\n     to complete. The fraction of unique reflections measured out\n     to this angle is given by _diffrn.measured_fraction_theta_full.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'resolution_full' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'reciprocal_angstroms' ] ] ],
                          [ 'save_',
                            'diffrn_reflns.resolution_max',
                            [ [ 'item_', '_definition.id', '_diffrn_reflns.resolution_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_reflns_resolution_max' ] ],
                              [ 'item_', '_definition.update', '2013-02-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Maximum resolution of the measured diffraction pattern.\n     The fraction of unique reflections measured out to this angle\n     is given by _diffrn.measured_fraction_theta_max.' ],
                              [ 'item_', '_name.category_id', 'reflns' ],
                              [ 'item_', '_name.object_id', 'resolution_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'reciprocal_angstroms' ] ] ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'DIFFRN_REFLNS_TRANSF_MATRIX',
                            [ [ 'item_', '_definition.id', 'DIFFRN_REFLNS_TRANSF_MATRIX' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.\n                                 |11 12 13|\n            (h k l) diffraction  |21 22 23|  =  (h\' k\' l\')\n                                 |31 32 33|' ],
                              [ 'item_', '_name.category_id', 'DIFFRN_REFLNS' ],
                              [ 'item_', '_name.object_id', 'TRANSF_MATRIX' ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.TIJ',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.TIJ' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Elements of the matrix used to transform the diffraction reflection\n     indices _diffrn_refln.hkl into the _refln.hkl indices.\n                                  |11 12 13|\n             (h k l) diffraction  |21 22 23|  =  (h\' k\' l\')\n                                  |31 32 33|' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', 'TIJ' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With t as diffrn_reflns_transf_matrix\n \n          _diffrn_reflns_transf_matrix.TIJ =  [[t.11, t.12, t.13],\n                                               [t.21, t.22, t.23],\n                                               [t.31, t.32, t.33]]' ] ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.11',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.11' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_11',
                                      '_diffrn_reflns.transf_matrix[1][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '11' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.12',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.12' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_12',
                                      '_diffrn_reflns.transf_matrix[1][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '12' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.13',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.13' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_13',
                                      '_diffrn_reflns.transf_matrix[1][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '13' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.21',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.21' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_21',
                                      '_diffrn_reflns.transf_matrix[2][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '21' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.22',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.22' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_22',
                                      '_diffrn_reflns.transf_matrix[2][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '22' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.23',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.23' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_23',
                                      '_diffrn_reflns.transf_matrix[2][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '23' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.31',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.31' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_31',
                                      '_diffrn_reflns.transf_matrix[3][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '31' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.32',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.32' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_32',
                                      '_diffrn_reflns.transf_matrix[3][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '32' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_transf_matrix.33',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_transf_matrix.33' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_transf_matrix_33',
                                      '_diffrn_reflns.transf_matrix[3][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-05-07' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items which specify the elements of the matrix\n     used to transform the reflection indices _diffrn_refln.hkl\n     into _refln.hkl.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'transf_matrix' ],
                                  [ 'item_', '_name.object_id', '33' ] ] ] ] ],
                          [ '@comment',
                            '------ close DIFFRN_REFLNS_TRANS_MATRIX category' ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'DIFFRN_REFLNS_CLASS',
                            [ [ 'item_', '_definition.id', 'DIFFRN_REFLNS_CLASS' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which specify different classes of\n     reflections in the raw measured diffraction data.\n ' ],
                              [ 'item_', '_name.category_id', 'DIFFRN_REFLNS' ],
                              [ 'item_', '_name.object_id', 'CLASS' ],
                              [ 'item_', '_category.key_id', '_diffrn_reflns_class.key' ],
                              [ 'save_',
                                'diffrn_reflns_class.key',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.key' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of DIFFRN_REFLNS_CLASS items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '           _type.contents = Type_Contents(diffrn_reflns_class.code)',
                                      'Evaluation',
                                      '           _diffrn_reflns_class.key = _diffrn_reflns_class.code' ] ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.av_R_eq',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.av_R_eq' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_av_R_eq' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Residual [sum av|del(I)|/sum|av(I)|] for symmetry-equivalent\n     reflections used to calculate the average intensity av(I).\n     The av|del(I)| term is the average absolute difference\n     between av(I) and the individual intensities.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'av_R_eq' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.av_suI_over_I',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_diffrn_reflns_class.av_suI_over_I' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_av_uI_over_I',
                                      '_diffrn_reflns_class_av_uI/I',
                                      '_diffrn_reflns_class_av_sgI/I' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Recorded [sum|su(net I)|/sum|net I|] in a reflection class.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'av_suI_over_I' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.code',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.code' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_code' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Code identifying a reflection class.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'code' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_', [ '_description_example.case' ], [ 'm2' ] ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.description',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.description' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_description' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Description of a reflection class.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'description' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'm=1 first order satellites' ] ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.d_res_high',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.d_res_high' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_d_res_high' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Highest resolution in reflection class i.e. smallest d value in class.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'd_res_high' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'angstroms' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.d_res_low',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.d_res_low' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_d_res_low' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Lowest resolution in reflection class i.e. largest d value in class.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'd_res_low' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'angstroms' ] ] ],
                              [ 'save_',
                                'diffrn_reflns_class.number',
                                [ [ 'item_', '_definition.id', '_diffrn_reflns_class.number' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_reflns_class_number' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Number of measured intensities for a reflection class, excluding\n     the systematic absences arising from centring translations.' ],
                                  [ 'item_', '_name.category_id', 'class' ],
                                  [ 'item_', '_name.object_id', 'number' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Count' ],
                                  [ 'item_', '_enumeration.range', '0:' ] ] ] ] ],
                          [ '@comment', '------ close DIFFRN_REFLNS_CLASS category' ] ] ],
                      [ '@comment', '------ close DIFFRN_REFLNS category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_SCALE_GROUP',
                        [ [ 'item_', '_definition.id', 'DIFFRN_SCALE_GROUP' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the groups of reflections in\n     the raw measured diffraction data with different relative scales.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'SCALE_GROUP' ],
                          [ 'item_', '_category.key_id', '_diffrn_scale_group.key' ],
                          [ 'save_',
                            'diffrn_scale_group.key',
                            [ [ 'item_', '_definition.id', '_diffrn_scale_group.key' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of DIFFRN_SCALE_GROUP items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'scale_group' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '           _type.contents = Type_Contents(diffrn_scale_group.code)',
                                  'Evaluation',
                                  '           _diffrn_scale_group.key = _diffrn_scale_group.code' ] ] ] ],
                          [ 'save_',
                            'diffrn_scale_group.code',
                            [ [ 'item_', '_definition.id', '_diffrn_scale_group.code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_scale_group_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying a specific scale group of reflections (e.g. for\n     multi-film or multi-crystal data). The code must match a\n     _diffrn_refln.scale_group_code in the diffrn_refln list.\n ' ],
                              [ 'item_', '_name.category_id', 'scale_group' ],
                              [ 'item_', '_name.object_id', 'code' ],
                              [ 'item_',
                                '_name.linked_item_id',
                                '_diffrn_refln.scale_group_code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '1', '2', '3', 's1', 'A', 'B', 'c1', 'c2', 'c3' ] ] ] ],
                          [ 'save_',
                            'diffrn_scale_group.I_net',
                            [ [ 'item_', '_definition.id', '_diffrn_scale_group.I_net' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_scale_group_I_net' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Scale for a specific measurement group of eflections. Is multiplied\n     with the net intensity to place all intensities on a common scale.' ],
                              [ 'item_', '_name.category_id', 'scale_group' ],
                              [ 'item_', '_name.object_id', 'I_net' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ] ] ],
                      [ '@comment', '------ close DIFFRN_SCALE_GROUP category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_SOURCE',
                        [ [ 'item_', '_definition.id', 'DIFFRN_SOURCE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify information about the\n     radiation source.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'SOURCE' ],
                          [ 'save_',
                            'diffrn_source.device',
                            [ [ 'item_', '_definition.id', '_diffrn_source.device' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source', '_diffrn_radiation_source' ] ],
                              [ 'item_', '_definition.update', '2013-08-09' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Enumerated code for the device providing the source of radiation.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'device' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'tube',
                                  'sealed X-ray tube',
                                  'nuclear',
                                  'nuclear reactor',
                                  'spallation',
                                  'spallation source',
                                  'elect-micro',
                                  'electron microscope',
                                  'rot_anode',
                                  'rotating-anode X-ray tube',
                                  'synch',
                                  'synchrotron' ] ],
                              [ 'item_', '_enumeration.default', 'tube' ] ] ],
                          [ 'save_',
                            'diffrn_source.current',
                            [ [ 'item_', '_definition.id', '_diffrn_source.current' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_current' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Generator current at which the radiation source device was operated.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'current' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'milliamperes' ] ] ],
                          [ 'save_',
                            'diffrn_source.details',
                            [ [ 'item_', '_definition.id', '_diffrn_source.details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     General description of the radiation source device.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'diffrn_source.power',
                            [ [ 'item_', '_definition.id', '_diffrn_source.power' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_power' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '    Generator power at which the radiation source device was operated.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'power' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'kilowatts' ] ] ],
                          [ 'save_',
                            'diffrn_source.size',
                            [ [ 'item_', '_definition.id', '_diffrn_source.size' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_size' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the collimated source beam as viewed from the sample.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'size' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '8mm x 0.4 mm fine-focus', 'broad focus' ] ] ] ],
                          [ 'save_',
                            'diffrn_source.take_off_angle',
                            [ [ 'item_', '_definition.id', '_diffrn_source.take_off_angle' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_take-off_angle' ] ],
                              [ 'item_', '_definition.update', '2013-02-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The complement of the angle in degrees between the normal\n     to the surface of the X-ray tube target and the primary\n     X-ray beam for beams generated by traditional X-ray tubes.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'take_off_angle' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0:90' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'diffrn_source.target',
                            [ [ 'item_', '_definition.id', '_diffrn_source.target' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_target' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Chemical element symbol for the radiation source target (usually\n     the anode). This can be used also for spallation sources.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'target' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'Ac',
                                  'Actinium',
                                  'Ag',
                                  'Silver',
                                  'Al',
                                  'Aluminum',
                                  'Am',
                                  'Americium',
                                  'Ar',
                                  'Argon',
                                  'As',
                                  'Arsenic',
                                  'At',
                                  'Astatine',
                                  'Au',
                                  'Gold',
                                  'B',
                                  'Boron',
                                  'Ba',
                                  'Barium',
                                  'Be',
                                  'Beryllium',
                                  'Bh',
                                  'Bohrium',
                                  'Bi',
                                  'Bismuth',
                                  'Bk',
                                  'Berkelium',
                                  'Br',
                                  'Bromine',
                                  'C',
                                  'Carbon',
                                  'Ca',
                                  'Calcium',
                                  'Cd',
                                  'Cadmium',
                                  'Ce',
                                  'Cerium',
                                  'Cf',
                                  'Californium',
                                  'Cl',
                                  'Chlorine',
                                  'Cm',
                                  'Curium',
                                  'Co',
                                  'Cobalt',
                                  'Cr',
                                  'Chromium',
                                  'Cs',
                                  'Cesium',
                                  'Cu',
                                  'Copper',
                                  'Db',
                                  'Dubnium',
                                  'Ds',
                                  'Darmstadtium',
                                  'Dy',
                                  'Dysprosium',
                                  'Er',
                                  'Erbium',
                                  'Es',
                                  'Einsteinium',
                                  'Eu',
                                  'Europium',
                                  'F',
                                  'Fluorine',
                                  'Fe',
                                  'Iron',
                                  'Fm',
                                  'Fermium',
                                  'Fr',
                                  'Francium',
                                  'Ga',
                                  'Gallium',
                                  'Gd',
                                  'Gadolinium',
                                  'Ge',
                                  'Germanium',
                                  'H',
                                  'Hydrogen',
                                  'He',
                                  'Helium',
                                  'Hf',
                                  'Hafnium',
                                  'Hg',
                                  'Mercury',
                                  'Ho',
                                  'Holmium',
                                  'Hs',
                                  'Hassium',
                                  'I',
                                  'Iodine',
                                  'In',
                                  'Indium',
                                  'Ir',
                                  'Iridium',
                                  'K',
                                  'Potassium',
                                  'Kr',
                                  'Krypton',
                                  'La',
                                  'Lanthanum',
                                  'Li',
                                  'Lithium',
                                  'Lr',
                                  'Lawrencium',
                                  'Lu',
                                  'Lutetium',
                                  'Md',
                                  'Mendelevium',
                                  'Mg',
                                  'Magnesium',
                                  'Mn',
                                  'Manganese',
                                  'Mo',
                                  'Molybdenum',
                                  'Mt',
                                  'Meitnerium',
                                  'N',
                                  'Nitrogen',
                                  'Na',
                                  'Sodium',
                                  'Ne',
                                  'Neon',
                                  'Nb',
                                  'Niobium',
                                  'Nd',
                                  'Neodymium',
                                  'Ni',
                                  'Nickel',
                                  'No',
                                  'Nobelium',
                                  'Np',
                                  'Neptunium',
                                  'O',
                                  'Oxygen',
                                  'Os',
                                  'Osmium',
                                  'P',
                                  'Phosphorus',
                                  'Pd',
                                  'Palladium',
                                  'Po',
                                  'Polonium',
                                  'Pb',
                                  'Lead',
                                  'Pt',
                                  'Platinum',
                                  'Pr',
                                  'Praseodymium',
                                  'Pm',
                                  'Promethium',
                                  'Pu',
                                  'Plutonium',
                                  'Pa',
                                  'Protactinium',
                                  'Ra',
                                  'Radium',
                                  'Rb',
                                  'Rubidium',
                                  'Re',
                                  'Rhenium',
                                  'Rf',
                                  'Rutherfordium',
                                  'Rh',
                                  'Rhodium',
                                  'Rn',
                                  'Radon',
                                  'Ru',
                                  'Ruthenium',
                                  'S',
                                  'Sulfur',
                                  'Sb',
                                  'Antimony',
                                  'Sc',
                                  'Scandium',
                                  'Se',
                                  'Selenium',
                                  'Sg',
                                  'Seaborgium',
                                  'Si',
                                  'Silicon',
                                  'Sm',
                                  'Samarium',
                                  'Sn',
                                  'Tin',
                                  'Sr',
                                  'Strontium',
                                  'Ta',
                                  'Tantalum',
                                  'Tb',
                                  'Terbium',
                                  'Tc',
                                  'Technetium',
                                  'Te',
                                  'Tellurium',
                                  'Th',
                                  'Thorium',
                                  'Ti',
                                  'Titanium',
                                  'Tl',
                                  'Thallium',
                                  'Tm',
                                  'Thulium',
                                  'U',
                                  'Uranium',
                                  'Uub',
                                  'Ununbium',
                                  'Uun',
                                  'Ununnilium',
                                  'Uuu',
                                  'Ununumium',
                                  'V',
                                  'Vanadium',
                                  'W',
                                  'Tungsten',
                                  'Xe',
                                  'Xenon',
                                  'Y',
                                  'Yttrium',
                                  'Yb',
                                  'Ytterbium',
                                  'Zn',
                                  'Zinc',
                                  'Zr',
                                  'Zirconium' ] ],
                              [ 'item_', '_enumeration.default', 'Cu' ] ] ],
                          [ 'save_',
                            'diffrn_source.make',
                            [ [ 'item_', '_definition.id', '_diffrn_source.make' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_make',
                                  '_diffrn_source.type',
                                  '_diffrn_source_type' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the make, model or name of the source device.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'make' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'NSLS beamline X8C', 'Rigaku RU2012-05-07 ' ] ] ] ],
                          [ 'save_',
                            'diffrn_source.voltage',
                            [ [ 'item_', '_definition.id', '_diffrn_source.voltage' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_source_voltage' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Generator voltage at which the radiation source device was operated.' ],
                              [ 'item_', '_name.category_id', 'source' ],
                              [ 'item_', '_name.object_id', 'voltage' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'kilovolts' ] ] ] ] ],
                      [ '@comment', '------ close DIFFRN_SOURCE category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DIFFRN_STANDARD',
                        [ [ 'item_', '_definition.id', 'DIFFRN_STANDARD' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify information about the\n     standard reflections used in the diffraction measurement process.' ],
                          [ 'item_', '_name.category_id', 'DIFFRN' ],
                          [ 'item_', '_name.object_id', 'STANDARD' ],
                          [ 'save_',
                            'diffrn_standard.decay_percent',
                            [ [ 'item_', '_definition.id', '_diffrn_standard.decay_percent' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_standards_decay_%',
                                  '_diffrn_standards.decay_%',
                                  '_diffrn_standards_decay_percent' ] ],
                              [ 'item_', '_definition.update', '2013-03-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The percentage decrease in the mean of the intensities for the\n     standard reflections at the start to the finish of the measurement\n     process. This value affords a measure of the overall decay in\n     crystal quality during measurement. Negative values only occur in\n     exceptional instances where the final intensities are greater than\n     the initial ones.  If no measurable decay has occurred, the\n     standard uncertainty should be quoted to indicate the maximum\n     possible value the decay might have.  A range of 3 standard\n     uncertainties is considered possible.  Thus 0.0(1) would indicate\n     a decay of less than 0.3% or an enhancement of less than 0.3%.' ],
                              [ 'item_', '_name.category_id', 'standard' ],
                              [ 'item_', '_name.object_id', 'decay_percent' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', ':100' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '0.5(1)',
                                  'represents a decay between 0.2% and 0.8%',
                                  '-1(1)',
                                  'change in standards between 2% decay and 4% rise',
                                  '0.0(2)',
                                  'change in standards between 0.6% decay and 0.6% rise.' ] ] ] ],
                          [ 'save_',
                            'diffrn_standard.interval_count',
                            [ [ 'item_', '_definition.id', '_diffrn_standard.interval_count' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_standards_interval_count%',
                                  '_diffrn_standards_interval_count' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Reflection count between the standard reflection measurements.' ],
                              [ 'item_', '_name.category_id', 'standard' ],
                              [ 'item_', '_name.object_id', 'interval_count' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'diffrn_standard.interval_time',
                            [ [ 'item_', '_definition.id', '_diffrn_standard.interval_time' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_standards_interval_time' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Time between the standard reflection measurements.' ],
                              [ 'item_', '_name.category_id', 'standard' ],
                              [ 'item_', '_name.object_id', 'interval_time' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'minutes' ] ] ],
                          [ 'save_',
                            'diffrn_standard.number',
                            [ [ 'item_', '_definition.id', '_diffrn_standard.number' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_standards_number' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of unique standard reflections used in measurements.' ],
                              [ 'item_', '_name.category_id', 'standard' ],
                              [ 'item_', '_name.object_id', 'number' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'diffrn_standard.scale_su_average',
                            [ [ 'item_',
                                '_definition.id',
                                '_diffrn_standard.scale_su_average' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_diffrn_standards_scale_sigma',
                                  '_diffrn_standards.scale_sigma',
                                  '_diffrn_standards_scale_u' ] ],
                              [ 'item_', '_definition.update', '2013-01-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The average standard uncertainty of the individual standard scales\n     applied to the intensity data.' ],
                              [ 'item_', '_name.category_id', 'standard' ],
                              [ 'item_', '_name.object_id', 'scale_su_average' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'DIFFRN_STANDARD_REFLN',
                            [ [ 'item_', '_definition.id', 'DIFFRN_STANDARD_REFLN' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items which specify the "standard" reflections\n     measured repeatedly to monitor variations in intensity due to source\n     flux, environment conditions or crystal quality.' ],
                              [ 'item_', '_name.category_id', 'DIFFRN_STANDARD' ],
                              [ 'item_', '_name.object_id', 'REFLN' ],
                              [ 'item_', '_category.key_id', '_diffrn_standard_refln.key' ],
                              [ 'save_',
                                'diffrn_standard_refln.key',
                                [ [ 'item_', '_definition.id', '_diffrn_standard_refln.key' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of DIFFRN_STANDARD_REFLN items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '        _type.contents = Type_Contents(diffrn_standard_refln.code)',
                                      'Evaluation',
                                      '       _diffrn_standard_refln.key = _diffrn_standard_refln.code' ] ] ] ],
                              [ 'save_',
                                'diffrn_standard_refln.code',
                                [ [ 'item_', '_definition.id', '_diffrn_standard_refln.code' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_standard_refln_code',
                                      '_diffrn_standard_refln.diffrn_id' ] ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Code identifying a standard reflection used to monitor source\n     intensity variations or crystal degradation or movement during\n     data collection.' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'code' ],
                                  [ 'item_',
                                    '_name.linked_item_id',
                                    '_diffrn_refln.standard_code' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_', [ '_description_example.case' ], [ 's1' ] ] ] ],
                              [ 'save_',
                                'diffrn_standard_refln.hkl',
                                [ [ 'item_', '_definition.id', '_diffrn_standard_refln.hkl' ],
                                  [ 'item_', '_definition.update', '2012-11-26' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Miller indices of a standard reflection.' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'hkl' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_type.dimension', [ '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With d as diffrn_standard_refln\n \n      _diffrn_standard_refln.hkl =  [d.index_h, d.index_h, d.index_l]' ] ] ] ],
                              [ 'save_',
                                'diffrn_standard_refln.index_h',
                                [ [ 'item_', '_definition.id', '_diffrn_standard_refln.index_h' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_standard_refln_index_h' ] ],
                                  [ 'item_', '_definition.update', '2013-04-16' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The index of a reciprocal space vector.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_enumeration.range', '-1000:1000' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'index_h' ] ] ],
                              [ 'save_',
                                'diffrn_standard_refln.index_k',
                                [ [ 'item_', '_definition.id', '_diffrn_standard_refln.index_k' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_standard_refln_index_k' ] ],
                                  [ 'item_', '_definition.update', '2013-04-16' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The index of a reciprocal space vector.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_enumeration.range', '-1000:1000' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'index_k' ] ] ],
                              [ 'save_',
                                'diffrn_standard_refln.index_l',
                                [ [ 'item_', '_definition.id', '_diffrn_standard_refln.index_l' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_diffrn_standard_refln_index_l' ] ],
                                  [ 'item_', '_definition.update', '2013-04-16' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The index of a reciprocal space vector.' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Integer' ],
                                  [ 'item_', '_enumeration.range', '-1000:1000' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'refln' ],
                                  [ 'item_', '_name.object_id', 'index_l' ] ] ] ] ],
                          [ '@comment', '------ close DIFFRN_STANDARD_REFLN category' ] ] ],
                      [ '@comment', '------ close DIFFRN_STANDARD category' ] ] ],
                  [ '@comment', '------ close DIFFRN category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'REFLN',
                    [ [ 'item_', '_definition.id', 'REFLN' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Loop' ],
                      [ 'item_', '_definition.update', '2012-11-26' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to describe the reflection data\n     used in the refinement of a crystallographic structure model.' ],
                      [ 'item_', '_name.category_id', 'DIFFRACTION' ],
                      [ 'item_', '_name.object_id', 'REFLN' ],
                      [ 'item_', '_category.key_id', '_refln.key' ],
                      [ 'save_',
                        'refln.key',
                        [ [ 'item_', '_definition.id', '_refln.key' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Value is a unique key to a set of REFLN items\n     in a looped list.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'key' ],
                          [ 'item_', '_type.purpose', 'Key' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Implied' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '           _type.contents = Type_Contents(_refln.hkl)',
                              'Evaluation',
                              '           _refln.key = _refln.hkl' ] ] ] ],
                      [ 'save_',
                        'refln.A_calc',
                        [ [ 'item_', '_definition.id', '_refln.A_calc' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_A_calc' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The calculated real structure-factor component A =|Fcalc|cos(phase)' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'A_calc' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"',
                              'Evaluation',
                              '\n    _refln.A_calc =  Real ( _refln.F_complex )' ] ] ] ],
                      [ 'save_',
                        'refln.A_meas',
                        [ [ 'item_', '_definition.id', '_refln.A_meas' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_A_meas' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The measured real structure-factor component A =|Fmeas|cos(phase)' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'A_meas' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ],
                      [ 'save_',
                        'refln.B_calc',
                        [ [ 'item_', '_definition.id', '_refln.B_calc' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_B_calc' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The calculated imaginary structure-factor component B =|Fcalc|sin(phase)' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'B_calc' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"',
                              'Evaluation',
                              '\n    _refln.B_calc =  Imag ( _refln.F_complex )' ] ] ] ],
                      [ 'save_',
                        'refln.B_meas',
                        [ [ 'item_', '_definition.id', '_refln.B_meas' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_B_meas' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The measured imaginary structure-factor component B =|Fmeas|sin(phase)' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'B_meas' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ],
                      [ 'save_',
                        'refln.class_code',
                        [ [ 'item_', '_definition.id', '_refln.class_code' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_class_code' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifying the class to which this reflection has been\n     assigned. This code must match a value of _reflns_class.code.\n     Reflections may be grouped into classes for a variety of\n     purposes. For example, for modulated structures each reflection\n     class may be defined by the number m=sum|m~i~|, where the m~i~\n     are the integer coefficients that, in addition to h,k,l, index\n     the corresponding diffraction vector in the basis defined\n     for the reciprocal lattice.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'class_code' ],
                          [ 'item_', '_name.linked_item_id', '_reflns_class.code' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'refln.crystal_id',
                        [ [ 'item_', '_definition.id', '_refln.crystal_id' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_crystal_id' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifying each crystal if multiple crystals are used. Is\n     used to link with crystals identified by _exptl_crystal.id.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'crystal_id' ],
                          [ 'item_', '_name.linked_item_id', '_exptl_crystal.id' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'refln.d_spacing',
                        [ [ 'item_', '_definition.id', '_refln.d_spacing' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_d_spacing' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The distance in angstroms between lattice planes in the crystal\n     with the indices _refln.hkl for this reflection.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'd_spacing' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'angstroms' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n    _refln.d_spacing = 2. / _refln.sin_theta_over_lambda' ] ] ] ],
                      [ 'save_',
                        'refln.F_calc',
                        [ [ 'item_', '_definition.id', '_refln.F_calc' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_F_calc' ] ],
                          [ 'item_', '_definition.update', '2013-02-21' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The structure factor amplitude for the reflection calculated from\n     the atom site data.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_calc' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"',
                              'Evaluation',
                              '\n      _refln.F_calc  =   Magn ( _refln.F_complex )' ] ] ] ],
                      [ 'save_',
                        'refln.F_complex',
                        [ [ 'item_', '_definition.id', '_refln.F_complex' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_F_complex' ] ],
                          [ 'item_', '_definition.update', '2013-04-23' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The structure factor vector for the reflection calculated from\n     the atom site data.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_complex' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Complex' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"',
                              'Evaluation',
                              '\n   With r  as  refln\n \n      fc  =   Complex (0., 0.)\n      h   =   r.hkl\n \n   Loop a  as  atom_site  {\n \n          f  =   a.site_symmetry_multiplicity * a.occupancy *\n                 ( r.form_factor_table [a.type_symbol]      +\n                        _atom_type_scat[a.type_symbol].dispersion  )\n \n      Loop s  as  symmetry_equiv  {\n \n          t   =  Exp(-h * s.R * a.tensor_beta * s.RT * h)\n \n          fc +=  f * t * ExpImag(TwoPi *( h *( s.R * a.fract_xyz + s.T)))\n   }  }\n          _refln.F_complex  =   fc / _symmetry.multiplicity' ] ] ] ],
                      [ 'save_',
                        'refln.F_meas',
                        [ [ 'item_', '_definition.id', '_refln.F_meas' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_F_meas' ] ],
                          [ 'item_', '_definition.update', '2013-02-21' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The structure factor amplitude for the reflection derived from the\n     measured intensities.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_meas' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"',
                              [ '@comment', '     Evaluation' ],
                              [ '@comment', ';' ],
                              [ '@comment',
                                '                _refln.F_meas  =   Sqrt ( _refln.F_squared_meas )' ],
                              [ '@comment', ';' ] ] ] ] ],
                      [ 'save_',
                        'refln.F_meas_su',
                        [ [ 'item_', '_definition.id', '_refln.F_meas_su' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_F_sigma', '_refln.F_meas_sigma', '_refln_F_meas_su' ] ],
                          [ 'item_', '_definition.update', '2013-02-21' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The standard uncertainty of the measured structure factor amplitude.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_meas_su' ],
                          [ 'item_', '_name.linked_item_id', '_refln.F_meas' ],
                          [ 'item_', '_type.purpose', 'SU' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"',
                              [ '@comment', '     Evaluation' ],
                              [ '@comment', ';' ],
                              [ '@comment',
                                '                _refln.F_meas_su  =   _refln.F_squared_meas_su / 2' ],
                              [ '@comment', ';' ] ] ] ] ],
                      [ 'save_',
                        'refln.F_squared_calc',
                        [ [ 'item_', '_definition.id', '_refln.F_squared_calc' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_F_squared_calc' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The structure factor amplitude squared for the reflection calculated from\n     the atom site data.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_squared_calc' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n    If      (_diffrn_radiation.probe == "neutron")\n                                         _units.code =  "femtometre_squared"\n    Else If (_diffrn_radiation.probe == "electron")\n                                         _units.code =  "volt_squared"\n    Else                                 _units.code =  "electron_squared"',
                              [ '@comment', '     Evaluation' ],
                              [ '@comment', ';' ],
                              [ '@comment',
                                '                _refln.F_squared_calc  =    _refln.F_calc **2' ],
                              [ '@comment', ';' ] ] ] ] ],
                      [ 'save_',
                        'refln.F_squared_meas',
                        [ [ 'item_', '_definition.id', '_refln.F_squared_meas' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_F_squared_meas' ] ],
                          [ 'item_', '_definition.update', '2013-02-21' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The structure factor amplitude for the reflection derived from the\n     measured intensities.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_squared_meas' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n    If      (_diffrn_radiation.probe == "neutron")\n                                         _units.code =  "femtometre_squared"\n    Else If (_diffrn_radiation.probe == "electron")\n                                         _units.code =  "volt_squared"\n    Else                                 _units.code =  "electron_squared"',
                              [ '@comment', '     Evaluation' ],
                              [ '@comment', ';' ],
                              [ '@comment',
                                '                _refln.F_squared_meas  =   _refln.F_meas **2' ],
                              [ '@comment', ';' ] ] ] ] ],
                      [ 'save_',
                        'refln.F_squared_meas_su',
                        [ [ 'item_', '_definition.id', '_refln.F_squared_meas_su' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_F_squared_sigma',
                              '_refln.F_squared_sigma',
                              '_refln_F_squared_meas_su' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The standard uncertainty of the measured structure factor squared.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'F_squared_meas_su' ],
                          [ 'item_', '_name.linked_item_id', '_refln.F_squared_meas' ],
                          [ 'item_', '_type.purpose', 'SU' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '\n    If      (_diffrn_radiation.probe == "neutron")\n                                         _units.code =  "femtometre_squared"\n    Else If (_diffrn_radiation.probe == "electron")\n                                         _units.code =  "volt_squared"\n    Else                                 _units.code =  "electron_squared"',
                              [ '@comment', '     Evaluation' ],
                              [ '@comment', ';' ],
                              [ '@comment',
                                '                _refln.F_squared_meas_su  =   2. * _refln.F_meas_su' ],
                              [ '@comment', ';' ] ] ] ] ],
                      [ 'save_',
                        'refln.form_factor_table',
                        [ [ 'item_', '_definition.id', '_refln.form_factor_table' ],
                          [ 'item_', '_definition.update', '2013-04-23' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Atomic scattering factor table for the scattering angle\n     of this diffraction vector and atom types in structure.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'form_factor_table' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Table' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_type.dimension', [] ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n    With r  as  refln\n \n     table = Table ()\n     s  =    r.sin_theta_over_lambda\n \n    Loop t  as  atom_type  {\n \n       If (_diffrn_radiation.probe == \'neutron\') {\n \n            f  =   t.length_neutron\n \n       } Else If (s < 2.0 ) {\n \n            c  =   t.Cromer_Mann_coeffs\n \n            f  =  (c[0] + c[1] * Exp (-c[2] * s*s)\n                        + c[3] * Exp (-c[4] * s*s)\n                        + c[5] * Exp (-c[6] * s*s)\n                        + c[7] * Exp (-c[8] * s*s))\n       } Else {\n \n            c  =   t.hi_ang_Fox_coeffs\n \n            f  =   Exp ( c[0] + c[1]*s + c[2]*s*s + c[3]*s*s*s )\n       }\n        table [ t.symbol ]  =   f\n    }\n       _refln.form_factor_table  =   table' ] ] ] ],
                      [ 'save_',
                        'refln.include_status',
                        [ [ 'item_', '_definition.id', '_refln.include_status' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_include_status',
                              '_refln_observed_status',
                              '_refln.observed_status' ] ],
                          [ 'item_', '_definition.update', '2013-03-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code indicating how the reflection was included in the refinement\n     and R-factor calculations.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'include_status' ],
                          [ 'item_', '_type.purpose', 'State' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_enumeration_set.state', '_enumeration_set.detail' ],
                            [ 'o',
                              'ob : within  _reflns.threshold_expression; within d-res limits',
                              '<',
                              'lt : without _reflns.threshold_expression; within d-res limits',
                              '-',
                              'sa : systematically absent reflection due to symmetry',
                              'x',
                              'du : deemed unreliable measurement -- not used',
                              'h',
                              'hd : above _refine_ls.d_res_high',
                              'l',
                              'ld : below _refine_ls.d_res_low' ] ],
                          [ 'item_', '_enumeration.default', 'o' ] ] ],
                      [ 'save_',
                        'refln.hkl',
                        [ [ 'item_', '_definition.id', '_refln.hkl' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The Miller indices as a reciprocal space vector.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'hkl' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Matrix' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_type.dimension', [ '3' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With r  as  refln\n \n            _refln.hkl =  [r.index_h, r.index_k, r.index_l]' ] ] ] ],
                      [ 'save_',
                        'refln.index_h',
                        [ [ 'item_', '_definition.id', '_refln.index_h' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_index_h' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'index_h' ] ] ],
                      [ 'save_',
                        'refln.index_k',
                        [ [ 'item_', '_definition.id', '_refln.index_k' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_index_k' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'index_k' ] ] ],
                      [ 'save_',
                        'refln.index_l',
                        [ [ 'item_', '_definition.id', '_refln.index_l' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_index_l' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'index_l' ] ] ],
                      [ 'save_',
                        'refln.intensity_calc',
                        [ [ 'item_', '_definition.id', '_refln.intensity_calc' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_intensity_calc' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The intensity of the reflection calculated from the atom site data.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'intensity_calc' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.:' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n    _refln.intensity_calc  =   _refln.F_squared_calc / _refln.Lp_factor' ] ] ] ],
                      [ 'save_',
                        'refln.intensity_meas',
                        [ [ 'item_', '_definition.id', '_refln.intensity_meas' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_intensity_meas' ] ],
                          [ 'item_', '_definition.update', '2013-04-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The intensity of the reflection derived from the diffraction measurements.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'intensity_meas' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.:' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'refln.intensity_meas_su',
                        [ [ 'item_', '_definition.id', '_refln.intensity_meas_su' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_intensity_meas_su', '_refln_intensity_sigma' ] ],
                          [ 'item_', '_definition.update', '2013-01-23' ],
                          [ 'item_',
                            '_description.text',
                            '\n     standard uncertainty of the measured intensity.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'intensity_meas_su' ],
                          [ 'item_', '_name.linked_item_id', '_refln.intensity_meas' ],
                          [ 'item_', '_type.purpose', 'SU' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.:' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'refln.Lp_factor',
                        [ [ 'item_', '_definition.id', '_refln.Lp_factor' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_Lp_factor' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The Lorentz-polarization factor appropriate for the instrument\n     used to measure the diffraction intensity. This is applied to\n     convert the net intensity into the measured F squared.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'Lp_factor' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.:' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'refln.mean_path_length_tbar',
                        [ [ 'item_', '_definition.id', '_refln.mean_path_length_tbar' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_mean_path_length_tbar' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Mean path length through the crystal for this diffraction vector.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'mean_path_length_tbar' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'millimetres' ] ] ],
                      [ 'save_',
                        'refln.phase_calc',
                        [ [ 'item_', '_definition.id', '_refln.phase_calc' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_phase_calc' ] ],
                          [ 'item_', '_definition.update', '2013-04-27' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The phase of the calculated structure-factor.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'phase_calc' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.:360.' ],
                          [ 'item_', '_units.code', 'degrees' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n    phase  = Atan2d ( _refln.B_calc, _refln.A_calc )\n      If(phase < 0.) _refln.phase_calc = phase + 360.\n      Else           _refln.phase_calc = phase' ] ] ] ],
                      [ 'save_',
                        'refln.phase_meas',
                        [ [ 'item_', '_definition.id', '_refln.phase_meas' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_phase_meas' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The phase of the measured structure-factor. This may be derived from\n     the atom site data if available or from the phase solution process\n     prior to determination of the structure.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'phase_meas' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.:360.' ],
                          [ 'item_', '_units.code', 'degrees' ] ] ],
                      [ 'save_',
                        'refln.refinement_status',
                        [ [ 'item_', '_definition.id', '_refln.refinement_status' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_refinement_status' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Status code of reflection in the structure refinement process.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'refinement_status' ],
                          [ 'item_', '_type.purpose', 'State' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_enumeration_set.state', '_enumeration_set.detail' ],
                            [ 'incl',
                              'included in ls process',
                              'excl',
                              'excluded from ls process',
                              'extn',
                              'excluded due to extinction' ] ],
                          [ 'item_', '_enumeration.default', 'incl' ] ] ],
                      [ 'save_',
                        'refln.scale_group_code',
                        [ [ 'item_', '_definition.id', '_refln.scale_group_code' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_scale_group_code' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifying the scale (if there is more than one scale) used\n     convert the measured structure factor to a common absolute value.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'scale_group_code' ],
                          [ 'item_', '_name.linked_item_id', '_reflns_scale.group_code' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'refln.sin_theta_over_lambda',
                        [ [ 'item_', '_definition.id', '_refln.sin_theta_over_lambda' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_sint/lambda',
                              '_refln_sin_theta_over_lambda',
                              '_refln.sint_over_lambda' ] ],
                          [ 'item_', '_definition.update', '2013-03-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The (sin theta)/lambda value for this reflection.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'sin_theta_over_lambda' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With r  as  refln\n                            h =  r.hkl\n                            G =  _cell_reciprocal.metric_tensor\n \n     r.sin_theta_over_lambda  =   Sqrt ( h * G * h ) / 2.' ] ] ] ],
                      [ 'save_',
                        'refln.symmetry_epsilon',
                        [ [ 'item_', '_definition.id', '_refln.symmetry_epsilon' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_symmetry_epsilon' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The symmetry reinforcement factor corresponding to the number of\n     times the reflection indices are generated identically from the\n     space-group symmetry operations.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'symmetry_epsilon' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:48' ] ] ],
                      [ 'save_',
                        'refln.symmetry_multiplicity',
                        [ [ 'item_', '_definition.id', '_refln.symmetry_multiplicity' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_symmetry_multiplicity' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The number of reflections symmetry-equivalent under the Laue\n     symmetry to the present reflection. In the Laue symmetry, Friedel\n     opposites (h k l and -h -k -l) are equivalent. Tables of\n     symmetry-equivalent reflections are available in International\n     Tables for Crystallography, Volume A (1987), section 10.2.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'symmetry_multiplicity' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:48' ] ] ],
                      [ 'save_',
                        'refln.wavelength',
                        [ [ 'item_', '_definition.id', '_refln.wavelength' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_refln_wavelength' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The mean wavelength in angstroms of radiation used to measure\n     this reflection. This is an important parameter for data\n     collected using energy-dispersive detectors or the Laue method.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'wavelength' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'refln.wavelength_id',
                        [ [ 'item_', '_definition.id', '_refln.wavelength_id' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refln_wavelength_id' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifying the wavelength in DIFFRN_RADIATION_WAVELENGTH list.' ],
                          [ 'item_', '_name.category_id', 'refln' ],
                          [ 'item_', '_name.object_id', 'wavelength_id' ],
                          [ 'item_',
                            '_name.linked_item_id',
                            '_diffrn_radiation_wavelength.id' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
                  [ '@comment', '------ close REFLN category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'REFLNS',
                    [ [ 'item_', '_definition.id', 'REFLNS' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-11-26' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to specify parameters for the complete\n     set of reflections used in the structure refinement process. Note that\n     these parameters are often similar measures to those defined in the\n     DIFFRN categories, but differ in that the parameters refer to the\n     reduced/transformed reflections which have been used to refine the\n     atom site data in the ATOM_SITE category. The DIFFRN definitions refer\n     to the diffraction measurements and the raw reflection data.' ],
                      [ 'item_', '_name.category_id', 'DIFFRACTION' ],
                      [ 'item_', '_name.object_id', 'REFLNS' ],
                      [ 'save_',
                        'reflns.apply_dispersion_to_Fcalc',
                        [ [ 'item_',
                            '_definition.id',
                            '_reflns.apply_dispersion_to_Fcalc' ],
                          [ 'item_', '_definition.update', '2013-04-28' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Yes or No flag on whether the anomalous dispersion scattering\n     components will be applied in the F_complex calculation.\n     See _refln.F_complex' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'apply_dispersion_to_Fcalc' ],
                          [ 'item_', '_type.purpose', 'State' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_enumeration_set.state', '_enumeration_set.detail' ],
                            [ 'Yes', 'Apply dispersion', 'No', 'Do not apply dispersion' ] ],
                          [ 'item_', '_enumeration.default', 'Yes' ] ] ],
                      [ 'save_',
                        'reflns.d_resolution_high',
                        [ [ 'item_', '_definition.id', '_reflns.d_resolution_high' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_d_resolution_high' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Highest resolution for the final REFLN data set.\n     This corresponds to the smallest interpanar d value.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'd_resolution_high' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'reflns.d_resolution_low',
                        [ [ 'item_', '_definition.id', '_reflns.d_resolution_low' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_d_resolution_low' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Lowest resolution for the final REFLN data set.\n     This corresponds to the largest interpanar d value.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'd_resolution_low' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'reflns.Friedel_coverage',
                        [ [ 'item_', '_definition.id', '_reflns.Friedel_coverage' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_Friedel_coverage' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The proportion of Friedel related reflections present in the number of\n     the \'independent reflections\' specified by the item _reflns.number_total.\n \n     This proportion is calculated as the ratio:\n \n           [N(Crystal class) - N(Laue symmetry)] / N(Laue symmetry)\n \n     where, working from the @diffrn_refln_ list,\n \n         N(Crystal class) is the number of reflections obtained on\n             averaging under the symmetry of the crystal class\n         N(Laue symmetry) is the number of reflections obtained on\n             averaging under the Laue symmetry.\n \n       (a) For centrosymmetric structures its value is\n           necessarily equal to 0.0 as the crystal class\n           is identical to the Laue symmetry.\n       (b) For whole-sphere data for a crystal in the space\n           group P1, _reflns.Friedel_coverage is equal to 1.0,\n           as no reflection h k l is equivalent to -h -k -l\n           in the crystal class and all Friedel pairs\n           {h k l; -h -k -l} have been measured.\n       (c) For whole-sphere data in space group Pmm2, the value\n           will be < 1.0 because although reflections h k l and\n           -h -k -l are not equivalent when h k l indices are\n           non-zero, they are when l=0.\n       (d) For a crystal in the group Pmm2 measurements of the\n           two inequivalent octants h >= 0, k >=0, l lead to the\n           same value as in (c), whereas measurements of the\n           two equivalent octants h >= 0, k, l >= 0 will lead to\n           a zero value for @reflns_Friedel_coverage.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'Friedel_coverage' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:1.0' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'reflns.Friedel_fraction_full',
                        [ [ 'item_', '_definition.id', '_reflns.Friedel_fraction_full' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_Friedel_fraction_full' ] ],
                          [ 'item_', '_definition.update', '2013-01-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The ratio of Friedel pairs measured to _diffrn_reflns.theta_full\n     to the number theoretically possible (ignoring reflections in\n     centric projections and systematic absences throughout).\n     In contrast to _reflns.Friedel_coverage this can take values in\n     the full range 0 to 1 for any non-centrosymmetric space group,\n     and so one can see at a glance how completely the Friedel pairs\n     have been measured. For centrosymmetric space groups the value\n     would be given as not-applicable \'.\'' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'Friedel_fraction_full' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:1.0' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'reflns.Friedel_fraction_max',
                        [ [ 'item_', '_definition.id', '_reflns.Friedel_fraction_max' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_Friedel_fraction_max' ] ],
                          [ 'item_', '_definition.update', '2013-01-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The ratio of Friedel pairs measured to _diffrn_reflns.theta_max\n     to the number theoretically possible (ignoring reflections in\n     centric projections and systematic absences throughout).\n     In contrast to _reflns.Friedel_coverage this can take values in\n     the full range 0 to 1 for any non-centrosymmetric space group,\n     and so one can see at a glance how completely the Friedel pairs\n     have been measured. For centrosymmetric space groups the value\n     would be given as not-applicable \'.\'' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'Friedel_fraction_max' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.0:1.0' ],
                          [ 'item_', '_units.code', 'none' ] ] ],
                      [ 'save_',
                        'reflns.limit_max',
                        [ [ 'item_', '_definition.id', '_reflns.limit_max' ],
                          [ 'item_', '_definition.update', '2013-01-15' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Maximum Miller indices of refined diffraction reflections.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_max' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Matrix' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_type.dimension', [ '3' ] ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With t as reflns\n \n     _reflns.limit_max = [t.limit_h_max,t.limit_k_max,t.limit_l_max]' ] ] ] ],
                      [ 'save_',
                        'reflns.limit_min',
                        [ [ 'item_', '_definition.id', '_reflns.limit_min' ],
                          [ 'item_', '_definition.update', '2013-01-15' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Minimum Miller indices of refined diffraction reflections.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_min' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Matrix' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_type.dimension', [ '3' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With t as reflns\n \n     _reflns.limit_min = [t.limit_h_min,t.limit_k_min,t.limit_l_min]' ] ] ] ],
                      [ 'save_',
                        'reflns.limit_h_max',
                        [ [ 'item_', '_definition.id', '_reflns.limit_h_max' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_limit_h_max' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_h_max' ] ] ],
                      [ 'save_',
                        'reflns.limit_h_min',
                        [ [ 'item_', '_definition.id', '_reflns.limit_h_min' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_limit_h_min' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_h_min' ] ] ],
                      [ 'save_',
                        'reflns.limit_k_max',
                        [ [ 'item_', '_definition.id', '_reflns.limit_k_max' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_limit_k_max' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_k_max' ] ] ],
                      [ 'save_',
                        'reflns.limit_k_min',
                        [ [ 'item_', '_definition.id', '_reflns.limit_k_min' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_limit_k_min' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_k_min' ] ] ],
                      [ 'save_',
                        'reflns.limit_l_max',
                        [ [ 'item_', '_definition.id', '_reflns.limit_l_max' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_limit_l_max' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_l_max' ] ] ],
                      [ 'save_',
                        'reflns.limit_l_min',
                        [ [ 'item_', '_definition.id', '_reflns.limit_l_min' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_limit_l_min' ] ],
                          [ 'item_', '_definition.update', '2013-04-16' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The index of a reciprocal space vector.' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '-1000:1000' ],
                          [ 'item_', '_units.code', 'none' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'limit_l_min' ] ] ],
                      [ 'save_',
                        'reflns.number_gt',
                        [ [ 'item_', '_definition.id', '_reflns.number_gt' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_number_gt',
                              '_reflns_number_observed',
                              '_reflns_number_obs',
                              '_reflns.number_obs' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Count of reflections in the REFLN set (not the DIFFRN_REFLN set) which\n     are significantly intense (see _reflns.threshold_expression). It may\n     include Friedel equivalent reflections (i.e. those which are equivalent\n     under the Laue symmetry but inequivalent under the crystal class),\n     depending to the nature of the structure and the procedures used.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'number_gt' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Count' ],
                          [ 'item_', '_enumeration.range', '0:' ] ] ],
                      [ 'save_',
                        'reflns.number_total',
                        [ [ 'item_', '_definition.id', '_reflns.number_total' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_number_total',
                              '_reflns_number_all',
                              '_reflns.number_all' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Number of reflections in the REFLN set (not the DIFFRN_REFLN set). It may\n     include Friedel equivalent reflections (i.e. those which are equivalent\n     under the Laue symmetry but inequivalent under the crystal class),\n     depending to the nature of the structure and the procedures used.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'number_total' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Count' ],
                          [ 'item_', '_enumeration.range', '0:' ] ] ],
                      [ 'save_',
                        'reflns.special_details',
                        [ [ 'item_', '_definition.id', '_reflns.special_details' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_special_details', '_reflns.details' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Description of the properties of the REFLN reflection list that is not\n     given in other data items. Should include details about the averaging\n     of symmetry-equivalent reflections including Friedel pairs.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'special_details' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'reflns.threshold_expression',
                        [ [ 'item_', '_definition.id', '_reflns.threshold_expression' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_reflns_threshold_expression',
                              '_reflns_observed_criterion',
                              '_reflns.observed_criterion' ] ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Description of the criterion used to classify a reflection as having a\n     "significant intensity". This criterion is usually expressed in terms\n     of a u(I) or u(F) threshold. "u" is the standard uncertainty.' ],
                          [ 'item_', '_name.category_id', 'reflns' ],
                          [ 'item_', '_name.object_id', 'threshold_expression' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_', [ '_description_example.case' ], [ 'I>2u(I)' ] ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'REFLNS_CLASS',
                        [ [ 'item_', '_definition.id', 'REFLNS_CLASS' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the properties of reflections\n     in specific classes of reflections.' ],
                          [ 'item_', '_name.category_id', 'REFLNS' ],
                          [ 'item_', '_name.object_id', 'CLASS' ],
                          [ 'item_', '_category.key_id', '_reflns_class.key' ],
                          [ 'save_',
                            'reflns_class.key',
                            [ [ 'item_', '_definition.id', '_reflns_class.key' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of REFLNS_CLASS items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '           _type.contents = Type_Contents(reflns_class.code)',
                                  'Evaluation',
                                  '           _reflns_class.key = _reflns_class.code' ] ] ] ],
                          [ 'save_',
                            'reflns_class.code',
                            [ [ 'item_', '_definition.id', '_reflns_class.code' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_reflns_class_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying a reflection class.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_', [ '_description_example.case' ], [ 'c1' ] ] ] ],
                          [ 'save_',
                            'reflns_class.description',
                            [ [ 'item_', '_definition.id', '_reflns_class.description' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_description' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of a reflection class.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'description' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'H0L0 common projection reflections' ] ] ] ],
                          [ 'save_',
                            'reflns_class.d_res_high',
                            [ [ 'item_', '_definition.id', '_reflns_class.d_res_high' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_d_res_high' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Highest resolution for the reflections in this class.\n     This corresponds to the smallest interpanar d value.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'd_res_high' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'reflns_class.d_res_low',
                            [ [ 'item_', '_definition.id', '_reflns_class.d_res_low' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_d_res_low' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Lowest resolution for the reflections in this class.\n     This corresponds to the largest interpanar d value.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'd_res_low' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'reflns_class.number_gt',
                            [ [ 'item_', '_definition.id', '_reflns_class.number_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_number_observed', '_reflns_class_number_gt' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Count of reflections in this REFLN class (not the DIFFRN_REFLN set)\n     which are significantly intense (see _reflns.threshold_expression). It may\n     include Friedel equivalent reflections (i.e. those which are equivalent\n     under the Laue symmetry but inequivalent under the crystal class),\n     depending to the nature of the structure and the procedures used.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'number_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_class.number_total',
                            [ [ 'item_', '_definition.id', '_reflns_class.number_total' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_number_total' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Count of reflections in this REFLN class (not the DIFFRN_REFLN set). It\n     may include Friedel equivalent reflections (those which are equivalent\n     under the Laue symmetry but inequivalent under the crystal class),\n     depending to the nature of the structure and the procedures used.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'number_total' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_class.R_factor_all',
                            [ [ 'item_', '_definition.id', '_reflns_class.R_factor_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_R_factor_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor for reflections in this class used in refinement.\n \n                   sum | F(meas) - F(calc) |\n        R(F all) = ------------------------\n                         sum | F(meas) |\n \n               F(meas) = the measured structure-factor amplitudes\n               F(calc) = the calculated structure-factor amplitudes\n \n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'R_factor_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_class.R_factor_gt',
                            [ [ 'item_', '_definition.id', '_reflns_class.R_factor_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_R_factor_gt',
                                  '_reflns_class_R_factor_observed' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor for the reflections in this class judged\n     significantly intense (i.e. greater than required by the\n     _reflns.threshold_expression) and included in the refinement.\n \n                   sum | F(meas_gt) - F(calc) |\n        R(F gt) = --------------------------------\n                         sum | F(meas_gt) |\n \n               F(meas) = the measured structure-factor amplitudes\n               F(calc) = the calculated structure-factor amplitudes\n \n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'R_factor_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_class.R_Fsqd_factor',
                            [ [ 'item_', '_definition.id', '_reflns_class.R_Fsqd_factor' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_R_Fsqd_factor' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor R(F^2^) for reflections in this class judged\n     significantly intense (i.e. greater than required by the\n     _reflns.threshold_expression) and included in the refinement.\n \n                          sum | F(meas_gt)^2^ - F(calc)^2^ |\n            R(Fsqd gt) = ------------------------------------\n                                  sum F(meas_gt)^2^\n \n          F(meas_gt)^2^ = square of the \'observed\' structure-factor\n          F(calc   )^2^ = square of the calculated structure-factor\n \n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'R_Fsqd_factor' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_class.R_I_factor',
                            [ [ 'item_', '_definition.id', '_reflns_class.R_I_factor' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_R_I_factor' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor R(I) for reflections in this class judged\n     significantly intense (i.e. greater than required by the\n     _reflns.threshold_expression) and included in the refinement.\n \n                       sum | I(meas_gt) - I(calc) |\n            R(I gt) =  ----------------------------\n                              sum | I(meas_gt) |\n \n               I(meas_gt) = the net \'observed\' intensity\n               I(calc   ) = the net calculated intensity\n \n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'R_I_factor' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_class.wR_factor_all',
                            [ [ 'item_', '_definition.id', '_reflns_class.wR_factor_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_class_wR_factor_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     For each reflection class, the weighted residual factors for all\n     reflections included in the refinement. The reflections also\n     satisfy the resolution limits established by\n     _reflns_class.d_res_high and _reflns_class.d_res_low.\n \n          ( sum w [ Y(meas) - Y(calc) ]^2^  )^1/2^\n     wR = ( ------------------------------- )\n          (         sum w Y(meas)^2^        )\n \n         Y(meas) = the measured amplitudes specified by\n                   _refine_ls.structure_factor_coef\n         Y(calc) = the calculated amplitudes specified by\n                   _refine_ls.structure_factor_coef\n         w       = the least-squares weights\n \n     and the sum is taken over the reflections of this class.' ],
                              [ 'item_', '_name.category_id', 'class' ],
                              [ 'item_', '_name.object_id', 'wR_factor_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ] ] ],
                      [ '@comment', '------ close REFLNS_CLASS category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'REFLNS_SCALE',
                        [ [ 'item_', '_definition.id', 'REFLNS_SCALE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the scales needed to place\n     measured structure factor coefficients on the same absolute scale.' ],
                          [ 'item_', '_name.category_id', 'REFLNS' ],
                          [ 'item_', '_name.object_id', 'SCALE' ],
                          [ 'item_', '_category.key_id', '_reflns_scale.key' ],
                          [ 'save_',
                            'reflns_scale.key',
                            [ [ 'item_', '_definition.id', '_reflns_scale.key' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of REFLNS_SCALE items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'scale' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '           _type.contents = Type_Contents(reflns_scale.group_code)',
                                  'Evaluation',
                                  '           _reflns_scale.key = _reflns_scale.group_code' ] ] ] ],
                          [ 'save_',
                            'reflns_scale.group_code',
                            [ [ 'item_', '_definition.id', '_reflns_scale.group_code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_scale_group_code' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying a reflection scale group. These names need not\n     correspond to _diffrn_scale_group.code names.' ],
                              [ 'item_', '_name.category_id', 'scale' ],
                              [ 'item_', '_name.object_id', 'group_code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'reflns_scale.meas_F',
                            [ [ 'item_', '_definition.id', '_reflns_scale.meas_F' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_scale_meas_F' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Structure factor scale for this scale group.' ],
                              [ 'item_', '_name.category_id', 'scale' ],
                              [ 'item_', '_name.object_id', 'meas_F' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_scale.meas_F_squared',
                            [ [ 'item_', '_definition.id', '_reflns_scale.meas_F_squared' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_scale_meas_F_squared' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Structure factor squared scale for this scale group.' ],
                              [ 'item_', '_name.category_id', 'scale' ],
                              [ 'item_', '_name.object_id', 'meas_F_squared' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_scale.meas_intensity',
                            [ [ 'item_', '_definition.id', '_reflns_scale.meas_intensity' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_scale_meas_intensity' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Net intensity scale for this scale group.' ],
                              [ 'item_', '_name.category_id', 'scale' ],
                              [ 'item_', '_name.object_id', 'meas_intensity' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ] ] ],
                      [ '@comment', '------ close REFLNS_SCALE category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'REFLNS_SHELL',
                        [ [ 'item_', '_definition.id', 'REFLNS_SHELL' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-26' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the information about\n     reflections divided into shells bounded by d resolution limits.' ],
                          [ 'item_', '_name.category_id', 'REFLNS' ],
                          [ 'item_', '_name.object_id', 'SHELL' ],
                          [ 'item_', '_category.key_id', '_reflns_shell.key' ],
                          [ 'save_',
                            'reflns_shell.key',
                            [ [ 'item_', '_definition.id', '_reflns_shell.key' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of REFLNS_SHELL items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '         _type.contents = Type_Contents(reflns_shell.d_res_limits)',
                                  'Evaluation',
                                  '         _reflns_shell.key = _reflns_shell.d_res_limits' ] ] ] ],
                          [ 'save_',
                            'reflns_shell.d_res_limits',
                            [ [ 'item_', '_definition.id', '_reflns_shell.d_res_limits' ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Resolution for the reflections in this shell stored as\n     the list of lowest and highest values. This is the\n     category key.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'd_res_limits' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '2' ] ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With s as reflns_shell\n \n        _reflns_shell.d_res_limits =  [ s.d_res_low, s.d_res_high ]' ] ] ] ],
                          [ 'save_',
                            'reflns_shell.d_res_high',
                            [ [ 'item_', '_definition.id', '_reflns_shell.d_res_high' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_d_res_high' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Highest resolution for the reflections in this shell.\n     This corresponds to the smallest interpanar d value.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'd_res_high' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'reflns_shell.d_res_low',
                            [ [ 'item_', '_definition.id', '_reflns_shell.d_res_low' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_d_res_low' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Lowest resolution for the reflections in this shell.\n     This corresponds to the largest interpanar d value.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'd_res_low' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'reflns_shell.meanI_over_suI_all',
                            [ [ 'item_', '_definition.id', '_reflns_shell.meanI_over_suI_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_meanI_over_uI_all',
                                  '_reflns_shell_meanI_over_sigI_all',
                                  '_reflns_shell.meanI_over_sigI_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Ratio of the mean intensity in a shell to the mean standard uncertainty\n     of the intensities in the shell.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'meanI_over_suI_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.meanI_over_suI_gt',
                            [ [ 'item_', '_definition.id', '_reflns_shell.meanI_over_suI_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_meanI_over_sigI_obs',
                                  '_reflns_shell.meanI_over_sigI_obs',
                                  '_reflns_shell_meanI_over_sigI_gt',
                                  '_reflns_shell_meanI_over_uI_gt' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Ratio of the mean intensity of significantly intense reflections (see\n     _reflns.threshold_expression) in this shell to the mean standard\n     uncertainty of the intensities in the shell.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'meanI_over_suI_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.number_measured_all',
                            [ [ 'item_',
                                '_definition.id',
                                '_reflns_shell.number_measured_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_number_measured_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Total count of reflections measured for this resolution shell.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'number_measured_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_shell.number_measured_gt',
                            [ [ 'item_', '_definition.id', '_reflns_shell.number_measured_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_number_measured_obs',
                                  '_reflns_shell.number_measured_obs',
                                  '_reflns_shell_number_measured_gt' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of reflections measured for this resolution shell which are\n     significantly intense (see _reflns.threshold_expression).' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'number_measured_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_shell.number_possible',
                            [ [ 'item_', '_definition.id', '_reflns_shell.number_possible' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_number_possible',
                                  '_reflns_shell.number_possible_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Count of symmetry-unique reflections possible in this reflection shell.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'number_possible' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_shell.number_unique_all',
                            [ [ 'item_', '_definition.id', '_reflns_shell.number_unique_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_number_unique_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Count of symmetry-unique reflections present in this reflection shell.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'number_unique_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_shell.number_unique_gt',
                            [ [ 'item_', '_definition.id', '_reflns_shell.number_unique_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_number_unique_gt',
                                  '_reflns_shell_number_unique_obs',
                                  '_reflns_shell.number_unique_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of symmetry-unique reflections present in this reflection shell\n     which are significantly intense (see _reflns.threshold_expression).' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'number_unique_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'reflns_shell.percent_possible_all',
                            [ [ 'item_',
                                '_definition.id',
                                '_reflns_shell.percent_possible_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_percent_possible_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Percentage of reflections present in this shell over that possible.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'percent_possible_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:100.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.percent_possible_gt',
                            [ [ 'item_',
                                '_definition.id',
                                '_reflns_shell.percent_possible_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_percent_possible_gt',
                                  '_reflns_shell_percent_possible_obs',
                                  '_reflns_shell.percent_possible_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Percentage of reflections present in this shell which are significantly\n     intense (see _reflns.threshold_expression), over that possible.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'percent_possible_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:100.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.Rmerge_F_all',
                            [ [ 'item_', '_definition.id', '_reflns_shell.Rmerge_F_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_Rmerge_F_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Rmerge(F) for all reflections in a given shell.\n \n                     sum~i~ ( sum~j~ | F~j~ - <F> | )\n         Rmerge(F) = --------------------------------\n                         sum~i~ ( sum~j~ <F> )\n \n         F~j~  = the amplitude of the jth observation of reflection i\n         <F> = the mean of the amplitudes of all observations of\n                reflection i\n \n         sum~i~ is taken over all reflections\n         sum~j~ is taken over all observations of each reflection.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'Rmerge_F_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.Rmerge_F_gt',
                            [ [ 'item_', '_definition.id', '_reflns_shell.Rmerge_F_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_Rmerge_F_obs',
                                  '_reflns_shell.Rmerge_F_obs',
                                  '_reflns_shell_Rmerge_F_gt' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Rmerge(F) for reflections in a shell which are significantly intense\n     (see _reflns.threshold_expression). The residual merge expression is\n     shown in the _reflns_shell.Rmerge_F_all definition.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'Rmerge_F_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.Rmerge_I_all',
                            [ [ 'item_', '_definition.id', '_reflns_shell.Rmerge_I_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_Rmerge_I_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Rmerge(I) for all reflections in a given shell.\n \n                     sum~i~ ( sum~j~ | I~j~ - <I> | )\n         Rmerge(I) = --------------------------------\n                         sum~i~ ( sum~j~ <I> )\n \n         I~j~  = the intensity of the jth observation of reflection i\n         <I> = the mean of the intensities of all observations of\n                reflection i\n \n         sum~i~ is taken over all reflections\n         sum~j~ is taken over all observations of each reflection.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'Rmerge_I_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'reflns_shell.Rmerge_I_gt',
                            [ [ 'item_', '_definition.id', '_reflns_shell.Rmerge_I_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_reflns_shell_Rmerge_I_obs',
                                  '_reflns_shell.Rmerge_I_obs',
                                  '_reflns_shell_Rmerge_I_gt' ] ],
                              [ 'item_', '_definition.update', '2012-11-26' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Rmerge(I) for reflections in a shell which are significantly intense\n     (see _reflns.threshold_expression). The residual merge expression is\n     shown in the _reflns_shell.Rmerge_I_all definition.' ],
                              [ 'item_', '_name.category_id', 'shell' ],
                              [ 'item_', '_name.object_id', 'Rmerge_I_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ] ] ],
                      [ '@comment', '------ close REFLNS_SHELL category' ] ] ],
                  [ '@comment', '------ close REFLNS category' ] ] ],
              [ '@comment', '------ close DIFFRACTION category' ],
              [ 'save_',
                'STRUCTURE',
                [ [ 'item_', '_definition.id', 'STRUCTURE' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Head' ],
                  [ 'item_', '_definition.update', '2012-11-20' ],
                  [ 'item_',
                    '_description.text',
                    '\n    The DICTIONARY group encompassing the CORE STRUCTURE data items defined\n    and used with in the Crystallographic Information Framework (CIF).' ],
                  [ 'item_', '_name.category_id', 'CIF_CORE' ],
                  [ 'item_', '_name.object_id', 'STRUCTURE' ],
                  [ '@comment',
                    '===========================================================================' ],
                  [ 'save_',
                    'ATOM',
                    [ [ 'item_', '_definition.id', 'ATOM' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-11-20' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to describe atomic information\n     used in crystallographic structure studies.' ],
                      [ 'item_', '_name.category_id', 'STRUCTURE' ],
                      [ 'item_', '_name.object_id', 'ATOM' ],
                      [ '@comment',
                        '===========================================================================' ],
                      [ 'save_',
                        'ATOM_SITE',
                        [ [ 'item_', '_definition.id', 'ATOM_SITE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to describe atom site information\n     used in crystallographic structure studies.' ],
                          [ 'item_', '_name.category_id', 'ATOM' ],
                          [ 'item_', '_name.object_id', 'SITE' ],
                          [ 'item_', '_category.key_id', '_atom_site.key' ],
                          [ 'save_',
                            'atom_site.key',
                            [ [ 'item_', '_definition.id', '_atom_site.key' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of ATOM_SITE items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(atom_site.label)',
                                  'Evaluation',
                                  '              _atom_site.key = _atom_site.label' ] ] ] ],
                          [ 'save_',
                            'atom_site.adp_type',
                            [ [ 'item_', '_definition.id', '_atom_site.adp_type' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_adp_type',
                                  '_atom_site_thermal_displace_type',
                                  '_atom_site.thermal_displace_type' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code for type of atomic displacement parameters used for the site.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'adp_type' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'Uani',
                                  'anisotropic Uij',
                                  'Uiso',
                                  'isotropic U',
                                  'Uovl',
                                  'overall U',
                                  'Umpe',
                                  'multipole expansion U',
                                  'Bani',
                                  'anisotropic Bij',
                                  'Biso',
                                  'isotropic B',
                                  'Bovl',
                                  'overall B' ] ],
                              [ 'item_', '_enumeration.default', 'Uiso' ] ] ],
                          [ 'save_',
                            'atom_site.tensor_beta',
                            [ [ 'item_', '_definition.id', '_atom_site.tensor_beta' ],
                              [ 'item_', '_definition.update', '2013-04-28' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The symmetric anisotropic atomic displacement tensor beta[I,J]\n     appears in a structure factor expression as:\n \n     t = exp -[ beta11 h h + ............ 2 beta23 k l ]\n \n     It is related to the adp matrices U(IJ) and B(IJ) as follows:\n \n     t = exp -2pi**2 ( U11    h h a* a* + ...... 2 U23    k l b* c* )\n     t = exp - 0.25  ( B11    h h a* a* + ...... 2 B23    k l b* c* )' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'tensor_beta' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Matrix' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '3', '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  atom_site\n \n     label = a.label\n \n     If      (a.adp_type == \'uani\')  {\n         Loop b as atom_site_aniso     {\n           If(label == b.label)           {\n \n               UIJ = b.matrix_U\n               Break\n     } } }\n \n     Else If (a.adp_type == \'bani\')  {\n         Loop b as atom_site_aniso     {\n           If(label == b.label)           {\n \n              UIJ = b.matrix_B / (8 * Pi**2)\n              Break\n     } } }\n \n     Else                                    {\n         If (a.adp_type == \'uiso\')  U  =  a.U_iso_or_equiv\n         Else                       U  =  a.B_iso_or_equiv / (8 * Pi**2)\n \n             UIJ = U * _cell_reciprocal.convert_Uiso_to_Uij\n     }\n \n              CUB = _cell_reciprocal.convert_Uij_to_betaij\n \n        _atom_site.tensor_beta =  CUB * UIJ * CUB' ] ] ] ],
                          [ 'save_',
                            'atom_site.attached_hydrogens',
                            [ [ 'item_', '_definition.id', '_atom_site.attached_hydrogens' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_attached_hydrogens' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of hydrogen atoms attached to the atom at this site\n     excluding any H atoms for which coordinates (measured or calculated)\n     are given.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'attached_hydrogens' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:8' ],
                              [ 'item_', '_enumeration.default', '0' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '2',
                                  'water oxygen',
                                  '1',
                                  'hydroxyl oxygen',
                                  '4',
                                  'ammonium nitrogen' ] ] ] ],
                          [ 'save_',
                            'atom_site.B_equiv_geom_mean',
                            [ [ 'item_', '_definition.id', '_atom_site.B_equiv_geom_mean' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_B_equiv_geom_mean' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Equivalent isotropic atomic displacement parameter, B(equiv),\n     in angstroms squared, calculated as the geometric mean of\n     the anisotropic atomic displacement parameters.\n \n                 B(equiv) = (B~i~ B~j~ B~k~)^1/3^\n \n     B~n~  = the principal components of the orthogonalised B^ij^\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'B_equiv_geom_mean' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstrom_squared' ] ] ],
                          [ 'save_',
                            'atom_site.B_iso_or_equiv',
                            [ [ 'item_', '_definition.id', '_atom_site.B_iso_or_equiv' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_B_iso_or_equiv' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Isotropic atomic displacement parameter, or equivalent isotropic\n     atomic displacement parameter, B(equiv), in angstroms squared,\n     calculated from anisotropic temperature factor parameters.\n \n         B(equiv) = (1/3) sum~i~[sum~j~(B^ij^ a*~i~ a*~j~ a~i~ a~j~)]\n \n     a     = the real-space cell lengths\n     a*    = the reciprocal-space cell lengths\n     B^ij^ = 8 pi^2^ U^ij^\n     Ref: Fischer, R. X. & Tillmanns, E. (1988). Acta Cryst. C44, 775-776.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'B_iso_or_equiv' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstrom_squared' ] ] ],
                          [ 'save_',
                            'atom_site.calc_attached_atom',
                            [ [ 'item_', '_definition.id', '_atom_site.calc_attached_atom' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_calc_attached_atom' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The _atom_site.label of the atom site to which the \'geometry-\n     calculated\' atom site is attached.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'calc_attached_atom' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'atom_site.calc_flag',
                            [ [ 'item_', '_definition.id', '_atom_site.calc_flag' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_calc_flag' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A standard code to signal if the site coordinates have been\n     determined from the intensities or calculated from the geometry\n     of surrounding sites, or have been assigned dummy coordinates.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'calc_flag' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'd',
                                  'determined from diffraction measurements',
                                  'calc',
                                  'calculated from molecular geometry',
                                  'c',
                                  'abbreviation for "calc"',
                                  'dum',
                                  'dummy site with meaningless coordinates' ] ],
                              [ 'item_', '_enumeration.default', 'd' ] ] ],
                          [ 'save_',
                            'atom_site.Cartn_xyz',
                            [ [ 'item_', '_definition.id', '_atom_site.Cartn_xyz' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Vector of Cartesian (orthogonal angstrom) atom site coordinates.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'Cartn_xyz' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Matrix' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n    With a  as  atom_site\n \n    _atom_site.Cartn_xyz =   [a.Cartn_x, a.Cartn_y, a.Cartn_z]' ] ] ] ],
                          [ 'save_',
                            'atom_site.Cartn_x',
                            [ [ 'item_', '_definition.id', '_atom_site.Cartn_x' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_Cartn_x' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The atom site coordinates in angstroms specified according to a\n     set of orthogonal Cartesian axes related to the cell axes as\n     specified by the _atom_sites_Cartn_transform.axes description.' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1000.:1000.' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'Cartn_x' ] ] ],
                          [ 'save_',
                            'atom_site.Cartn_y',
                            [ [ 'item_', '_definition.id', '_atom_site.Cartn_y' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_Cartn_y' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The atom site coordinates in angstroms specified according to a\n     set of orthogonal Cartesian axes related to the cell axes as\n     specified by the _atom_sites_Cartn_transform.axes description.' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1000.:1000.' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'Cartn_y' ] ] ],
                          [ 'save_',
                            'atom_site.Cartn_z',
                            [ [ 'item_', '_definition.id', '_atom_site.Cartn_z' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_Cartn_z' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The atom site coordinates in angstroms specified according to a\n     set of orthogonal Cartesian axes related to the cell axes as\n     specified by the _atom_sites_Cartn_transform.axes description.' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1000.:1000.' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'Cartn_z' ] ] ],
                          [ 'save_',
                            'atom_site.chemical_conn_number',
                            [ [ 'item_', '_definition.id', '_atom_site.chemical_conn_number' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_chemical_conn_number' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This number links an atom site to the chemical connectivity list.\n     It must match a number specified by _chemical_conn_atom.number.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'chemical_conn_number' ],
                              [ 'item_', '_name.linked_item_id', '_chemical_conn_atom.number' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '1:' ] ] ],
                          [ 'save_',
                            'atom_site.constraints',
                            [ [ 'item_', '_definition.id', '_atom_site.constraints' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_constraints' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A description of the constraints applied to parameters at this\n     site during refinement. See also _atom_site.refinement_flags\n     and _refine_ls.number_constraints.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'constraints' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'pop=1.0-pop(Zn3)' ] ] ] ],
                          [ 'save_',
                            'atom_site.description',
                            [ [ 'item_', '_definition.id', '_atom_site.description' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_description', '_atom_site.details' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A description of special aspects of this site. See also\n     _atom_site.refinement_flags.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'description' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Ag/Si disordered' ] ] ] ],
                          [ 'save_',
                            'atom_site.disorder_assembly',
                            [ [ 'item_', '_definition.id', '_atom_site.disorder_assembly' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_disorder_assembly' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A code which identifies a cluster of atoms that show long range\n     positional disorder but are locally ordered. Within each such\n     cluster of atoms, _atom_site.disorder_group is used to identify\n     the sites that are simultaneously occupied. This field is only\n     needed if there is more than one cluster of disordered atoms\n     showing independent local order.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'disorder_assembly' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ 'A',
                                  'disordered methyl assembly with groups 1 and 2',
                                  'B',
                                  'disordered sites related by a mirror',
                                  'S',
                                  'disordered sites independent of symmetry' ] ] ] ],
                          [ 'save_',
                            'atom_site.disorder_group',
                            [ [ 'item_', '_definition.id', '_atom_site.disorder_group' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_disorder_group' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A code that identifies a group of positionally disordered atom\n     sites that are locally simultaneously occupied. Atoms that are\n     positionally disordered over two or more sites (e.g. the H\n     atoms of a methyl group that exists in two orientations) can\n     be assigned to two or more groups. Sites belonging to the same\n     group are simultaneously occupied, but those belonging to\n     different groups are not. A minus prefix (e.g. "-1") is used to\n     indicate sites disordered about a special position.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'disorder_group' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '1',
                                  'unique disordered site in group 1',
                                  '2',
                                  'unique disordered site in group 2',
                                  '-1',
                                  'symmetry-independent disordered site' ] ] ] ],
                          [ 'save_',
                            'atom_site.fract_xyz',
                            [ [ 'item_', '_definition.id', '_atom_site.fract_xyz' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Vector of atom site coordinates projected onto the crystal unit\n     cell as fractions of the cell lengths.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'fract_xyz' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Matrix' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With a  as  atom_site\n \n     atom_site.fract_xyz =  [a.fract_x, a.fract_y, a.fract_z]' ] ] ] ],
                          [ 'save_',
                            'atom_site.fract_x',
                            [ [ 'item_', '_definition.id', '_atom_site.fract_x' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_fract_x' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site coordinates as fractions of the cell length values.' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1.:1.' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'fract_x' ] ] ],
                          [ 'save_',
                            'atom_site.fract_y',
                            [ [ 'item_', '_definition.id', '_atom_site.fract_y' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_fract_y' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site coordinates as fractions of the cell length values.' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1.:1.' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'fract_y' ] ] ],
                          [ 'save_',
                            'atom_site.fract_z',
                            [ [ 'item_', '_definition.id', '_atom_site.fract_z' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_fract_z' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site coordinates as fractions of the cell length values.' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1.:1.' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'fract_z' ] ] ],
                          [ 'save_',
                            'atom_site.label',
                            [ [ 'item_', '_definition.id', '_atom_site.label' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_site_label' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_0',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_0' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_0' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_0' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_1',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_1' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_1' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_2',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_2' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_2' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_3',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_3' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_3' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_3' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_4',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_4' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_4' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_4' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_5',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_5' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_5' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_5' ] ] ],
                          [ 'save_',
                            'atom_site.label_component_6',
                            [ [ 'item_', '_definition.id', '_atom_site.label_component_6' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_label_component_6' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Component_0 is normally a code which matches identically with\n     one of the _atom_type.symbol codes. If this is the case then the\n     rules governing the _atom_type.symbol code apply. If, however,\n     the data item _atom_site.type_symbol is also specified in the\n     atom site list, component 0 need not match this symbol or adhere\n     to any of the _atom_type.symbol rules.\n     Component_1 is referred to as the "atom number". When component 0\n     is the atom type code, it is used to number the sites with the\n     same atom type. This component code must start with at least one\n     digit which is not followed by a + or - sign (to distinguish it\n     from the component 0 rules).\n     Components_2 to 6 contain the identifier, residue, sequence,\n     asymmetry identifier and alternate codes, respectively. These\n     codes may be composed of any characters except an underline.' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'label_component_6' ] ] ],
                          [ 'save_',
                            'atom_site.occupancy',
                            [ [ 'item_', '_definition.id', '_atom_site.occupancy' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_occupancy' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The fraction of the atom type present at this site.\n     The sum of the occupancies of all the atom types at this site\n     may not significantly exceed 1.0 unless it is a dummy site. The\n     value must lie in the 99.97% Gaussian confidence interval\n     -3u =< x =< 1 + 3u. The _enumeration.range of 0.0:1.0 is thus\n     correctly interpreted as meaning (0.0 - 3u) =< x =< (1.0 + 3u).' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'occupancy' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:1.0' ],
                              [ 'item_', '_enumeration.default', '1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'atom_site.refinement_flags',
                            [ [ 'item_', '_definition.id', '_atom_site.refinement_flags' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_refinement_flags' ] ],
                              [ 'item_', '_definition.update', '2013-03-08' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A concatenated series of single-letter codes which indicate the\n     refinement restraints or constraints applied to this site.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'refinement_flags' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'S',
                                  'special position constraint on site',
                                  'G',
                                  'rigid group refinement of site',
                                  'R',
                                  'riding-atom site attached to non-riding atom',
                                  'D',
                                  'distance or angle restraint on site',
                                  'T',
                                  'thermal displacement constraints',
                                  'U',
                                  'Uiso or Uij restraint (rigid bond)',
                                  'P',
                                  'partial occupancy constraint',
                                  '.',
                                  'no refinement constraints' ] ],
                              [ 'item_', '_enumeration.default', '.' ] ] ],
                          [ 'save_',
                            'atom_site.refinement_flags_adp',
                            [ [ 'item_', '_definition.id', '_atom_site.refinement_flags_adp' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_refinement_flags_adp' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A code which indicates the refinement restraints or constraints\n     applied to the atomic displacement parameters of this site.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'refinement_flags_adp' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ '.',
                                  'no constraints on atomic displacement parameters',
                                  'T',
                                  'special-position constraints on atomic displacement parameters',
                                  'U',
                                  'Uiso or Uij restraint (rigid bond)',
                                  'TU',
                                  'both constraints applied' ] ],
                              [ 'item_', '_enumeration.default', '.' ] ] ],
                          [ 'save_',
                            'atom_site.refinement_flags_occupancy',
                            [ [ 'item_',
                                '_definition.id',
                                '_atom_site.refinement_flags_occupancy' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_refinement_flags_occupancy' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A code which indicates the refinement restraints or constraints\n     applied to the occupancy of this site.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'refinement_flags_occupancy' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ '.',
                                  'no constraints on atomic displacement parameters',
                                  'T',
                                  'special-position constraints on atomic displacement parameters',
                                  'U',
                                  'Uiso or Uij restraint (rigid bond)',
                                  'TU',
                                  'both constraints applied' ] ],
                              [ 'item_', '_enumeration.default', '.' ] ] ],
                          [ 'save_',
                            'atom_site.refinement_flags_posn',
                            [ [ 'item_', '_definition.id', '_atom_site.refinement_flags_posn' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_refinement_flags_posn' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A code which indicates the refinement restraints or constraints\n     applied to the positional coordinates of this site.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'refinement_flags_posn' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ '.',
                                  'no constraints on positional coordinates',
                                  'D',
                                  'distance or angle restraint on positional coordinates',
                                  'G',
                                  'rigid-group refinement of positional coordinates',
                                  'R',
                                  'riding-atom site attached to non-riding atom',
                                  'S',
                                  'special-position constraint on positional coordinates',
                                  'DG',
                                  'combination of the above constraints',
                                  'DR',
                                  'combination of the above constraints',
                                  'DS',
                                  'combination of the above constraints',
                                  'GR',
                                  'combination of the above constraints',
                                  'GS',
                                  'combination of the above constraints',
                                  'RS',
                                  'combination of the above constraints',
                                  'DGR',
                                  'combination of the above constraints',
                                  'DGS',
                                  'combination of the above constraints',
                                  'DRS',
                                  'combination of the above constraints',
                                  'GRS',
                                  'combination of the above constraints',
                                  'DGRS',
                                  'combination of the above constraints' ] ],
                              [ 'item_', '_enumeration.default', '.' ] ] ],
                          [ 'save_',
                            'atom_site.restraints',
                            [ [ 'item_', '_definition.id', '_atom_site.restraints' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_restraints' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A description of restraints applied to specific parameters at\n     this site during refinement. See also _atom_site.refinement_flags\n     and _refine_ls.number_restraints.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'restraints' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'restrained to planar ring' ] ] ] ],
                          [ 'save_',
                            'atom_site.site_symmetry_multiplicity',
                            [ [ 'item_',
                                '_definition.id',
                                '_atom_site.site_symmetry_multiplicity' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_site_symmetry_multiplicity',
                                  '_atom_site_symmetry_multiplicity' ] ],
                              [ 'item_', '_definition.update', '2013-04-28' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The number of different sites that are generated by the\n     application of the space-group symmetry to the coordinates\n     given for this site. It is equal to the multiplicity given\n     for this Wyckoff site in International Tables for Cryst.\n     Vol. A (2002). It is equal to the multiplicity of the general\n     position divided by the order of the site symmetry given in\n     _atom_site.site_symmetry_order.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_multiplicity' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '1:192' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  atom_site\n \n        mul  =   0\n        xyz  =   a.fract_xyz\n \n          Loop  s  as  symmetry_equiv  {\n \n             sxyz  =   s.R * xyz + s.T\n             diff  =   Mod( 99.5 + xyz - sxyz, 1.0) - 0.5\n \n             If ( Norm ( diff ) < 0.1 ) mul +=  1\n       }\n    _atom_site.site_symmetry_multiplicity =  _symmetry.multiplicity / mul' ] ] ] ],
                          [ 'save_',
                            'atom_site.site_symmetry_order',
                            [ [ 'item_', '_definition.id', '_atom_site.site_symmetry_order' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_site_symmetry_order' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The number of times application of the crystallographic symmetry\n    to the coordinates for this site generates the same coordinates.\n    That is:\n            multiplicity of the general position\n            ------------------------------------\n            _atom_site.site_symmetry_multiplicity' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_order' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '1:48' ] ] ],
                          [ 'save_',
                            'atom_site.type_symbol',
                            [ [ 'item_', '_definition.id', '_atom_site.type_symbol' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_type_symbol' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A code to identify the atom specie(s) occupying this site.\n     This code must match a corresponding _atom_type.symbol. The\n     specification of this code is optional if component_0 of the\n     _atom_site.label is used for this purpose. See _atom_type.symbol.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'type_symbol' ],
                              [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                              [ 'item_', '_type.purpose', 'Link' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Cu', 'Cu2+', 'S', 'O1-' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n          _atom_site.type_symbol  =   AtomType ( _atom_site.label )' ] ] ] ],
                          [ 'save_',
                            'atom_site.U_equiv_geom_mean',
                            [ [ 'item_', '_definition.id', '_atom_site.U_equiv_geom_mean' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_U_equiv_geom_mean' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Equivalent isotropic atomic displacement parameter, U(equiv),\n     in angstroms squared, calculated as the geometric mean of\n     the anisotropic atomic displacement parameters.\n \n                U(equiv) = (U~i~ U~j~ U~k~)^1/3^\n \n     U~n~ = the principal components of the orthogonalised U^ij^' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'U_equiv_geom_mean' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstrom_squared' ] ] ],
                          [ 'save_',
                            'atom_site.U_iso_or_equiv',
                            [ [ 'item_', '_definition.id', '_atom_site.U_iso_or_equiv' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_U_iso_or_equiv' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Isotropic atomic displacement parameter, or equivalent isotropic\n     atomic  displacement parameter, U(equiv), in angstroms squared,\n     calculated from anisotropic atomic displacement  parameters.\n \n        U(equiv) = (1/3) sum~i~[sum~j~(U^ij^ a*~i~ a*~j~ a~i~ a~j~)]\n \n     a  = the real-space cell lengths\n     a* = the reciprocal-space cell lengths\n     Ref: Fischer, R. X. & Tillmanns, E. (1988). Acta Cryst. C44, 775-776.' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'U_iso_or_equiv' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstrom_squared' ] ] ],
                          [ 'save_',
                            'atom_site.Wyckoff_symbol',
                            [ [ 'item_', '_definition.id', '_atom_site.Wyckoff_symbol' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_site_Wyckoff_symbol' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The Wyckoff symbol (letter) as listed in the space-group section\n     of International Tables for Crystallography, Vol. A (1987).' ],
                              [ 'item_', '_name.category_id', 'site' ],
                              [ 'item_', '_name.object_id', 'Wyckoff_symbol' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'ATOM_SITE_ANISO',
                            [ [ 'item_', '_definition.id', 'ATOM_SITE_ANISO' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to describe the anisotropic\n     thermal parameters of the atomic sites in a crystal structure.' ],
                              [ 'item_', '_name.category_id', 'ATOM_SITE' ],
                              [ 'item_', '_name.object_id', 'ANISO' ],
                              [ 'item_', '_category.key_id', '_atom_site_aniso.key' ],
                              [ 'save_',
                                'atom_site_aniso.key',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.key' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of ATOM_SITE_ANISO items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '              _type.contents = Type_Contents(atom_site_aniso.label)',
                                      'Evaluation',
                                      '              _atom_site_aniso.key = _atom_site_aniso.label' ] ] ] ],
                              [ 'save_',
                                'atom_site_aniso.label',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.label' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_label' ] ],
                                  [ 'item_', '_definition.update', '2013-01-23' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Anisotropic atomic displacement parameters are usually looped in\n     a separate list. If this is the case, this code must match the\n     _atom_site_label of the associated atom in the atom coordinate\n     list and conform with the same rules described in _atom_site.label.' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'label' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.ratio',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.ratio' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_ratio', '_atom_site_anisotrop.ratio' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Ratio of the maximum to minimum eigenvalues of the atomic\n     displacement (thermal) ellipsoids.' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'ratio' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '1.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.type_symbol',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.type_symbol' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_type_symbol',
                                      '_atom_site_anisotrop.type_symbol' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     This _atom_type.symbol code links the anisotropic atom parameters to\n     the atom type data associated with this site and must match one of\n     the _atom_type.symbol codes in this list.' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'type_symbol' ],
                                  [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                                  [ 'item_', '_type.purpose', 'Link' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     _atom_site_aniso.type_symbol  =   AtomType ( _atom_site_aniso.label )' ] ] ] ],
                              [ 'save_',
                                'atom_site_aniso.matrix_B',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.matrix_B' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The symmetric anisotropic atomic displacement matrix B.' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'matrix_B' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a as atom_site_aniso\n \n      a.matrix_B =  [[ a.B_11, a.B_12, a.B_13 ],\n                     [ a.B_12, a.B_22, a.B_23 ],\n                     [ a.B_13, a.B_23, a.B_33 ]]' ] ] ] ],
                              [ 'save_',
                                'atom_site_aniso.B_11',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.B_11' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_B_11',
                                      '_atom_site.aniso_B[1][1]',
                                      '_atom_site_anisotrop.B[1][1]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement components\n     in angstroms squared which appear in the structure factor term:\n \n         T = exp{-1/4 sum~i~ [ sum~j~ (B^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n     The unique elements of the real symmetric matrix are entered by row.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'B_11' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.B_12',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.B_12' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_B_12',
                                      '_atom_site.aniso_B[1][2]',
                                      '_atom_site_anisotrop.B[1][2]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement components\n     in angstroms squared which appear in the structure factor term:\n \n         T = exp{-1/4 sum~i~ [ sum~j~ (B^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n     The unique elements of the real symmetric matrix are entered by row.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'B_12' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.B_13',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.B_13' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_B_13',
                                      '_atom_site.aniso_B[1][3]',
                                      '_atom_site_anisotrop.B[1][3]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement components\n     in angstroms squared which appear in the structure factor term:\n \n         T = exp{-1/4 sum~i~ [ sum~j~ (B^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n     The unique elements of the real symmetric matrix are entered by row.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'B_13' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.B_22',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.B_22' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_B_22',
                                      '_atom_site.aniso_B[2][2]',
                                      '_atom_site_anisotrop.B[2][2]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement components\n     in angstroms squared which appear in the structure factor term:\n \n         T = exp{-1/4 sum~i~ [ sum~j~ (B^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n     The unique elements of the real symmetric matrix are entered by row.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'B_22' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.B_23',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.B_23' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_B_23',
                                      '_atom_site.aniso_B[2][3]',
                                      '_atom_site_anisotrop.B[2][3]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement components\n     in angstroms squared which appear in the structure factor term:\n \n         T = exp{-1/4 sum~i~ [ sum~j~ (B^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n     The unique elements of the real symmetric matrix are entered by row.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'B_23' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.B_33',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.B_33' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_B_33',
                                      '_atom_site.aniso_B[3][3]',
                                      '_atom_site_anisotrop.B[3][3]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement components\n     in angstroms squared which appear in the structure factor term:\n \n         T = exp{-1/4 sum~i~ [ sum~j~ (B^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n     The unique elements of the real symmetric matrix are entered by row.\n \n     The IUCr Commission on Nomenclature recommends against the use\n     of B for reporting atomic displacement parameters. U, being\n     directly proportional to B, is preferred.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'B_33' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.matrix_U',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.matrix_U' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The symmetric anisotropic atomic displacement matrix U.' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'matrix_U' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a as atom_site_aniso\n \n        a.matrix_U =  [[ a.U_11, a.U_12, a.U_13 ],\n                       [ a.U_12, a.U_22, a.U_23 ],\n                       [ a.U_13, a.U_23, a.U_33 ]]' ] ] ] ],
                              [ 'save_',
                                'atom_site_aniso.U_11',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.U_11' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_U_11',
                                      '_atom_site.aniso_U[1][1]',
                                      '_atom_site_anisotrop.U[1][1]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement\n     components in angstroms squared which appear in the\n     structure factor term:\n \n        T = exp{-2pi^2^ sum~i~ [sum~j~ (U^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n \n     The unique elements of the real symmetric matrix are entered by row.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'U_11' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.U_12',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.U_12' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_U_12',
                                      '_atom_site.aniso_U[1][2]',
                                      '_atom_site_anisotrop.U[1][2]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement\n     components in angstroms squared which appear in the\n     structure factor term:\n \n        T = exp{-2pi^2^ sum~i~ [sum~j~ (U^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n \n     The unique elements of the real symmetric matrix are entered by row.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'U_12' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.U_13',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.U_13' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_U_13',
                                      '_atom_site.aniso_U[1][3]',
                                      '_atom_site_anisotrop.U[1][3]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement\n     components in angstroms squared which appear in the\n     structure factor term:\n \n        T = exp{-2pi^2^ sum~i~ [sum~j~ (U^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n \n     The unique elements of the real symmetric matrix are entered by row.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'U_13' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.U_22',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.U_22' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_U_22',
                                      '_atom_site.aniso_U[2][2]',
                                      '_atom_site_anisotrop.U[2][2]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement\n     components in angstroms squared which appear in the\n     structure factor term:\n \n        T = exp{-2pi^2^ sum~i~ [sum~j~ (U^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n \n     The unique elements of the real symmetric matrix are entered by row.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'U_22' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.U_23',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.U_23' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_U_23',
                                      '_atom_site.aniso_U[2][3]',
                                      '_atom_site_anisotrop.U[2][3]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement\n     components in angstroms squared which appear in the\n     structure factor term:\n \n        T = exp{-2pi^2^ sum~i~ [sum~j~ (U^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n \n     The unique elements of the real symmetric matrix are entered by row.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'U_23' ] ] ],
                              [ 'save_',
                                'atom_site_aniso.U_33',
                                [ [ 'item_', '_definition.id', '_atom_site_aniso.U_33' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_site_aniso_U_33',
                                      '_atom_site.aniso_U[3][3]',
                                      '_atom_site_anisotrop.U[3][3]' ] ],
                                  [ 'item_', '_definition.update', '2013-03-08' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     These are the standard anisotropic atomic displacement\n     components in angstroms squared which appear in the\n     structure factor term:\n \n        T = exp{-2pi^2^ sum~i~ [sum~j~ (U^ij^ h~i~ h~j~ a*~i~ a*~j~) ] }\n \n     h = the Miller indices\n     a* = the reciprocal-space cell lengths\n \n     The unique elements of the real symmetric matrix are entered by row.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'angstrom_squared' ],
                                  [ 'item_', '_name.category_id', 'aniso' ],
                                  [ 'item_', '_name.object_id', 'U_33' ] ] ] ] ],
                          [ '@comment', '------ close ATOM_SITE category' ] ] ],
                      [ '@comment', '------ close ATOM_SITE_ANISO category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'ATOM_SITES',
                        [ [ 'item_', '_definition.id', 'ATOM_SITES' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to describe information which applies\n     to all atom sites in a crystal structure.' ],
                          [ 'item_', '_name.category_id', 'ATOM' ],
                          [ 'item_', '_name.object_id', 'SITES' ],
                          [ 'save_',
                            'atom_sites.solution_primary',
                            [ [ 'item_', '_definition.id', '_atom_sites.solution_primary' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_sites_solution_primary' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Codes which identify the methods used to locate the initial\n     atom sites. The *_primary code identifies how the first\n     atom sites were determined; the *_secondary code identifies\n     how the remaining non-hydrogen sites were located; and the\n     *_hydrogens code identifies how the hydrogen sites were located.\n \n     Ref: Sheldrick, G. M., Hauptman, H. A., Weeks, C. M.,\n          Miller, R. and Us\\\'on, I. (2001). Ab initio phasing.\n          In International Tables for Crystallography,\n          Vol. F. Crystallography of biological macromolecules,\n          edited by M. G. Rossmann and E. Arnold, ch. 16.1.\n          Dordrecht: Kluwer Academic Publishers.' ],
                              [ 'item_', '_name.category_id', 'sites' ],
                              [ 'item_', '_name.object_id', 'solution_primary' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'difmap',
                                  'difference Fourier map',
                                  'vecmap',
                                  'real-space vector search',
                                  'heavy',
                                  'heavy-atom method',
                                  'direct',
                                  'structure-invariant direct methods',
                                  'geom',
                                  'inferred from neighbouring sites',
                                  'disper',
                                  'anomalous-dispersion techniques',
                                  'isomor',
                                  'isomorphous structure methods',
                                  'notdet',
                                  'coordinates were not determined',
                                  'dual',
                                  'dual-space method (Sheldrick et al., 2001)',
                                  'iterative',
                                  'iterative e.g. charge flipping [Oszl\\\'anyi, G.\n                  and S\\"uto, A. (2004). Acta Cryst. A60, 134-141]',
                                  'other',
                                  'a method not included elsewhere in this list' ] ],
                              [ 'item_', '_enumeration.default', 'direct' ] ] ],
                          [ 'save_',
                            'atom_sites.solution_secondary',
                            [ [ 'item_', '_definition.id', '_atom_sites.solution_secondary' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_sites_solution_secondary' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Codes which identify the methods used to locate the initial\n     atom sites. The *_primary code identifies how the first\n     atom sites were determined; the *_secondary code identifies\n     how the remaining non-hydrogen sites were located; and the\n     *_hydrogens code identifies how the hydrogen sites were located.\n \n     Ref: Sheldrick, G. M., Hauptman, H. A., Weeks, C. M.,\n          Miller, R. and Us\\\'on, I. (2001). Ab initio phasing.\n          In International Tables for Crystallography,\n          Vol. F. Crystallography of biological macromolecules,\n          edited by M. G. Rossmann and E. Arnold, ch. 16.1.\n          Dordrecht: Kluwer Academic Publishers.' ],
                              [ 'item_', '_name.category_id', 'sites' ],
                              [ 'item_', '_name.object_id', 'solution_secondary' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'difmap',
                                  'difference Fourier map',
                                  'vecmap',
                                  'real-space vector search',
                                  'heavy',
                                  'heavy-atom method',
                                  'direct',
                                  'structure-invariant direct methods',
                                  'geom',
                                  'inferred from neighbouring sites',
                                  'disper',
                                  'anomalous-dispersion techniques',
                                  'isomor',
                                  'isomorphous structure methods',
                                  'notdet',
                                  'coordinates were not determined',
                                  'dual',
                                  'dual-space method (Sheldrick et al., 2001)',
                                  'iterative',
                                  'iterative e.g. charge flipping [Oszl\\\'anyi, G.\n                  and S\\"uto, A. (2004). Acta Cryst. A60, 134-141]',
                                  'other',
                                  'a method not included elsewhere in this list' ] ],
                              [ 'item_', '_enumeration.default', 'difmap' ] ] ],
                          [ 'save_',
                            'atom_sites.solution_hydrogens',
                            [ [ 'item_', '_definition.id', '_atom_sites.solution_hydrogens' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_sites_solution_hydrogens' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Codes which identify the methods used to locate the initial\n     atom sites. The *_primary code identifies how the first\n     atom sites were determined; the *_secondary code identifies\n     how the remaining non-hydrogen sites were located; and the\n     *_hydrogens code identifies how the hydrogen sites were located.\n \n     Ref: Sheldrick, G. M., Hauptman, H. A., Weeks, C. M.,\n          Miller, R. and Us\\\'on, I. (2001). Ab initio phasing.\n          In International Tables for Crystallography,\n          Vol. F. Crystallography of biological macromolecules,\n          edited by M. G. Rossmann and E. Arnold, ch. 16.1.\n          Dordrecht: Kluwer Academic Publishers.' ],
                              [ 'item_', '_name.category_id', 'sites' ],
                              [ 'item_', '_name.object_id', 'solution_hydrogens' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'difmap',
                                  'difference Fourier map',
                                  'vecmap',
                                  'real-space vector search',
                                  'heavy',
                                  'heavy-atom method',
                                  'direct',
                                  'structure-invariant direct methods',
                                  'geom',
                                  'inferred from neighbouring sites',
                                  'disper',
                                  'anomalous-dispersion techniques',
                                  'isomor',
                                  'isomorphous structure methods',
                                  'notdet',
                                  'coordinates were not determined',
                                  'dual',
                                  'dual-space method (Sheldrick et al., 2001)',
                                  'iterative',
                                  'iterative e.g. charge flipping [Oszl\\\'anyi, G.\n                  and S\\"uto, A. (2004). Acta Cryst. A60, 134-141]',
                                  'other',
                                  'a method not included elsewhere in this list' ] ],
                              [ 'item_', '_enumeration.default', 'difmap' ] ] ],
                          [ 'save_',
                            'atom_sites.special_details',
                            [ [ 'item_', '_definition.id', '_atom_sites.special_details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_sites_special_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n    Information about atomic coordinates not coded elsewhere in the CIF.' ],
                              [ 'item_', '_name.category_id', 'sites' ],
                              [ 'item_', '_name.object_id', 'special_details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'ATOM_SITES_CARTN_TRANSFORM',
                            [ [ 'item_', '_definition.id', 'ATOM_SITES_CARTN_TRANSFORM' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to describe the matrix elements\n     used to transform Cartesion coordinates into fractional coordinates\n     of all atom sites in a crystal structure.' ],
                              [ 'item_', '_name.category_id', 'ATOM_SITES' ],
                              [ 'item_', '_name.object_id', 'CARTN_TRANSFORM' ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.axes',
                                [ [ 'item_', '_definition.id', '_atom_sites_Cartn_transform.axes' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_transform_axes',
                                      '_atom_sites.Cartn_transform_axes' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Description of the relative alignment of the crystal cell axes to the\n     Cartesian orthogonal axes as applied in the transformation matrix\n     _atom_sites_Cartn_transform.matrix.' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'axes' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'a parallel to x; b in the plane of y & z' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.matrix',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.matrix' ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3 x 1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                   |11 12 13|     x                  | 1 |\n     ( y\' ) Cartesian   =   |21 22 23| * ( y ) fractional  + v| 2 |\n       z\'                   |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'matrix' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a as atom_sites_Cartn_transform\n \n     _atom_sites_Cartn_transform.matrix = [[a.mat_11, a.mat_12, a.mat_13],\n                                           [a.mat_21, a.mat_22, a.mat_23],\n                                           [a.mat_31, a.mat_32, a.mat_33]]' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_11',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_11' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_11',
                                      '_atom_sites_Cartn_tran_matrix_[1][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_11' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With l  as  cell_length\n     With a  as  cell_angle\n     With r  as  cell_reciprocal_angle\n \n    _atom_sites_Cartn_transform.mat_11 =  l.a*Sind(a.beta)*Sind(r.gamma)' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_12',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_12' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_12',
                                      '_atom_sites_Cartn_tran_matrix_[1][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_12' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    _atom_sites_Cartn_transform.mat_12 =  0.' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_13',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_13' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_13',
                                      '_atom_sites_Cartn_tran_matrix_[1][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_13' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    _atom_sites_Cartn_transform.mat_13 =  0.' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_21',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_21' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_21',
                                      '_atom_sites_Cartn_tran_matrix_[2][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_21' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With l  as  cell_length\n     With a  as  cell_angle\n     With r  as  cell_reciprocal_angle\n \n    _atom_sites_Cartn_transform.mat_21 =  -l.a*Sind(a.beta)*Cosd(r.gamma)' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_22',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_22' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_22',
                                      '_atom_sites_Cartn_tran_matrix_[2][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_22' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a  as  cell_angle\n \n    _atom_sites_Cartn_transform.mat_22 =  _cell_length.b * Sind(a.alpha)' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_23',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_23' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_23',
                                      '_atom_sites_Cartn_tran_matrix_[2][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_23' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    _atom_sites_Cartn_transform.mat_23 =  0.' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_31',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_31' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_31',
                                      '_atom_sites_Cartn_tran_matrix_[3][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_31' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a  as  cell_angle\n \n    _atom_sites_Cartn_transform.mat_31 =  _cell_length.a * Cosd(a.beta)' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_32',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_32' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_32',
                                      '_atom_sites_Cartn_tran_matrix_[3][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_32' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a  as  cell_angle\n \n    _atom_sites_Cartn_transform.mat_32 =  _cell_length.b * Cosd(a.alpha)' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.mat_33',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.mat_33' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_matrix_33',
                                      '_atom_sites_Cartn_tran_matrix_[3][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_33' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    _atom_sites_Cartn_transform.mat_33 =  _cell_length.c' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.vector',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.vector' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The 3x1 translation is used with _atom_sites_Cartn_transform.matrix\n     used to transform fractional coordinates to Cartesian  coordinates.\n     The axial alignments of this transformation are described in\n     _atom_sites_Cartn_transform.axes.' ],
                                  [ 'item_', '_name.category_id', 'atom_sites_Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'vector' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With t as atom_sites_Cartn_transform\n \n    _atom_sites_Cartn_transform.vector =  [ t.vec_1, t.vec_2, t.vec_3 ]' ] ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.vec_1',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.vec_1' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_vector_1',
                                      '_atom_sites_Cartn_tran_vector_[1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'vec_1' ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.vec_2',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.vec_2' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_vector_2',
                                      '_atom_sites_Cartn_tran_vector_[2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'vec_2' ] ] ],
                              [ 'save_',
                                'atom_sites_Cartn_transform.vec_3',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_Cartn_transform.vec_3' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_Cartn_tran_vector_3',
                                      '_atom_sites_Cartn_tran_vector_[3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_Cartn_transform.axes.\n     The 3x1 translation is defined in _atom_sites_Cartn_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )Cartesian  = mat|21 22 23| * ( y )fractional + vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'reciprocal_angstroms' ],
                                  [ 'item_', '_name.category_id', 'Cartn_transform' ],
                                  [ 'item_', '_name.object_id', 'vec_3' ] ] ] ] ],
                          [ '@comment',
                            '------ close ATOM_SITES_CARTN_TRANSFORM category' ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'ATOM_SITES_FRACT_TRANSFORM',
                            [ [ 'item_', '_definition.id', 'ATOM_SITES_FRACT_TRANSFORM' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Set' ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to describe the matrix elements\n     used to transform Cartesion coordinates into fractional coordinates\n     of all atom sites in a crystal structure.' ],
                              [ 'item_', '_name.category_id', 'ATOM_SITES' ],
                              [ 'item_', '_name.object_id', 'FRACT_TRANSFORM' ],
                              [ 'save_',
                                'atom_sites_fract_transform.axes',
                                [ [ 'item_', '_definition.id', '_atom_sites_fract_transform.axes' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_transform_axes',
                                      '_atom_sites.fract_transform_axes' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Description of the relative alignment of the crystal cell axes to the\n     Cartesian orthogonal axes as applied in the transformation matrix\n     _atom_sites_fract_transform.matrix.' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'axes' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'a parallel to x; b in the plane of y & z' ] ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.matrix',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.matrix' ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform fractional coordinates in the ATOM_SITE\n     category to Cartesian  coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3 x 1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                   |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat |21 22 23| * ( y ) Cartesian + vec| 2 |\n       z\'                   |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'matrix' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3', '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With a as atom_sites_fract_transform\n \n     _atom_sites_fract_transform.matrix = [[a.mat_11, a.mat_12, a.mat_13],\n                                           [a.mat_21, a.mat_22, a.mat_23],\n                                           [a.mat_31, a.mat_32, a.mat_33]]' ] ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_11',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_11' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_11',
                                      '_atom_sites_fract_tran_matrix_[1][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_11' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_12',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_12' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_12',
                                      '_atom_sites_fract_tran_matrix_[1][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_12' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_13',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_13' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_13',
                                      '_atom_sites_fract_tran_matrix_[1][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_13' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_21',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_21' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_21',
                                      '_atom_sites_fract_tran_matrix_[2][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_21' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_22',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_22' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_22',
                                      '_atom_sites_fract_tran_matrix_[2][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_22' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_23',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_23' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_23',
                                      '_atom_sites_fract_tran_matrix_[2][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_23' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_31',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_31' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_31',
                                      '_atom_sites_fract_tran_matrix_[3][1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_31' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_32',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_32' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_32',
                                      '_atom_sites_fract_tran_matrix_[3][2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_32' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.mat_33',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.mat_33' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_matrix_33',
                                      '_atom_sites_fract_tran_matrix_[3][3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'mat_33' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.vector',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.vector' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The 3x1 translation is used with _atom_sites_fract_transform.matrix\n     used to transform Cartesian coordinates to fractional  coordinates.\n     The axial alignments of this transformation are described in\n     _atom_sites_fract_transform.axes.' ],
                                  [ 'item_', '_name.category_id', 'atom_sites_fract_transform' ],
                                  [ 'item_', '_name.object_id', 'vector' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Matrix' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '3' ] ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With t as atom_sites_fract_transform\n \n    _atom_sites_fract_transform.vector =  [ t.vec_1, t.vec_2, t.vec_3 ]' ] ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.vec_1',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.vec_1' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_vector_1',
                                      '_atom_sites_fract_tran_vector_[1]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'vec_1' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.vec_2',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.vec_2' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_vector_2',
                                      '_atom_sites_fract_tran_vector_[2]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'vec_2' ] ] ],
                              [ 'save_',
                                'atom_sites_fract_transform.vec_3',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_sites_fract_transform.vec_3' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_sites_fract_tran_vector_3',
                                      '_atom_sites_fract_tran_vector_[3]' ] ],
                                  [ 'item_', '_definition.update', '2012-12-11' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Matrix used to transform Cartesian coordinates in the ATOM_SITE\n     category to fractional coordinates. The axial alignments of this\n     transformation are described in _atom_sites_fract_transform.axes.\n     The 3x1 translation is defined in _atom_sites_fract_transform.vector.\n \n       x\'                  |11 12 13|     x                  | 1 |\n     ( y\' )fractional = mat|21 22 23| * ( y )Cartesian +  vec| 2 |\n       z\'                  |31 32 33|     z                  | 3 |\n \n     The default transformation matrix uses Rollet\'s axial\n     assignments with cell vectors a,b,c aligned with orthogonal\n     axes X,Y,Z so that c||Z and b in plane YZ.' ],
                                  [ 'item_', '_type.purpose', 'Measurand' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '?' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'item_', '_name.category_id', 'fract_transform' ],
                                  [ 'item_', '_name.object_id', 'vec_3' ] ] ] ] ],
                          [ '@comment',
                            '------ close ATOM_SITES_FRACT_TRANSFORM category' ] ] ],
                      [ '@comment', '------ close ATOM_SITES category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'ATOM_TYPE',
                        [ [ 'item_', '_definition.id', 'ATOM_TYPE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2013-02-18' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to describe atomic type information\n     used in crystallographic structure studies.' ],
                          [ 'item_', '_name.category_id', 'ATOM' ],
                          [ 'item_', '_name.object_id', 'TYPE' ],
                          [ 'item_', '_category.key_id', '_atom_type.key' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     typelist  = List()\n \n     Loop  a  as  atom_site  {\n        type = AtomType ( a.label )\n        If( type not in typelist )  typelist ++= type\n      }\n      For type in typelist {\n                              atom_type(.symbol         = type,\n                                        .number_in_cell = \'?\'   )\n      }' ] ],
                          [ 'save_',
                            'atom_type.key',
                            [ [ 'item_', '_definition.id', '_atom_type.key' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of ATOM_TYPE items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(atom_type.symbol)',
                                  'Evaluation',
                                  '              _atom_type.key = _atom_type.symbol' ] ] ] ],
                          [ 'save_',
                            'atom_type.analytical_mass_percent',
                            [ [ 'item_',
                                '_definition.id',
                                '_atom_type.analytical_mass_percent' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_type_analytical_mass_%',
                                  '_atom_type.analytical_mass_%' ] ],
                              [ 'item_', '_definition.update', '2013-04-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Mass percentage of this atom type derived from chemical analysis.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'analytical_mass_percent' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:100.' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'atom_type.atomic_mass',
                            [ [ 'item_', '_definition.id', '_atom_type.atomic_mass' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Mass of this atom type.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'atomic_mass' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'loop_',
                                [ '_enumeration_default.index', '_enumeration_default.value' ],
                                [ 'H',
                                  '1.008',
                                  'D',
                                  '2.008',
                                  'H1-',
                                  '1.008',
                                  'He',
                                  '4.003',
                                  'Li',
                                  '6.941',
                                  'Li1+',
                                  '6.941',
                                  'Be',
                                  '9.012',
                                  'Be2+',
                                  '9.012',
                                  'B',
                                  '10.811',
                                  'C',
                                  '12.011',
                                  'N',
                                  '14.007',
                                  'O',
                                  '15.999',
                                  'O1-',
                                  '15.999',
                                  'F',
                                  '18.998',
                                  'F1-',
                                  '18.998',
                                  'Ne',
                                  '20.179',
                                  'Na',
                                  '22.990',
                                  'Na1+',
                                  '22.990',
                                  'Mg',
                                  '24.305',
                                  'Mg2+',
                                  '24.305',
                                  'Al',
                                  '26.982',
                                  'Al3+',
                                  '26.982',
                                  'Si',
                                  '28.086',
                                  'Si4+',
                                  '28.086',
                                  'P',
                                  '30.974',
                                  'S',
                                  '32.066',
                                  'Cl',
                                  '35.453',
                                  'Cl1-',
                                  '35.453',
                                  'Ar',
                                  '39.948',
                                  'K',
                                  '39.098',
                                  'K1+',
                                  '39.098',
                                  'Ca',
                                  '40.078',
                                  'Ca2+',
                                  '40.078',
                                  'Sc',
                                  '44.956',
                                  'Sc3+',
                                  '44.956',
                                  'Ti',
                                  '47.88',
                                  'Ti2+',
                                  '47.88',
                                  'Ti3+',
                                  '47.88',
                                  'Ti4+',
                                  '47.88',
                                  'V',
                                  '50.942',
                                  'V2+',
                                  '50.942',
                                  'V3+',
                                  '50.942',
                                  'V5+',
                                  '50.942',
                                  'Cr',
                                  '51.996',
                                  'Cr2+',
                                  '51.996',
                                  'Cr3+',
                                  '51.996',
                                  'Mn',
                                  '54.938',
                                  'Mn2+',
                                  '54.938',
                                  'Mn3+',
                                  '54.938',
                                  'Mn4+',
                                  '54.938',
                                  'Fe',
                                  '55.847',
                                  'Fe2+',
                                  '55.847',
                                  'Fe3+',
                                  '55.847',
                                  'Co',
                                  '58.933',
                                  'Co2+',
                                  '58.933',
                                  'Co3+',
                                  '58.933',
                                  'Ni',
                                  '58.69',
                                  'Ni2+',
                                  '58.69',
                                  'Ni3+',
                                  '58.69',
                                  'Cu',
                                  '63.546',
                                  'Cu1+',
                                  '63.546',
                                  'Cu2+',
                                  '63.546',
                                  'Zn',
                                  '65.39',
                                  'Zn2+',
                                  '65.39',
                                  'Ga',
                                  '69.723',
                                  'Ga3+',
                                  '69.723',
                                  'Ge',
                                  '72.59',
                                  'Ge4+',
                                  '72.59',
                                  'As',
                                  '74.922',
                                  'Se',
                                  '78.96',
                                  'Br',
                                  '79.904',
                                  'Br1-',
                                  '79.904',
                                  'Kr',
                                  '83.80',
                                  'Rb',
                                  '85.468',
                                  'Rb1+',
                                  '85.468',
                                  'Sr',
                                  '87.62',
                                  'Sr2+',
                                  '87.62',
                                  'Y',
                                  '88.906',
                                  'Y3+',
                                  '88.906',
                                  'Zr',
                                  '91.224',
                                  'Zr4+',
                                  '91.224',
                                  'Nb',
                                  '92.906',
                                  'Nb3+',
                                  '92.906',
                                  'Nb5+',
                                  '92.906',
                                  'Mo',
                                  '95.94',
                                  'Mo3+',
                                  '95.94',
                                  'Mo5+',
                                  '95.94',
                                  'Mo6+',
                                  '95.94',
                                  'Tc',
                                  '98.906',
                                  'Ru',
                                  '101.07',
                                  'Ru3+',
                                  '101.07',
                                  'Ru4+',
                                  '101.07',
                                  'Rh',
                                  '102.906',
                                  'Rh3+',
                                  '102.906',
                                  'Rh4+',
                                  '102.906',
                                  'Pd',
                                  '106.42',
                                  'Pd2+',
                                  '106.42',
                                  'Pd4+',
                                  '106.42',
                                  'Ag',
                                  '107.868',
                                  'Ag1+',
                                  '107.868',
                                  'Ag2+',
                                  '107.868',
                                  'Cd',
                                  '112.41',
                                  'Cd2+',
                                  '112.41',
                                  'In',
                                  '114.82',
                                  'In3+',
                                  '114.82',
                                  'Sn',
                                  '118.71',
                                  'Sn2+',
                                  '118.71',
                                  'Sn4+',
                                  '118.71',
                                  'Sb',
                                  '121.75',
                                  'Sb3+',
                                  '121.75',
                                  'Sb5+',
                                  '121.75',
                                  'Te',
                                  '127.60',
                                  'I',
                                  '126.905',
                                  'I1-',
                                  '126.905',
                                  'Xe',
                                  '131.29',
                                  'Cs',
                                  '132.905',
                                  'Cs1+',
                                  '132.905',
                                  'Ba',
                                  '137.33',
                                  'Ba2+',
                                  '137.33',
                                  'La',
                                  '138.906',
                                  'La3+',
                                  '138.906',
                                  'Ce',
                                  '140.12',
                                  'Ce3+',
                                  '140.12',
                                  'Ce4+',
                                  '140.12',
                                  'Pr',
                                  '140.908',
                                  'Pr3+',
                                  '140.908',
                                  'Pr4+',
                                  '140.908',
                                  'Nd',
                                  '144.24',
                                  'Nd3+',
                                  '144.24',
                                  'Pm',
                                  '147.',
                                  'Sm',
                                  '150.36',
                                  'Sm3+',
                                  '150.36',
                                  'Eu',
                                  '151.96',
                                  'Eu2+',
                                  '151.96',
                                  'Eu3+',
                                  '151.96',
                                  'Gd',
                                  '157.25',
                                  'Gd3+',
                                  '157.25',
                                  'Tb',
                                  '158.926',
                                  'Tb3+',
                                  '158.926',
                                  'Dy',
                                  '162.5',
                                  'Dy3+',
                                  '162.5',
                                  'Ho',
                                  '164.93',
                                  'Ho3+',
                                  '164.93',
                                  'Er',
                                  '167.26',
                                  'Er3+',
                                  '167.26',
                                  'Tm',
                                  '168.934',
                                  'Tm3+',
                                  '168.934',
                                  'Yb',
                                  '173.04',
                                  'Yb2+',
                                  '173.04',
                                  'Yb3+',
                                  '173.04',
                                  'Lu',
                                  '174.967',
                                  'Lu3+',
                                  '174.967',
                                  'Hf',
                                  '178.49',
                                  'Hf4+',
                                  '178.49',
                                  'Ta',
                                  '180.948',
                                  'Ta5+',
                                  '180.948',
                                  'W',
                                  '183.85',
                                  'W6+',
                                  '183.85',
                                  'Re',
                                  '186.207',
                                  'Os',
                                  '190.2',
                                  'Os4+',
                                  '190.2',
                                  'Ir',
                                  '192.22',
                                  'Ir3+',
                                  '192.22',
                                  'Ir4+',
                                  '192.22',
                                  'Pt',
                                  '195.08',
                                  'Pt2+',
                                  '195.08',
                                  'Pt4+',
                                  '195.08',
                                  'Au',
                                  '196.966',
                                  'Au1+',
                                  '196.966',
                                  'Au3+',
                                  '196.966',
                                  'Hg',
                                  '200.59',
                                  'Hg1+',
                                  '200.59',
                                  'Hg2+',
                                  '200.59',
                                  'Tl',
                                  '204.383',
                                  'TL1+',
                                  '204.383',
                                  'Tl3+',
                                  '204.383',
                                  'Pb',
                                  '207.2',
                                  'Pb2+',
                                  '207.2',
                                  'Pb4+',
                                  '207.2',
                                  'Bi',
                                  '208.980',
                                  'Bi3+',
                                  '208.980',
                                  'Bi5+',
                                  '208.980',
                                  'Po',
                                  '209.',
                                  'At',
                                  '210.',
                                  'Rn',
                                  '222.',
                                  'Fr',
                                  '223.',
                                  'Ra',
                                  '226.025',
                                  'Ra2+',
                                  '226.025',
                                  'Ac',
                                  '227.',
                                  'Ac3+',
                                  '227.',
                                  'Th',
                                  '232.038',
                                  'Th4+',
                                  '232.038',
                                  'Pa',
                                  '231.036',
                                  'U',
                                  '238.029',
                                  'U3+',
                                  '238.029',
                                  'U4+',
                                  '238.029',
                                  'U6+',
                                  '238.029',
                                  'Np',
                                  '237.048',
                                  'Np3+',
                                  '237.048',
                                  'Np4+',
                                  '237.048',
                                  'Np6+',
                                  '237.048',
                                  'Pu',
                                  '242.',
                                  'Pu3+',
                                  '242.',
                                  'Pu4+',
                                  '242.',
                                  'Pu6+',
                                  '242.',
                                  'Am',
                                  '243.',
                                  'Cm',
                                  '247.',
                                  'Bk',
                                  '247.',
                                  'Cf',
                                  '249.' ] ],
                              [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                              [ 'item_', '_units.code', 'dalton' ] ] ],
                          [ 'save_',
                            'atom_type.atomic_number',
                            [ [ 'item_', '_definition.id', '_atom_type.atomic_number' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atomic number of this atom type.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'atomic_number' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'loop_',
                                [ '_enumeration_default.index', '_enumeration_default.value' ],
                                [ 'H',
                                  '01',
                                  'D',
                                  '01',
                                  'H1-',
                                  '01',
                                  'He',
                                  '02',
                                  'Li',
                                  '03',
                                  'Li1+',
                                  '03',
                                  'Be',
                                  '04',
                                  'Be2+',
                                  '04',
                                  'B',
                                  '05',
                                  'C',
                                  '06',
                                  'N',
                                  '07',
                                  'O',
                                  '08',
                                  'O1-',
                                  '08',
                                  'F',
                                  '09',
                                  'F1-',
                                  '09',
                                  'Ne',
                                  '10',
                                  'Na',
                                  '11',
                                  'Na1+',
                                  '11',
                                  'Mg',
                                  '12',
                                  'Mg2+',
                                  '12',
                                  'Al',
                                  '13',
                                  'Al3+',
                                  '13',
                                  'Si',
                                  '14',
                                  'Si4+',
                                  '14',
                                  'P',
                                  '15',
                                  'S',
                                  '16',
                                  'Cl',
                                  '17',
                                  'Cl1-',
                                  '17',
                                  'Ar',
                                  '18',
                                  'K',
                                  '19',
                                  'K1+',
                                  '19',
                                  'Ca',
                                  '20',
                                  'Ca2+',
                                  '20',
                                  'Sc',
                                  '21',
                                  'Sc3+',
                                  '21',
                                  'Ti',
                                  '22',
                                  'Ti2+',
                                  '22',
                                  'Ti3+',
                                  '22',
                                  'Ti4+',
                                  '22',
                                  'V',
                                  '23',
                                  'V2+',
                                  '23',
                                  'V3+',
                                  '23',
                                  'V5+',
                                  '23',
                                  'Cr',
                                  '24',
                                  'Cr2+',
                                  '24',
                                  'Cr3+',
                                  '24',
                                  'Mn',
                                  '25',
                                  'Mn2+',
                                  '25',
                                  'Mn3+',
                                  '25',
                                  'Mn4+',
                                  '25',
                                  'Fe',
                                  '26',
                                  'Fe2+',
                                  '26',
                                  'Fe3+',
                                  '26',
                                  'Co',
                                  '27',
                                  'Co2+',
                                  '27',
                                  'Co3+',
                                  '27',
                                  'Ni',
                                  '28',
                                  'Ni2+',
                                  '28',
                                  'Ni3+',
                                  '28',
                                  'Cu',
                                  '29',
                                  'Cu1+',
                                  '29',
                                  'Cu2+',
                                  '29',
                                  'Zn',
                                  '30',
                                  'Zn2+',
                                  '30',
                                  'Ga',
                                  '31',
                                  'Ga3+',
                                  '31',
                                  'Ge',
                                  '32',
                                  'Ge4+',
                                  '32',
                                  'As',
                                  '33',
                                  'Se',
                                  '34',
                                  'Br',
                                  '35',
                                  'Br1-',
                                  '35',
                                  'Kr',
                                  '36',
                                  'Rb',
                                  '37',
                                  'Rb1+',
                                  '37',
                                  'Sr',
                                  '38',
                                  'Sr2+',
                                  '38',
                                  'Y',
                                  '39',
                                  'Y3+',
                                  '39',
                                  'Zr',
                                  '40',
                                  'Zr4+',
                                  '40',
                                  'Nb',
                                  '41',
                                  'Nb3+',
                                  '41',
                                  'Nb5+',
                                  '41',
                                  'Mo',
                                  '42',
                                  'Mo3+',
                                  '42',
                                  'Mo5+',
                                  '42',
                                  'Mo6+',
                                  '42',
                                  'Tc',
                                  '43',
                                  'Ru',
                                  '44',
                                  'Ru3+',
                                  '44',
                                  'Ru4+',
                                  '44',
                                  'Rh',
                                  '45',
                                  'Rh3+',
                                  '45',
                                  'Rh4+',
                                  '45',
                                  'Pd',
                                  '46',
                                  'Pd2+',
                                  '46',
                                  'Pd4+',
                                  '46',
                                  'Ag',
                                  '47',
                                  'Ag1+',
                                  '47',
                                  'Ag2+',
                                  '47',
                                  'Cd',
                                  '48',
                                  'Cd2+',
                                  '48',
                                  'In',
                                  '49',
                                  'In3+',
                                  '49',
                                  'Sn',
                                  '50',
                                  'Sn2+',
                                  '50',
                                  'Sn4+',
                                  '50',
                                  'Sb',
                                  '51',
                                  'Sb3+',
                                  '51',
                                  'Sb5+',
                                  '51',
                                  'Te',
                                  '52',
                                  'I',
                                  '53',
                                  'I1-',
                                  '53',
                                  'Xe',
                                  '54',
                                  'Cs',
                                  '55',
                                  'Cs1+',
                                  '55',
                                  'Ba',
                                  '56',
                                  'Ba2+',
                                  '56',
                                  'La',
                                  '57',
                                  'La3+',
                                  '57',
                                  'Ce',
                                  '58',
                                  'Ce3+',
                                  '58',
                                  'Ce4+',
                                  '58',
                                  'Pr',
                                  '59',
                                  'Pr3+',
                                  '59',
                                  'Pr4+',
                                  '59',
                                  'Nd',
                                  '60',
                                  'Nd3+',
                                  '60',
                                  'Pm',
                                  '61',
                                  'Sm',
                                  '62',
                                  'Sm3+',
                                  '62',
                                  'Eu',
                                  '63',
                                  'Eu2+',
                                  '63',
                                  'Eu3+',
                                  '63',
                                  'Gd',
                                  '64',
                                  'Gd3+',
                                  '64',
                                  'Tb',
                                  '65',
                                  'Tb3+',
                                  '65',
                                  'Dy',
                                  '66',
                                  'Dy3+',
                                  '66',
                                  'Ho',
                                  '67',
                                  'Ho3+',
                                  '67',
                                  'Er',
                                  '68',
                                  'Er3+',
                                  '68',
                                  'Tm',
                                  '69',
                                  'Tm3+',
                                  '69',
                                  'Yb',
                                  '70',
                                  'Yb2+',
                                  '70',
                                  'Yb3+',
                                  '70',
                                  'Lu',
                                  '71',
                                  'Lu3+',
                                  '71',
                                  'Hf',
                                  '72',
                                  'Hf4+',
                                  '72',
                                  'Ta',
                                  '73',
                                  'Ta5+',
                                  '73',
                                  'W',
                                  '74',
                                  'W6+',
                                  '74',
                                  'Re',
                                  '75',
                                  'Os',
                                  '76',
                                  'Os4+',
                                  '76',
                                  'Ir',
                                  '77',
                                  'Ir3+',
                                  '77',
                                  'Ir4+',
                                  '77',
                                  'Pt',
                                  '78',
                                  'Pt2+',
                                  '78',
                                  'Pt4+',
                                  '78',
                                  'Au',
                                  '79',
                                  'Au1+',
                                  '79',
                                  'Au3+',
                                  '79',
                                  'Hg',
                                  '80',
                                  'Hg1+',
                                  '80',
                                  'Hg2+',
                                  '80',
                                  'Tl',
                                  '81',
                                  'TL1+',
                                  '81',
                                  'Tl3+',
                                  '81',
                                  'Pb',
                                  '82',
                                  'Pb2+',
                                  '82',
                                  'Pb4+',
                                  '82',
                                  'Bi',
                                  '83',
                                  'Bi3+',
                                  '83',
                                  'Bi5+',
                                  '83',
                                  'Po',
                                  '84',
                                  'At',
                                  '85',
                                  'Rn',
                                  '86',
                                  'Fr',
                                  '87',
                                  'Ra',
                                  '88',
                                  'Ra2+',
                                  '88',
                                  'Ac',
                                  '89',
                                  'Ac3+',
                                  '89',
                                  'Th',
                                  '90',
                                  'Th4+',
                                  '90',
                                  'Pa',
                                  '91',
                                  'U',
                                  '92',
                                  'U3+',
                                  '92',
                                  'U4+',
                                  '92',
                                  'U6+',
                                  '92',
                                  'Np',
                                  '93',
                                  'Np3+',
                                  '93',
                                  'Np4+',
                                  '93',
                                  'Np6+',
                                  '93',
                                  'Pu',
                                  '94',
                                  'Pu3+',
                                  '94',
                                  'Pu4+',
                                  '94',
                                  'Pu6+',
                                  '94',
                                  'Am',
                                  '95',
                                  'Cm',
                                  '96',
                                  'Bk',
                                  '97',
                                  'Cf',
                                  '98' ] ],
                              [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ] ] ],
                          [ 'save_',
                            'atom_type.description',
                            [ [ 'item_', '_definition.id', '_atom_type.description' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_type_description' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A description of the atom(s) designated by this atom type. In\n     most cases this will be the element name and oxidation state of\n     a single atom  species. For disordered or nonstoichiometric\n     structures it will describe a combination of atom species.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'description' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'deuterium', '0.34Fe+0.66Ni' ] ] ] ],
                          [ 'save_',
                            'atom_type.display_colour',
                            [ [ 'item_', '_definition.id', '_atom_type.display_colour' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The display colour assigned to this atom type. Note that the\n     possible colours are enumerated in the display_colour list\n     category of items.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'display_colour' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'black',
                                  '[ 000, 000, 000 ]',
                                  'white',
                                  '[ 255, 255, 255 ]',
                                  'grey',
                                  '[ 192, 192, 192 ]',
                                  'grey_light',
                                  '[ 211, 211, 211 ]',
                                  'grey_slate',
                                  '[ 112, 128, 144 ]',
                                  'blue',
                                  '[ 000, 000, 255 ]',
                                  'blue_light',
                                  '[ 176, 224, 230 ]',
                                  'blue_medium',
                                  '[ 000, 000, 205 ]',
                                  'blue_dark',
                                  '[ 025, 025, 112 ]',
                                  'blue_navy',
                                  '[ 000, 000, 128 ]',
                                  'blue_royal',
                                  '[ 065, 105, 225 ]',
                                  'blue_sky',
                                  '[ 135, 206, 235 ]',
                                  'blue_steel',
                                  '[ 070, 130, 180 ]',
                                  'turquoise',
                                  '[ 064, 224, 208 ]',
                                  'cyan',
                                  '[ 000, 255, 255 ]',
                                  'cyan_light',
                                  '[ 224, 255, 255 ]',
                                  'green',
                                  '[ 000, 255, 000 ]',
                                  'green_light',
                                  '[ 152, 251, 152 ]',
                                  'green_dark',
                                  '[ 000, 100, 000 ]',
                                  'green_sea',
                                  '[ 046, 139, 087 ]',
                                  'green_lime',
                                  '[ 050, 205, 050 ]',
                                  'green_olive',
                                  '[ 107, 142, 035 ]',
                                  'green_khaki',
                                  '[ 240, 230, 140 ]',
                                  'yellow',
                                  '[ 255, 255, 000 ]',
                                  'yellow_light',
                                  '[ 255, 255, 224 ]',
                                  'yellow_gold',
                                  '[ 255, 215, 000 ]',
                                  'brown',
                                  '[ 165, 042, 042 ]',
                                  'brown_sienna',
                                  '[ 160, 082, 045 ]',
                                  'brown_beige',
                                  '[ 245, 245, 220 ]',
                                  'brown_tan',
                                  '[ 210, 180, 140 ]',
                                  'salmon',
                                  '[ 250, 128, 114 ]',
                                  'salmon_light',
                                  '[ 255, 160, 122 ]',
                                  'salmon_dark',
                                  '[ 233, 150, 122 ]',
                                  'orange',
                                  '[ 255, 165, 000 ]',
                                  'orange_dark',
                                  '[ 255, 140, 000 ]',
                                  'red',
                                  '[ 255, 000, 000 ]',
                                  'red_coral',
                                  '[ 255, 127, 080 ]',
                                  'red_tomato',
                                  '[ 255, 099, 071 ]',
                                  'red_orange',
                                  '[ 255, 069, 000 ]',
                                  'red_violet',
                                  '[ 219, 112, 147 ]',
                                  'red_maroon',
                                  '[ 176, 048, 096 ]',
                                  'pink',
                                  '[ 255, 192, 203 ]',
                                  'pink_light',
                                  '[ 255, 182, 193 ]',
                                  'pink_deep',
                                  '[ 255, 020, 147 ]',
                                  'pink_hot',
                                  '[ 255, 105, 180 ]',
                                  'violet',
                                  '[ 238, 130, 238 ]',
                                  'violet_red',
                                  '[ 208, 032, 144 ]',
                                  'violet_magenta',
                                  '[ 255, 000, 255 ]',
                                  'violet_dark',
                                  '[ 148, 000, 211 ]',
                                  'violet_blue',
                                  '[ 138, 043, 226 ]' ] ],
                              [ 'loop_',
                                [ '_enumeration_default.index', '_enumeration_default.value' ],
                                [ 'H',
                                  'white',
                                  'D',
                                  'blue_light',
                                  'H1-',
                                  'white',
                                  'He',
                                  'unknown',
                                  'Li',
                                  'unknown',
                                  'Li1+',
                                  'unknown',
                                  'Be',
                                  'unknown',
                                  'Be2+',
                                  'unknown',
                                  'B',
                                  'unknown',
                                  'C',
                                  'steel_grey',
                                  'N',
                                  'blue',
                                  'O',
                                  'red',
                                  'O1-',
                                  'red',
                                  'F',
                                  'green',
                                  'F1-',
                                  'green',
                                  'Ne',
                                  'unknown',
                                  'Na',
                                  'magenta',
                                  'Na1+',
                                  'magenta',
                                  'Mg',
                                  'magenta',
                                  'Mg2+',
                                  'magenta',
                                  'Al',
                                  'magenta',
                                  'Al3+',
                                  'magenta',
                                  'Si',
                                  'unknown',
                                  'Si4+',
                                  'unknown',
                                  'P',
                                  'magenta',
                                  'S',
                                  'yellow',
                                  'Cl',
                                  'green',
                                  'Cl1-',
                                  'green',
                                  'Ar',
                                  'unknown',
                                  'K',
                                  'magenta',
                                  'K1+',
                                  'magenta',
                                  'Ca',
                                  'magenta',
                                  'Ca2+',
                                  'magenta',
                                  'Sc',
                                  'unknown',
                                  'Sc3+',
                                  'unknown',
                                  'Ti',
                                  'magenta',
                                  'Ti2+',
                                  'magenta',
                                  'Ti3+',
                                  'magenta',
                                  'Ti4+',
                                  'magenta',
                                  'V',
                                  'magenta',
                                  'V2+',
                                  'magenta',
                                  'V3+',
                                  'magenta',
                                  'V5+',
                                  'magenta',
                                  'Cr',
                                  'magenta',
                                  'Cr2+',
                                  'magenta',
                                  'Cr3+',
                                  'magenta',
                                  'Mn',
                                  'magenta',
                                  'Mn2+',
                                  'magenta',
                                  'Mn3+',
                                  'magenta',
                                  'Mn4+',
                                  'magenta',
                                  'Fe',
                                  'magenta',
                                  'Fe2+',
                                  'magenta',
                                  'Fe3+',
                                  'magenta',
                                  'Co',
                                  'magenta',
                                  'Co2+',
                                  'magenta',
                                  'Co3+',
                                  'magenta',
                                  'Ni',
                                  'magenta',
                                  'Ni2+',
                                  'magenta',
                                  'Ni3+',
                                  'magenta',
                                  'Cu',
                                  'magenta',
                                  'Cu1+',
                                  'magenta',
                                  'Cu2+',
                                  'magenta',
                                  'Zn',
                                  'magenta',
                                  'Zn2+',
                                  'magenta',
                                  'Ga',
                                  'magenta',
                                  'Ga3+',
                                  'magenta',
                                  'Ge',
                                  'magenta',
                                  'Ge4+',
                                  'magenta',
                                  'As',
                                  'magenta',
                                  'Se',
                                  'yellow',
                                  'Br',
                                  'green',
                                  'Br1-',
                                  'green',
                                  'Kr',
                                  'unknown',
                                  'Rb',
                                  'unknown',
                                  'Rb1+',
                                  'unknown',
                                  'Sr',
                                  'unknown',
                                  'Sr2+',
                                  'unknown',
                                  'Y',
                                  'unknown',
                                  'Y3+',
                                  'unknown',
                                  'Zr',
                                  'unknown',
                                  'Zr4+',
                                  'unknown',
                                  'Nb',
                                  'unknown',
                                  'Nb3+',
                                  'unknown',
                                  'Nb5+',
                                  'unknown',
                                  'Mo',
                                  'unknown',
                                  'Mo3+',
                                  'magenta',
                                  'Mo5+',
                                  'magenta',
                                  'Mo6+',
                                  'magenta',
                                  'Tc',
                                  'unknown',
                                  'Ru',
                                  'unknown',
                                  'Ru3+',
                                  'unknown',
                                  'Ru4+',
                                  'unknown',
                                  'Rh',
                                  'unknown',
                                  'Rh3+',
                                  'unknown',
                                  'Rh4+',
                                  'unknown',
                                  'Pd',
                                  'unknown',
                                  'Pd2+',
                                  'unknown',
                                  'Pd4+',
                                  'unknown',
                                  'Ag',
                                  'magenta',
                                  'Ag1+',
                                  'magenta',
                                  'Ag2+',
                                  'magenta',
                                  'Cd',
                                  'magenta',
                                  'Cd2+',
                                  'magenta',
                                  'In',
                                  'unknown',
                                  'In3+',
                                  'unknown',
                                  'Sn',
                                  'magenta',
                                  'Sn2+',
                                  'magenta',
                                  'Sn4+',
                                  'magenta',
                                  'Sb',
                                  'magenta',
                                  'Sb3+',
                                  'magenta',
                                  'Sb5+',
                                  'magenta',
                                  'Te',
                                  'unknown',
                                  'I',
                                  'green',
                                  'I1-',
                                  'green',
                                  'Xe',
                                  'unknown',
                                  'Cs',
                                  'unknown',
                                  'Cs1+',
                                  'unknown',
                                  'Ba',
                                  'unknown',
                                  'Ba2+',
                                  'unknown',
                                  'La',
                                  'unknown',
                                  'La3+',
                                  'unknown',
                                  'Ce',
                                  'unknown',
                                  'Ce3+',
                                  'unknown',
                                  'Ce4+',
                                  'unknown',
                                  'Pr',
                                  'unknown',
                                  'Pr3+',
                                  'unknown',
                                  'Pr4+',
                                  'unknown',
                                  'Nd',
                                  'unknown',
                                  'Nd3+',
                                  'unknown',
                                  'Pm',
                                  'unknown',
                                  'Sm',
                                  'unknown',
                                  'Sm3+',
                                  'unknown',
                                  'Eu',
                                  'unknown',
                                  'Eu2+',
                                  'unknown',
                                  'Eu3+',
                                  'unknown',
                                  'Gd',
                                  'unknown',
                                  'Gd3+',
                                  'unknown',
                                  'Tb',
                                  'unknown',
                                  'Tb3+',
                                  'unknown',
                                  'Dy',
                                  'unknown',
                                  'Dy3+',
                                  'unknown',
                                  'Ho',
                                  'unknown',
                                  'Ho3+',
                                  'unknown',
                                  'Er',
                                  'unknown',
                                  'Er3+',
                                  'unknown',
                                  'Tm',
                                  'unknown',
                                  'Tm3+',
                                  'unknown',
                                  'Yb',
                                  'unknown',
                                  'Yb2+',
                                  'unknown',
                                  'Yb3+',
                                  'unknown',
                                  'Lu',
                                  'unknown',
                                  'Lu3+',
                                  'unknown',
                                  'Hf',
                                  'unknown',
                                  'Hf4+',
                                  'unknown',
                                  'Ta',
                                  'unknown',
                                  'Ta5+',
                                  'unknown',
                                  'W',
                                  'unknown',
                                  'W6+',
                                  'unknown',
                                  'Re',
                                  'unknown',
                                  'Os',
                                  'unknown',
                                  'Os4+',
                                  'unknown',
                                  'Ir',
                                  'unknown',
                                  'Ir3+',
                                  'unknown',
                                  'Ir4+',
                                  'unknown',
                                  'Pt',
                                  'magenta',
                                  'Pt2+',
                                  'magenta',
                                  'Pt4+',
                                  'magenta',
                                  'Au',
                                  'magenta',
                                  'Au1+',
                                  'magenta',
                                  'Au3+',
                                  'magenta',
                                  'Hg',
                                  'magenta',
                                  'Hg1+',
                                  'magenta',
                                  'Hg2+',
                                  'magenta',
                                  'Tl',
                                  'unknown',
                                  'TL1+',
                                  'unknown',
                                  'Tl3+',
                                  'unknown',
                                  'Pb',
                                  'magenta',
                                  'Pb2+',
                                  'magenta',
                                  'Pb4+',
                                  'magenta',
                                  'Bi',
                                  'magenta',
                                  'Bi3+',
                                  'magenta',
                                  'Bi5+',
                                  'magenta',
                                  'Po',
                                  'unknown',
                                  'At',
                                  'unknown',
                                  'Rn',
                                  'unknown',
                                  'Fr',
                                  'unknown',
                                  'Ra',
                                  'unknown',
                                  'Ra2+',
                                  'unknown',
                                  'Ac',
                                  'unknown',
                                  'Ac3+',
                                  'unknown',
                                  'Th',
                                  'unknown',
                                  'Th4+',
                                  'unknown',
                                  'Pa',
                                  'unknown',
                                  'U',
                                  'unknown',
                                  'U3+',
                                  'unknown',
                                  'U4+',
                                  'unknown',
                                  'U6+',
                                  'unknown',
                                  'Np',
                                  'unknown',
                                  'Np3+',
                                  'unknown',
                                  'Np4+',
                                  'unknown',
                                  'Np6+',
                                  'unknown',
                                  'Pu',
                                  'unknown',
                                  'Pu3+',
                                  'unknown',
                                  'Pu4+',
                                  'unknown',
                                  'Pu6+',
                                  'unknown',
                                  'Am',
                                  'unknown',
                                  'Cm',
                                  'unknown',
                                  'Bk',
                                  'unknown',
                                  'Cf',
                                  'unknown' ] ],
                              [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ] ] ],
                          [ 'save_',
                            'atom_type.electron_count',
                            [ [ 'item_', '_definition.id', '_atom_type.electron_count' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of electrons in this atom type.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'electron_count' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'loop_',
                                [ '_enumeration_default.index', '_enumeration_default.value' ],
                                [ 'H',
                                  '01',
                                  'D',
                                  '01',
                                  'H1-',
                                  '02',
                                  'He',
                                  '02',
                                  'Li',
                                  '03',
                                  'Li1+',
                                  '02',
                                  'Be',
                                  '04',
                                  'Be2+',
                                  '02',
                                  'B',
                                  '05',
                                  'C',
                                  '06',
                                  'N',
                                  '07',
                                  'O',
                                  '08',
                                  'O1-',
                                  '09',
                                  'F',
                                  '09',
                                  'F1-',
                                  '10',
                                  'Ne',
                                  '10',
                                  'Na',
                                  '11',
                                  'Na1+',
                                  '10',
                                  'Mg',
                                  '12',
                                  'Mg2+',
                                  '10',
                                  'Al',
                                  '13',
                                  'Al3+',
                                  '10',
                                  'Si',
                                  '14',
                                  'Si4+',
                                  '10',
                                  'P',
                                  '15',
                                  'S',
                                  '16',
                                  'Cl',
                                  '17',
                                  'Cl1-',
                                  '18',
                                  'Ar',
                                  '18',
                                  'K',
                                  '19',
                                  'K1+',
                                  '18',
                                  'Ca',
                                  '20',
                                  'Ca2+',
                                  '18',
                                  'Sc',
                                  '21',
                                  'Sc3+',
                                  '18',
                                  'Ti',
                                  '22',
                                  'Ti2+',
                                  '20',
                                  'Ti3+',
                                  '19',
                                  'Ti4+',
                                  '18',
                                  'V',
                                  '23',
                                  'V2+',
                                  '21',
                                  'V3+',
                                  '20',
                                  'V5+',
                                  '18',
                                  'Cr',
                                  '24',
                                  'Cr2+',
                                  '22',
                                  'Cr3+',
                                  '21',
                                  'Mn',
                                  '25',
                                  'Mn2+',
                                  '23',
                                  'Mn3+',
                                  '22',
                                  'Mn4+',
                                  '21',
                                  'Fe',
                                  '26',
                                  'Fe2+',
                                  '24',
                                  'Fe3+',
                                  '23',
                                  'Co',
                                  '27',
                                  'Co2+',
                                  '25',
                                  'Co3+',
                                  '24',
                                  'Ni',
                                  '28',
                                  'Ni2+',
                                  '26',
                                  'Ni3+',
                                  '25',
                                  'Cu',
                                  '29',
                                  'Cu1+',
                                  '28',
                                  'Cu2+',
                                  '27',
                                  'Zn',
                                  '30',
                                  'Zn2+',
                                  '28',
                                  'Ga',
                                  '31',
                                  'Ga3+',
                                  '28',
                                  'Ge',
                                  '32',
                                  'Ge4+',
                                  '28',
                                  'As',
                                  '33',
                                  'Se',
                                  '34',
                                  'Br',
                                  '35',
                                  'Br1-',
                                  '36',
                                  'Kr',
                                  '36',
                                  'Rb',
                                  '37',
                                  'Rb1+',
                                  '36',
                                  'Sr',
                                  '38',
                                  'Sr2+',
                                  '36',
                                  'Y',
                                  '39',
                                  'Y3+',
                                  '36',
                                  'Zr',
                                  '40',
                                  'Zr4+',
                                  '36',
                                  'Nb',
                                  '41',
                                  'Nb3+',
                                  '38',
                                  'Nb5+',
                                  '36',
                                  'Mo',
                                  '42',
                                  'Mo3+',
                                  '39',
                                  'Mo5+',
                                  '37',
                                  'Mo6+',
                                  '36',
                                  'Tc',
                                  '43',
                                  'Ru',
                                  '44',
                                  'Ru3+',
                                  '41',
                                  'Ru4+',
                                  '40',
                                  'Rh',
                                  '45',
                                  'Rh3+',
                                  '42',
                                  'Rh4+',
                                  '41',
                                  'Pd',
                                  '46',
                                  'Pd2+',
                                  '44',
                                  'Pd4+',
                                  '42',
                                  'Ag',
                                  '47',
                                  'Ag1+',
                                  '46',
                                  'Ag2+',
                                  '45',
                                  'Cd',
                                  '48',
                                  'Cd2+',
                                  '46',
                                  'In',
                                  '49',
                                  'In3+',
                                  '46',
                                  'Sn',
                                  '50',
                                  'Sn2+',
                                  '48',
                                  'Sn4+',
                                  '46',
                                  'Sb',
                                  '51',
                                  'Sb3+',
                                  '48',
                                  'Sb5+',
                                  '46',
                                  'Te',
                                  '52',
                                  'I',
                                  '53',
                                  'I1-',
                                  '54',
                                  'Xe',
                                  '54',
                                  'Cs',
                                  '55',
                                  'Cs1+',
                                  '54',
                                  'Ba',
                                  '56',
                                  'Ba2+',
                                  '54',
                                  'La',
                                  '57',
                                  'La3+',
                                  '54',
                                  'Ce',
                                  '58',
                                  'Ce3+',
                                  '55',
                                  'Ce4+',
                                  '54',
                                  'Pr',
                                  '59',
                                  'Pr3+',
                                  '56',
                                  'Pr4+',
                                  '55',
                                  'Nd',
                                  '60',
                                  'Nd3+',
                                  '57',
                                  'Pm',
                                  '61',
                                  'Sm',
                                  '62',
                                  'Sm3+',
                                  '59',
                                  'Eu',
                                  '63',
                                  'Eu2+',
                                  '61',
                                  'Eu3+',
                                  '60',
                                  'Gd',
                                  '64',
                                  'Gd3+',
                                  '61',
                                  'Tb',
                                  '65',
                                  'Tb3+',
                                  '62',
                                  'Dy',
                                  '66',
                                  'Dy3+',
                                  '63',
                                  'Ho',
                                  '67',
                                  'Ho3+',
                                  '64',
                                  'Er',
                                  '68',
                                  'Er3+',
                                  '65',
                                  'Tm',
                                  '69',
                                  'Tm3+',
                                  '66',
                                  'Yb',
                                  '70',
                                  'Yb2+',
                                  '68',
                                  'Yb3+',
                                  '67',
                                  'Lu',
                                  '71',
                                  'Lu3+',
                                  '68',
                                  'Hf',
                                  '72',
                                  'Hf4+',
                                  '68',
                                  'Ta',
                                  '73',
                                  'Ta5+',
                                  '68',
                                  'W',
                                  '74',
                                  'W6+',
                                  '68',
                                  'Re',
                                  '75',
                                  'Os',
                                  '76',
                                  'Os4+',
                                  '72',
                                  'Ir',
                                  '77',
                                  'Ir3+',
                                  '74',
                                  'Ir4+',
                                  '73',
                                  'Pt',
                                  '78',
                                  'Pt2+',
                                  '76',
                                  'Pt4+',
                                  '74',
                                  'Au',
                                  '79',
                                  'Au1+',
                                  '78',
                                  'Au3+',
                                  '76',
                                  'Hg',
                                  '80',
                                  'Hg1+',
                                  '79',
                                  'Hg2+',
                                  '78',
                                  'Tl',
                                  '81',
                                  'TL1+',
                                  '80',
                                  'Tl3+',
                                  '78',
                                  'Pb',
                                  '82',
                                  'Pb2+',
                                  '80',
                                  'Pb4+',
                                  '78',
                                  'Bi',
                                  '83',
                                  'Bi3+',
                                  '80',
                                  'Bi5+',
                                  '78',
                                  'Po',
                                  '84',
                                  'At',
                                  '85',
                                  'Rn',
                                  '86',
                                  'Fr',
                                  '87',
                                  'Ra',
                                  '88',
                                  'Ra2+',
                                  '86',
                                  'Ac',
                                  '89',
                                  'Ac3+',
                                  '86',
                                  'Th',
                                  '90',
                                  'Th4+',
                                  '86',
                                  'Pa',
                                  '91',
                                  'U',
                                  '92',
                                  'U3+',
                                  '89',
                                  'U4+',
                                  '88',
                                  'U6+',
                                  '84',
                                  'Np',
                                  '93',
                                  'Np3+',
                                  '90',
                                  'Np4+',
                                  '89',
                                  'Np6+',
                                  '87',
                                  'Pu',
                                  '94',
                                  'Pu3+',
                                  '91',
                                  'Pu4+',
                                  '90',
                                  'Pu6+',
                                  '88',
                                  'Am',
                                  '95',
                                  'Cm',
                                  '96',
                                  'Bk',
                                  '97',
                                  'Cf',
                                  '98' ] ],
                              [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                              [ 'item_', '_enumeration.range', '1:' ] ] ],
                          [ 'save_',
                            'atom_type.element_symbol',
                            [ [ 'item_', '_definition.id', '_atom_type.element_symbol' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Element symbol for of this atom type. The default value is extracted\n     from the ion-to-element enumeration_default list using the index\n     value of atom_type.symbol.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'element_symbol' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'Ac',
                                  'Actinium',
                                  'Ag',
                                  'Silver',
                                  'Al',
                                  'Aluminum',
                                  'Am',
                                  'Americium',
                                  'Ar',
                                  'Argon',
                                  'As',
                                  'Arsenic',
                                  'At',
                                  'Astatine',
                                  'Au',
                                  'Gold',
                                  'B',
                                  'Boron',
                                  'Ba',
                                  'Barium',
                                  'Be',
                                  'Beryllium',
                                  'Bh',
                                  'Bohrium',
                                  'Bi',
                                  'Bismuth',
                                  'Bk',
                                  'Berkelium',
                                  'Br',
                                  'Bromine',
                                  'C',
                                  'Carbon',
                                  'Ca',
                                  'Calcium',
                                  'Cd',
                                  'Cadmium',
                                  'Ce',
                                  'Cerium',
                                  'Cf',
                                  'Californium',
                                  'Cl',
                                  'Chlorine',
                                  'Cm',
                                  'Curium',
                                  'Co',
                                  'Cobalt',
                                  'Cr',
                                  'Chromium',
                                  'Cs',
                                  'Cesium',
                                  'Cu',
                                  'Copper',
                                  'Db',
                                  'Dubnium',
                                  'Ds',
                                  'Darmstadtium',
                                  'Dy',
                                  'Dysprosium',
                                  'Er',
                                  'Erbium',
                                  'Es',
                                  'Einsteinium',
                                  'Eu',
                                  'Europium',
                                  'F',
                                  'Fluorine',
                                  'Fe',
                                  'Iron',
                                  'Fm',
                                  'Fermium',
                                  'Fr',
                                  'Francium',
                                  'Ga',
                                  'Gallium',
                                  'Gd',
                                  'Gadolinium',
                                  'Ge',
                                  'Germanium',
                                  'H',
                                  'Hydrogen',
                                  'He',
                                  'Helium',
                                  'Hf',
                                  'Hafnium',
                                  'Hg',
                                  'Mercury',
                                  'Ho',
                                  'Holmium',
                                  'Hs',
                                  'Hassium',
                                  'I',
                                  'Iodine',
                                  'In',
                                  'Indium',
                                  'Ir',
                                  'Iridium',
                                  'K',
                                  'Potassium',
                                  'Kr',
                                  'Krypton',
                                  'La',
                                  'Lanthanum',
                                  'Li',
                                  'Lithium',
                                  'Lr',
                                  'Lawrencium',
                                  'Lu',
                                  'Lutetium',
                                  'Md',
                                  'Mendelevium',
                                  'Mg',
                                  'Magnesium',
                                  'Mn',
                                  'Manganese',
                                  'Mo',
                                  'Molybdenum',
                                  'Mt',
                                  'Meitnerium',
                                  'N',
                                  'Nitrogen',
                                  'Na',
                                  'Sodium',
                                  'Ne',
                                  'Neon',
                                  'Nb',
                                  'Niobium',
                                  'Nd',
                                  'Neodymium',
                                  'Ni',
                                  'Nickel',
                                  'No',
                                  'Nobelium',
                                  'Np',
                                  'Neptunium',
                                  'O',
                                  'Oxygen',
                                  'Os',
                                  'Osmium',
                                  'P',
                                  'Phosphorus',
                                  'Pd',
                                  'Palladium',
                                  'Po',
                                  'Polonium',
                                  'Pb',
                                  'Lead',
                                  'Pt',
                                  'Platinum',
                                  'Pr',
                                  'Praseodymium',
                                  'Pm',
                                  'Promethium',
                                  'Pu',
                                  'Plutonium',
                                  'Pa',
                                  'Protactinium',
                                  'Ra',
                                  'Radium',
                                  'Rb',
                                  'Rubidium',
                                  'Re',
                                  'Rhenium',
                                  'Rf',
                                  'Rutherfordium',
                                  'Rh',
                                  'Rhodium',
                                  'Rn',
                                  'Radon',
                                  'Ru',
                                  'Ruthenium',
                                  'S',
                                  'Sulfur',
                                  'Sb',
                                  'Antimony',
                                  'Sc',
                                  'Scandium',
                                  'Se',
                                  'Selenium',
                                  'Sg',
                                  'Seaborgium',
                                  'Si',
                                  'Silicon',
                                  'Sm',
                                  'Samarium',
                                  'Sn',
                                  'Tin',
                                  'Sr',
                                  'Strontium',
                                  'Ta',
                                  'Tantalum',
                                  'Tb',
                                  'Terbium',
                                  'Tc',
                                  'Technetium',
                                  'Te',
                                  'Tellurium',
                                  'Th',
                                  'Thorium',
                                  'Ti',
                                  'Titanium',
                                  'Tl',
                                  'Thallium',
                                  'Tm',
                                  'Thulium',
                                  'U',
                                  'Uranium',
                                  'Uub',
                                  'Ununbium',
                                  'Uun',
                                  'Ununnilium',
                                  'Uuu',
                                  'Ununumium',
                                  'V',
                                  'Vanadium',
                                  'W',
                                  'Tungsten',
                                  'Xe',
                                  'Xenon',
                                  'Y',
                                  'Yttrium',
                                  'Yb',
                                  'Ytterbium',
                                  'Zn',
                                  'Zinc',
                                  'Zr',
                                  'Zirconium' ] ],
                              [ 'loop_',
                                [ '_enumeration_default.index', '_enumeration_default.value' ],
                                [ 'H',
                                  'H',
                                  'D',
                                  'D',
                                  'H1-',
                                  'H',
                                  'He',
                                  'He',
                                  'Li',
                                  'Li',
                                  'Li1+',
                                  'Li',
                                  'Be',
                                  'Be',
                                  'Be2+',
                                  'Be',
                                  'B',
                                  'B',
                                  'C',
                                  'C',
                                  'N',
                                  'N',
                                  'O',
                                  'O',
                                  'O1-',
                                  'O',
                                  'F',
                                  'F',
                                  'F1-',
                                  'F',
                                  'Ne',
                                  'Ne',
                                  'Na',
                                  'Na',
                                  'Na1+',
                                  'Na',
                                  'Mg',
                                  'Mg',
                                  'Mg2+',
                                  'Mg',
                                  'Al',
                                  'Al',
                                  'Al3+',
                                  'Al',
                                  'Si',
                                  'Si',
                                  'Si4+',
                                  'Si',
                                  'P',
                                  'P',
                                  'S',
                                  'S',
                                  'Cl',
                                  'Cl',
                                  'Cl1-',
                                  'Cl',
                                  'Ar',
                                  'Ar',
                                  'K',
                                  'K',
                                  'K1+',
                                  'K',
                                  'Ca',
                                  'Ca',
                                  'Ca2+',
                                  'Ca',
                                  'Sc',
                                  'Sc',
                                  'Sc3+',
                                  'Sc',
                                  'Ti',
                                  'Ti',
                                  'Ti2+',
                                  'Ti',
                                  'Ti3+',
                                  'Ti',
                                  'Ti4+',
                                  'Ti',
                                  'V',
                                  'V',
                                  'V2+',
                                  'V',
                                  'V3+',
                                  'V',
                                  'V5+',
                                  'V',
                                  'Cr',
                                  'Cr',
                                  'Cr2+',
                                  'Cr',
                                  'Cr3+',
                                  'Cr',
                                  'Mn',
                                  'Mn',
                                  'Mn2+',
                                  'Mn',
                                  'Mn3+',
                                  'Mn',
                                  'Mn4+',
                                  'Mn',
                                  'Fe',
                                  'Fe',
                                  'Fe2+',
                                  'Fe',
                                  'Fe3+',
                                  'Fe',
                                  'Co',
                                  'Co',
                                  'Co2+',
                                  'Co',
                                  'Co3+',
                                  'Co',
                                  'Ni',
                                  'Ni',
                                  'Ni2+',
                                  'Ni',
                                  'Ni3+',
                                  'Ni',
                                  'Cu',
                                  'Cu',
                                  'Cu1+',
                                  'Cu',
                                  'Cu2+',
                                  'Cu',
                                  'Zn',
                                  'Zn',
                                  'Zn2+',
                                  'Zn',
                                  'Ga',
                                  'Ga',
                                  'Ga3+',
                                  'Ga',
                                  'Ge',
                                  'Ge',
                                  'Ge4+',
                                  'Ge',
                                  'As',
                                  'As',
                                  'Se',
                                  'Se',
                                  'Br',
                                  'Br',
                                  'Br1-',
                                  'Br',
                                  'Kr',
                                  'Kr',
                                  'Rb',
                                  'Rb',
                                  'Rb1+',
                                  'Rb',
                                  'Sr',
                                  'Sr',
                                  'Sr2+',
                                  'Sr',
                                  'Y',
                                  'Y',
                                  'Y3+',
                                  'Y',
                                  'Zr',
                                  'Zr',
                                  'Zr4+',
                                  'Zr',
                                  'Nb',
                                  'Nb',
                                  'Nb3+',
                                  'Nb',
                                  'Nb5+',
                                  'Nb',
                                  'Mo',
                                  'Mo',
                                  'Mo3+',
                                  'Mo',
                                  'Mo5+',
                                  'Mo',
                                  'Mo6+',
                                  'Mo',
                                  'Tc',
                                  'Tc',
                                  'Ru',
                                  'Ru',
                                  'Ru3+',
                                  'Ru',
                                  'Ru4+',
                                  'Ru',
                                  'Rh',
                                  'Rh',
                                  'Rh3+',
                                  'Rh',
                                  'Rh4+',
                                  'Rh',
                                  'Pd',
                                  'Pd',
                                  'Pd2+',
                                  'Pd',
                                  'Pd4+',
                                  'Pd',
                                  'Ag',
                                  'Ag',
                                  'Ag1+',
                                  'Ag',
                                  'Ag2+',
                                  'Ag',
                                  'Cd',
                                  'Cd',
                                  'Cd2+',
                                  'Cd',
                                  'In',
                                  'In',
                                  'In3+',
                                  'In',
                                  'Sn',
                                  'Sn',
                                  'Sn2+',
                                  'Sn',
                                  'Sn4+',
                                  'Sn',
                                  'Sb',
                                  'Sb',
                                  'Sb3+',
                                  'Sb',
                                  'Sb5+',
                                  'Sb',
                                  'Te',
                                  'Te',
                                  'I',
                                  'I',
                                  'I1-',
                                  'I',
                                  'Xe',
                                  'Xe',
                                  'Cs',
                                  'Cs',
                                  'Cs1+',
                                  'Cs',
                                  'Ba',
                                  'Ba',
                                  'Ba2+',
                                  'Ba',
                                  'La',
                                  'La',
                                  'La3+',
                                  'La',
                                  'Ce',
                                  'Ce',
                                  'Ce3+',
                                  'Ce',
                                  'Ce4+',
                                  'Ce',
                                  'Pr',
                                  'Pr',
                                  'Pr3+',
                                  'Pr',
                                  'Pr4+',
                                  'Pr',
                                  'Nd',
                                  'Nd',
                                  'Nd3+',
                                  'Nd',
                                  'Pm',
                                  'Pm',
                                  'Sm',
                                  'Sm',
                                  'Sm3+',
                                  'Sm',
                                  'Eu',
                                  'Eu',
                                  'Eu2+',
                                  'Eu',
                                  'Eu3+',
                                  'Eu',
                                  'Gd',
                                  'Gd',
                                  'Gd3+',
                                  'Gd',
                                  'Tb',
                                  'Tb',
                                  'Tb3+',
                                  'Tb',
                                  'Dy',
                                  'Dy',
                                  'Dy3+',
                                  'Dy',
                                  'Ho',
                                  'Ho',
                                  'Ho3+',
                                  'Ho',
                                  'Er',
                                  'Er',
                                  'Er3+',
                                  'Er',
                                  'Tm',
                                  'Tm',
                                  'Tm3+',
                                  'Tm',
                                  'Yb',
                                  'Yb',
                                  'Yb2+',
                                  'Yb',
                                  'Yb3+',
                                  'Yb',
                                  'Lu',
                                  'Lu',
                                  'Lu3+',
                                  'Lu',
                                  'Hf',
                                  'Hf',
                                  'Hf4+',
                                  'Hf',
                                  'Ta',
                                  'Ta',
                                  'Ta5+',
                                  'Ta',
                                  'W',
                                  'W',
                                  'W6+',
                                  'W',
                                  'Re',
                                  'Re',
                                  'Os',
                                  'Os',
                                  'Os4+',
                                  'Os',
                                  'Ir',
                                  'Ir',
                                  'Ir3+',
                                  'Ir',
                                  'Ir4+',
                                  'Ir',
                                  'Pt',
                                  'Pt',
                                  'Pt2+',
                                  'Pt',
                                  'Pt4+',
                                  'Pt',
                                  'Au',
                                  'Au',
                                  'Au1+',
                                  'Au',
                                  'Au3+',
                                  'Au',
                                  'Hg',
                                  'Hg',
                                  'Hg1+',
                                  'Hg',
                                  'Hg2+',
                                  'Hg',
                                  'Tl',
                                  'Tl',
                                  'TL1+',
                                  'Tl',
                                  'Tl3+',
                                  'Tl',
                                  'Pb',
                                  'Pb',
                                  'Pb2+',
                                  'Pb',
                                  'Pb4+',
                                  'Pb',
                                  'Bi',
                                  'Bi',
                                  'Bi3+',
                                  'Bi',
                                  'Bi5+',
                                  'Bi',
                                  'Po',
                                  'Po',
                                  'At',
                                  'At',
                                  'Rn',
                                  'Rn',
                                  'Fr',
                                  'Fr',
                                  'Ra',
                                  'Ra',
                                  'Ra2+',
                                  'Ra',
                                  'Ac',
                                  'Ac',
                                  'Ac3+',
                                  'Ac',
                                  'Th',
                                  'Th',
                                  'Th4+',
                                  'Th',
                                  'Pa',
                                  'Pa',
                                  'U',
                                  'U',
                                  'U3+',
                                  'U',
                                  'U4+',
                                  'U',
                                  'U6+',
                                  'U',
                                  'Np',
                                  'Np',
                                  'Np3+',
                                  'Np',
                                  'Np4+',
                                  'Np',
                                  'Np6+',
                                  'Np',
                                  'Pu',
                                  'Pu',
                                  'Pu3+',
                                  'Pu',
                                  'Pu4+',
                                  'Pu',
                                  'Pu6+',
                                  'Pu',
                                  'Am',
                                  'Am',
                                  'Cm',
                                  'Cm',
                                  'Bk',
                                  'Bk',
                                  'Cf',
                                  'Cf' ] ],
                              [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ] ] ],
                          [ 'save_',
                            'atom_type.number_in_cell',
                            [ [ 'item_', '_definition.id', '_atom_type.number_in_cell' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_type_number_in_cell' ] ],
                              [ 'item_', '_definition.update', '2013-01-28' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Total number of atoms of this atom type in the unit cell.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'number_in_cell' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n    With t as atom_type\n \n    cnt =  0.\n \n    Loop a  as  atom_site  {\n \n       if ( a.type_symbol == t.symbol ) {\n \n          cnt +=  a.occupancy * a.site_symmetry_multiplicity\n    }  }\n    _atom_type.number_in_cell =  cnt' ] ] ] ],
                          [ 'save_',
                            'atom_type.oxidation_number',
                            [ [ 'item_', '_definition.id', '_atom_type.oxidation_number' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_type_oxidation_number' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Formal oxidation state of this atom type in the structure.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'oxidation_number' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_enumeration.range', '-8:8' ],
                              [ 'item_', '_enumeration.default', '0' ] ] ],
                          [ 'save_',
                            'atom_type.radius_bond',
                            [ [ 'item_', '_definition.id', '_atom_type.radius_bond' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_type_radius_bond' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The effective intra-molecular bonding radius of this atom type.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'radius_bond' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'loop_',
                                [ '_enumeration_default.index', '_enumeration_default.value' ],
                                [ 'H',
                                  '0.37',
                                  'D',
                                  '0.37',
                                  'H1-',
                                  '0.37',
                                  'He',
                                  '0.40',
                                  'Li',
                                  '1.23',
                                  'Li1+',
                                  '1.23',
                                  'Be',
                                  '0.89',
                                  'Be2+',
                                  '0.89',
                                  'B',
                                  '0.80',
                                  'C',
                                  '0.77',
                                  'N',
                                  '0.74',
                                  'O',
                                  '0.74',
                                  'O1-',
                                  '0.74',
                                  'F',
                                  '0.72',
                                  'F1-',
                                  '0.72',
                                  'Ne',
                                  '0.72',
                                  'Na',
                                  '1.57',
                                  'Na1+',
                                  '1.57',
                                  'Mg',
                                  '1.36',
                                  'Mg2+',
                                  '1.36',
                                  'Al',
                                  '1.25',
                                  'Al3+',
                                  '1.25',
                                  'Si',
                                  '1.17',
                                  'Si4+',
                                  '1.17',
                                  'P',
                                  '1.10',
                                  'S',
                                  '1.04',
                                  'Cl',
                                  '0.99',
                                  'Cl1-',
                                  '0.99',
                                  'Ar',
                                  '1.00',
                                  'K',
                                  '2.03',
                                  'K1+',
                                  '2.03',
                                  'Ca',
                                  '1.74',
                                  'Ca2+',
                                  '1.74',
                                  'Sc',
                                  '1.44',
                                  'Sc3+',
                                  '1.44',
                                  'Ti',
                                  '1.35',
                                  'Ti2+',
                                  '1.35',
                                  'Ti3+',
                                  '1.35',
                                  'Ti4+',
                                  '1.35',
                                  'V',
                                  '1.22',
                                  'V2+',
                                  '1.22',
                                  'V3+',
                                  '1.22',
                                  'V5+',
                                  '1.22',
                                  'Cr',
                                  '1.17',
                                  'Cr2+',
                                  '1.17',
                                  'Cr3+',
                                  '1.17',
                                  'Mn',
                                  '1.17',
                                  'Mn2+',
                                  '1.17',
                                  'Mn3+',
                                  '1.17',
                                  'Mn4+',
                                  '1.17',
                                  'Fe',
                                  '1.17',
                                  'Fe2+',
                                  '1.17',
                                  'Fe3+',
                                  '1.17',
                                  'Co',
                                  '1.16',
                                  'Co2+',
                                  '1.16',
                                  'Co3+',
                                  '1.16',
                                  'Ni',
                                  '1.15',
                                  'Ni2+',
                                  '1.15',
                                  'Ni3+',
                                  '1.15',
                                  'Cu',
                                  '1.17',
                                  'Cu1+',
                                  '1.17',
                                  'Cu2+',
                                  '1.17',
                                  'Zn',
                                  '1.25',
                                  'Zn2+',
                                  '1.25',
                                  'Ga',
                                  '1.25',
                                  'Ga3+',
                                  '1.25',
                                  'Ge',
                                  '1.22',
                                  'Ge4+',
                                  '1.22',
                                  'As',
                                  '1.21',
                                  'Se',
                                  '1.17',
                                  'Br',
                                  '1.14',
                                  'Br1-',
                                  '1.14',
                                  'Kr',
                                  '1.14',
                                  'Rb',
                                  '2.16',
                                  'Rb1+',
                                  '2.16',
                                  'Sr',
                                  '1.91',
                                  'Sr2+',
                                  '1.91',
                                  'Y',
                                  '1.62',
                                  'Y3+',
                                  '1.62',
                                  'Zr',
                                  '1.45',
                                  'Zr4+',
                                  '1.45',
                                  'Nb',
                                  '1.34',
                                  'Nb3+',
                                  '1.34',
                                  'Nb5+',
                                  '1.34',
                                  'Mo',
                                  '1.29',
                                  'Mo3+',
                                  '1.29',
                                  'Mo5+',
                                  '1.29',
                                  'Mo6+',
                                  '1.29',
                                  'Tc',
                                  '1.27',
                                  'Ru',
                                  '1.24',
                                  'Ru3+',
                                  '1.24',
                                  'Ru4+',
                                  '1.24',
                                  'Rh',
                                  '1.25',
                                  'Rh3+',
                                  '1.25',
                                  'Rh4+',
                                  '1.25',
                                  'Pd',
                                  '1.28',
                                  'Pd2+',
                                  '1.28',
                                  'Pd4+',
                                  '1.28',
                                  'Ag',
                                  '1.34',
                                  'Ag1+',
                                  '1.34',
                                  'Ag2+',
                                  '1.34',
                                  'Cd',
                                  '1.41',
                                  'Cd2+',
                                  '1.41',
                                  'In',
                                  '1.50',
                                  'In3+',
                                  '1.50',
                                  'Sn',
                                  '1.41',
                                  'Sn2+',
                                  '1.41',
                                  'Sn4+',
                                  '1.41',
                                  'Sb',
                                  '1.41',
                                  'Sb3+',
                                  '1.41',
                                  'Sb5+',
                                  '1.41',
                                  'Te',
                                  '1.37',
                                  'I',
                                  '1.33',
                                  'I1-',
                                  '1.33',
                                  'Xe',
                                  '1.33',
                                  'Cs',
                                  '2.35',
                                  'Cs1+',
                                  '2.35',
                                  'Ba',
                                  '1.98',
                                  'Ba2+',
                                  '1.98',
                                  'La',
                                  '1.69',
                                  'La3+',
                                  '1.69',
                                  'Ce',
                                  '1.65',
                                  'Ce3+',
                                  '1.65',
                                  'Ce4+',
                                  '1.65',
                                  'Pr',
                                  '1.65',
                                  'Pr3+',
                                  '1.65',
                                  'Pr4+',
                                  '1.65',
                                  'Nd',
                                  '1.64',
                                  'Nd3+',
                                  '1.64',
                                  'Pm',
                                  '1.63',
                                  'Sm',
                                  '1.66',
                                  'Sm3+',
                                  '1.66',
                                  'Eu',
                                  '1.85',
                                  'Eu2+',
                                  '1.85',
                                  'Eu3+',
                                  '1.85',
                                  'Gd',
                                  '1.61',
                                  'Gd3+',
                                  '1.61',
                                  'Tb',
                                  '1.59',
                                  'Tb3+',
                                  '1.59',
                                  'Dy',
                                  '1.59',
                                  'Dy3+',
                                  '1.59',
                                  'Ho',
                                  '1.58',
                                  'Ho3+',
                                  '1.58',
                                  'Er',
                                  '1.57',
                                  'Er3+',
                                  '1.57',
                                  'Tm',
                                  '1.56',
                                  'Tm3+',
                                  '1.56',
                                  'Yb',
                                  '1.70',
                                  'Yb2+',
                                  '1.70',
                                  'Yb3+',
                                  '1.70',
                                  'Lu',
                                  '1.56',
                                  'Lu3+',
                                  '1.56',
                                  'Hf',
                                  '1.44',
                                  'Hf4+',
                                  '1.44',
                                  'Ta',
                                  '1.34',
                                  'Ta5+',
                                  '1.34',
                                  'W',
                                  '1.30',
                                  'W6+',
                                  '1.30',
                                  'Re',
                                  '1.28',
                                  'Os',
                                  '1.26',
                                  'Os4+',
                                  '1.26',
                                  'Ir',
                                  '1.26',
                                  'Ir3+',
                                  '1.26',
                                  'Ir4+',
                                  '1.26',
                                  'Pt',
                                  '1.29',
                                  'Pt2+',
                                  '1.29',
                                  'Pt4+',
                                  '1.29',
                                  'Au',
                                  '1.34',
                                  'Au1+',
                                  '1.34',
                                  'Au3+',
                                  '1.34',
                                  'Hg',
                                  '1.44',
                                  'Hg1+',
                                  '1.44',
                                  'Hg2+',
                                  '1.44',
                                  'Tl',
                                  '1.55',
                                  'TL1+',
                                  '1.55',
                                  'Tl3+',
                                  '1.55',
                                  'Pb',
                                  '1.54',
                                  'Pb2+',
                                  '1.54',
                                  'Pb4+',
                                  '1.54',
                                  'Bi',
                                  '1.52',
                                  'Bi3+',
                                  '1.52',
                                  'Bi5+',
                                  '1.52',
                                  'Po',
                                  '1.53',
                                  'At',
                                  '1.53',
                                  'Rn',
                                  '1.53',
                                  'Fr',
                                  '1.53',
                                  'Ra',
                                  '1.53',
                                  'Ra2+',
                                  '1.53',
                                  'Ac',
                                  '1.53',
                                  'Ac3+',
                                  '1.53',
                                  'Th',
                                  '1.65',
                                  'Th4+',
                                  '1.65',
                                  'Pa',
                                  '1.53',
                                  'U',
                                  '1.42',
                                  'U3+',
                                  '1.42',
                                  'U4+',
                                  '1.42',
                                  'U6+',
                                  '1.42',
                                  'Np',
                                  '1.42',
                                  'Np3+',
                                  '1.42',
                                  'Np4+',
                                  '1.42',
                                  'Np6+',
                                  '1.42',
                                  'Pu',
                                  '1.42',
                                  'Pu3+',
                                  '1.42',
                                  'Pu4+',
                                  '1.42',
                                  'Pu6+',
                                  '1.42',
                                  'Am',
                                  '1.42',
                                  'Cm',
                                  '1.42',
                                  'Bk',
                                  '1.42',
                                  'Cf',
                                  '1.42' ] ],
                              [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                              [ 'item_', '_enumeration.range', '0.0:5.0' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'atom_type.radius_contact',
                            [ [ 'item_', '_definition.id', '_atom_type.radius_contact' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_atom_type_radius_contact' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The effective inter-molecular bonding radius of this atom type.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'radius_contact' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:5.0' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     _atom_type.radius_contact =  atom_type.radius_bond + 1.25' ] ] ] ],
                          [ 'save_',
                            'atom_type.symbol',
                            [ [ 'item_', '_definition.id', '_atom_type.symbol' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_atom_type_symbol' ] ],
                              [ 'item_', '_definition.update', '2012-12-21' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The identity of the atom specie(s) representing this atom type.\n     Normally this code is the element symbol followed by the charge\n     if there is one. The symbol may be composed of any character except\n     an underline or a blank, with the proviso that digits designate an\n     oxidation state and must be followed by a + or - character.' ],
                              [ 'item_', '_name.category_id', 'type' ],
                              [ 'item_', '_name.object_id', 'symbol' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Mg', 'Cu2+', 'dummy', 'FeNi' ] ] ] ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'ATOM_TYPE_SCAT',
                            [ [ 'item_', '_definition.id', 'ATOM_TYPE_SCAT' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to describe atomic scattering\n     information used in crystallographic structure studies.' ],
                              [ 'item_', '_name.category_id', 'ATOM_TYPE' ],
                              [ 'item_', '_name.object_id', 'SCAT' ],
                              [ 'item_', '_category.key_id', '_atom_type_scat.key' ],
                              [ 'save_',
                                'atom_type_scat.key',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.key' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of ATOM_TYPE_SCAT items in a\n     looped list. This list may be joined with the ATOM_TYPE list.' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '              _type.contents = Type_Contents(atom_type_scat.symbol)',
                                      'Evaluation',
                                      '              _atom_type_scat.key = _atom_type_scat.symbol' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_coeffs',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.Cromer_Mann_coeffs' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of Cromer-Mann coefficients for generating X-ray scattering\n     factors. [ a1, b1, a2, b2, a3, b3, a4, b4, c]\n     Ref: International Tables for Crystallography, Vol. C\n             (1991) Table 6.1.1.4' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_coeffs' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'List' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '9' ] ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With t  as  atom_type_scat\n \n      _atom_type_scat.Cromer_Mann_coeffs  =          [ t.Cromer_Mann_c,\n                                     t.Cromer_Mann_a1, t.Cromer_Mann_b1,\n                                     t.Cromer_Mann_a2, t.Cromer_Mann_b2,\n                                     t.Cromer_Mann_a3, t.Cromer_Mann_b3,\n                                     t.Cromer_Mann_a4, t.Cromer_Mann_b4 ]' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_a1',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_a1' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_a1',
                                      '_atom_type.scat_Cromer_Mann_a1' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.493002',
                                      'D',
                                      '.493002',
                                      'H1-',
                                      '.897661',
                                      'He',
                                      '0.8734',
                                      'Li',
                                      '1.1282',
                                      'Li1+',
                                      '.6968',
                                      'Be',
                                      '1.5919',
                                      'Be2+',
                                      '6.2603',
                                      'B',
                                      '2.0545',
                                      'C',
                                      '2.31',
                                      'N',
                                      '12.2126',
                                      'O',
                                      '3.0485',
                                      'O1-',
                                      '4.1916',
                                      'F',
                                      '3.5392',
                                      'F1-',
                                      '3.6322',
                                      'Ne',
                                      '3.9553',
                                      'Na',
                                      '4.7626',
                                      'Na1+',
                                      '3.2565',
                                      'Mg',
                                      '5.4204',
                                      'Mg2+',
                                      '3.4988',
                                      'Al',
                                      '6.4202',
                                      'Al3+',
                                      '4.17448',
                                      'Si',
                                      '6.2915',
                                      'Si4+',
                                      '4.43918',
                                      'P',
                                      '6.4345',
                                      'S',
                                      '6.9053',
                                      'Cl',
                                      '11.4604',
                                      'Cl1-',
                                      '18.2915',
                                      'Ar',
                                      '7.4845',
                                      'K',
                                      '8.2186',
                                      'K1+',
                                      '7.9578',
                                      'Ca',
                                      '8.6266',
                                      'Ca2+',
                                      '15.6348',
                                      'Sc',
                                      '9.189',
                                      'Sc3+',
                                      '13.4008',
                                      'Ti',
                                      '9.7595',
                                      'Ti2+',
                                      '9.11423',
                                      'Ti3+',
                                      '17.7344',
                                      'Ti4+',
                                      '19.5114',
                                      'V',
                                      '10.2971',
                                      'V2+',
                                      '10.106',
                                      'V3+',
                                      '9.43141',
                                      'V5+',
                                      '15.6887',
                                      'Cr',
                                      '10.6406',
                                      'Cr2+',
                                      '9.54034',
                                      'Cr3+',
                                      '9.6809',
                                      'Mn',
                                      '11.2819',
                                      'Mn2+',
                                      '10.8061',
                                      'Mn3+',
                                      '9.84521',
                                      'Mn4+',
                                      '9.96253',
                                      'Fe',
                                      '11.7695',
                                      'Fe2+',
                                      '11.0424',
                                      'Fe3+',
                                      '11.1764',
                                      'Co',
                                      '12.2841',
                                      'Co2+',
                                      '11.2296',
                                      'Co3+',
                                      '10.338',
                                      'Ni',
                                      '12.8376',
                                      'Ni2+',
                                      '11.4166',
                                      'Ni3+',
                                      '10.7806',
                                      'Cu',
                                      '13.338',
                                      'Cu1+',
                                      '11.9475',
                                      'Cu2+',
                                      '11.8168',
                                      'Zn',
                                      '14.0743',
                                      'Zn2+',
                                      '11.9719',
                                      'Ga',
                                      '15.2354',
                                      'Ga3+',
                                      '12.692',
                                      'Ge',
                                      '16.0816',
                                      'Ge4+',
                                      '12.9172',
                                      'As',
                                      '16.6723',
                                      'Se',
                                      '17.0006',
                                      'Br',
                                      '17.1789',
                                      'Br1-',
                                      '17.1718',
                                      'Kr',
                                      '17.3555',
                                      'Rb',
                                      '17.1784',
                                      'Rb1+',
                                      '17.5816',
                                      'Sr',
                                      '17.5663',
                                      'Sr2+',
                                      '18.0874',
                                      'Y',
                                      '17.776',
                                      'Y3+',
                                      '17.9268',
                                      'Zr',
                                      '17.8765',
                                      'Zr4+',
                                      '18.1668',
                                      'Nb',
                                      '17.6142',
                                      'Nb3+',
                                      '19.8812',
                                      'Nb5+',
                                      '17.9163',
                                      'Mo',
                                      '3.7025',
                                      'Mo3+',
                                      '21.1664',
                                      'Mo5+',
                                      '21.0149',
                                      'Mo6+',
                                      '17.8871',
                                      'Tc',
                                      '19.1301',
                                      'Ru',
                                      '19.2674',
                                      'Ru3+',
                                      '18.5638',
                                      'Ru4+',
                                      '18.5003',
                                      'Rh',
                                      '19.2957',
                                      'Rh3+',
                                      '18.8785',
                                      'Rh4+',
                                      '18.8545',
                                      'Pd',
                                      '19.3319',
                                      'Pd2+',
                                      '19.1701',
                                      'Pd4+',
                                      '19.2493',
                                      'Ag',
                                      '19.2808',
                                      'Ag1+',
                                      '19.1812',
                                      'Ag2+',
                                      '19.1643',
                                      'Cd',
                                      '19.2214',
                                      'Cd2+',
                                      '19.1514',
                                      'In',
                                      '19.1624',
                                      'In3+',
                                      '19.1045',
                                      'Sn',
                                      '19.1889',
                                      'Sn2+',
                                      '19.1094',
                                      'Sn4+',
                                      '18.9333',
                                      'Sb',
                                      '19.6418',
                                      'Sb3+',
                                      '18.9755',
                                      'Sb5+',
                                      '19.8685',
                                      'Te',
                                      '19.9644',
                                      'I',
                                      '20.1472',
                                      'I1-',
                                      '20.2332',
                                      'Xe',
                                      '20.2933',
                                      'Cs',
                                      '20.3892',
                                      'Cs1+',
                                      '20.3524',
                                      'Ba',
                                      '20.3361',
                                      'Ba2+',
                                      '20.1807',
                                      'La',
                                      '20.578',
                                      'La3+',
                                      '20.2489',
                                      'Ce',
                                      '21.1671',
                                      'Ce3+',
                                      '20.8036',
                                      'Ce4+',
                                      '20.3235',
                                      'Pr',
                                      '22.044',
                                      'Pr3+',
                                      '21.3727',
                                      'Pr4+',
                                      '20.9413',
                                      'Nd',
                                      '22.6845',
                                      'Nd3+',
                                      '21.961',
                                      'Pm',
                                      '23.3405',
                                      'Sm',
                                      '24.0042',
                                      'Sm3+',
                                      '23.1504',
                                      'Eu',
                                      '24.6274',
                                      'Eu2+',
                                      '24.0063',
                                      'Eu3+',
                                      '23.7497',
                                      'Gd',
                                      '25.0709',
                                      'Gd3+',
                                      '24.3466',
                                      'Tb',
                                      '25.8976',
                                      'Tb3+',
                                      '24.9559',
                                      'Dy',
                                      '26.507',
                                      'Dy3+',
                                      '25.5395',
                                      'Ho',
                                      '26.9049',
                                      'Ho3+',
                                      '26.1296',
                                      'Er',
                                      '27.6563',
                                      'Er3+',
                                      '26.722',
                                      'Tm',
                                      '28.1819',
                                      'Tm3+',
                                      '27.3083',
                                      'Yb',
                                      '28.6641',
                                      'Yb2+',
                                      '28.1209',
                                      'Yb3+',
                                      '27.8917',
                                      'Lu',
                                      '28.9476',
                                      'Lu3+',
                                      '28.4628',
                                      'Hf',
                                      '29.144',
                                      'Hf4+',
                                      '28.8131',
                                      'Ta',
                                      '29.2024',
                                      'Ta5+',
                                      '29.1587',
                                      'W',
                                      '29.0818',
                                      'W6+',
                                      '29.4936',
                                      'Re',
                                      '28.7621',
                                      'Os',
                                      '28.1894',
                                      'Os4+',
                                      '30.419',
                                      'Ir',
                                      '27.3049',
                                      'Ir3+',
                                      '30.4156',
                                      'Ir4+',
                                      '30.7058',
                                      'Pt',
                                      '27.0059',
                                      'Pt2+',
                                      '29.8429',
                                      'Pt4+',
                                      '30.9612',
                                      'Au',
                                      '16.8819',
                                      'Au1+',
                                      '28.0109',
                                      'Au3+',
                                      '30.6886',
                                      'Hg',
                                      '20.6809',
                                      'Hg1+',
                                      '25.0853',
                                      'Hg2+',
                                      '29.5641',
                                      'Tl',
                                      '27.5446',
                                      'TL1+',
                                      '21.3985',
                                      'Tl3+',
                                      '30.8695',
                                      'Pb',
                                      '31.0617',
                                      'Pb2+',
                                      '21.7886',
                                      'Pb4+',
                                      '32.1244',
                                      'Bi',
                                      '33.3689',
                                      'Bi3+',
                                      '21.8053',
                                      'Bi5+',
                                      '33.5364',
                                      'Po',
                                      '34.6726',
                                      'At',
                                      '35.3163',
                                      'Rn',
                                      '35.5631',
                                      'Fr',
                                      '35.9299',
                                      'Ra',
                                      '35.7630',
                                      'Ra2+',
                                      '35.2150',
                                      'Ac',
                                      '35.6597',
                                      'Ac3+',
                                      '35.1736',
                                      'Th',
                                      '35.5645',
                                      'Th4+',
                                      '35.1007',
                                      'Pa',
                                      '35.8847',
                                      'U',
                                      '36.0228',
                                      'U3+',
                                      '35.5747',
                                      'U4+',
                                      '35.3715',
                                      'U6+',
                                      '34.8509',
                                      'Np',
                                      '36.1874',
                                      'Np3+',
                                      '35.7074',
                                      'Np4+',
                                      '35.5103',
                                      'Np6+',
                                      '35.0136',
                                      'Pu',
                                      '36.5254',
                                      'Pu3+',
                                      '35.8400',
                                      'Pu4+',
                                      '35.6493',
                                      'Pu6+',
                                      '35.1736',
                                      'Am',
                                      '36.6706',
                                      'Cm',
                                      '36.6488',
                                      'Bk',
                                      '36.7881',
                                      'Cf',
                                      '36.9185' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_a1' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_a2',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_a2' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_a2',
                                      '_atom_type.scat_Cromer_Mann_a2' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.322912',
                                      'D',
                                      '.322912',
                                      'H1-',
                                      '.565616',
                                      'He',
                                      '0.6309',
                                      'Li',
                                      '.7508',
                                      'Li1+',
                                      '.7888',
                                      'Be',
                                      '1.1278',
                                      'Be2+',
                                      '.8849',
                                      'B',
                                      '1.3326',
                                      'C',
                                      '1.02',
                                      'N',
                                      '3.1322',
                                      'O',
                                      '2.2868',
                                      'O1-',
                                      '1.63969',
                                      'F',
                                      '2.6412',
                                      'F1-',
                                      '3.51057',
                                      'Ne',
                                      '3.1125',
                                      'Na',
                                      '3.1736',
                                      'Na1+',
                                      '3.9362',
                                      'Mg',
                                      '2.1735',
                                      'Mg2+',
                                      '3.8378',
                                      'Al',
                                      '1.9002',
                                      'Al3+',
                                      '3.3876',
                                      'Si',
                                      '3.0353',
                                      'Si4+',
                                      '3.20345',
                                      'P',
                                      '4.1791',
                                      'S',
                                      '5.2034',
                                      'Cl',
                                      '7.1964',
                                      'Cl1-',
                                      '7.2084',
                                      'Ar',
                                      '6.6623',
                                      'K',
                                      '7.4398',
                                      'K1+',
                                      '7.4917',
                                      'Ca',
                                      '7.3873',
                                      'Ca2+',
                                      '7.9518',
                                      'Sc',
                                      '7.3679',
                                      'Sc3+',
                                      '8.0273',
                                      'Ti',
                                      '7.3558',
                                      'Ti2+',
                                      '7.62174',
                                      'Ti3+',
                                      '8.73816',
                                      'Ti4+',
                                      '8.23473',
                                      'V',
                                      '7.3511',
                                      'V2+',
                                      '7.3541',
                                      'V3+',
                                      '7.7419',
                                      'V5+',
                                      '8.14208',
                                      'Cr',
                                      '7.3537',
                                      'Cr2+',
                                      '7.7509',
                                      'Cr3+',
                                      '7.81136',
                                      'Mn',
                                      '7.3573',
                                      'Mn2+',
                                      '7.362',
                                      'Mn3+',
                                      '7.87194',
                                      'Mn4+',
                                      '7.97057',
                                      'Fe',
                                      '7.3573',
                                      'Fe2+',
                                      '7.374',
                                      'Fe3+',
                                      '7.3863',
                                      'Co',
                                      '7.3409',
                                      'Co2+',
                                      '7.3883',
                                      'Co3+',
                                      '7.88173',
                                      'Ni',
                                      '7.292',
                                      'Ni2+',
                                      '7.4005',
                                      'Ni3+',
                                      '7.75868',
                                      'Cu',
                                      '7.1676',
                                      'Cu1+',
                                      '7.3573',
                                      'Cu2+',
                                      '7.11181',
                                      'Zn',
                                      '7.0318',
                                      'Zn2+',
                                      '7.3862',
                                      'Ga',
                                      '6.7006',
                                      'Ga3+',
                                      '6.69883',
                                      'Ge',
                                      '6.3747',
                                      'Ge4+',
                                      '6.70003',
                                      'As',
                                      '6.0701',
                                      'Se',
                                      '5.8196',
                                      'Br',
                                      '5.2358',
                                      'Br1-',
                                      '6.3338',
                                      'Kr',
                                      '6.7286',
                                      'Rb',
                                      '9.6435',
                                      'Rb1+',
                                      '7.6598',
                                      'Sr',
                                      '9.8184',
                                      'Sr2+',
                                      '8.1373',
                                      'Y',
                                      '10.2946',
                                      'Y3+',
                                      '9.1531',
                                      'Zr',
                                      '10.948',
                                      'Zr4+',
                                      '10.0562',
                                      'Nb',
                                      '12.0144',
                                      'Nb3+',
                                      '18.0653',
                                      'Nb5+',
                                      '13.3417',
                                      'Mo',
                                      '17.2356',
                                      'Mo3+',
                                      '18.2017',
                                      'Mo5+',
                                      '18.0992',
                                      'Mo6+',
                                      '11.175',
                                      'Tc',
                                      '11.0948',
                                      'Ru',
                                      '12.9182',
                                      'Ru3+',
                                      '13.2885',
                                      'Ru4+',
                                      '13.1787',
                                      'Rh',
                                      '14.3501',
                                      'Rh3+',
                                      '14.1259',
                                      'Rh4+',
                                      '13.9806',
                                      'Pd',
                                      '15.5017',
                                      'Pd2+',
                                      '15.2096',
                                      'Pd4+',
                                      '14.79',
                                      'Ag',
                                      '16.6885',
                                      'Ag1+',
                                      '15.9719',
                                      'Ag2+',
                                      '16.2456',
                                      'Cd',
                                      '17.6444',
                                      'Cd2+',
                                      '17.2535',
                                      'In',
                                      '18.5596',
                                      'In3+',
                                      '18.1108',
                                      'Sn',
                                      '19.1005',
                                      'Sn2+',
                                      '19.0548',
                                      'Sn4+',
                                      '19.7131',
                                      'Sb',
                                      '19.0455',
                                      'Sb3+',
                                      '18.933',
                                      'Sb5+',
                                      '19.0302',
                                      'Te',
                                      '19.0138',
                                      'I',
                                      '18.9949',
                                      'I1-',
                                      '18.997',
                                      'Xe',
                                      '19.0298',
                                      'Cs',
                                      '19.1062',
                                      'Cs1+',
                                      '19.1278',
                                      'Ba',
                                      '19.297',
                                      'Ba2+',
                                      '19.1136',
                                      'La',
                                      '19.599',
                                      'La3+',
                                      '19.3763',
                                      'Ce',
                                      '19.7695',
                                      'Ce3+',
                                      '19.559',
                                      'Ce4+',
                                      '19.8186',
                                      'Pr',
                                      '19.6697',
                                      'Pr3+',
                                      '19.7491',
                                      'Pr4+',
                                      '20.0539',
                                      'Nd',
                                      '19.6847',
                                      'Nd3+',
                                      '19.9339',
                                      'Pm',
                                      '19.6095',
                                      'Sm',
                                      '19.4258',
                                      'Sm3+',
                                      '20.2599',
                                      'Eu',
                                      '19.0886',
                                      'Eu2+',
                                      '19.9504',
                                      'Eu3+',
                                      '20.3745',
                                      'Gd',
                                      '19.0798',
                                      'Gd3+',
                                      '20.4208',
                                      'Tb',
                                      '18.2185',
                                      'Tb3+',
                                      '20.3271',
                                      'Dy',
                                      '17.6383',
                                      'Dy3+',
                                      '20.2861',
                                      'Ho',
                                      '17.294',
                                      'Ho3+',
                                      '20.0994',
                                      'Er',
                                      '16.4285',
                                      'Er3+',
                                      '19.7748',
                                      'Tm',
                                      '15.8851',
                                      'Tm3+',
                                      '19.332',
                                      'Yb',
                                      '15.4345',
                                      'Yb2+',
                                      '17.6817',
                                      'Yb3+',
                                      '18.7614',
                                      'Lu',
                                      '15.2208',
                                      'Lu3+',
                                      '18.121',
                                      'Hf',
                                      '15.1726',
                                      'Hf4+',
                                      '18.4601',
                                      'Ta',
                                      '15.2293',
                                      'Ta5+',
                                      '18.8407',
                                      'W',
                                      '15.43',
                                      'W6+',
                                      '19.3763',
                                      'Re',
                                      '15.7189',
                                      'Os',
                                      '16.155',
                                      'Os4+',
                                      '15.2637',
                                      'Ir',
                                      '16.7296',
                                      'Ir3+',
                                      '15.862',
                                      'Ir4+',
                                      '15.5512',
                                      'Pt',
                                      '17.7639',
                                      'Pt2+',
                                      '16.7224',
                                      'Pt4+',
                                      '15.9829',
                                      'Au',
                                      '18.5913',
                                      'Au1+',
                                      '17.8204',
                                      'Au3+',
                                      '16.9029',
                                      'Hg',
                                      '19.0417',
                                      'Hg1+',
                                      '18.4973',
                                      'Hg2+',
                                      '18.06',
                                      'Tl',
                                      '19.1584',
                                      'TL1+',
                                      '20.4723',
                                      'Tl3+',
                                      '18.3841',
                                      'Pb',
                                      '13.0637',
                                      'Pb2+',
                                      '19.5682',
                                      'Pb4+',
                                      '18.8003',
                                      'Bi',
                                      '12.951',
                                      'Bi3+',
                                      '19.5026',
                                      'Bi5+',
                                      '25.0946',
                                      'Po',
                                      '15.4733',
                                      'At',
                                      '19.0211',
                                      'Rn',
                                      '21.2816',
                                      'Fr',
                                      '23.0547',
                                      'Ra',
                                      '22.9064',
                                      'Ra2+',
                                      '21.6700',
                                      'Ac',
                                      '23.1032',
                                      'Ac3+',
                                      '22.1112',
                                      'Th',
                                      '23.4219',
                                      'Th4+',
                                      '22.4418',
                                      'Pa',
                                      '23.2948',
                                      'U',
                                      '23.4128',
                                      'U3+',
                                      '22.5259',
                                      'U4+',
                                      '22.5326',
                                      'U6+',
                                      '22.7584',
                                      'Np',
                                      '23.5964',
                                      'Np3+',
                                      '22.6130',
                                      'Np4+',
                                      '22.5787',
                                      'Np6+',
                                      '22.7286',
                                      'Pu',
                                      '23.8083',
                                      'Pu3+',
                                      '22.7169',
                                      'Pu4+',
                                      '22.6460',
                                      'Pu6+',
                                      '22.7181',
                                      'Am',
                                      '24.0992',
                                      'Cm',
                                      '24.4096',
                                      'Bk',
                                      '24.7736',
                                      'Cf',
                                      '25.1995' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_a2' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_a3',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_a3' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_a3',
                                      '_atom_type.scat_Cromer_Mann_a3' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.140191',
                                      'D',
                                      '.140191',
                                      'H1-',
                                      '.415815',
                                      'He',
                                      '0.3112',
                                      'Li',
                                      '.6175',
                                      'Li1+',
                                      '.3414',
                                      'Be',
                                      '.5391',
                                      'Be2+',
                                      '.7993',
                                      'B',
                                      '1.0979',
                                      'C',
                                      '1.5886',
                                      'N',
                                      '2.0125',
                                      'O',
                                      '1.5463',
                                      'O1-',
                                      '1.52673',
                                      'F',
                                      '1.517',
                                      'F1-',
                                      '1.26064',
                                      'Ne',
                                      '1.4546',
                                      'Na',
                                      '1.2674',
                                      'Na1+',
                                      '1.3998',
                                      'Mg',
                                      '1.2269',
                                      'Mg2+',
                                      '1.3284',
                                      'Al',
                                      '1.5936',
                                      'Al3+',
                                      '1.20296',
                                      'Si',
                                      '1.9891',
                                      'Si4+',
                                      '1.19453',
                                      'P',
                                      '1.78',
                                      'S',
                                      '1.4379',
                                      'Cl',
                                      '6.2556',
                                      'Cl1-',
                                      '6.5337',
                                      'Ar',
                                      '0.6539',
                                      'K',
                                      '1.0519',
                                      'K1+',
                                      '6.359',
                                      'Ca',
                                      '1.5899',
                                      'Ca2+',
                                      '8.4372',
                                      'Sc',
                                      '1.6409',
                                      'Sc3+',
                                      '1.65943',
                                      'Ti',
                                      '1.6991',
                                      'Ti2+',
                                      '2.2793',
                                      'Ti3+',
                                      '5.25691',
                                      'Ti4+',
                                      '2.01341',
                                      'V',
                                      '2.0703',
                                      'V2+',
                                      '2.2884',
                                      'V3+',
                                      '2.15343',
                                      'V5+',
                                      '2.03081',
                                      'Cr',
                                      '3.324',
                                      'Cr2+',
                                      '3.58274',
                                      'Cr3+',
                                      '2.87603',
                                      'Mn',
                                      '3.0193',
                                      'Mn2+',
                                      '3.5268',
                                      'Mn3+',
                                      '3.56531',
                                      'Mn4+',
                                      '2.76067',
                                      'Fe',
                                      '3.5222',
                                      'Fe2+',
                                      '4.1346',
                                      'Fe3+',
                                      '3.3948',
                                      'Co',
                                      '4.0034',
                                      'Co2+',
                                      '4.7393',
                                      'Co3+',
                                      '4.76795',
                                      'Ni',
                                      '4.4438',
                                      'Ni2+',
                                      '5.3442',
                                      'Ni3+',
                                      '5.22746',
                                      'Cu',
                                      '5.6158',
                                      'Cu1+',
                                      '6.2455',
                                      'Cu2+',
                                      '5.78135',
                                      'Zn',
                                      '5.1652',
                                      'Zn2+',
                                      '6.4668',
                                      'Ga',
                                      '4.3591',
                                      'Ga3+',
                                      '6.06692',
                                      'Ge',
                                      '3.7068',
                                      'Ge4+',
                                      '6.06791',
                                      'As',
                                      '3.4313',
                                      'Se',
                                      '3.9731',
                                      'Br',
                                      '5.6377',
                                      'Br1-',
                                      '5.5754',
                                      'Kr',
                                      '5.5493',
                                      'Rb',
                                      '5.1399',
                                      'Rb1+',
                                      '5.8981',
                                      'Sr',
                                      '5.422',
                                      'Sr2+',
                                      '2.5654',
                                      'Y',
                                      '5.72629',
                                      'Y3+',
                                      '1.76795',
                                      'Zr',
                                      '5.41732',
                                      'Zr4+',
                                      '1.01118',
                                      'Nb',
                                      '4.04183',
                                      'Nb3+',
                                      '11.0177',
                                      'Nb5+',
                                      '10.799',
                                      'Mo',
                                      '12.8876',
                                      'Mo3+',
                                      '11.7423',
                                      'Mo5+',
                                      '11.4632',
                                      'Mo6+',
                                      '6.57891',
                                      'Tc',
                                      '4.64901',
                                      'Ru',
                                      '4.86337',
                                      'Ru3+',
                                      '9.32602',
                                      'Ru4+',
                                      '4.71304',
                                      'Rh',
                                      '4.73425',
                                      'Rh3+',
                                      '3.32515',
                                      'Rh4+',
                                      '2.53464',
                                      'Pd',
                                      '5.29537',
                                      'Pd2+',
                                      '4.32234',
                                      'Pd4+',
                                      '2.89289',
                                      'Ag',
                                      '4.8045',
                                      'Ag1+',
                                      '5.27475',
                                      'Ag2+',
                                      '4.3709',
                                      'Cd',
                                      '4.461',
                                      'Cd2+',
                                      '4.47128',
                                      'In',
                                      '4.2948',
                                      'In3+',
                                      '3.78897',
                                      'Sn',
                                      '4.4585',
                                      'Sn2+',
                                      '4.5648',
                                      'Sn4+',
                                      '3.4182',
                                      'Sb',
                                      '5.0371',
                                      'Sb3+',
                                      '5.10789',
                                      'Sb5+',
                                      '2.41253',
                                      'Te',
                                      '6.14487',
                                      'I',
                                      '7.5138',
                                      'I1-',
                                      '7.8069',
                                      'Xe',
                                      '8.9767',
                                      'Cs',
                                      '10.662',
                                      'Cs1+',
                                      '10.2821',
                                      'Ba',
                                      '10.888',
                                      'Ba2+',
                                      '10.9054',
                                      'La',
                                      '11.3727',
                                      'La3+',
                                      '11.6323',
                                      'Ce',
                                      '11.8513',
                                      'Ce3+',
                                      '11.9369',
                                      'Ce4+',
                                      '12.1233',
                                      'Pr',
                                      '12.3856',
                                      'Pr3+',
                                      '12.1329',
                                      'Pr4+',
                                      '12.4668',
                                      'Nd',
                                      '12.774',
                                      'Nd3+',
                                      '12.12',
                                      'Pm',
                                      '13.1235',
                                      'Sm',
                                      '13.4396',
                                      'Sm3+',
                                      '11.9202',
                                      'Eu',
                                      '13.7603',
                                      'Eu2+',
                                      '11.8034',
                                      'Eu3+',
                                      '11.8509',
                                      'Gd',
                                      '13.8518',
                                      'Gd3+',
                                      '11.8708',
                                      'Tb',
                                      '14.3167',
                                      'Tb3+',
                                      '12.2471',
                                      'Dy',
                                      '14.5596',
                                      'Dy3+',
                                      '11.9812',
                                      'Ho',
                                      '14.5583',
                                      'Ho3+',
                                      '11.9788',
                                      'Er',
                                      '14.9779',
                                      'Er3+',
                                      '12.1506',
                                      'Tm',
                                      '15.1542',
                                      'Tm3+',
                                      '12.3339',
                                      'Yb',
                                      '15.3087',
                                      'Yb2+',
                                      '13.3335',
                                      'Yb3+',
                                      '12.6072',
                                      'Lu',
                                      '15.1',
                                      'Lu3+',
                                      '12.8429',
                                      'Hf',
                                      '14.7586',
                                      'Hf4+',
                                      '12.7285',
                                      'Ta',
                                      '14.5135',
                                      'Ta5+',
                                      '12.8268',
                                      'W',
                                      '14.4327',
                                      'W6+',
                                      '13.0544',
                                      'Re',
                                      '14.5564',
                                      'Os',
                                      '14.9305',
                                      'Os4+',
                                      '14.7458',
                                      'Ir',
                                      '15.6115',
                                      'Ir3+',
                                      '13.6145',
                                      'Ir4+',
                                      '14.2326',
                                      'Pt',
                                      '15.7131',
                                      'Pt2+',
                                      '13.2153',
                                      'Pt4+',
                                      '13.7348',
                                      'Au',
                                      '25.5582',
                                      'Au1+',
                                      '14.3359',
                                      'Au3+',
                                      '12.7801',
                                      'Hg',
                                      '21.6575',
                                      'Hg1+',
                                      '16.8883',
                                      'Hg2+',
                                      '12.8374',
                                      'Tl',
                                      '15.538',
                                      'TL1+',
                                      '18.7478',
                                      'Tl3+',
                                      '11.9328',
                                      'Pb',
                                      '18.442',
                                      'Pb2+',
                                      '19.1406',
                                      'Pb4+',
                                      '12.0175',
                                      'Bi',
                                      '16.5877',
                                      'Bi3+',
                                      '19.1053',
                                      'Bi5+',
                                      '19.2497',
                                      'Po',
                                      '13.1138',
                                      'At',
                                      '9.49887',
                                      'Rn',
                                      '8.0037',
                                      'Fr',
                                      '12.1439',
                                      'Ra',
                                      '12.4739',
                                      'Ra2+',
                                      '7.91342',
                                      'Ac',
                                      '12.5977',
                                      'Ac3+',
                                      '8.19216',
                                      'Th',
                                      '12.7473',
                                      'Th4+',
                                      '9.78554',
                                      'Pa',
                                      '14.1891',
                                      'U',
                                      '14.9491',
                                      'U3+',
                                      '12.2165',
                                      'U4+',
                                      '12.0291',
                                      'U6+',
                                      '14.0099',
                                      'Np',
                                      '15.6402',
                                      'Np3+',
                                      '12.9898',
                                      'Np4+',
                                      '12.7766',
                                      'Np6+',
                                      '14.3884',
                                      'Pu',
                                      '16.7707',
                                      'Pu3+',
                                      '13.5807',
                                      'Pu4+',
                                      '13.3595',
                                      'Pu6+',
                                      '14.7635',
                                      'Am',
                                      '17.3415',
                                      'Cm',
                                      '17.3990',
                                      'Bk',
                                      '17.8919',
                                      'Cf',
                                      '18.3317' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_a3' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_a4',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_a4' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_a4',
                                      '_atom_type.scat_Cromer_Mann_a4' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.04081',
                                      'D',
                                      '.04081',
                                      'H1-',
                                      '.116973',
                                      'He',
                                      '0.178',
                                      'Li',
                                      '.4653',
                                      'Li1+',
                                      '.1563',
                                      'Be',
                                      '.7029',
                                      'Be2+',
                                      '.1647',
                                      'B',
                                      '.7068',
                                      'C',
                                      '.865',
                                      'N',
                                      '1.1663',
                                      'O',
                                      '.867',
                                      'O1-',
                                      '-20.307',
                                      'F',
                                      '1.0243',
                                      'F1-',
                                      '.940706',
                                      'Ne',
                                      '1.1251',
                                      'Na',
                                      '1.1128',
                                      'Na1+',
                                      '1.0032',
                                      'Mg',
                                      '2.3073',
                                      'Mg2+',
                                      '.8497',
                                      'Al',
                                      '1.9646',
                                      'Al3+',
                                      '.528137',
                                      'Si',
                                      '1.541',
                                      'Si4+',
                                      '.41653',
                                      'P',
                                      '1.4908',
                                      'S',
                                      '1.5863',
                                      'Cl',
                                      '1.6455',
                                      'Cl1-',
                                      '2.3386',
                                      'Ar',
                                      '1.6442',
                                      'K',
                                      '.8659',
                                      'K1+',
                                      '1.1915',
                                      'Ca',
                                      '1.0211',
                                      'Ca2+',
                                      '.8537',
                                      'Sc',
                                      '1.468',
                                      'Sc3+',
                                      '1.57936',
                                      'Ti',
                                      '1.9021',
                                      'Ti2+',
                                      '.087899',
                                      'Ti3+',
                                      '1.92134',
                                      'Ti4+',
                                      '1.5208',
                                      'V',
                                      '2.0571',
                                      'V2+',
                                      '.0223',
                                      'V3+',
                                      '.016865',
                                      'V5+',
                                      '-9.576',
                                      'Cr',
                                      '1.4922',
                                      'Cr2+',
                                      '.509107',
                                      'Cr3+',
                                      '.113575',
                                      'Mn',
                                      '2.2441',
                                      'Mn2+',
                                      '.2184',
                                      'Mn3+',
                                      '.323613',
                                      'Mn4+',
                                      '.054447',
                                      'Fe',
                                      '2.3045',
                                      'Fe2+',
                                      '.4399',
                                      'Fe3+',
                                      '.0724',
                                      'Co',
                                      '2.3488',
                                      'Co2+',
                                      '.7108',
                                      'Co3+',
                                      '.725591',
                                      'Ni',
                                      '2.38',
                                      'Ni2+',
                                      '.9773',
                                      'Ni3+',
                                      '.847114',
                                      'Cu',
                                      '1.6735',
                                      'Cu1+',
                                      '1.5578',
                                      'Cu+',
                                      '1.14523',
                                      'Zn',
                                      '2.41',
                                      'Zn2+',
                                      '1.394',
                                      'Ga',
                                      '2.9623',
                                      'Ga3+',
                                      '1.0066',
                                      'Ge',
                                      '3.683',
                                      'Ge4+',
                                      '.859041',
                                      'As',
                                      '4.2779',
                                      'Se',
                                      '4.3543',
                                      'Br',
                                      '3.9851',
                                      'Br1-',
                                      '3.7272',
                                      'Kr',
                                      '3.5375',
                                      'Rb',
                                      '1.5292',
                                      'Rb1+',
                                      '2.7817',
                                      'Sr',
                                      '2.6694',
                                      'Sr2+',
                                      '-34.193',
                                      'Y',
                                      '3.26588',
                                      'Y3+',
                                      '-33.108',
                                      'Zr',
                                      '3.65721',
                                      'Zr4+',
                                      '-2.6479',
                                      'Nb',
                                      '3.53346',
                                      'Nb3+',
                                      '1.94715',
                                      'Nb5+',
                                      '.337905',
                                      'Mo',
                                      '3.7429',
                                      'Mo3+',
                                      '2.30951',
                                      'Mo5+',
                                      '.740625',
                                      'Mo6+',
                                      '0.',
                                      'Tc',
                                      '2.71263',
                                      'Ru',
                                      '1.56756',
                                      'Ru3+',
                                      '3.00964',
                                      'Ru4+',
                                      '2.18535',
                                      'Rh',
                                      '1.28918',
                                      'Rh3+',
                                      '-6.1989',
                                      'Rh4+',
                                      '-5.6526',
                                      'Pd',
                                      '.605844',
                                      'Pd2+',
                                      '0.',
                                      'Pd4+',
                                      '-7.9492',
                                      'Ag',
                                      '1.0463',
                                      'Ag1+',
                                      '.357534',
                                      'Ag2+',
                                      '0.',
                                      'Cd',
                                      '1.6029',
                                      'Cd2+',
                                      '0.',
                                      'In',
                                      '2.0396',
                                      'In3+',
                                      '0.',
                                      'Sn',
                                      '2.4663',
                                      'Sn2+',
                                      '.487',
                                      'Sn4+',
                                      '.0193',
                                      'Sb',
                                      '2.6827',
                                      'Sb3+',
                                      '.288753',
                                      'Sb5+',
                                      '0.',
                                      'Te',
                                      '2.5239',
                                      'I',
                                      '2.2735',
                                      'I1-',
                                      '2.8868',
                                      'Xe',
                                      '1.99',
                                      'Cs',
                                      '1.4953',
                                      'Cs1+',
                                      '.9615',
                                      'Ba',
                                      '2.6959',
                                      'Ba2+',
                                      '.773634',
                                      'La',
                                      '3.28719',
                                      'La3+',
                                      '.336048',
                                      'Ce',
                                      '3.33049',
                                      'Ce3+',
                                      '.612376',
                                      'Ce4+',
                                      '.144583',
                                      'Pr',
                                      '2.82428',
                                      'Pr3+',
                                      '.97518',
                                      'Pr4+',
                                      '.296689',
                                      'Nd',
                                      '2.85137',
                                      'Nd3+',
                                      '1.51031',
                                      'Pm',
                                      '2.87516',
                                      'Sm',
                                      '2.89604',
                                      'Sm3+',
                                      '2.71488',
                                      'Eu',
                                      '2.9227',
                                      'Eu2+',
                                      '3.87243',
                                      'Eu3+',
                                      '3.26503',
                                      'Gd',
                                      '3.54545',
                                      'Gd3+',
                                      '3.7149',
                                      'Tb',
                                      '2.95354',
                                      'Tb3+',
                                      '3.773',
                                      'Dy',
                                      '2.96577',
                                      'Dy3+',
                                      '4.50073',
                                      'Ho',
                                      '3.63837',
                                      'Ho3+',
                                      '4.93676',
                                      'Er',
                                      '2.98233',
                                      'Er3+',
                                      '5.17379',
                                      'Tm',
                                      '2.98706',
                                      'Tm3+',
                                      '5.38348',
                                      'Yb',
                                      '2.98963',
                                      'Yb2+',
                                      '5.14657',
                                      'Yb3+',
                                      '5.47647',
                                      'Lu',
                                      '3.71601',
                                      'Lu3+',
                                      '5.59415',
                                      'Hf',
                                      '4.30013',
                                      'Hf4+',
                                      '5.59927',
                                      'Ta',
                                      '4.76492',
                                      'Ta5+',
                                      '5.38695',
                                      'W',
                                      '5.11982',
                                      'W6+',
                                      '5.06412',
                                      'Re',
                                      '5.44174',
                                      'Os',
                                      '5.67589',
                                      'Os4+',
                                      '5.06795',
                                      'Ir',
                                      '5.83377',
                                      'Ir3+',
                                      '5.82008',
                                      'Ir4+',
                                      '5.53672',
                                      'Pt',
                                      '5.7837',
                                      'Pt2+',
                                      '6.35234',
                                      'Pt4+',
                                      '5.92034',
                                      'Au',
                                      '5.86',
                                      'Au1+',
                                      '6.58077',
                                      'Au3+',
                                      '6.52354',
                                      'Hg',
                                      '5.9676',
                                      'Hg1+',
                                      '6.48216',
                                      'Hg2+',
                                      '6.89912',
                                      'Tl',
                                      '5.52593',
                                      'TL1+',
                                      '6.82847',
                                      'Tl3+',
                                      '7.00574',
                                      'Pb',
                                      '5.9696',
                                      'Pb2+',
                                      '7.01107',
                                      'Pb4+',
                                      '6.96886',
                                      'Bi',
                                      '6.4692',
                                      'Bi3+',
                                      '7.10295',
                                      'Bi5+',
                                      '6.91555',
                                      'Po',
                                      '7.02588',
                                      'At',
                                      '7.42518',
                                      'Rn',
                                      '7.4433',
                                      'Fr',
                                      '2.11253',
                                      'Ra',
                                      '3.21097',
                                      'Ra2+',
                                      '7.65078',
                                      'Ac',
                                      '4.08655',
                                      'Ac3+',
                                      '7.05545',
                                      'Th',
                                      '4.80703',
                                      'Th4+',
                                      '5.29444',
                                      'Pa',
                                      '4.17287',
                                      'U',
                                      '4.1880',
                                      'U3+',
                                      '5.37073',
                                      'U4+',
                                      '4.79840',
                                      'U6+',
                                      '1.21457',
                                      'Np',
                                      '4.18550',
                                      'Np3+',
                                      '5.43227',
                                      'Np4+',
                                      '4.92159',
                                      'Np6+',
                                      '1.75669',
                                      'Pu',
                                      '3.47947',
                                      'Pu3+',
                                      '5.66016',
                                      'Pu4+',
                                      '5.18831',
                                      'Pu6+',
                                      '2.28678',
                                      'Am',
                                      '3.49331',
                                      'Cm',
                                      '4.21665',
                                      'Bk',
                                      '4.23284',
                                      'Cf',
                                      '4.24391' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_a4' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_b1',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_b1' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_b1',
                                      '_atom_type.scat_Cromer_Mann_b1' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '10.5109',
                                      'D',
                                      '10.5109',
                                      'H1-',
                                      '53.1368',
                                      'He',
                                      '9.1037',
                                      'Li',
                                      '3.9546',
                                      'Li1+',
                                      '4.6237',
                                      'Be',
                                      '43.6427',
                                      'Be2+',
                                      '.0027',
                                      'B',
                                      '23.2185',
                                      'C',
                                      '20.8439',
                                      'N',
                                      '.0057',
                                      'O',
                                      '13.2771',
                                      'O1-',
                                      '12.8573',
                                      'F',
                                      '10.2825',
                                      'F1-',
                                      '5.27756',
                                      'Ne',
                                      '8.4042',
                                      'Na',
                                      '3.285',
                                      'Na1+',
                                      '2.6671',
                                      'Mg',
                                      '2.8275',
                                      'Mg2+',
                                      '2.1676',
                                      'Al',
                                      '3.0387',
                                      'Al3+',
                                      '1.93816',
                                      'Si',
                                      '2.4386',
                                      'Si4+',
                                      '1.64167',
                                      'P',
                                      '1.9067',
                                      'S',
                                      '1.4679',
                                      'Cl',
                                      '.0104',
                                      'Cl1-',
                                      '.0066',
                                      'Ar',
                                      '0.9072',
                                      'K',
                                      '12.7949',
                                      'K1+',
                                      '12.6331',
                                      'Ca',
                                      '10.4421',
                                      'Ca2+',
                                      '-.0074',
                                      'Sc',
                                      '9.0213',
                                      'Sc3+',
                                      '.29854',
                                      'Ti',
                                      '7.8508',
                                      'Ti2+',
                                      '7.5243',
                                      'Ti3+',
                                      '.22061',
                                      'Ti4+',
                                      '.178847',
                                      'V',
                                      '6.8657',
                                      'V2+',
                                      '6.8818',
                                      'V3+',
                                      '6.39535',
                                      'V5+',
                                      '.679003',
                                      'Cr',
                                      '6.1038',
                                      'Cr2+',
                                      '5.66078',
                                      'Cr3+',
                                      '5.59463',
                                      'Mn',
                                      '5.3409',
                                      'Mn2+',
                                      '5.2796',
                                      'Mn3+',
                                      '4.91797',
                                      'Mn4+',
                                      '4.8485',
                                      'Fe',
                                      '4.7611',
                                      'Fe2+',
                                      '4.6538',
                                      'Fe3+',
                                      '4.6147',
                                      'Co',
                                      '4.2791',
                                      'Co2+',
                                      '4.1231',
                                      'Co3+',
                                      '3.90969',
                                      'Ni',
                                      '3.8785',
                                      'Ni2+',
                                      '3.6766',
                                      'Ni3+',
                                      '3.5477',
                                      'Cu',
                                      '3.5828',
                                      'Cu1+',
                                      '3.3669',
                                      'Cu2+',
                                      '3.37484',
                                      'Zn',
                                      '3.2655',
                                      'Zn2+',
                                      '2.9946',
                                      'Ga',
                                      '3.0669',
                                      'Ga3+',
                                      '2.81262',
                                      'Ge',
                                      '2.8509',
                                      'Ge4+',
                                      '2.53718',
                                      'As',
                                      '2.6345',
                                      'Se',
                                      '2.4098',
                                      'Br',
                                      '2.1723',
                                      'Br1-',
                                      '2.2059',
                                      'Kr',
                                      '1.9384',
                                      'Rb',
                                      '1.7888',
                                      'Rb1+',
                                      '1.7139',
                                      'Sr',
                                      '1.5564',
                                      'Sr2+',
                                      '1.4907',
                                      'Y',
                                      '1.4029',
                                      'Y3+',
                                      '1.35417',
                                      'Zr',
                                      '1.27618',
                                      'Zr4+',
                                      '1.2148',
                                      'Nb',
                                      '1.18865',
                                      'Nb3+',
                                      '.019175',
                                      'Nb5+',
                                      '1.12446',
                                      'Mo',
                                      '.2772',
                                      'Mo3+',
                                      '.014734',
                                      'Mo5+',
                                      '.014345',
                                      'Mo6+',
                                      '1.03649',
                                      'Tc',
                                      '.864132',
                                      'Ru',
                                      '.80852',
                                      'Ru3+',
                                      '.847329',
                                      'Ru4+',
                                      '.844582',
                                      'Rh',
                                      '.751536',
                                      'Rh3+',
                                      '.764252',
                                      'Rh4+',
                                      '.760825',
                                      'Pd',
                                      '.698655',
                                      'Pd2+',
                                      '.696219',
                                      'Pd4+',
                                      '.683839',
                                      'Ag',
                                      '.6446',
                                      'Ag1+',
                                      '.646179',
                                      'Ag2+',
                                      '.645643',
                                      'Cd',
                                      '.5946',
                                      'Cd2+',
                                      '.597922',
                                      'In',
                                      '.5476',
                                      'In3+',
                                      '.551522',
                                      'Sn',
                                      '5.8303',
                                      'Sn2+',
                                      '.5036',
                                      'Sn4+',
                                      '5.764',
                                      'Sb',
                                      '5.3034',
                                      'Sb3+',
                                      '.467196',
                                      'Sb5+',
                                      '5.44853',
                                      'Te',
                                      '4.81742',
                                      'I',
                                      '4.347',
                                      'I1-',
                                      '4.3579',
                                      'Xe',
                                      '3.9282',
                                      'Cs',
                                      '3.569',
                                      'Cs1+',
                                      '3.552',
                                      'Ba',
                                      '3.216',
                                      'Ba2+',
                                      '3.21367',
                                      'La',
                                      '2.94817',
                                      'La3+',
                                      '2.9207',
                                      'Ce',
                                      '2.81219',
                                      'Ce3+',
                                      '2.77691',
                                      'Ce4+',
                                      '2.65941',
                                      'Pr',
                                      '2.77393',
                                      'Pr3+',
                                      '2.6452',
                                      'Pr4+',
                                      '2.54467',
                                      'Nd',
                                      '2.66248',
                                      'Nd3+',
                                      '2.52722',
                                      'Pm',
                                      '2.5627',
                                      'Sm',
                                      '2.47274',
                                      'Sm3+',
                                      '2.31641',
                                      'Eu',
                                      '2.3879',
                                      'Eu2+',
                                      '2.27783',
                                      'Eu3+',
                                      '2.22258',
                                      'Gd',
                                      '2.25341',
                                      'Gd3+',
                                      '2.13553',
                                      'Tb',
                                      '2.24256',
                                      'Tb3+',
                                      '2.05601',
                                      'Dy',
                                      '2.1802',
                                      'Dy3+',
                                      '1.9804',
                                      'Ho',
                                      '2.07051',
                                      'Ho3+',
                                      '1.91072',
                                      'Er',
                                      '2.07356',
                                      'Er3+',
                                      '1.84659',
                                      'Tm',
                                      '2.02859',
                                      'Tm3+',
                                      '1.78711',
                                      'Yb',
                                      '1.9889',
                                      'Yb2+',
                                      '1.78503',
                                      'Yb3+',
                                      '1.73272',
                                      'Lu',
                                      '1.90182',
                                      'Lu3+',
                                      '1.68216',
                                      'Hf',
                                      '1.83262',
                                      'Hf4+',
                                      '1.59136',
                                      'Ta',
                                      '1.77333',
                                      'Ta5+',
                                      '1.50711',
                                      'W',
                                      '1.72029',
                                      'W6+',
                                      '1.42755',
                                      'Re',
                                      '1.67191',
                                      'Os',
                                      '1.62903',
                                      'Os4+',
                                      '1.37113',
                                      'Ir',
                                      '1.59279',
                                      'Ir3+',
                                      '1.34323',
                                      'Ir4+',
                                      '1.30923',
                                      'Pt',
                                      '1.51293',
                                      'Pt2+',
                                      '1.32927',
                                      'Pt4+',
                                      '1.24813',
                                      'Au',
                                      '.4611',
                                      'Au1+',
                                      '1.35321',
                                      'Au3+',
                                      '1.2199',
                                      'Hg',
                                      '.545',
                                      'Hg1+',
                                      '1.39507',
                                      'Hg2+',
                                      '1.21152',
                                      'Tl',
                                      '.65515',
                                      'TL1+',
                                      '1.4711',
                                      'Tl3+',
                                      '1.1008',
                                      'Pb',
                                      '.6902',
                                      'Pb2+',
                                      '1.3366',
                                      'Pb4+',
                                      '1.00566',
                                      'Bi',
                                      '.704',
                                      'Bi3+',
                                      '1.2356',
                                      'Bi5+',
                                      '.91654',
                                      'Po',
                                      '.700999',
                                      'At',
                                      '.685870',
                                      'Rn',
                                      '.6631',
                                      'Fr',
                                      '.646453',
                                      'Ra',
                                      '.616341',
                                      'Ra2+',
                                      '.604909',
                                      'Ac',
                                      '.589092',
                                      'Ac3+',
                                      '.579689',
                                      'Th',
                                      '.563359',
                                      'Th4+',
                                      '.555054',
                                      'Pa',
                                      '.547751',
                                      'U',
                                      '.5293',
                                      'U3+',
                                      '.520480',
                                      'U4+',
                                      '.516598',
                                      'U6+',
                                      '.507079',
                                      'Np',
                                      '.511929',
                                      'Np3+',
                                      '.502322',
                                      'Np4+',
                                      '.498626',
                                      'Np6+',
                                      '.489810',
                                      'Pu',
                                      '.499384',
                                      'Pu3+',
                                      '.484938',
                                      'Pu4+',
                                      '.481422',
                                      'Pu6+',
                                      '.473204',
                                      'Am',
                                      '.483629',
                                      'Cm',
                                      '.465154',
                                      'Bk',
                                      '.451018',
                                      'Cf',
                                      '.437533' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_b1' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_b2',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_b2' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_b2',
                                      '_atom_type.scat_Cromer_Mann_b2' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '26.1257',
                                      'D',
                                      '26.1257',
                                      'H1-',
                                      '15.187',
                                      'He',
                                      '3.3568',
                                      'Li',
                                      '1.0524',
                                      'Li1+',
                                      '1.9557',
                                      'Be',
                                      '1.8623',
                                      'Be2+',
                                      '.8313',
                                      'B',
                                      '1.021',
                                      'C',
                                      '10.2075',
                                      'N',
                                      '9.8933',
                                      'O',
                                      '5.7011',
                                      'O1-',
                                      '4.17236',
                                      'F',
                                      '4.2944',
                                      'F1-',
                                      '14.7353',
                                      'Ne',
                                      '3.4262',
                                      'Na',
                                      '8.8422',
                                      'Na1+',
                                      '6.1153',
                                      'Mg',
                                      '79.2611',
                                      'Mg2+',
                                      '4.7542',
                                      'Al',
                                      '.7426',
                                      'Al3+',
                                      '4.14553',
                                      'Si',
                                      '32.3337',
                                      'Si4+',
                                      '3.43757',
                                      'P',
                                      '27.157',
                                      'S',
                                      '22.2151',
                                      'Cl',
                                      '1.1662',
                                      'Cl1-',
                                      '1.1717',
                                      'Ar',
                                      '14.8407',
                                      'K',
                                      '.7748',
                                      'K1+',
                                      '.7674',
                                      'Ca',
                                      '.6599',
                                      'Ca2+',
                                      '.6089',
                                      'Sc',
                                      '.5729',
                                      'Sc3+',
                                      '7.9629',
                                      'Ti',
                                      '.5',
                                      'Ti2+',
                                      '.457585',
                                      'Ti3+',
                                      '7.04716',
                                      'Ti4+',
                                      '6.67018',
                                      'V',
                                      '.4385',
                                      'V2+',
                                      '.4409',
                                      'V3+',
                                      '.383349',
                                      'V5+',
                                      '5.40135',
                                      'Cr',
                                      '.392',
                                      'Cr2+',
                                      '.344261',
                                      'Cr3+',
                                      '.334393',
                                      'Mn',
                                      '.3432',
                                      'Mn2+',
                                      '.3435',
                                      'Mn3+',
                                      '.294393',
                                      'Mn4+',
                                      '.283303',
                                      'Fe',
                                      '.3072',
                                      'Fe2+',
                                      '.3053',
                                      'Fe3+',
                                      '.3005',
                                      'Co',
                                      '.2784',
                                      'Co2+',
                                      '.2726',
                                      'Co3+',
                                      '.238668',
                                      'Ni',
                                      '.2565',
                                      'Ni2+',
                                      '.2449',
                                      'Ni3+',
                                      '.22314',
                                      'Cu',
                                      '.247',
                                      'Cu1+',
                                      '.2274',
                                      'Cu2+',
                                      '.244078',
                                      'Zn',
                                      '.2333',
                                      'Zn2+',
                                      '.2031',
                                      'Ga',
                                      '.2412',
                                      'Ga3+',
                                      '.22789',
                                      'Ge',
                                      '.2516',
                                      'Ge4+',
                                      '.205855',
                                      'As',
                                      '.2647',
                                      'Se',
                                      '.2726',
                                      'Br',
                                      '16.5796',
                                      'Br1-',
                                      '19.3345',
                                      'Kr',
                                      '16.5623',
                                      'Rb',
                                      '17.3151',
                                      'Rb1+',
                                      '14.7957',
                                      'Sr',
                                      '14.0988',
                                      'Sr2+',
                                      '12.6963',
                                      'Y',
                                      '12.8006',
                                      'Y3+',
                                      '11.2145',
                                      'Zr',
                                      '11.916',
                                      'Zr4+',
                                      '10.1483',
                                      'Nb',
                                      '11.766',
                                      'Nb3+',
                                      '1.13305',
                                      'Nb5+',
                                      '.028781',
                                      'Mo',
                                      '1.0958',
                                      'Mo3+',
                                      '1.03031',
                                      'Mo5+',
                                      '1.02238',
                                      'Mo6+',
                                      '8.48061',
                                      'Tc',
                                      '8.14487',
                                      'Ru',
                                      '8.43467',
                                      'Ru3+',
                                      '8.37164',
                                      'Ru4+',
                                      '8.12534',
                                      'Rh',
                                      '8.21758',
                                      'Rh3+',
                                      '7.84438',
                                      'Rh4+',
                                      '7.62436',
                                      'Pd',
                                      '7.98929',
                                      'Pd2+',
                                      '7.55573',
                                      'Pd4+',
                                      '7.14833',
                                      'Ag',
                                      '7.4726',
                                      'Ag1+',
                                      '7.19123',
                                      'Ag2+',
                                      '7.18544',
                                      'Cd',
                                      '6.9089',
                                      'Cd2+',
                                      '6.80639',
                                      'In',
                                      '6.3776',
                                      'In3+',
                                      '6.3247',
                                      'Sn',
                                      '.5031',
                                      'Sn2+',
                                      '5.8378',
                                      'Sn4+',
                                      '.4655',
                                      'Sb',
                                      '.4607',
                                      'Sb3+',
                                      '5.22126',
                                      'Sb5+',
                                      '.467973',
                                      'Te',
                                      '.420885',
                                      'I',
                                      '.3814',
                                      'I1-',
                                      '.3815',
                                      'Xe',
                                      '0.344',
                                      'Cs',
                                      '.3107',
                                      'Cs1+',
                                      '.3086',
                                      'Ba',
                                      '.2756',
                                      'Ba2+',
                                      '.28331',
                                      'La',
                                      '.244475',
                                      'La3+',
                                      '.250698',
                                      'Ce',
                                      '.226836',
                                      'Ce3+',
                                      '.23154',
                                      'Ce4+',
                                      '.21885',
                                      'Pr',
                                      '.222087',
                                      'Pr3+',
                                      '.214299',
                                      'Pr4+',
                                      '.202481',
                                      'Nd',
                                      '.210628',
                                      'Nd3+',
                                      '.199237',
                                      'Pm',
                                      '0.202088',
                                      'Sm',
                                      '.196451',
                                      'Sm3+',
                                      '.174081',
                                      'Eu',
                                      '.1942',
                                      'Eu2+',
                                      '.17353',
                                      'Eu3+',
                                      '.16394',
                                      'Gd',
                                      '.181951',
                                      'Gd3+',
                                      '.155525',
                                      'Tb',
                                      '.196143',
                                      'Tb3+',
                                      '.149525',
                                      'Dy',
                                      '.202172',
                                      'Dy3+',
                                      '.143384',
                                      'Ho',
                                      '.19794',
                                      'Ho3+',
                                      '.139358',
                                      'Er',
                                      '.223545',
                                      'Er3+',
                                      '.13729',
                                      'Tm',
                                      '.238849',
                                      'Tm3+',
                                      '.136974',
                                      'Yb',
                                      '.25711',
                                      'Yb2+',
                                      '.15997',
                                      'Yb3+',
                                      '.13879',
                                      'Lu',
                                      '9.98519',
                                      'Lu3+',
                                      '.142292',
                                      'Hf',
                                      '9.5999',
                                      'Hf4+',
                                      '.128903',
                                      'Ta',
                                      '9.37046',
                                      'Ta5+',
                                      '.116741',
                                      'W',
                                      '9.2259',
                                      'W6+',
                                      '.104621',
                                      'Re',
                                      '9.09227',
                                      'Os',
                                      '8.97948',
                                      'Os4+',
                                      '6.84706',
                                      'Ir',
                                      '8.86553',
                                      'Ir3+',
                                      '7.10909',
                                      'Ir4+',
                                      '6.71983',
                                      'Pt',
                                      '8.81174',
                                      'Pt2+',
                                      '7.38979',
                                      'Pt4+',
                                      '6.60834',
                                      'Au',
                                      '8.6216',
                                      'Au1+',
                                      '7.7395',
                                      'Au3+',
                                      '6.82872',
                                      'Hg',
                                      '8.4484',
                                      'Hg1+',
                                      '7.65105',
                                      'Hg2+',
                                      '7.05639',
                                      'Tl',
                                      '8.70751',
                                      'TL1+',
                                      '.517394',
                                      'Tl3+',
                                      '6.53852',
                                      'Pb',
                                      '2.3576',
                                      'Pb2+',
                                      '.488383',
                                      'Pb4+',
                                      '6.10926',
                                      'Bi',
                                      '2.9238',
                                      'Bi3+',
                                      '6.24149',
                                      'Bi5+',
                                      '.039042',
                                      'Po',
                                      '3.55078',
                                      'At',
                                      '3.97458',
                                      'Rn',
                                      '4.0691',
                                      'Fr',
                                      '4.17619',
                                      'Ra',
                                      '3.87135',
                                      'Ra2+',
                                      '3.57670',
                                      'Ac',
                                      '3.65155',
                                      'Ac3+',
                                      '3.41437',
                                      'Th',
                                      '3.46204',
                                      'Th4+',
                                      '3.24498',
                                      'Pa',
                                      '3.41519',
                                      'U',
                                      '3.3253',
                                      'U3+',
                                      '3.12293',
                                      'U4+',
                                      '3.05053',
                                      'U6+',
                                      '2.89030',
                                      'Np',
                                      '3.25396',
                                      'Np3+',
                                      '3.03807',
                                      'Np4+',
                                      '2.96627',
                                      'Np6+',
                                      '2.81099',
                                      'Pu',
                                      '3.26371',
                                      'Pu3+',
                                      '2.96118',
                                      'Pu4+',
                                      '2.89020',
                                      'Pu6+',
                                      '2.73848',
                                      'Am',
                                      '3.20647',
                                      'Cm',
                                      '3.08997',
                                      'Bk',
                                      '3.04619',
                                      'Cf',
                                      '3.00775' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_b2' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_b3',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_b3' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_b3',
                                      '_atom_type.scat_Cromer_Mann_b3' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '3.14236',
                                      'D',
                                      '3.14236',
                                      'H1-',
                                      '186.576',
                                      'He',
                                      '22.9276',
                                      'Li',
                                      '85.3905',
                                      'Li1+',
                                      '.6316',
                                      'Be',
                                      '103.483',
                                      'Be2+',
                                      '2.2758',
                                      'B',
                                      '60.3498',
                                      'C',
                                      '.5687',
                                      'N',
                                      '28.9975',
                                      'O',
                                      '.3239',
                                      'O1-',
                                      '47.0179',
                                      'F',
                                      '.2615',
                                      'F1-',
                                      '.442258',
                                      'Ne',
                                      '0.2306',
                                      'Na',
                                      '.3136',
                                      'Na1+',
                                      '.2001',
                                      'Mg',
                                      '.3808',
                                      'Mg2+',
                                      '.185',
                                      'Al',
                                      '31.5472',
                                      'Al3+',
                                      '.228753',
                                      'Si',
                                      '.6785',
                                      'Si4+',
                                      '.2149',
                                      'P',
                                      '.526',
                                      'S',
                                      '.2536',
                                      'Cl',
                                      '18.5194',
                                      'Cl1-',
                                      '19.5424',
                                      'Ar',
                                      '43.8983',
                                      'K',
                                      '213.187',
                                      'K1+',
                                      '-.002',
                                      'Ca',
                                      '85.7484',
                                      'Ca2+',
                                      '10.3116',
                                      'Sc',
                                      '136.108',
                                      'Sc3+',
                                      '-.28604',
                                      'Ti',
                                      '35.6338',
                                      'Ti2+',
                                      '19.5361',
                                      'Ti3+',
                                      '-.15762',
                                      'Ti4+',
                                      '-.29263',
                                      'V',
                                      '26.8938',
                                      'V2+',
                                      '20.3004',
                                      'V3+',
                                      '15.1908',
                                      'V5+',
                                      '9.97278',
                                      'Cr',
                                      '20.2626',
                                      'Cr2+',
                                      '13.3075',
                                      'Cr3+',
                                      '12.8288',
                                      'Mn',
                                      '17.8674',
                                      'Mn2+',
                                      '14.343',
                                      'Mn3+',
                                      '10.8171',
                                      'Mn4+',
                                      '10.4852',
                                      'Fe',
                                      '15.3535',
                                      'Fe2+',
                                      '12.0546',
                                      'Fe3+',
                                      '11.6729',
                                      'Co',
                                      '13.5359',
                                      'Co2+',
                                      '10.2443',
                                      'Co3+',
                                      '8.35583',
                                      'Ni',
                                      '12.1763',
                                      'Ni2+',
                                      '8.873',
                                      'Ni3+',
                                      '7.64468',
                                      'Cu',
                                      '11.3966',
                                      'Cu1+',
                                      '8.6625',
                                      'Cu2+',
                                      '7.9876',
                                      'Zn',
                                      '10.3163',
                                      'Zn2+',
                                      '7.0826',
                                      'Ga',
                                      '10.7805',
                                      'Ga3+',
                                      '6.36441',
                                      'Ge',
                                      '11.4468',
                                      'Ge4+',
                                      '5.47913',
                                      'As',
                                      '12.9479',
                                      'Se',
                                      '15.2372',
                                      'Br',
                                      '.2609',
                                      'Br1-',
                                      '.2871',
                                      'Kr',
                                      '0.2261',
                                      'Rb',
                                      '.2748',
                                      'Rb1+',
                                      '.1603',
                                      'Sr',
                                      '.1664',
                                      'Sr2+',
                                      '24.5651',
                                      'Y',
                                      '.125599',
                                      'Y3+',
                                      '22.6599',
                                      'Zr',
                                      '.117622',
                                      'Zr4+',
                                      '21.6054',
                                      'Nb',
                                      '.204785',
                                      'Nb3+',
                                      '10.1621',
                                      'Nb5+',
                                      '9.28206',
                                      'Mo',
                                      '11.004',
                                      'Mo3+',
                                      '9.53659',
                                      'Mo5+',
                                      '8.78809',
                                      'Mo6+',
                                      '.058881',
                                      'Tc',
                                      '21.5707',
                                      'Ru',
                                      '24.7997',
                                      'Ru3+',
                                      '.017662',
                                      'Ru4+',
                                      '.036495',
                                      'Rh',
                                      '25.8749',
                                      'Rh3+',
                                      '21.2487',
                                      'Rh4+',
                                      '19.3317',
                                      'Pd',
                                      '25.2052',
                                      'Pd2+',
                                      '22.5057',
                                      'Pd4+',
                                      '17.9144',
                                      'Ag',
                                      '24.6605',
                                      'Ag1+',
                                      '21.7326',
                                      'Ag2+',
                                      '21.4072',
                                      'Cd',
                                      '24.7008',
                                      'Cd2+',
                                      '20.2521',
                                      'In',
                                      '25.8499',
                                      'In3+',
                                      '17.3595',
                                      'Sn',
                                      '26.8909',
                                      'Sn2+',
                                      '23.3752',
                                      'Sn4+',
                                      '14.0049',
                                      'Sb',
                                      '27.9074',
                                      'Sb3+',
                                      '19.5902',
                                      'Sb5+',
                                      '14.1259',
                                      'Te',
                                      '28.5284',
                                      'I',
                                      '27.766',
                                      'I1-',
                                      '29.5259',
                                      'Xe',
                                      '26.4659',
                                      'Cs',
                                      '24.3879',
                                      'Cs1+',
                                      '23.7128',
                                      'Ba',
                                      '20.2073',
                                      'Ba2+',
                                      '20.0558',
                                      'La',
                                      '18.7726',
                                      'La3+',
                                      '17.8211',
                                      'Ce',
                                      '17.6083',
                                      'Ce3+',
                                      '16.5408',
                                      'Ce4+',
                                      '15.7992',
                                      'Pr',
                                      '16.7669',
                                      'Pr3+',
                                      '15.323',
                                      'Pr4+',
                                      '14.8137',
                                      'Nd',
                                      '15.885',
                                      'Nd3+',
                                      '14.1783',
                                      'Pm',
                                      '15.1009',
                                      'Sm',
                                      '14.3996',
                                      'Sm3+',
                                      '12.1571',
                                      'Eu',
                                      '13.7546',
                                      'Eu2+',
                                      '11.6096',
                                      'Eu3+',
                                      '11.311',
                                      'Gd',
                                      '12.9331',
                                      'Gd3+',
                                      '10.5782',
                                      'Tb',
                                      '12.6648',
                                      'Tb3+',
                                      '10.0499',
                                      'Dy',
                                      '12.1899',
                                      'Dy3+',
                                      '9.34972',
                                      'Ho',
                                      '11.4407',
                                      'Ho3+',
                                      '8.80018',
                                      'Er',
                                      '11.3604',
                                      'Er3+',
                                      '8.36225',
                                      'Tm',
                                      '10.9975',
                                      'Tm3+',
                                      '7.96778',
                                      'Yb',
                                      '10.6647',
                                      'Yb2+',
                                      '8.18304',
                                      'Yb3+',
                                      '7.64412',
                                      'Lu',
                                      '.261033',
                                      'Lu3+',
                                      '7.33727',
                                      'Hf',
                                      '.275116',
                                      'Hf4+',
                                      '6.76232',
                                      'Ta',
                                      '.295977',
                                      'Ta5+',
                                      '6.31524',
                                      'W',
                                      '.321703',
                                      'W6+',
                                      '5.93667',
                                      'Re',
                                      '.3505',
                                      'Os',
                                      '.382661',
                                      'Os4+',
                                      '.165191',
                                      'Ir',
                                      '.417916',
                                      'Ir3+',
                                      '.204633',
                                      'Ir4+',
                                      '.167252',
                                      'Pt',
                                      '.424593',
                                      'Pt2+',
                                      '.263297',
                                      'Pt4+',
                                      '.16864',
                                      'Au',
                                      '1.4826',
                                      'Au1+',
                                      '.356752',
                                      'Au3+',
                                      '.212867',
                                      'Hg',
                                      '1.5729',
                                      'Hg1+',
                                      '.443378',
                                      'Hg2+',
                                      '.284738',
                                      'Tl',
                                      '1.96347',
                                      'TL1+',
                                      '7.43463',
                                      'Tl3+',
                                      '.219074',
                                      'Pb',
                                      '8.618',
                                      'Pb2+',
                                      '6.7727',
                                      'Pb4+',
                                      '.147041',
                                      'Bi',
                                      '8.7937',
                                      'Bi3+',
                                      '.469999',
                                      'Bi5+',
                                      '5.71414',
                                      'Po',
                                      '9.55642',
                                      'At',
                                      '11.3824',
                                      'Rn',
                                      '14.0422',
                                      'Fr',
                                      '23.1052',
                                      'Ra',
                                      '19.9887',
                                      'Ra2+',
                                      '12.6010',
                                      'Ac',
                                      '18.5990',
                                      'Ac3+',
                                      '12.9187',
                                      'Th',
                                      '17.8309',
                                      'Th4+',
                                      '13.4661',
                                      'Pa',
                                      '16.9235',
                                      'U',
                                      '16.0927',
                                      'U3+',
                                      '12.7148',
                                      'U4+',
                                      '12.5723',
                                      'U6+',
                                      '13.1767',
                                      'Np',
                                      '15.3622',
                                      'Np3+',
                                      '12.1449',
                                      'Np4+',
                                      '11.9484',
                                      'Np6+',
                                      '12.3300',
                                      'Pu',
                                      '14.9455',
                                      'Pu3+',
                                      '11.5331',
                                      'Pu4+',
                                      '11.3160',
                                      'Pu6+',
                                      '11.5530',
                                      'Am',
                                      '14.3136',
                                      'Cm',
                                      '13.4346',
                                      'Bk',
                                      '12.8946',
                                      'Cf',
                                      '12.4044' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_b3' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_b4',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_b4' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_b4',
                                      '_atom_type.scat_Cromer_Mann_b4' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '57.7997',
                                      'D',
                                      '57.7997',
                                      'H1-',
                                      '3.56709',
                                      'He',
                                      '0.9821',
                                      'Li',
                                      '168.261',
                                      'Li1+',
                                      '10.0953',
                                      'Be',
                                      '.542',
                                      'Be2+',
                                      '5.1146',
                                      'B',
                                      '.1403',
                                      'C',
                                      '51.6512',
                                      'N',
                                      '.5826',
                                      'O',
                                      '32.9089',
                                      'O1-',
                                      '-.01404',
                                      'F',
                                      '26.1476',
                                      'F1-',
                                      '47.3437',
                                      'Ne',
                                      '21.7814',
                                      'Na',
                                      '129.424',
                                      'Na1+',
                                      '14.039',
                                      'Mg',
                                      '7.1937',
                                      'Mg2+',
                                      '10.1411',
                                      'Al',
                                      '85.0886',
                                      'Al3+',
                                      '8.28524',
                                      'Si',
                                      '81.6937',
                                      'Si4+',
                                      '6.65365',
                                      'P',
                                      '68.1645',
                                      'S',
                                      '56.172',
                                      'Cl',
                                      '47.7784',
                                      'Cl1-',
                                      '60.4486',
                                      'Ar',
                                      '33.3929',
                                      'K',
                                      '41.6841',
                                      'K1+',
                                      '31.9128',
                                      'Ca',
                                      '178.437',
                                      'Ca2+',
                                      '25.9905',
                                      'Sc',
                                      '51.3531',
                                      'Sc3+',
                                      '16.0662',
                                      'Ti',
                                      '116.105',
                                      'Ti2+',
                                      '61.6558',
                                      'Ti3+',
                                      '15.9768',
                                      'Ti4+',
                                      '12.9464',
                                      'V',
                                      '102.478',
                                      'V2+',
                                      '115.122',
                                      'V3+',
                                      '63.969',
                                      'V5+',
                                      '.940464',
                                      'Cr',
                                      '98.7399',
                                      'Cr2+',
                                      '32.4224',
                                      'Cr3+',
                                      '32.8761',
                                      'Mn',
                                      '83.7543',
                                      'Mn2+',
                                      '41.3235',
                                      'Mn3+',
                                      '24.1281',
                                      'Mn4+',
                                      '27.573',
                                      'Fe',
                                      '76.8805',
                                      'Fe2+',
                                      '31.2809',
                                      'Fe3+',
                                      '38.5566',
                                      'Co',
                                      '71.1692',
                                      'Co2+',
                                      '25.6466',
                                      'Co3+',
                                      '18.3491',
                                      'Ni',
                                      '66.3421',
                                      'Ni2+',
                                      '22.1626',
                                      'Ni3+',
                                      '16.9673',
                                      'Cu',
                                      '64.8126',
                                      'Cu1+',
                                      '25.8487',
                                      'Cu2+',
                                      '19.897',
                                      'Zn',
                                      '58.7097',
                                      'Zn2+',
                                      '18.0995',
                                      'Ga',
                                      '61.4135',
                                      'Ga3+',
                                      '14.4122',
                                      'Ge',
                                      '54.7625',
                                      'Ge4+',
                                      '11.603',
                                      'As',
                                      '47.7972',
                                      'Se',
                                      '43.8163',
                                      'Br',
                                      '41.4328',
                                      'Br1-',
                                      '58.1535',
                                      'Kr',
                                      '39.3972',
                                      'Rb',
                                      '164.934',
                                      'Rb1+',
                                      '31.2087',
                                      'Sr',
                                      '132.376',
                                      'Sr2+',
                                      '-.0138',
                                      'Y',
                                      '104.354',
                                      'Y3+',
                                      '-.01319',
                                      'Zr',
                                      '87.6627',
                                      'Zr4+',
                                      '-.10276',
                                      'Nb',
                                      '69.7957',
                                      'Nb3+',
                                      '28.3389',
                                      'Nb5+',
                                      '25.7228',
                                      'Mo',
                                      '61.6584',
                                      'Mo3+',
                                      '26.6307',
                                      'Mo5+',
                                      '23.3452',
                                      'Mo6+',
                                      '0.',
                                      'Tc',
                                      '86.8472',
                                      'Ru',
                                      '94.2928',
                                      'Ru3+',
                                      '22.887',
                                      'Ru4+',
                                      '20.8504',
                                      'Rh',
                                      '98.6062',
                                      'Rh3+',
                                      '-.01036',
                                      'Rh4+',
                                      '-.0102',
                                      'Pd',
                                      '76.8986',
                                      'Pd2+',
                                      '0.',
                                      'Pd4+',
                                      '.005127',
                                      'Ag',
                                      '99.8156',
                                      'Ag1+',
                                      '66.1147',
                                      'Ag2+',
                                      '0.',
                                      'Cd',
                                      '87.4825',
                                      'Cd2+',
                                      '0.',
                                      'In',
                                      '92.8029',
                                      'In3+',
                                      '0.',
                                      'Sn',
                                      '83.9571',
                                      'Sn2+',
                                      '62.2061',
                                      'Sn4+',
                                      '-.7583',
                                      'Sb',
                                      '75.2825',
                                      'Sb3+',
                                      '55.5113',
                                      'Sb5+',
                                      '0.',
                                      'Te',
                                      '70.8403',
                                      'I',
                                      '66.8776',
                                      'I1-',
                                      '84.9304',
                                      'Xe',
                                      '64.2658',
                                      'Cs',
                                      '213.904',
                                      'Cs1+',
                                      '59.4565',
                                      'Ba',
                                      '167.202',
                                      'Ba2+',
                                      '51.746',
                                      'La',
                                      '133.124',
                                      'La3+',
                                      '54.9453',
                                      'Ce',
                                      '127.113',
                                      'Ce3+',
                                      '43.1692',
                                      'Ce4+',
                                      '62.2355',
                                      'Pr',
                                      '143.644',
                                      'Pr3+',
                                      '36.4065',
                                      'Pr4+',
                                      '45.4643',
                                      'Nd',
                                      '137.903',
                                      'Nd3+',
                                      '30.8717',
                                      'Pm',
                                      '132.721',
                                      'Sm',
                                      '128.007',
                                      'Sm3+',
                                      '24.8242',
                                      'Eu',
                                      '123.174',
                                      'Eu2+',
                                      '26.5156',
                                      'Eu3+',
                                      '22.9966',
                                      'Gd',
                                      '101.398',
                                      'Gd3+',
                                      '21.7029',
                                      'Tb',
                                      '115.362',
                                      'Tb3+',
                                      '21.2773',
                                      'Dy',
                                      '111.874',
                                      'Dy3+',
                                      '19.581',
                                      'Ho',
                                      '92.6566',
                                      'Ho3+',
                                      '18.5908',
                                      'Er',
                                      '105.703',
                                      'Er3+',
                                      '17.8974',
                                      'Tm',
                                      '102.961',
                                      'Tm3+',
                                      '17.2922',
                                      'Yb',
                                      '100.417',
                                      'Yb2+',
                                      '20.39',
                                      'Yb3+',
                                      '16.8153',
                                      'Lu',
                                      '84.3298',
                                      'Lu3+',
                                      '16.3535',
                                      'Hf',
                                      '72.029',
                                      'Hf4+',
                                      '14.0366',
                                      'Ta',
                                      '63.3644',
                                      'Ta5+',
                                      '12.4244',
                                      'W',
                                      '57.056',
                                      'W6+',
                                      '11.1972',
                                      'Re',
                                      '52.0861',
                                      'Os',
                                      '48.1647',
                                      'Os4+',
                                      '18.003',
                                      'Ir',
                                      '45.0011',
                                      'Ir3+',
                                      '20.3254',
                                      'Ir4+',
                                      '17.4911',
                                      'Pt',
                                      '38.6103',
                                      'Pt2+',
                                      '22.9426',
                                      'Pt4+',
                                      '16.9392',
                                      'Au',
                                      '36.3956',
                                      'Au1+',
                                      '26.4043',
                                      'Au3+',
                                      '18.659',
                                      'Hg',
                                      '38.3246',
                                      'Hg1+',
                                      '28.2262',
                                      'Hg2+',
                                      '20.7482',
                                      'Tl',
                                      '45.8149',
                                      'TL1+',
                                      '28.8482',
                                      'Tl3+',
                                      '17.2114',
                                      'Pb',
                                      '47.2579',
                                      'Pb2+',
                                      '23.8132',
                                      'Pb4+',
                                      '14.714',
                                      'Bi',
                                      '48.0093',
                                      'Bi3+',
                                      '20.3185',
                                      'Bi5+',
                                      '12.8285',
                                      'Po',
                                      '47.0045',
                                      'At',
                                      '45.4715',
                                      'Rn',
                                      '44.2473',
                                      'Fr',
                                      '150.645',
                                      'Ra',
                                      '142.325',
                                      'Ra2+',
                                      '29.8436',
                                      'Ac',
                                      '117.020',
                                      'Ac3+',
                                      '25.9443',
                                      'Th',
                                      '99.1722',
                                      'Th4+',
                                      '23.9533',
                                      'Pa',
                                      '105.251',
                                      'U',
                                      '100.613',
                                      'U3+',
                                      '26.3394',
                                      'U4+',
                                      '23.4582',
                                      'U6+',
                                      '25.2017',
                                      'Np',
                                      '97.4908',
                                      'Np3+',
                                      '25.4928',
                                      'Np4+',
                                      '22.7502',
                                      'Np6+',
                                      '22.6581',
                                      'Pu',
                                      '105.980',
                                      'Pu3+',
                                      '24.3992',
                                      'Pu4+',
                                      '21.8301',
                                      'Pu6+',
                                      '20.9303',
                                      'Am',
                                      '102.273',
                                      'Cm',
                                      '88.4834',
                                      'Bk',
                                      '86.0030',
                                      'Cf',
                                      '83.7881' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_b4' ] ] ],
                              [ 'save_',
                                'atom_type_scat.Cromer_Mann_c',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.Cromer_Mann_c' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_Cromer_Mann_c',
                                      '_atom_type.scat_Cromer_Mann_c' ] ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of data items used to define Cromer-Mann coefficients\n     for generation of X-ray scattering factors.\n \n        Ref: International Tables for X-ray Crystallography, Vol. IV\n             (1974) Table 2.2B\n        or   International Tables for Crystallography, Vol. C\n             (1991) Tables 6.1.1.4 and 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.003038',
                                      'D',
                                      '.003038',
                                      'H1-',
                                      '.002389',
                                      'He',
                                      '0.0064',
                                      'Li',
                                      '.0377',
                                      'Li1+',
                                      '.0167',
                                      'Be',
                                      '.0385',
                                      'Be2+',
                                      '-6.1092',
                                      'B',
                                      '-.1932',
                                      'C',
                                      '.2156',
                                      'N',
                                      '-11.529',
                                      'O',
                                      '.2508',
                                      'O1-',
                                      '21.9412',
                                      'F',
                                      '.2776',
                                      'F1-',
                                      '.653396',
                                      'Ne',
                                      '0.3515',
                                      'Na',
                                      '.6760',
                                      'Na1+',
                                      '.4040',
                                      'Mg',
                                      '.8584',
                                      'Mg2+',
                                      '.4853',
                                      'Al',
                                      '1.1151',
                                      'Al3+',
                                      '.706786',
                                      'Si',
                                      '1.1407',
                                      'Si4+',
                                      '.746297',
                                      'P',
                                      '1.1149',
                                      'S',
                                      '.8669',
                                      'Cl',
                                      '-9.5574',
                                      'Cl1-',
                                      '-16.378',
                                      'Ar',
                                      '1.44450',
                                      'K',
                                      '1.4228',
                                      'K1+',
                                      '-4.9978',
                                      'Ca',
                                      '1.3751',
                                      'Ca2+',
                                      '-14.875',
                                      'Sc',
                                      '1.3329',
                                      'Sc3+',
                                      '-6.6667',
                                      'Ti',
                                      '1.2807',
                                      'Ti2+',
                                      '.897155',
                                      'Ti3+',
                                      '-14.652',
                                      'Ti4+',
                                      '-13.280',
                                      'V',
                                      '1.2199',
                                      'V2+',
                                      '1.2298',
                                      'V3+',
                                      '.656565',
                                      'V5+',
                                      '1.71430',
                                      'Cr',
                                      '1.1832',
                                      'Cr2+',
                                      '.616898',
                                      'Cr3+',
                                      '.518275',
                                      'Mn',
                                      '1.0896',
                                      'Mn2+',
                                      '1.0874',
                                      'Mn3+',
                                      '.393974',
                                      'Mn4+',
                                      '.251877',
                                      'Fe',
                                      '1.0369',
                                      'Fe2+',
                                      '1.0097',
                                      'Fe3+',
                                      '.9707',
                                      'Co',
                                      '1.0118',
                                      'Co2+',
                                      '.9324',
                                      'Co3+',
                                      '.286667',
                                      'Ni',
                                      '1.0341',
                                      'Ni2+',
                                      '.8614',
                                      'Ni3+',
                                      '.386044',
                                      'Cu',
                                      '1.1910',
                                      'Cu1+',
                                      '.8900',
                                      'Cu2+',
                                      '1.14431',
                                      'Zn',
                                      '1.3041',
                                      'Zn2+',
                                      '.7807',
                                      'Ga',
                                      '1.7189',
                                      'Ga3+',
                                      '1.53545',
                                      'Ge',
                                      '2.1313',
                                      'Ge4+',
                                      '1.45572',
                                      'As',
                                      '2.5310',
                                      'Se',
                                      '2.8409',
                                      'Br',
                                      '2.9557',
                                      'Br1-',
                                      '3.1776',
                                      'Kr',
                                      '2.825',
                                      'Rb',
                                      '3.4873',
                                      'Rb1+',
                                      '2.0782',
                                      'Sr',
                                      '2.5064',
                                      'Sr2+',
                                      '41.4025',
                                      'Y',
                                      '1.91213',
                                      'Y3+',
                                      '40.2602',
                                      'Zr',
                                      '2.06929',
                                      'Zr4+',
                                      '9.41454',
                                      'Nb',
                                      '3.75591',
                                      'Nb3+',
                                      '-12.912',
                                      'Nb5+',
                                      '-6.3934',
                                      'Mo',
                                      '4.3875',
                                      'Mo3+',
                                      '-14.421',
                                      'Mo5+',
                                      '-14.316',
                                      'Mo6+',
                                      '.344941',
                                      'Tc',
                                      '5.40428',
                                      'Ru',
                                      '5.37874',
                                      'Ru3+',
                                      '-3.1892',
                                      'Ru4+',
                                      '1.42357',
                                      'Rh',
                                      '5.32800',
                                      'Rh3+',
                                      '11.8678',
                                      'Rh4+',
                                      '11.2835',
                                      'Pd',
                                      '5.26593',
                                      'Pd2+',
                                      '5.29160',
                                      'Pd4+',
                                      '13.0174',
                                      'Ag',
                                      '5.1790',
                                      'Ag1+',
                                      '5.21572',
                                      'Ag2+',
                                      '5.21404',
                                      'Cd',
                                      '5.0694',
                                      'Cd2+',
                                      '5.11937',
                                      'In',
                                      '4.9391',
                                      'In3+',
                                      '4.99635',
                                      'Sn',
                                      '4.7821',
                                      'Sn2+',
                                      '4.7861',
                                      'Sn4+',
                                      '3.9182',
                                      'Sb',
                                      '4.5909',
                                      'Sb3+',
                                      '4.69626',
                                      'Sb5+',
                                      '4.69263',
                                      'Te',
                                      '4.35200',
                                      'I',
                                      '4.0712',
                                      'I1-',
                                      '4.0714',
                                      'Xe',
                                      '3.7118',
                                      'Cs',
                                      '3.3352',
                                      'Cs1+',
                                      '3.2791',
                                      'Ba',
                                      '2.7731',
                                      'Ba2+',
                                      '3.02902',
                                      'La',
                                      '2.14678',
                                      'La3+',
                                      '2.40860',
                                      'Ce',
                                      '1.86264',
                                      'Ce3+',
                                      '2.09013',
                                      'Ce4+',
                                      '1.59180',
                                      'Pr',
                                      '2.05830',
                                      'Pr3+',
                                      '1.77132',
                                      'Pr4+',
                                      '1.24285',
                                      'Nd',
                                      '1.98486',
                                      'Nd3+',
                                      '1.47588',
                                      'Pm',
                                      '2.02876',
                                      'Sm',
                                      '2.20963',
                                      'Sm3+',
                                      '.954586',
                                      'Eu',
                                      '2.5745',
                                      'Eu2+',
                                      '1.36389',
                                      'Eu3+',
                                      '.759344',
                                      'Gd',
                                      '2.41960',
                                      'Gd3+',
                                      '.645089',
                                      'Tb',
                                      '3.58324',
                                      'Tb3+',
                                      '.691967',
                                      'Dy',
                                      '4.29728',
                                      'Dy3+',
                                      '.689690',
                                      'Ho',
                                      '4.56796',
                                      'Ho3+',
                                      '.852795',
                                      'Er',
                                      '5.92046',
                                      'Er3+',
                                      '1.17613',
                                      'Tm',
                                      '6.75621',
                                      'Tm3+',
                                      '1.63929',
                                      'Yb',
                                      '7.56672',
                                      'Yb2+',
                                      '3.70983',
                                      'Yb3+',
                                      '2.26001',
                                      'Lu',
                                      '7.97628',
                                      'Lu3+',
                                      '2.97573',
                                      'Hf',
                                      '8.58154',
                                      'Hf4+',
                                      '2.39699',
                                      'Ta',
                                      '9.24354',
                                      'Ta5+',
                                      '1.78555',
                                      'W',
                                      '9.88750',
                                      'W6+',
                                      '1.01074',
                                      'Re',
                                      '10.4720',
                                      'Os',
                                      '11.0005',
                                      'Os4+',
                                      '6.49804',
                                      'Ir',
                                      '11.4722',
                                      'Ir3+',
                                      '8.27903',
                                      'Ir4+',
                                      '6.96824',
                                      'Pt',
                                      '11.6883',
                                      'Pt2+',
                                      '9.85329',
                                      'Pt4+',
                                      '7.39534',
                                      'Au',
                                      '12.0658',
                                      'Au1+',
                                      '11.2299',
                                      'Au3+',
                                      '9.09680',
                                      'Hg',
                                      '12.6089',
                                      'Hg1+',
                                      '12.0205',
                                      'Hg2+',
                                      '10.6268',
                                      'Tl',
                                      '13.1746',
                                      'TL1+',
                                      '12.5258',
                                      'Tl3+',
                                      '9.80270',
                                      'Pb',
                                      '13.4118',
                                      'Pb2+',
                                      '12.4734',
                                      'Pb4+',
                                      '8.08428',
                                      'Bi',
                                      '13.5782',
                                      'Bi3+',
                                      '12.4711',
                                      'Bi5+',
                                      '-6.7994',
                                      'Po',
                                      '13.6770',
                                      'At',
                                      '13.7108',
                                      'Rn',
                                      '13.6905',
                                      'Fr',
                                      '13.7247',
                                      'Ra',
                                      '13.6211',
                                      'Ra2+',
                                      '13.5431',
                                      'Ac',
                                      '13.5266',
                                      'Ac3+',
                                      '13.4637',
                                      'Th',
                                      '13.4314',
                                      'Th4+',
                                      '13.3760',
                                      'Pa',
                                      '13.4287',
                                      'U',
                                      '13.3966',
                                      'U3+',
                                      '13.3092',
                                      'U4+',
                                      '13.2671',
                                      'U6+',
                                      '13.1665',
                                      'Np',
                                      '13.3573',
                                      'Np3+',
                                      '13.2544',
                                      'Np4+',
                                      '13.2116',
                                      'Np6+',
                                      '13.1130',
                                      'Pu',
                                      '13.3812',
                                      'Pu3+',
                                      '13.1991',
                                      'Pu4+',
                                      '13.1555',
                                      'Pu6+',
                                      '13.0582',
                                      'Am',
                                      '13.3592',
                                      'Cm',
                                      '13.2887',
                                      'Bk',
                                      '13.2754',
                                      'Cf',
                                      '13.2674' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'Cromer_Mann_c' ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.dispersion' ],
                                  [ 'item_', '_definition.update', '2013-04-28' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The anomalous dispersion scattering factor in its complex form\n     for this atom type and radiation by _diffrn_radiation_wavelength.value' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Complex' ],
                                  [ 'item_', '_enumeration.default', '0.0' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With s as atom_type_scat\n \n             d = Complex( s.dispersion_real, s.dispersion_imag )\n \n        if(_reflns.apply_dispersion_to_Fcalc == \'no\')   d = 0.\n \n                 _atom_type_scat.dispersion = d' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_imag',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.dispersion_imag' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_dispersion_imag',
                                      '_atom_type.scat_dispersion_imag' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The imaginary component of the anomalous dispersion scattering factors\n     for this atom type and radiation by _diffrn_radiation_wavelength.value' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_imag' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '0.0' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    With q as atom_type_scat\n \n     If ( _diffrn_radiation.type[0:2] == \'Cu\' ) a = q.dispersion_imag_cu\n     If ( _diffrn_radiation.type[0:2] == \'Mo\' ) a = q.dispersion_imag_mo\n \n             _atom_type_scat.dispersion_imag = a' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_imag_cu',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.dispersion_imag_cu' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The imaginary component of the anomalous dispersion scattering factors\n     for this atom type and Cu K alpha radiation' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_imag_cu' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.0',
                                      'D',
                                      '.0',
                                      'H1-',
                                      '.0',
                                      'He',
                                      '.0',
                                      'Li',
                                      '.0',
                                      'Li1+',
                                      '.0',
                                      'Be',
                                      '.001',
                                      'Be2+',
                                      '.001',
                                      'B',
                                      '.004',
                                      'C',
                                      '.009',
                                      'N',
                                      '.018',
                                      'O',
                                      '.032',
                                      'O1-',
                                      '.032',
                                      'F',
                                      '.053',
                                      'F1-',
                                      '.053',
                                      'Ne',
                                      '.083',
                                      'Na',
                                      '.124',
                                      'Na1+',
                                      '.124',
                                      'Mg',
                                      '.177',
                                      'Mg2+',
                                      '.177',
                                      'Al',
                                      '.246',
                                      'Al3+',
                                      '.246',
                                      'Si',
                                      '.33',
                                      'Si4+',
                                      '.33',
                                      'P',
                                      '.434',
                                      'S',
                                      '.557',
                                      'Cl',
                                      '.702',
                                      'Cl1-',
                                      '.702',
                                      'Ar',
                                      '.872',
                                      'K',
                                      '1.066',
                                      'K1+',
                                      '1.066',
                                      'Ca',
                                      '1.286',
                                      'Ca2+',
                                      '1.286',
                                      'Sc',
                                      '1.533',
                                      'Sc3+',
                                      '1.533',
                                      'Ti',
                                      '1.807',
                                      'Ti2+',
                                      '1.807',
                                      'Ti3+',
                                      '1.807',
                                      'Ti4+',
                                      '1.807',
                                      'V',
                                      '2.11',
                                      'V2+',
                                      '2.11',
                                      'V3+',
                                      '2.11',
                                      'V5+',
                                      '2.11',
                                      'Cr',
                                      '2.443',
                                      'Cr2+',
                                      '2.443',
                                      'Cr3+',
                                      '2.443',
                                      'Mn',
                                      '2.808',
                                      'Mn2+',
                                      '2.808',
                                      'Mn3+',
                                      '2.808',
                                      'Mn4+',
                                      '2.808',
                                      'Fe',
                                      '3.204',
                                      'Fe2+',
                                      '3.204',
                                      'Fe3+',
                                      '3.204',
                                      'Co',
                                      '3.608',
                                      'Co2+',
                                      '3.608',
                                      'Co3+',
                                      '3.608',
                                      'Ni',
                                      '.509',
                                      'Ni2+',
                                      '.509',
                                      'Ni3+',
                                      '.509',
                                      'Cu',
                                      '.589',
                                      'Cu1+',
                                      '.589',
                                      'Cu2+',
                                      '.589',
                                      'Zn',
                                      '.678',
                                      'Zn2+',
                                      '.678',
                                      'Ga',
                                      '0.777',
                                      'Ga3+',
                                      '0.777',
                                      'Ge',
                                      '.886',
                                      'Ge4+',
                                      '.886',
                                      'As',
                                      '1.006',
                                      'Se',
                                      '1.139',
                                      'Br',
                                      '1.283',
                                      'Br1-',
                                      '1.283',
                                      'Kr',
                                      '1.439',
                                      'Rb',
                                      '1.608',
                                      'Rb1+',
                                      '1.608',
                                      'Sr',
                                      '1.82',
                                      'Sr2+',
                                      '1.82',
                                      'Y',
                                      '2.025',
                                      'Y3+',
                                      '2.025',
                                      'Zr',
                                      '2.245',
                                      'Zr4+',
                                      '2.245',
                                      'Nb',
                                      '2.482',
                                      'Nb3+',
                                      '2.482',
                                      'Nb5+',
                                      '2.482',
                                      'Mo',
                                      '2.735',
                                      'Mo3+',
                                      '2.735',
                                      'Mo5+',
                                      '2.735',
                                      'Mo6+',
                                      '2.735',
                                      'Tc',
                                      '3.005',
                                      'Ru',
                                      '3.296',
                                      'Ru3+',
                                      '3.296',
                                      'Ru4+',
                                      '3.296',
                                      'Rh',
                                      '3.605',
                                      'Rh3+',
                                      '3.605',
                                      'Rh4+',
                                      '3.605',
                                      'Pd',
                                      '3.934',
                                      'Pd2+',
                                      '3.934',
                                      'Pd4+',
                                      '3.934',
                                      'Ag',
                                      '4.282',
                                      'Ag1+',
                                      '4.282',
                                      'Ag2+',
                                      '4.282',
                                      'Cd',
                                      '4.653',
                                      'Cd2+',
                                      '4.653',
                                      'In',
                                      '5.045',
                                      'In3+',
                                      '5.045',
                                      'Sn',
                                      '5.459',
                                      'Sn2+',
                                      '5.459',
                                      'Sn4+',
                                      '5.459',
                                      'Sb',
                                      '5.894',
                                      'Sb3+',
                                      '5.894',
                                      'Sb5+',
                                      '5.894',
                                      'Te',
                                      '6.352',
                                      'I',
                                      '6.835',
                                      'I1-',
                                      '6.835',
                                      'Xe',
                                      '7.348',
                                      'Cs',
                                      '7.904',
                                      'Cs1+',
                                      '7.904',
                                      'Ba',
                                      '8.46',
                                      'Ba2+',
                                      '8.46',
                                      'La',
                                      '9.036',
                                      'La3+',
                                      '9.036',
                                      'Ce',
                                      '9.648',
                                      'Ce3+',
                                      '9.648',
                                      'Ce4+',
                                      '9.648',
                                      'Pr',
                                      '10.535',
                                      'Pr3+',
                                      '10.535',
                                      'Pr4+',
                                      '10.535',
                                      'Nd',
                                      '10.933',
                                      'Nd3+',
                                      '10.933',
                                      'Pm',
                                      '11.614',
                                      'Sm',
                                      '12.32',
                                      'Sm3+',
                                      '12.32',
                                      'Eu',
                                      '11.276',
                                      'Eu2+',
                                      '11.276',
                                      'Eu3+',
                                      '11.276',
                                      'Gd',
                                      '11.946',
                                      'Gd3+',
                                      '11.946',
                                      'Tb',
                                      '9.242',
                                      'Tb3+',
                                      '9.242',
                                      'Dy',
                                      '9.748',
                                      'Dy3+',
                                      '9.748',
                                      'Ho',
                                      '3.704',
                                      'Ho3+',
                                      '3.704',
                                      'Er',
                                      '3.937',
                                      'Er3+',
                                      '3.937',
                                      'Tm',
                                      '4.181',
                                      'Tm3+',
                                      '4.181',
                                      'Yb',
                                      '4.432',
                                      'Yb2+',
                                      '4.432',
                                      'Yb3+',
                                      '4.432',
                                      'Lu',
                                      '4.693',
                                      'Lu3+',
                                      '4.693',
                                      'Hf',
                                      '4.977',
                                      'Hf4+',
                                      '4.977',
                                      'Ta',
                                      '5.271',
                                      'Ta5+',
                                      '5.271',
                                      'W',
                                      '5.577',
                                      'W6+',
                                      '5.577',
                                      'Re',
                                      '5.891',
                                      'Os',
                                      '6.221',
                                      'Os4+',
                                      '6.221',
                                      'Ir',
                                      '6.566',
                                      'Ir3+',
                                      '6.566',
                                      'Ir4+',
                                      '6.566',
                                      'Pt',
                                      '6.925',
                                      'Pt2+',
                                      '6.925',
                                      'Pt4+',
                                      '6.925',
                                      'Au',
                                      '7.297',
                                      'Au1+',
                                      '7.297',
                                      'Au3+',
                                      '7.297',
                                      'Hg',
                                      '7.686',
                                      'Hg1+',
                                      '7.686',
                                      'Hg2+',
                                      '7.686',
                                      'Tl',
                                      '8.089',
                                      'TL1+',
                                      '8.089',
                                      'Tl3+',
                                      '8.089',
                                      'Pb',
                                      '8.505',
                                      'Pb2+',
                                      '8.505',
                                      'Pb4+',
                                      '8.505',
                                      'Bi',
                                      '8.93',
                                      'Bi3+',
                                      '8.93',
                                      'Bi5+',
                                      '8.93',
                                      'Po',
                                      '9.383',
                                      'At',
                                      '9.843',
                                      'Rn',
                                      '10.317',
                                      'Fr',
                                      '10.803',
                                      'Ra',
                                      '11.296',
                                      'Ra2+',
                                      '11.296',
                                      'Ac',
                                      '11.799',
                                      'Ac3+',
                                      '11.799',
                                      'Th',
                                      '12.33',
                                      'Th4+',
                                      '12.33',
                                      'Pa',
                                      '12.868',
                                      'U',
                                      '13.409',
                                      'U3+',
                                      '13.409',
                                      'U4+',
                                      '13.409',
                                      'U6+',
                                      '13.409',
                                      'Np',
                                      '13.967',
                                      'Np3+',
                                      '13.967',
                                      'Np4+',
                                      '13.967',
                                      'Np6+',
                                      '13.967',
                                      'Pu',
                                      '14.536',
                                      'Pu3+',
                                      '14.536',
                                      'Pu4+',
                                      '14.536',
                                      'Pu6+',
                                      '14.536',
                                      'Am',
                                      '15.087',
                                      'Cm',
                                      '15.634',
                                      'Bk',
                                      '16.317',
                                      'Cf',
                                      '16.93' ] ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_imag_mo',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.dispersion_imag_mo' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The imaginary component of the anomalous dispersion scattering factors\n     for this atom type and Mo K alpha radiation' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_imag_mo' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.0',
                                      'D',
                                      '.0',
                                      'H1-',
                                      '.0',
                                      'He',
                                      '.0',
                                      'Li',
                                      '.0',
                                      'Li1+',
                                      '.0',
                                      'Be',
                                      '.0',
                                      'Be2+',
                                      '.0',
                                      'B',
                                      '.001',
                                      'C',
                                      '.002',
                                      'N',
                                      '.003',
                                      'O',
                                      '.006',
                                      'O1-',
                                      '.006',
                                      'F',
                                      '.01',
                                      'F1-',
                                      '.01',
                                      'Ne',
                                      '.016',
                                      'Na',
                                      '.025',
                                      'Na1+',
                                      '.025',
                                      'Mg',
                                      '.036',
                                      'Mg2+',
                                      '.036',
                                      'Al',
                                      '.052',
                                      'Al3+',
                                      '.052',
                                      'Si',
                                      '.071',
                                      'Si4+',
                                      '.071',
                                      'P',
                                      '.095',
                                      'S',
                                      '.124',
                                      'Cl',
                                      '.159',
                                      'Cl1-',
                                      '.159',
                                      'Ar',
                                      '.201',
                                      'K',
                                      '.25',
                                      'K1+',
                                      '.25',
                                      'Ca',
                                      '.306',
                                      'Ca2+',
                                      '.306',
                                      'Sc',
                                      '0.372',
                                      'Sc3+',
                                      '0.372',
                                      'Ti',
                                      '.446',
                                      'Ti2+',
                                      '.446',
                                      'Ti3+',
                                      '.446',
                                      'Ti4+',
                                      '.446',
                                      'V',
                                      '.53',
                                      'V2+',
                                      '.53',
                                      'V3+',
                                      '.53',
                                      'V5+',
                                      '.53',
                                      'Cr',
                                      '.624',
                                      'Cr2+',
                                      '.624',
                                      'Cr3+',
                                      '.624',
                                      'Mn',
                                      '.729',
                                      'Mn2+',
                                      '.729',
                                      'Mn3+',
                                      '.729',
                                      'Mn4+',
                                      '.729',
                                      'Fe',
                                      '.845',
                                      'Fe2+',
                                      '.845',
                                      'Fe3+',
                                      '.845',
                                      'Co',
                                      '.973',
                                      'Co2+',
                                      '.973',
                                      'Co3+',
                                      '.973',
                                      'Ni',
                                      '1.113',
                                      'Ni2+',
                                      '1.113',
                                      'Ni3+',
                                      '1.113',
                                      'Cu',
                                      '1.266',
                                      'Cu1+',
                                      '1.266',
                                      'Cu2+',
                                      '1.266',
                                      'Zn',
                                      '1.431',
                                      'Zn2+',
                                      '1.431',
                                      'Ga',
                                      '1.609',
                                      'Ga3+',
                                      '1.609',
                                      'Ge',
                                      '1.801',
                                      'Ge4+',
                                      '1.801',
                                      'As',
                                      '2.007',
                                      'Se',
                                      '2.223',
                                      'Br',
                                      '2.456',
                                      'Br1-',
                                      '2.456',
                                      'Kr',
                                      '2.713',
                                      'Rb',
                                      '2.973',
                                      'Rb1+',
                                      '2.973',
                                      'Sr',
                                      '3.264',
                                      'Sr2+',
                                      '3.264',
                                      'Y',
                                      '3.542',
                                      'Y3+',
                                      '3.542',
                                      'Zr',
                                      '.56',
                                      'Zr4+',
                                      '.56',
                                      'Nb',
                                      '0.621',
                                      'Nb3+',
                                      '0.621',
                                      'Nb5+',
                                      '0.621',
                                      'Mo',
                                      '.688',
                                      'Mo3+',
                                      '.688',
                                      'Mo5+',
                                      '.688',
                                      'Mo6+',
                                      '.688',
                                      'Tc',
                                      '.759',
                                      'Ru',
                                      '.836',
                                      'Ru3+',
                                      '.836',
                                      'Ru4+',
                                      '.836',
                                      'Rh',
                                      '.919',
                                      'Rh3+',
                                      '.919',
                                      'Rh4+',
                                      '.919',
                                      'Pd',
                                      '1.007',
                                      'Pd2+',
                                      '1.007',
                                      'Pd4+',
                                      '1.007',
                                      'Ag',
                                      '1.101',
                                      'Ag1+',
                                      '1.101',
                                      'Ag2+',
                                      '1.101',
                                      'Cd',
                                      '1.202',
                                      'Cd2+',
                                      '1.202',
                                      'In',
                                      '1.31',
                                      'In3+',
                                      '1.31',
                                      'Sn',
                                      '1.424',
                                      'Sn2+',
                                      '1.424',
                                      'Sn4+',
                                      '1.424',
                                      'Sb',
                                      '1.546',
                                      'Sb3+',
                                      '1.546',
                                      'Sb5+',
                                      '1.546',
                                      'Te',
                                      '1.675',
                                      'I',
                                      '1.812',
                                      'I1-',
                                      '1.812',
                                      'Xe',
                                      '1.958',
                                      'Cs',
                                      '2.119',
                                      'Cs1+',
                                      '2.119',
                                      'Ba',
                                      '2.282',
                                      'Ba2+',
                                      '2.282',
                                      'La',
                                      '2.452',
                                      'La3+',
                                      '2.452',
                                      'Ce',
                                      '2.632',
                                      'Ce3+',
                                      '2.632',
                                      'Ce4+',
                                      '2.632',
                                      'Pr',
                                      '2.845',
                                      'Pr3+',
                                      '2.845',
                                      'Pr4+',
                                      '2.845',
                                      'Nd',
                                      '3.018',
                                      'Nd3+',
                                      '3.018',
                                      'Pm',
                                      '3.225',
                                      'Sm',
                                      '3.442',
                                      'Sm3+',
                                      '3.442',
                                      'Eu',
                                      '3.669',
                                      'Eu2+',
                                      '3.669',
                                      'Eu3+',
                                      '3.669',
                                      'Gd',
                                      '3.904',
                                      'Gd3+',
                                      '3.904',
                                      'Tb',
                                      '4.151',
                                      'Tb3+',
                                      '4.151',
                                      'Dy',
                                      '4.41',
                                      'Dy3+',
                                      '4.41',
                                      'Ho',
                                      '4.678',
                                      'Ho3+',
                                      '4.678',
                                      'Er',
                                      '4.958',
                                      'Er3+',
                                      '4.958',
                                      'Tm',
                                      '5.248',
                                      'Tm3+',
                                      '5.248',
                                      'Yb',
                                      '5.548',
                                      'Yb2+',
                                      '5.548',
                                      'Yb3+',
                                      '5.548',
                                      'Lu',
                                      '5.858',
                                      'Lu3+',
                                      '5.858',
                                      'Hf',
                                      '6.185',
                                      'Hf4+',
                                      '6.185',
                                      'Ta',
                                      '6.523',
                                      'Ta5+',
                                      '6.523',
                                      'W',
                                      '6.872',
                                      'W6+',
                                      '6.872',
                                      'Re',
                                      '7.232',
                                      'Os',
                                      '7.605',
                                      'Os4+',
                                      '7.605',
                                      'Ir',
                                      '7.99',
                                      'Ir3+',
                                      '7.99',
                                      'Ir4+',
                                      '7.99',
                                      'Pt',
                                      '8.388',
                                      'Pt2+',
                                      '8.388',
                                      'Pt4+',
                                      '8.388',
                                      'Au',
                                      '8.798',
                                      'Au1+',
                                      '8.798',
                                      'Au3+',
                                      '8.798',
                                      'Hg',
                                      '9.223',
                                      'Hg1+',
                                      '9.223',
                                      'Hg2+',
                                      '9.223',
                                      'Tl',
                                      '9.659',
                                      'TL1+',
                                      '9.659',
                                      'Tl3+',
                                      '9.659',
                                      'Pb',
                                      '10.102',
                                      'Pb2+',
                                      '10.102',
                                      'Pb4+',
                                      '10.102',
                                      'Bi',
                                      '10.559',
                                      'Bi3+',
                                      '10.559',
                                      'Bi5+',
                                      '10.559',
                                      'Po',
                                      '11.042',
                                      'At',
                                      '9.961',
                                      'Rn',
                                      '10.403',
                                      'Fr',
                                      '7.754',
                                      'Ra',
                                      '8.105',
                                      'Ra2+',
                                      '8.105',
                                      'Ac',
                                      '8.472',
                                      'Ac3+',
                                      '8.472',
                                      'Th',
                                      '8.87',
                                      'Th4+',
                                      '8.87',
                                      'Pa',
                                      '9.284',
                                      'U',
                                      '9.654',
                                      'U3+',
                                      '9.654',
                                      'U4+',
                                      '9.654',
                                      'U6+',
                                      '9.654',
                                      'Np',
                                      '4.148',
                                      'Np3+',
                                      '4.148',
                                      'Np4+',
                                      '4.148',
                                      'Np6+',
                                      '4.148',
                                      'Pu',
                                      '4.33',
                                      'Pu3+',
                                      '4.33',
                                      'Pu4+',
                                      '4.33',
                                      'Pu6+',
                                      '4.33',
                                      'Am',
                                      '4.511',
                                      'Cm',
                                      '4.697',
                                      'Bk',
                                      '4.908',
                                      'Cf',
                                      '5.107' ] ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_real',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.dispersion_real' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_dispersion_real',
                                      '_atom_type.scat_dispersion_real' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The real component of the anomalous dispersion scattering factors\n     for this atom type and radiation by _diffrn_radiation_wavelength.value' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_real' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n    With q as atom_type_scat\n \n     If ( _diffrn_radiation.type[0:2] == \'Cu\' ) a = q.dispersion_real_cu\n     If ( _diffrn_radiation.type[0:2] == \'Mo\' ) a = q.dispersion_real_mo\n \n             _atom_type_scat.dispersion_real = a' ] ],
                                  [ 'item_', '_enumeration.default', '0.0' ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_real_cu',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.dispersion_real_cu' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The real component of the anomalous dispersion scattering factors\n     for this atom type and Cu K alpha radiation' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_real_cu' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.0',
                                      'D',
                                      '.0',
                                      'H1-',
                                      '.0',
                                      'He',
                                      '.0',
                                      'Li',
                                      '.001',
                                      'Li1+',
                                      '.001',
                                      'Be',
                                      '.003',
                                      'Be2+',
                                      '.003',
                                      'B',
                                      '.008',
                                      'C',
                                      '.017',
                                      'N',
                                      '.029',
                                      'O',
                                      '.047',
                                      'O1-',
                                      '.047',
                                      'F',
                                      '.069',
                                      'F1-',
                                      '.069',
                                      'Ne',
                                      '.097',
                                      'Na',
                                      '0.129',
                                      'Na1+',
                                      '0.129',
                                      'Mg',
                                      '.165',
                                      'Mg2+',
                                      '.165',
                                      'Al',
                                      '.204',
                                      'Al3+',
                                      '.204',
                                      'Si',
                                      '.244',
                                      'Si4+',
                                      '.244',
                                      'P',
                                      '.283',
                                      'S',
                                      '.319',
                                      'Cl',
                                      '.348',
                                      'Cl1-',
                                      '.348',
                                      'Ar',
                                      '.366',
                                      'K',
                                      '.365',
                                      'K1+',
                                      '.365',
                                      'Ca',
                                      '.341',
                                      'Ca2+',
                                      '.341',
                                      'Sc',
                                      '0.285',
                                      'Sc3+',
                                      '0.285',
                                      'Ti',
                                      '.189',
                                      'Ti2+',
                                      '.189',
                                      'Ti3+',
                                      '.189',
                                      'Ti4+',
                                      '.189',
                                      'V',
                                      '.035',
                                      'V2+',
                                      '.035',
                                      'V3+',
                                      '.035',
                                      'V5+',
                                      '.035',
                                      'Cr',
                                      '-.198',
                                      'Cr2+',
                                      '-.198',
                                      'Cr3+',
                                      '-.198',
                                      'Mn',
                                      '-.568',
                                      'Mn2+',
                                      '-.568',
                                      'Mn3+',
                                      '-.568',
                                      'Mn4+',
                                      '-.568',
                                      'Fe',
                                      '-1.179',
                                      'Fe2+',
                                      '-1.179',
                                      'Fe3+',
                                      '-1.179',
                                      'Co',
                                      '-2.464',
                                      'Co2+',
                                      '-2.464',
                                      'Co3+',
                                      '-2.464',
                                      'Ni',
                                      '-2.956',
                                      'Ni2+',
                                      '-2.956',
                                      'Ni3+',
                                      '-2.956',
                                      'Cu',
                                      '-2.019',
                                      'Cu1+',
                                      '-2.019',
                                      'Cu2+',
                                      '-2.019',
                                      'Zn',
                                      '-1.612',
                                      'Zn2+',
                                      '-1.612',
                                      'Ga',
                                      '-1.354',
                                      'Ga3+',
                                      '-1.354',
                                      'Ge',
                                      '-1.163',
                                      'Ge4+',
                                      '-1.163',
                                      'As',
                                      '-1.011',
                                      'Se',
                                      '-.879',
                                      'Br',
                                      '-.767',
                                      'Br1-',
                                      '-.767',
                                      'Kr',
                                      '-.665',
                                      'Rb',
                                      '-.574',
                                      'Rb1+',
                                      '-.574',
                                      'Sr',
                                      '-.465',
                                      'Sr2+',
                                      '-.465',
                                      'Y',
                                      '-.386',
                                      'Y3+',
                                      '-.386',
                                      'Zr',
                                      '-.314',
                                      'Zr4+',
                                      '-.314',
                                      'Nb',
                                      '-.248',
                                      'Nb3+',
                                      '-.248',
                                      'Nb5+',
                                      '-.248',
                                      'Mo',
                                      '-.191',
                                      'Mo3+',
                                      '-.191',
                                      'Mo5+',
                                      '-.191',
                                      'Mo6+',
                                      '-.191',
                                      'Tc',
                                      '-.145',
                                      'Ru',
                                      '-.105',
                                      'Ru3+',
                                      '-.105',
                                      'Ru4+',
                                      '-.105',
                                      'Rh',
                                      '-.077',
                                      'Rh3+',
                                      '-.077',
                                      'Rh4+',
                                      '-.077',
                                      'Pd',
                                      '-.059',
                                      'Pd2+',
                                      '-.059',
                                      'Pd4+',
                                      '-.059',
                                      'Ag',
                                      '-.06',
                                      'Ag1+',
                                      '-.06',
                                      'Ag2+',
                                      '-.06',
                                      'Cd',
                                      '-.079',
                                      'Cd2+',
                                      '-.079',
                                      'In',
                                      '-.126',
                                      'In3+',
                                      '-.126',
                                      'Sn',
                                      '-.194',
                                      'Sn2+',
                                      '-.194',
                                      'Sn4+',
                                      '-.194',
                                      'Sb',
                                      '-.287',
                                      'Sb3+',
                                      '-.287',
                                      'Sb5+',
                                      '-.287',
                                      'Te',
                                      '-.418',
                                      'I',
                                      '-.579',
                                      'I1-',
                                      '-.579',
                                      'Xe',
                                      '-.783',
                                      'Cs',
                                      '-1.022',
                                      'Cs1+',
                                      '-1.022',
                                      'Ba',
                                      '-1.334',
                                      'Ba2+',
                                      '-1.334',
                                      'La',
                                      '-1.716',
                                      'La3+',
                                      '-1.716',
                                      'Ce',
                                      '-2.17',
                                      'Ce3+',
                                      '-2.17',
                                      'Ce4+',
                                      '-2.17',
                                      'Pr',
                                      '-2.939',
                                      'Pr3+',
                                      '-2.939',
                                      'Pr4+',
                                      '-2.939',
                                      'Nd',
                                      '-3.431',
                                      'Nd3+',
                                      '-3.431',
                                      'Pm',
                                      '-4.357',
                                      'Sm',
                                      '-5.696',
                                      'Sm3+',
                                      '-5.696',
                                      'Eu',
                                      '-7.718',
                                      'Eu2+',
                                      '-7.718',
                                      'Eu3+',
                                      '-7.718',
                                      'Gd',
                                      '-9.242',
                                      'Gd3+',
                                      '-9.242',
                                      'Tb',
                                      '-9.498',
                                      'Tb3+',
                                      '-9.498',
                                      'Dy',
                                      '-10.423',
                                      'Dy3+',
                                      '-10.423',
                                      'Ho',
                                      '-12.255',
                                      'Ho3+',
                                      '-12.255',
                                      'Er',
                                      '-9.733',
                                      'Er3+',
                                      '-9.733',
                                      'Tm',
                                      '-8.488',
                                      'Tm3+',
                                      '-8.488',
                                      'Yb',
                                      '-7.701',
                                      'Yb2+',
                                      '-7.701',
                                      'Yb3+',
                                      '-7.701',
                                      'Lu',
                                      '-7.133',
                                      'Lu3+',
                                      '-7.133',
                                      'Hf',
                                      '-6.715',
                                      'Hf4+',
                                      '-6.715',
                                      'Ta',
                                      '-6.351',
                                      'Ta5+',
                                      '-6.351',
                                      'W',
                                      '-6.048',
                                      'W6+',
                                      '-6.048',
                                      'Re',
                                      '-5.79',
                                      'Os',
                                      '-5.581',
                                      'Os4+',
                                      '-5.581',
                                      'Ir',
                                      '-5.391',
                                      'Ir3+',
                                      '-5.391',
                                      'Ir4+',
                                      '-5.391',
                                      'Pt',
                                      '-5.233',
                                      'Pt2+',
                                      '-5.233',
                                      'Pt4+',
                                      '-5.233',
                                      'Au',
                                      '-5.096',
                                      'Au1+',
                                      '-5.096',
                                      'Au3+',
                                      '-5.096',
                                      'Hg',
                                      '-4.99',
                                      'Hg1+',
                                      '-4.99',
                                      'Hg2+',
                                      '-4.99',
                                      'Tl',
                                      '-4.883',
                                      'TL1+',
                                      '-4.883',
                                      'Tl3+',
                                      '-4.883',
                                      'Pb',
                                      '-4.818',
                                      'Pb2+',
                                      '-4.818',
                                      'Pb4+',
                                      '-4.818',
                                      'Bi',
                                      '-4.776',
                                      'Bi3+',
                                      '-4.776',
                                      'Bi5+',
                                      '-4.776',
                                      'Po',
                                      '-4.756',
                                      'At',
                                      '-4.772',
                                      'Rn',
                                      '-4.787',
                                      'Fr',
                                      '-4.833',
                                      'Ra',
                                      '-4.898',
                                      'Ra2+',
                                      '-4.898',
                                      'Ac',
                                      '-4.994',
                                      'Ac3+',
                                      '-4.994',
                                      'Th',
                                      '-5.091',
                                      'Th4+',
                                      '-5.091',
                                      'Pa',
                                      '-5.216',
                                      'U',
                                      '-5.359',
                                      'U3+',
                                      '-5.359',
                                      'U4+',
                                      '-5.359',
                                      'U6+',
                                      '-5.359',
                                      'Np',
                                      '-5.529',
                                      'Np3+',
                                      '-5.529',
                                      'Np4+',
                                      '-5.529',
                                      'Np6+',
                                      '-5.529',
                                      'Pu',
                                      '-5.712',
                                      'Pu3+',
                                      '-5.712',
                                      'Pu4+',
                                      '-5.712',
                                      'Pu6+',
                                      '-5.712',
                                      'Am',
                                      '-5.93',
                                      'Cm',
                                      '-6.176',
                                      'Bk',
                                      '-6.498',
                                      'Cf',
                                      '-6.798' ] ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_real_mo',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.dispersion_real_mo' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The real component of the anomalous dispersion scattering factors\n     for this atom type and Mo K alpha radiation' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_real_mo' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.0',
                                      'D',
                                      '.0',
                                      'H1-',
                                      '.0',
                                      'He',
                                      '.0',
                                      'Li',
                                      '.0',
                                      'Li1+',
                                      '.0',
                                      'Be',
                                      '.0',
                                      'Be2+',
                                      '.0',
                                      'B',
                                      '.0',
                                      'C',
                                      '.002',
                                      'N',
                                      '.004',
                                      'O',
                                      '.008',
                                      'O1-',
                                      '.008',
                                      'F',
                                      '.014',
                                      'F1-',
                                      '.014',
                                      'Ne',
                                      '.021',
                                      'Na',
                                      '0.03',
                                      'Na1+',
                                      '0.03',
                                      'Mg',
                                      '.042',
                                      'Mg2+',
                                      '.042',
                                      'Al',
                                      '.056',
                                      'Al3+',
                                      '.056',
                                      'Si',
                                      '.072',
                                      'Si4+',
                                      '.072',
                                      'P',
                                      '.09',
                                      'S',
                                      '.11',
                                      'Cl',
                                      '.132',
                                      'Cl1-',
                                      '.132',
                                      'Ar',
                                      '.155',
                                      'K',
                                      '.179',
                                      'K1+',
                                      '.179',
                                      'Ca',
                                      '.203',
                                      'Ca2+',
                                      '.203',
                                      'Sc',
                                      '0.226',
                                      'Sc3+',
                                      '0.226',
                                      'Ti',
                                      '.248',
                                      'Ti2+',
                                      '.248',
                                      'Ti3+',
                                      '.248',
                                      'Ti4+',
                                      '.248',
                                      'V',
                                      '.267',
                                      'V2+',
                                      '.267',
                                      'V3+',
                                      '.267',
                                      'V5+',
                                      '.267',
                                      'Cr',
                                      '.284',
                                      'Cr2+',
                                      '.284',
                                      'Cr3+',
                                      '.284',
                                      'Mn',
                                      '.295',
                                      'Mn2+',
                                      '.295',
                                      'Mn3+',
                                      '.295',
                                      'Mn4+',
                                      '.295',
                                      'Fe',
                                      '.301',
                                      'Fe2+',
                                      '.301',
                                      'Fe3+',
                                      '.301',
                                      'Co',
                                      '.299',
                                      'Co2+',
                                      '.299',
                                      'Co3+',
                                      '.299',
                                      'Ni',
                                      '.285',
                                      'Ni2+',
                                      '.285',
                                      'Ni3+',
                                      '.285',
                                      'Cu',
                                      '.263',
                                      'Cu1+',
                                      '.263',
                                      'Cu2+',
                                      '.263',
                                      'Zn',
                                      '.222',
                                      'Zn2+',
                                      '.222',
                                      'Ga',
                                      '0.163',
                                      'Ga3+',
                                      '0.163',
                                      'Ge',
                                      '.081',
                                      'Ge4+',
                                      '.081',
                                      'As',
                                      '-.03',
                                      'Se',
                                      '-.178',
                                      'Br',
                                      '-.374',
                                      'Br1-',
                                      '-.374',
                                      'Kr',
                                      '-.652',
                                      'Rb',
                                      '-1.044',
                                      'Rb1+',
                                      '-1.044',
                                      'Sr',
                                      '-1.657',
                                      'Sr2+',
                                      '-1.657',
                                      'Y',
                                      '-2.951',
                                      'Y3+',
                                      '-2.951',
                                      'Zr',
                                      '-2.965',
                                      'Zr4+',
                                      '-2.965',
                                      'Nb',
                                      '-2.197',
                                      'Nb3+',
                                      '-2.197',
                                      'Nb5+',
                                      '-2.197',
                                      'Mo',
                                      '-1.825',
                                      'Mo3+',
                                      '-1.825',
                                      'Mo5+',
                                      '-1.825',
                                      'Mo6+',
                                      '-1.825',
                                      'Tc',
                                      '-1.59',
                                      'Ru',
                                      '-1.42',
                                      'Ru3+',
                                      '-1.42',
                                      'Ru4+',
                                      '-1.42',
                                      'Rh',
                                      '-1.287',
                                      'Rh3+',
                                      '-1.287',
                                      'Rh4+',
                                      '-1.287',
                                      'Pd',
                                      '-1.177',
                                      'Pd2+',
                                      '-1.177',
                                      'Pd4+',
                                      '-1.177',
                                      'Ag',
                                      '-1.085',
                                      'Ag1+',
                                      '-1.085',
                                      'Ag2+',
                                      '-1.085',
                                      'Cd',
                                      '-1.005',
                                      'Cd2+',
                                      '-1.005',
                                      'In',
                                      '-.936',
                                      'In3+',
                                      '-.936',
                                      'Sn',
                                      '-.873',
                                      'Sn2+',
                                      '-.873',
                                      'Sn4+',
                                      '-.873',
                                      'Sb',
                                      '-.816',
                                      'Sb3+',
                                      '-.816',
                                      'Sb5+',
                                      '-.816',
                                      'Te',
                                      '-.772',
                                      'I',
                                      '-.726',
                                      'I1-',
                                      '-.726',
                                      'Xe',
                                      '-.684',
                                      'Cs',
                                      '-.644',
                                      'Cs1+',
                                      '-.644',
                                      'Ba',
                                      '-.613',
                                      'Ba2+',
                                      '-.613',
                                      'La',
                                      '-.588',
                                      'La3+',
                                      '-.588',
                                      'Ce',
                                      '-.564',
                                      'Ce3+',
                                      '-.564',
                                      'Ce4+',
                                      '-.564',
                                      'Pr',
                                      '-.53',
                                      'Pr3+',
                                      '-.53',
                                      'Pr4+',
                                      '-.53',
                                      'Nd',
                                      '-.535',
                                      'Nd3+',
                                      '-.535',
                                      'Pm',
                                      '-.53',
                                      'Sm',
                                      '-.533',
                                      'Sm3+',
                                      '-.533',
                                      'Eu',
                                      '-.542',
                                      'Eu2+',
                                      '-.542',
                                      'Eu3+',
                                      '-.542',
                                      'Gd',
                                      '-.564',
                                      'Gd3+',
                                      '-.564',
                                      'Tb',
                                      '-.591',
                                      'Tb3+',
                                      '-.591',
                                      'Dy',
                                      '-.619',
                                      'Dy3+',
                                      '-.619',
                                      'Ho',
                                      '-.666',
                                      'Ho3+',
                                      '-.666',
                                      'Er',
                                      '-.723',
                                      'Er3+',
                                      '-.723',
                                      'Tm',
                                      '-.795',
                                      'Tm3+',
                                      '-.795',
                                      'Yb',
                                      '-.884',
                                      'Yb2+',
                                      '-.884',
                                      'Yb3+',
                                      '-.884',
                                      'Lu',
                                      '-.988',
                                      'Lu3+',
                                      '-.988',
                                      'Hf',
                                      '-1.118',
                                      'Hf4+',
                                      '-1.118',
                                      'Ta',
                                      '-1.258',
                                      'Ta5+',
                                      '-1.258',
                                      'W',
                                      '-1.421',
                                      'W6+',
                                      '-1.421',
                                      'Re',
                                      '-1.598',
                                      'Os',
                                      '-1.816',
                                      'Os4+',
                                      '-1.816',
                                      'Ir',
                                      '-2.066',
                                      'Ir3+',
                                      '-2.066',
                                      'Ir4+',
                                      '-2.066',
                                      'Pt',
                                      '-2.352',
                                      'Pt2+',
                                      '-2.352',
                                      'Pt4+',
                                      '-2.352',
                                      'Au',
                                      '-2.688',
                                      'Au1+',
                                      '-2.688',
                                      'Au3+',
                                      '-2.688',
                                      'Hg',
                                      '-3.084',
                                      'Hg1+',
                                      '-3.084',
                                      'Hg2+',
                                      '-3.084',
                                      'Tl',
                                      '-3.556',
                                      'TL1+',
                                      '-3.556',
                                      'Tl3+',
                                      '-3.556',
                                      'Pb',
                                      '-4.133',
                                      'Pb2+',
                                      '-4.133',
                                      'Pb4+',
                                      '-4.133',
                                      'Bi',
                                      '-4.861',
                                      'Bi3+',
                                      '-4.861',
                                      'Bi5+',
                                      '-4.861',
                                      'Po',
                                      '-5.924',
                                      'At',
                                      '-7.444',
                                      'Rn',
                                      '-8.862',
                                      'Fr',
                                      '-7.912',
                                      'Ra',
                                      '-7.62',
                                      'Ra2+',
                                      '-7.62',
                                      'Ac',
                                      '-7.725',
                                      'Ac3+',
                                      '-7.725',
                                      'Th',
                                      '-8.127',
                                      'Th4+',
                                      '-8.127',
                                      'Pa',
                                      '-8.96',
                                      'U',
                                      '-10.673',
                                      'U3+',
                                      '-10.673',
                                      'U4+',
                                      '-10.673',
                                      'U6+',
                                      '-10.673',
                                      'Np',
                                      '-11.158',
                                      'Np3+',
                                      '-11.158',
                                      'Np4+',
                                      '-11.158',
                                      'Np6+',
                                      '-11.158',
                                      'Pu',
                                      '-9.725',
                                      'Pu3+',
                                      '-9.725',
                                      'Pu4+',
                                      '-9.725',
                                      'Pu6+',
                                      '-9.725',
                                      'Am',
                                      '-8.926',
                                      'Cm',
                                      '-8.416',
                                      'Bk',
                                      '-7.99',
                                      'Cf',
                                      '-7.683' ] ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'atom_type_scat.dispersion_source',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.dispersion_source' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_dispersion_source' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Reference to source of real and imaginary dispersion\n     corrections for scattering factors used for this atom type.' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'dispersion_source' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'International Tables Vol. IV Table 2.3.1' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.hi_ang_Fox_coeffs',
                                [ [ 'item_',
                                    '_definition.id',
                                    '_atom_type_scat.hi_ang_Fox_coeffs' ],
                                  [ 'item_', '_definition.update', '2012-11-30' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The set of Fox et al. coefficients for generating high angle\n     X-ray scattering factors. [ c0, c1, c2, c3 ]\n     Ref: International Tables for Crystallography, Vol. C\n             (1991) Table 6.1.1.5' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'hi_ang_Fox_coeffs' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'List' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_type.dimension', [ '4' ] ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Evaluation',
                                      '\n     With t  as  atom_type_scat\n \n    _atom_type_scat.hi_ang_Fox_coeffs  =  \\\n     [t.hi_ang_Fox_c0,t.hi_ang_Fox_c1,t.hi_ang_Fox_c2,t.hi_ang_Fox_c3]' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.hi_ang_Fox_c0',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.hi_ang_Fox_c0' ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n    The set of data items used to define Fox et al.  coefficients\n     for generation of high angle (s >2.0) X-ray scattering factors.\n \n        Ref: International Tables for Crystallography, Vol. C\n             (1991) Table 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '-4.8',
                                      'D',
                                      '-4.8',
                                      'H1-',
                                      '-4.8',
                                      'He',
                                      '0.52543',
                                      'Li',
                                      '0.89463',
                                      'Li1+',
                                      '0.89463',
                                      'Be',
                                      '1.2584',
                                      'Be2+',
                                      '1.2584',
                                      'B',
                                      '1.6672',
                                      'C',
                                      '1.70560',
                                      'N',
                                      '1.54940',
                                      'O',
                                      '1.30530',
                                      'O1-',
                                      '1.30530',
                                      'F',
                                      '1.16710',
                                      'F1-',
                                      '1.16710',
                                      'Ne',
                                      '1.09310',
                                      'Na',
                                      '0.84558',
                                      'Na1+',
                                      '0.84558',
                                      'Mg',
                                      '0.71877',
                                      'Mg2+',
                                      '0.71877',
                                      'Al',
                                      '0.67975',
                                      'Al3+',
                                      '0.67975',
                                      'Si',
                                      '0.70683',
                                      'Si4+',
                                      '0.70683',
                                      'P',
                                      '0.85532',
                                      'S',
                                      '1.10400',
                                      'Cl',
                                      '1.42320',
                                      'Cl1-',
                                      '1.42320',
                                      'Ar',
                                      '1.82020',
                                      'K',
                                      '2.26550',
                                      'K1+',
                                      '2.26550',
                                      'Ca',
                                      '2.71740',
                                      'Ca2+',
                                      '2.71740',
                                      'Sc',
                                      '3.11730',
                                      'Sc3+',
                                      '3.11730',
                                      'Ti',
                                      '3.45360',
                                      'Ti2+',
                                      '3.45360',
                                      'Ti3+',
                                      '3.45360',
                                      'Ti4+',
                                      '3.45360',
                                      'V',
                                      '3.71270',
                                      'V2+',
                                      '3.71270',
                                      'V3+',
                                      '3.71270',
                                      'V5+',
                                      '3.71270',
                                      'Cr',
                                      '3.87870',
                                      'Cr2+',
                                      '3.87870',
                                      'Cr3+',
                                      '3.87870',
                                      'Mn',
                                      '3.98550',
                                      'Mn2+',
                                      '3.98550',
                                      'Mn3+',
                                      '3.98550',
                                      'Mn4+',
                                      '3.98550',
                                      'Fe',
                                      '3.99790',
                                      'Fe2+',
                                      '3.99790',
                                      'Fe3+',
                                      '3.99790',
                                      'Co',
                                      '3.95900',
                                      'Co2+',
                                      '3.95900',
                                      'Co3+',
                                      '3.95900',
                                      'Ni',
                                      '3.86070',
                                      'Ni2+',
                                      '3.86070',
                                      'Ni3+',
                                      '3.86070',
                                      'Cu',
                                      '3.72510',
                                      'Cu1+',
                                      '3.72510',
                                      'Cu2+',
                                      '3.72510',
                                      'Zn',
                                      '3.55950',
                                      'Zn2+',
                                      '3.55950',
                                      'Ga',
                                      '3.37560',
                                      'Ga3+',
                                      '3.37560',
                                      'Ge',
                                      '3.17800',
                                      'Ge4+',
                                      '3.17800',
                                      'As',
                                      '2.97740',
                                      'Se',
                                      '2.78340',
                                      'Br',
                                      '2.60610',
                                      'Br1-',
                                      '2.60610',
                                      'Kr',
                                      '2.44280',
                                      'Rb',
                                      '2.30990',
                                      'Rb1+',
                                      '2.30990',
                                      'Sr',
                                      '2.21070',
                                      'Sr2+',
                                      '2.21070',
                                      'Y',
                                      '2.14220',
                                      'Y3+',
                                      '2.14220',
                                      'Zr',
                                      '2.12690',
                                      'Zr4+',
                                      '2.12690',
                                      'Nb',
                                      '2.12120',
                                      'Nb3+',
                                      '2.12120',
                                      'Nb5+',
                                      '2.12120',
                                      'Mo',
                                      '2.18870',
                                      'Mo3+',
                                      '2.18870',
                                      'Mo5+',
                                      '2.18870',
                                      'Mo6+',
                                      '2.18870',
                                      'Tc',
                                      '2.25730',
                                      'Ru',
                                      '2.37300',
                                      'Ru3+',
                                      '2.37300',
                                      'Ru4+',
                                      '2.37300',
                                      'Rh',
                                      '2.50990',
                                      'Rh3+',
                                      '2.50990',
                                      'Rh4+',
                                      '2.50990',
                                      'Pd',
                                      '2.67520',
                                      'Pd2+',
                                      '2.67520',
                                      'Pd4+',
                                      '2.67520',
                                      'Ag',
                                      '2.88690',
                                      'Ag1+',
                                      '2.88690',
                                      'Ag2+',
                                      '2.88690',
                                      'Cd',
                                      '3.08430',
                                      'Cd2+',
                                      '3.08430',
                                      'In',
                                      '3.31400',
                                      'In3+',
                                      '3.31400',
                                      'Sn',
                                      '3.49840',
                                      'Sn2+',
                                      '3.49840',
                                      'Sn4+',
                                      '3.49840',
                                      'Sb',
                                      '3.70410',
                                      'Sb3+',
                                      '3.70410',
                                      'Sb5+',
                                      '3.70410',
                                      'Te',
                                      '3.88240',
                                      'I',
                                      '4.08010',
                                      'I1-',
                                      '4.08010',
                                      'Xe',
                                      '4.24610',
                                      'Cs',
                                      '4.38910',
                                      'Cs1+',
                                      '4.38910',
                                      'Ba',
                                      '4.51070',
                                      'Ba2+',
                                      '4.51070',
                                      'La',
                                      '4.60250',
                                      'La3+',
                                      '4.60250',
                                      'Ce',
                                      '4.69060',
                                      'Ce3+',
                                      '4.69060',
                                      'Ce4+',
                                      '4.69060',
                                      'Pr',
                                      '4.72150',
                                      'Pr3+',
                                      '4.72150',
                                      'Pr4+',
                                      '4.72150',
                                      'Nd',
                                      '4.75090',
                                      'Nd3+',
                                      '4.75090',
                                      'Pm',
                                      '4.74070',
                                      'Sm',
                                      '4.71700',
                                      'Sm3+',
                                      '4.71700',
                                      'Eu',
                                      '4.66940',
                                      'Eu2+',
                                      '4.66940',
                                      'Eu3+',
                                      '4.66940',
                                      'Gd',
                                      '4.61010',
                                      'Gd3+',
                                      '4.61010',
                                      'Tb',
                                      '4.52550',
                                      'Tb3+',
                                      '4.52550',
                                      'Dy',
                                      '4.45230',
                                      'Dy3+',
                                      '4.45230',
                                      'Ho',
                                      '4.37660',
                                      'Ho3+',
                                      '4.37660',
                                      'Er',
                                      '4.29460',
                                      'Er3+',
                                      '4.29460',
                                      'Tm',
                                      '4.21330',
                                      'Tm3+',
                                      '4.21330',
                                      'Yb',
                                      '4.13430',
                                      'Yb2+',
                                      '4.13430',
                                      'Yb3+',
                                      '4.13430',
                                      'Lu',
                                      '4.04230',
                                      'Lu3+',
                                      '4.04230',
                                      'Hf',
                                      '3.95160',
                                      'Hf4+',
                                      '3.95160',
                                      'Ta',
                                      '3.85000',
                                      'Ta5+',
                                      '3.85000',
                                      'W',
                                      '3.76510',
                                      'W6+',
                                      '3.76510',
                                      'Re',
                                      '3.67600',
                                      'Os',
                                      '3.60530',
                                      'Os4+',
                                      '3.60530',
                                      'Ir',
                                      '3.53130',
                                      'Ir3+',
                                      '3.53130',
                                      'Ir4+',
                                      '3.53130',
                                      'Pt',
                                      '3.47070',
                                      'Pt2+',
                                      '3.47070',
                                      'Pt4+',
                                      '3.47070',
                                      'Au',
                                      '3.41630',
                                      'Au1+',
                                      '3.41630',
                                      'Au3+',
                                      '3.41630',
                                      'Hg',
                                      '3.37350',
                                      'Hg1+',
                                      '3.37350',
                                      'Hg2+',
                                      '3.37350',
                                      'Tl',
                                      '3.34590',
                                      'TL1+',
                                      '3.34590',
                                      'Tl3+',
                                      '3.34590',
                                      'Pb',
                                      '3.32330',
                                      'Pb2+',
                                      '3.32330',
                                      'Pb4+',
                                      '3.32330',
                                      'Bi',
                                      '3.31880',
                                      'Bi3+',
                                      '3.31880',
                                      'Bi5+',
                                      '3.31880',
                                      'Po',
                                      '3.32030',
                                      'At',
                                      '3.34250',
                                      'Rn',
                                      '3.37780',
                                      'Fr',
                                      '3.41990',
                                      'Ra',
                                      '3.47530',
                                      'Ra2+',
                                      '3.47530',
                                      'Ac',
                                      '3.49020',
                                      'Ac3+',
                                      '3.49020',
                                      'Th',
                                      '3.61060',
                                      'Th4+',
                                      '3.61060',
                                      'Pa',
                                      '3.68630',
                                      'U',
                                      '3.76650',
                                      'U3+',
                                      '3.76650',
                                      'U4+',
                                      '3.76650',
                                      'U6+',
                                      '3.76650',
                                      'Np',
                                      '3.82870',
                                      'Np3+',
                                      '3.82870',
                                      'Np4+',
                                      '3.82870',
                                      'Np6+',
                                      '3.82870',
                                      'Pu',
                                      '3.88970',
                                      'Pu3+',
                                      '3.88970',
                                      'Pu4+',
                                      '3.88970',
                                      'Pu6+',
                                      '3.88970',
                                      'Am',
                                      '3.95060',
                                      'Cm',
                                      '4.01470',
                                      'Bk',
                                      '4.07780',
                                      'Cf',
                                      '4.14210' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'hi_ang_Fox_c0' ] ] ],
                              [ 'save_',
                                'atom_type_scat.hi_ang_Fox_c1',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.hi_ang_Fox_c1' ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n    The set of data items used to define Fox et al.  coefficients\n     for generation of high angle (s >2.0) X-ray scattering factors.\n \n        Ref: International Tables for Crystallography, Vol. C\n             (1991) Table 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '-.5',
                                      'D',
                                      '-.5',
                                      'H1-',
                                      '-.5',
                                      'He',
                                      '-3.433',
                                      'Li',
                                      '-2.4366',
                                      'Li1+',
                                      '-2.4366',
                                      'Be',
                                      '-1.9459',
                                      'Be2+',
                                      '-1.9459',
                                      'B',
                                      '-1.8556',
                                      'C',
                                      '-1.56760',
                                      'N',
                                      '-1.20190',
                                      'O',
                                      '-0.83742',
                                      'O1-',
                                      '-0.83742',
                                      'F',
                                      '-0.63203',
                                      'F1-',
                                      '-0.63203',
                                      'Ne',
                                      '-0.50221',
                                      'Na',
                                      '-0.26294',
                                      'Na1+',
                                      '-0.26294',
                                      'Mg',
                                      '-0.13144',
                                      'Mg2+',
                                      '-0.13144',
                                      'Al',
                                      '-0.08756',
                                      'Al3+',
                                      '-0.08756',
                                      'Si',
                                      '-0.09888',
                                      'Si4+',
                                      '-0.09888',
                                      'P',
                                      '-0.21262',
                                      'S',
                                      '-0.40325',
                                      'Cl',
                                      '-0.63936',
                                      'Cl1-',
                                      '-0.63936',
                                      'Ar',
                                      '-0.92776',
                                      'K',
                                      '-1.24530',
                                      'K1+',
                                      '-1.24530',
                                      'Ca',
                                      '-1.55670',
                                      'Ca2+',
                                      '-1.55670',
                                      'Sc',
                                      '-1.81380',
                                      'Sc3+',
                                      '-1.81380',
                                      'Ti',
                                      '-2.01150',
                                      'Ti2+',
                                      '-2.01150',
                                      'Ti3+',
                                      '-2.01150',
                                      'Ti4+',
                                      '-2.01150',
                                      'V',
                                      '-2.13920',
                                      'V2+',
                                      '-2.13920',
                                      'V3+',
                                      '-2.13920',
                                      'V5+',
                                      '-2.13920',
                                      'Cr',
                                      '-2.19000',
                                      'Cr2+',
                                      '-2.19000',
                                      'Cr3+',
                                      '-2.19000',
                                      'Mn',
                                      '-2.18850',
                                      'Mn2+',
                                      '-2.18850',
                                      'Mn3+',
                                      '-2.18850',
                                      'Mn4+',
                                      '-2.18850',
                                      'Fe',
                                      '-2.11080',
                                      'Fe2+',
                                      '-2.11080',
                                      'Fe3+',
                                      '-2.11080',
                                      'Co',
                                      '-1.99650',
                                      'Co2+',
                                      '-1.99650',
                                      'Co3+',
                                      '-1.99650',
                                      'Ni',
                                      '-1.88690',
                                      'Ni2+',
                                      '-1.88690',
                                      'Ni3+',
                                      '-1.88690',
                                      'Cu',
                                      '-1.65500',
                                      'Cu1+',
                                      '-1.65500',
                                      'Cu2+',
                                      '-1.65500',
                                      'Zn',
                                      '-1.45100',
                                      'Zn2+',
                                      '-1.45100',
                                      'Ga',
                                      '-1.23910',
                                      'Ga3+',
                                      '-1.23910',
                                      'Ge',
                                      '-1.02230',
                                      'Ge4+',
                                      '-1.02230',
                                      'As',
                                      '-0.81038',
                                      'Se',
                                      '-0.61110',
                                      'Br',
                                      '-0.43308',
                                      'Br1-',
                                      '-0.43308',
                                      'Kr',
                                      '-0.27244',
                                      'Rb',
                                      '-0.14328',
                                      'Rb1+',
                                      '-0.14328',
                                      'Sr',
                                      '-0.04770',
                                      'Sr2+',
                                      '-0.04770',
                                      'Y',
                                      '0.01935',
                                      'Y3+',
                                      '0.01935',
                                      'Zr',
                                      '0.08618',
                                      'Zr4+',
                                      '0.08618',
                                      'Nb',
                                      '0.05381',
                                      'Nb3+',
                                      '0.05381',
                                      'Nb5+',
                                      '0.05381',
                                      'Mo',
                                      '-0.00655',
                                      'Mo3+',
                                      '-0.00655',
                                      'Mo5+',
                                      '-0.00655',
                                      'Mo6+',
                                      '-0.00655',
                                      'Tc',
                                      '-0.05737',
                                      'Ru',
                                      '-0.15040',
                                      'Ru3+',
                                      '-0.15040',
                                      'Ru4+',
                                      '-0.15040',
                                      'Rh',
                                      '-0.25906',
                                      'Rh3+',
                                      '-0.25906',
                                      'Rh4+',
                                      '-0.25906',
                                      'Pd',
                                      '-0.39137',
                                      'Pd2+',
                                      '-0.39137',
                                      'Pd4+',
                                      '-0.39137',
                                      'Ag',
                                      '-0.56119',
                                      'Ag1+',
                                      '-0.56119',
                                      'Ag2+',
                                      '-0.56119',
                                      'Cd',
                                      '-0.71450',
                                      'Cd2+',
                                      '-0.71450',
                                      'In',
                                      '-0.89697',
                                      'In3+',
                                      '-0.89697',
                                      'Sn',
                                      '-1.02990',
                                      'Sn2+',
                                      '-1.02990',
                                      'Sn4+',
                                      '-1.02990',
                                      'Sb',
                                      '-1.18270',
                                      'Sb3+',
                                      '-1.18270',
                                      'Sb5+',
                                      '-1.18270',
                                      'Te',
                                      '-1.30980',
                                      'I',
                                      '-1.45080',
                                      'I1-',
                                      '-1.45080',
                                      'Xe',
                                      '-1.56330',
                                      'Cs',
                                      '-1.65420',
                                      'Cs1+',
                                      '-1.65420',
                                      'Ba',
                                      '-1.72570',
                                      'Ba2+',
                                      '-1.72570',
                                      'La',
                                      '-1.77070',
                                      'La3+',
                                      '-1.77070',
                                      'Ce',
                                      '-1.81790',
                                      'Ce3+',
                                      '-1.81790',
                                      'Ce4+',
                                      '-1.81790',
                                      'Pr',
                                      '-1.81390',
                                      'Pr3+',
                                      '-1.81390',
                                      'Pr4+',
                                      '-1.81390',
                                      'Nd',
                                      '-1.80800',
                                      'Nd3+',
                                      '-1.80800',
                                      'Pm',
                                      '-1.76600',
                                      'Sm',
                                      '-1.71410',
                                      'Sm3+',
                                      '-1.71410',
                                      'Eu',
                                      '-1.64140',
                                      'Eu2+',
                                      '-1.64140',
                                      'Eu3+',
                                      '-1.64140',
                                      'Gd',
                                      '-1.55750',
                                      'Gd3+',
                                      '-1.55750',
                                      'Tb',
                                      '-1.45520',
                                      'Tb3+',
                                      '-1.45520',
                                      'Dy',
                                      '-1.36440',
                                      'Dy3+',
                                      '-1.36440',
                                      'Ho',
                                      '-1.27460',
                                      'Ho3+',
                                      '-1.27460',
                                      'Er',
                                      '-1.18170',
                                      'Er3+',
                                      '-1.18170',
                                      'Tm',
                                      '-1.09060',
                                      'Tm3+',
                                      '-1.09060',
                                      'Yb',
                                      '-1.00310',
                                      'Yb2+',
                                      '-1.00310',
                                      'Yb3+',
                                      '-1.00310',
                                      'Lu',
                                      '-0.90518',
                                      'Lu3+',
                                      '-0.90518',
                                      'Hf',
                                      '-0.80978',
                                      'Hf4+',
                                      '-0.80978',
                                      'Ta',
                                      '-0.70599',
                                      'Ta5+',
                                      '-0.70599',
                                      'W',
                                      '-0.61807',
                                      'W6+',
                                      '-0.61807',
                                      'Re',
                                      '-0.52688',
                                      'Os',
                                      '-0.45420',
                                      'Os4+',
                                      '-0.45420',
                                      'Ir',
                                      '-0.37856',
                                      'Ir3+',
                                      '-0.37856',
                                      'Ir4+',
                                      '-0.37856',
                                      'Pt',
                                      '-0.31534',
                                      'Pt2+',
                                      '-0.31534',
                                      'Pt4+',
                                      '-0.31534',
                                      'Au',
                                      '-0.25987',
                                      'Au1+',
                                      '-0.25987',
                                      'Au3+',
                                      '-0.25987',
                                      'Hg',
                                      '-0.21428',
                                      'Hg1+',
                                      '-0.21428',
                                      'Hg2+',
                                      '-0.21428',
                                      'Tl',
                                      '-0.18322',
                                      'TL1+',
                                      '-0.18322',
                                      'Tl3+',
                                      '-0.18322',
                                      'Pb',
                                      '-0.15596',
                                      'Pb2+',
                                      '-0.15596',
                                      'Pb4+',
                                      '-0.15596',
                                      'Bi',
                                      '-0.14554',
                                      'Bi3+',
                                      '-0.14554',
                                      'Bi5+',
                                      '-0.14554',
                                      'Po',
                                      '-0.13999',
                                      'At',
                                      '-0.15317',
                                      'Rn',
                                      '-0.17800',
                                      'Fr',
                                      '-0.20823',
                                      'Ra',
                                      '-0.25005',
                                      'Ra2+',
                                      '-0.25005',
                                      'Ac',
                                      '-0.25109',
                                      'Ac3+',
                                      '-0.25109',
                                      'Th',
                                      '-0.35409',
                                      'Th4+',
                                      '-0.35409',
                                      'Pa',
                                      '-0.41329',
                                      'U',
                                      '-0.47542',
                                      'U3+',
                                      '-0.47542',
                                      'U4+',
                                      '-0.47542',
                                      'U6+',
                                      '-0.47542',
                                      'Np',
                                      '-0.51955',
                                      'Np3+',
                                      '-0.51955',
                                      'Np4+',
                                      '-0.51955',
                                      'Np6+',
                                      '-0.51955',
                                      'Pu',
                                      '-0.56296',
                                      'Pu3+',
                                      '-0.56296',
                                      'Pu4+',
                                      '-0.56296',
                                      'Pu6+',
                                      '-0.56296',
                                      'Am',
                                      '-0.60554',
                                      'Cm',
                                      '-0.65062',
                                      'Bk',
                                      '-0.69476',
                                      'Cf',
                                      '-0.73977' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'hi_ang_Fox_c1' ] ] ],
                              [ 'save_',
                                'atom_type_scat.hi_ang_Fox_c2',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.hi_ang_Fox_c2' ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n    The set of data items used to define Fox et al.  coefficients\n     for generation of high angle (s >2.0) X-ray scattering factors.\n \n        Ref: International Tables for Crystallography, Vol. C\n             (1991) Table 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.0',
                                      'D',
                                      '.0',
                                      'H1-',
                                      '.0',
                                      'He',
                                      '4.8007',
                                      'Li',
                                      '2.325',
                                      'Li1+',
                                      '2.325',
                                      'Be',
                                      '1.3046',
                                      'Be2+',
                                      '1.3046',
                                      'B',
                                      '1.6044',
                                      'C',
                                      '1.18930',
                                      'N',
                                      '0.51064',
                                      'O',
                                      '-0.16738',
                                      'O1-',
                                      '-0.16738',
                                      'F',
                                      '-0.40207',
                                      'F1-',
                                      '-0.40207',
                                      'Ne',
                                      '-0.53648',
                                      'Na',
                                      '-0.87884',
                                      'Na1+',
                                      '-0.87884',
                                      'Mg',
                                      '-1.20900',
                                      'Mg2+',
                                      '-1.20900',
                                      'Al',
                                      '-0.95431',
                                      'Al3+',
                                      '-0.95431',
                                      'Si',
                                      '-0.98356',
                                      'Si4+',
                                      '-0.98356',
                                      'P',
                                      '-0.37390',
                                      'S',
                                      '0.20094',
                                      'Cl',
                                      '0.84722',
                                      'Cl1-',
                                      '0.84722',
                                      'Ar',
                                      '1.59220',
                                      'K',
                                      '2.38330',
                                      'K1+',
                                      '2.38330',
                                      'Ca',
                                      '3.13170',
                                      'Ca2+',
                                      '3.13170',
                                      'Sc',
                                      '3.71390',
                                      'Sc3+',
                                      '3.71390',
                                      'Ti',
                                      '4.13170',
                                      'Ti2+',
                                      '4.13170',
                                      'Ti3+',
                                      '4.13170',
                                      'Ti4+',
                                      '4.13170',
                                      'V',
                                      '4.35610',
                                      'V2+',
                                      '4.35610',
                                      'V3+',
                                      '4.35610',
                                      'V5+',
                                      '4.35610',
                                      'Cr',
                                      '4.38670',
                                      'Cr2+',
                                      '4.38670',
                                      'Cr3+',
                                      '4.38670',
                                      'Mn',
                                      '4.27960',
                                      'Mn2+',
                                      '4.27960',
                                      'Mn3+',
                                      '4.27960',
                                      'Mn4+',
                                      '4.27960',
                                      'Fe',
                                      '3.98170',
                                      'Fe2+',
                                      '3.98170',
                                      'Fe3+',
                                      '3.98170',
                                      'Co',
                                      '3.60630',
                                      'Co2+',
                                      '3.60630',
                                      'Co3+',
                                      '3.60630',
                                      'Ni',
                                      '3.12390',
                                      'Ni2+',
                                      '3.12390',
                                      'Ni3+',
                                      '3.12390',
                                      'Cu',
                                      '2.60290',
                                      'Cu1+',
                                      '2.60290',
                                      'Cu2+',
                                      '2.60290',
                                      'Zn',
                                      '2.03390',
                                      'Zn2+',
                                      '2.03390',
                                      'Ga',
                                      '1.46160',
                                      'Ga3+',
                                      '1.46160',
                                      'Ge',
                                      '0.89119',
                                      'Ge4+',
                                      '0.89119',
                                      'As',
                                      '0.34861',
                                      'Se',
                                      '-0.14731',
                                      'Br',
                                      '-0.57381',
                                      'Br1-',
                                      '-0.57381',
                                      'Kr',
                                      '-0.95570',
                                      'Rb',
                                      '-1.22600',
                                      'Rb1+',
                                      '-1.22600',
                                      'Sr',
                                      '-1.41100',
                                      'Sr2+',
                                      '-1.41100',
                                      'Y',
                                      '-1.52240',
                                      'Y3+',
                                      '-1.52240',
                                      'Zr',
                                      '-1.49190',
                                      'Zr4+',
                                      '-1.49190',
                                      'Nb',
                                      '-1.50070',
                                      'Nb3+',
                                      '-1.50070',
                                      'Nb5+',
                                      '-1.50070',
                                      'Mo',
                                      '-1.25340',
                                      'Mo3+',
                                      '-1.25340',
                                      'Mo5+',
                                      '-1.25340',
                                      'Mo6+',
                                      '-1.25340',
                                      'Tc',
                                      '-1.07450',
                                      'Ru',
                                      '-0.77694',
                                      'Ru3+',
                                      '-0.77694',
                                      'Ru4+',
                                      '-0.77694',
                                      'Rh',
                                      '-0.44719',
                                      'Rh3+',
                                      '-0.44719',
                                      'Rh4+',
                                      '-0.44719',
                                      'Pd',
                                      '-0.05894',
                                      'Pd2+',
                                      '-0.05894',
                                      'Pd4+',
                                      '-0.05894',
                                      'Ag',
                                      '0.42189',
                                      'Ag1+',
                                      '0.42189',
                                      'Ag2+',
                                      '0.42189',
                                      'Cd',
                                      '0.84482',
                                      'Cd2+',
                                      '0.84482',
                                      'In',
                                      '1.35030',
                                      'In3+',
                                      '1.35030',
                                      'Sn',
                                      '1.68990',
                                      'Sn2+',
                                      '1.68990',
                                      'Sn4+',
                                      '1.68990',
                                      'Sb',
                                      '2.08920',
                                      'Sb3+',
                                      '2.08920',
                                      'Sb5+',
                                      '2.08920',
                                      'Te',
                                      '2.41170',
                                      'I',
                                      '2.76730',
                                      'I1-',
                                      '2.76730',
                                      'Xe',
                                      '3.04200',
                                      'Cs',
                                      '3.25450',
                                      'Cs1+',
                                      '3.25450',
                                      'Ba',
                                      '3.41320',
                                      'Ba2+',
                                      '3.41320',
                                      'La',
                                      '3.49970',
                                      'La3+',
                                      '3.49970',
                                      'Ce',
                                      '3.60280',
                                      'Ce3+',
                                      '3.60280',
                                      'Ce4+',
                                      '3.60280',
                                      'Pr',
                                      '3.56480',
                                      'Pr3+',
                                      '3.56480',
                                      'Pr4+',
                                      '3.56480',
                                      'Nd',
                                      '3.51970',
                                      'Nd3+',
                                      '3.51970',
                                      'Pm',
                                      '3.37430',
                                      'Sm',
                                      '3.20800',
                                      'Sm3+',
                                      '3.20800',
                                      'Eu',
                                      '2.98580',
                                      'Eu2+',
                                      '2.98580',
                                      'Eu3+',
                                      '2.98580',
                                      'Gd',
                                      '2.73190',
                                      'Gd3+',
                                      '2.73190',
                                      'Tb',
                                      '2.43770',
                                      'Tb3+',
                                      '2.43770',
                                      'Dy',
                                      '2.17540',
                                      'Dy3+',
                                      '2.17540',
                                      'Ho',
                                      '1.92540',
                                      'Ho3+',
                                      '1.92540',
                                      'Er',
                                      '1.67060',
                                      'Er3+',
                                      '1.67060',
                                      'Tm',
                                      '1.42390',
                                      'Tm3+',
                                      '1.42390',
                                      'Yb',
                                      '1.18810',
                                      'Yb2+',
                                      '1.18810',
                                      'Yb3+',
                                      '1.18810',
                                      'Lu',
                                      '0.92889',
                                      'Lu3+',
                                      '0.92889',
                                      'Hf',
                                      '0.67951',
                                      'Hf4+',
                                      '0.67951',
                                      'Ta',
                                      '0.41103',
                                      'Ta5+',
                                      '0.41103',
                                      'W',
                                      '0.18568',
                                      'W6+',
                                      '0.18568',
                                      'Re',
                                      '-0.04706',
                                      'Os',
                                      '-0.22529',
                                      'Os4+',
                                      '-0.22529',
                                      'Ir',
                                      '-0.41174',
                                      'Ir3+',
                                      '-0.41174',
                                      'Ir4+',
                                      '-0.41174',
                                      'Pt',
                                      '-0.56487',
                                      'Pt2+',
                                      '-0.56487',
                                      'Pt4+',
                                      '-0.56487',
                                      'Au',
                                      '-0.69030',
                                      'Au1+',
                                      '-0.69030',
                                      'Au3+',
                                      '-0.69030',
                                      'Hg',
                                      '-0.79013',
                                      'Hg1+',
                                      '-0.79013',
                                      'Hg2+',
                                      '-0.79013',
                                      'Tl',
                                      '-0.84911',
                                      'TL1+',
                                      '-0.84911',
                                      'Tl3+',
                                      '-0.84911',
                                      'Pb',
                                      '-0.89878',
                                      'Pb2+',
                                      '-0.89878',
                                      'Pb4+',
                                      '-0.89878',
                                      'Bi',
                                      '-0.90198',
                                      'Bi3+',
                                      '-0.90198',
                                      'Bi5+',
                                      '-0.90198',
                                      'Po',
                                      '-0.89333',
                                      'At',
                                      '-0.83350',
                                      'Rn',
                                      '-0.74320',
                                      'Fr',
                                      '-0.64000',
                                      'Ra',
                                      '-0.50660',
                                      'Ra2+',
                                      '-0.50660',
                                      'Ac',
                                      '-0.49651',
                                      'Ac3+',
                                      '-0.49651',
                                      'Th',
                                      '-0.18926',
                                      'Th4+',
                                      '-0.18926',
                                      'Pa',
                                      '-0.01192',
                                      'U',
                                      '0.16850',
                                      'U3+',
                                      '0.16850',
                                      'U4+',
                                      '0.16850',
                                      'U6+',
                                      '0.16850',
                                      'Np',
                                      '0.29804',
                                      'Np3+',
                                      '0.29804',
                                      'Np4+',
                                      '0.29804',
                                      'Np6+',
                                      '0.29804',
                                      'Pu',
                                      '0.42597',
                                      'Pu3+',
                                      '0.42597',
                                      'Pu4+',
                                      '0.42597',
                                      'Pu6+',
                                      '0.42597',
                                      'Am',
                                      '0.54967',
                                      'Cm',
                                      '0.67922',
                                      'Bk',
                                      '0.80547',
                                      'Cf',
                                      '0.93342' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'hi_ang_Fox_c2' ] ] ],
                              [ 'save_',
                                'atom_type_scat.hi_ang_Fox_c3',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.hi_ang_Fox_c3' ],
                                  [ 'item_', '_definition.update', '2012-11-29' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n    The set of data items used to define Fox et al.  coefficients\n     for generation of high angle (s >2.0) X-ray scattering factors.\n \n        Ref: International Tables for Crystallography, Vol. C\n             (1991) Table 6.1.1.5' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.def_index_id', '_atom_type.symbol' ],
                                  [ 'item_', '_units.code', 'none' ],
                                  [ 'loop_',
                                    [ '_enumeration_default.index', '_enumeration_default.value' ],
                                    [ 'H',
                                      '.0',
                                      'D',
                                      '.0',
                                      'H1-',
                                      '.0',
                                      'He',
                                      '-2.5476',
                                      'Li',
                                      '-.71949',
                                      'Li1+',
                                      '-.71949',
                                      'Be',
                                      '-0.04297',
                                      'Be2+',
                                      '-0.04297',
                                      'B',
                                      '-0.65981',
                                      'C',
                                      '-0.42715',
                                      'N',
                                      '0.02472',
                                      'O',
                                      '0.47500',
                                      'O1-',
                                      '0.47500',
                                      'F',
                                      '0.54352',
                                      'F1-',
                                      '0.54352',
                                      'Ne',
                                      '0.60957',
                                      'Na',
                                      '0.76974',
                                      'Na1+',
                                      '0.76974',
                                      'Mg',
                                      '0.82738',
                                      'Mg2+',
                                      '0.82738',
                                      'Al',
                                      '0.72294',
                                      'Al3+',
                                      '0.72294',
                                      'Si',
                                      '0.55631',
                                      'Si4+',
                                      '0.55631',
                                      'P',
                                      '0.20731',
                                      'S',
                                      '-0.26058',
                                      'Cl',
                                      '-0.76135',
                                      'Cl1-',
                                      '-0.76135',
                                      'Ar',
                                      '-1.32510',
                                      'K',
                                      '-1.91290',
                                      'K1+',
                                      '-1.91290',
                                      'Ca',
                                      '-2.45670',
                                      'Ca2+',
                                      '-2.45670',
                                      'Sc',
                                      '-2.85330',
                                      'Sc3+',
                                      '-2.85330',
                                      'Ti',
                                      '-3.11710',
                                      'Ti2+',
                                      '-3.11710',
                                      'Ti3+',
                                      '-3.11710',
                                      'Ti4+',
                                      '-3.11710',
                                      'V',
                                      '-3.22040',
                                      'V2+',
                                      '-3.22040',
                                      'V3+',
                                      '-3.22040',
                                      'V5+',
                                      '-3.22040',
                                      'Cr',
                                      '-3.17520',
                                      'Cr2+',
                                      '-3.17520',
                                      'Cr3+',
                                      '-3.17520',
                                      'Mn',
                                      '-3.02150',
                                      'Mn2+',
                                      '-3.02150',
                                      'Mn3+',
                                      '-3.02150',
                                      'Mn4+',
                                      '-3.02150',
                                      'Fe',
                                      '-2.71990',
                                      'Fe2+',
                                      '-2.71990',
                                      'Fe3+',
                                      '-2.71990',
                                      'Co',
                                      '-2.37050',
                                      'Co2+',
                                      '-2.37050',
                                      'Co3+',
                                      '-2.37050',
                                      'Ni',
                                      '-1.94290',
                                      'Ni2+',
                                      '-1.94290',
                                      'Ni3+',
                                      '-1.94290',
                                      'Cu',
                                      '-1.49760',
                                      'Cu1+',
                                      '-1.49760',
                                      'Cu2+',
                                      '-1.49760',
                                      'Zn',
                                      '-1.02160',
                                      'Zn2+',
                                      '-1.02160',
                                      'Ga',
                                      '-0.55471',
                                      'Ga3+',
                                      '-0.55471',
                                      'Ge',
                                      '-0.09984',
                                      'Ge4+',
                                      '-0.09984',
                                      'As',
                                      '0.32231',
                                      'Se',
                                      '0.69837',
                                      'Br',
                                      '1.00950',
                                      'Br1-',
                                      '1.00950',
                                      'Kr',
                                      '1.27070',
                                      'Rb',
                                      '1.45320',
                                      'Rb1+',
                                      '1.45320',
                                      'Sr',
                                      '1.55410',
                                      'Sr2+',
                                      '1.55410',
                                      'Y',
                                      '1.59630',
                                      'Y3+',
                                      '1.59630',
                                      'Zr',
                                      '1.51820',
                                      'Zr4+',
                                      '1.51820',
                                      'Nb',
                                      '1.50150',
                                      'Nb3+',
                                      '1.50150',
                                      'Nb5+',
                                      '1.50150',
                                      'Mo',
                                      '1.24010',
                                      'Mo3+',
                                      '1.24010',
                                      'Mo5+',
                                      '1.24010',
                                      'Mo6+',
                                      '1.24010',
                                      'Tc',
                                      '1.06630',
                                      'Ru',
                                      '0.79060',
                                      'Ru3+',
                                      '0.79060',
                                      'Ru4+',
                                      '0.79060',
                                      'Rh',
                                      '0.49443',
                                      'Rh3+',
                                      '0.49443',
                                      'Rh4+',
                                      '0.49443',
                                      'Pd',
                                      '0.15404',
                                      'Pd2+',
                                      '0.15404',
                                      'Pd4+',
                                      '0.15404',
                                      'Ag',
                                      '-0.25659',
                                      'Ag1+',
                                      '-0.25659',
                                      'Ag2+',
                                      '-0.25659',
                                      'Cd',
                                      '-0.60990',
                                      'Cd2+',
                                      '-0.60990',
                                      'In',
                                      '-1.03910',
                                      'In3+',
                                      '-1.03910',
                                      'Sn',
                                      '-1.29860',
                                      'Sn2+',
                                      '-1.29860',
                                      'Sn4+',
                                      '-1.29860',
                                      'Sb',
                                      '-1.61640',
                                      'Sb3+',
                                      '-1.61640',
                                      'Sb5+',
                                      '-1.61640',
                                      'Te',
                                      '-1.86420',
                                      'I',
                                      '-2.13920',
                                      'I1-',
                                      '-2.13920',
                                      'Xe',
                                      '-2.34290',
                                      'Cs',
                                      '-2.49220',
                                      'Cs1+',
                                      '-2.49220',
                                      'Ba',
                                      '-2.59590',
                                      'Ba2+',
                                      '-2.59590',
                                      'La',
                                      '-2.64050',
                                      'La3+',
                                      '-2.64050',
                                      'Ce',
                                      '-2.70670',
                                      'Ce3+',
                                      '-2.70670',
                                      'Ce4+',
                                      '-2.70670',
                                      'Pr',
                                      '-2.65180',
                                      'Pr3+',
                                      '-2.65180',
                                      'Pr4+',
                                      '-2.65180',
                                      'Nd',
                                      '-2.59010',
                                      'Nd3+',
                                      '-2.59010',
                                      'Pm',
                                      '-2.44210',
                                      'Sm',
                                      '-2.28170',
                                      'Sm3+',
                                      '-2.28170',
                                      'Eu',
                                      '-2.07460',
                                      'Eu2+',
                                      '-2.07460',
                                      'Eu3+',
                                      '-2.07460',
                                      'Gd',
                                      '-1.84040',
                                      'Gd3+',
                                      '-1.84040',
                                      'Tb',
                                      '-1.57950',
                                      'Tb3+',
                                      '-1.57950',
                                      'Dy',
                                      '-1.34550',
                                      'Dy3+',
                                      '-1.34550',
                                      'Ho',
                                      '-1.13090',
                                      'Ho3+',
                                      '-1.13090',
                                      'Er',
                                      '-0.91467',
                                      'Er3+',
                                      '-0.91467',
                                      'Tm',
                                      '-0.70804',
                                      'Tm3+',
                                      '-0.70804',
                                      'Yb',
                                      '-0.51120',
                                      'Yb2+',
                                      '-0.51120',
                                      'Yb3+',
                                      '-0.51120',
                                      'Lu',
                                      '-0.29820',
                                      'Lu3+',
                                      '-0.29820',
                                      'Hf',
                                      '-0.09620',
                                      'Hf4+',
                                      '-0.09620',
                                      'Ta',
                                      '0.11842',
                                      'Ta5+',
                                      '0.11842',
                                      'W',
                                      '0.29787',
                                      'W6+',
                                      '0.29787',
                                      'Re',
                                      '0.48180',
                                      'Os',
                                      '0.61700',
                                      'Os4+',
                                      '0.61700',
                                      'Ir',
                                      '0.75967',
                                      'Ir3+',
                                      '0.75967',
                                      'Ir4+',
                                      '0.75967',
                                      'Pt',
                                      '0.87492',
                                      'Pt2+',
                                      '0.87492',
                                      'Pt4+',
                                      '0.87492',
                                      'Au',
                                      '0.96224',
                                      'Au1+',
                                      '0.96224',
                                      'Au3+',
                                      '0.96224',
                                      'Hg',
                                      '1.02850',
                                      'Hg1+',
                                      '1.02850',
                                      'Hg2+',
                                      '1.02850',
                                      'Tl',
                                      '1.05970',
                                      'TL1+',
                                      '1.05970',
                                      'Tl3+',
                                      '1.05970',
                                      'Pb',
                                      '1.08380',
                                      'Pb2+',
                                      '1.08380',
                                      'Pb4+',
                                      '1.08380',
                                      'Bi',
                                      '1.06850',
                                      'Bi3+',
                                      '1.06850',
                                      'Bi5+',
                                      '1.06850',
                                      'Po',
                                      '1.04380',
                                      'At',
                                      '0.97641',
                                      'Rn',
                                      '0.88510',
                                      'Fr',
                                      '0.78354',
                                      'Ra',
                                      '0.65836',
                                      'Ra2+',
                                      '0.65836',
                                      'Ac',
                                      '0.64340',
                                      'Ac3+',
                                      '0.64340',
                                      'Th',
                                      '0.36849',
                                      'Th4+',
                                      '0.36849',
                                      'Pa',
                                      '0.20878',
                                      'U',
                                      '0.05060',
                                      'U3+',
                                      '0.05060',
                                      'U4+',
                                      '0.05060',
                                      'U6+',
                                      '0.05060',
                                      'Np',
                                      '-0.06566',
                                      'Np3+',
                                      '-0.06566',
                                      'Np4+',
                                      '-0.06566',
                                      'Np6+',
                                      '-0.06566',
                                      'Pu',
                                      '-0.18080',
                                      'Pu3+',
                                      '-0.18080',
                                      'Pu4+',
                                      '-0.18080',
                                      'Pu6+',
                                      '-0.18080',
                                      'Am',
                                      '-0.29112',
                                      'Cm',
                                      '-0.40588',
                                      'Bk',
                                      '-0.51729',
                                      'Cf',
                                      '-0.62981' ] ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'hi_ang_Fox_c3' ] ] ],
                              [ 'save_',
                                'atom_type_scat.length_neutron',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.length_neutron' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_length_neutron' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The bound coherent scattering length for the atom type at the\n     isotopic composition used for the diffraction experiment.' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'length_neutron' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.default', '0.0' ],
                                  [ 'item_', '_units.code', 'femtometres' ] ] ],
                              [ 'save_',
                                'atom_type_scat.source',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.source' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_source', '_atom_type.scat_source' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Reference to source of scattering factors used for this atom type.' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'source' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ],
                                  [ 'loop_',
                                    [ '_description_example.case' ],
                                    [ 'International Tables Vol. IV Table 2.4.6B' ] ] ] ],
                              [ 'save_',
                                'atom_type_scat.symbol',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.symbol' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_symbol' ] ],
                                  [ 'item_', '_definition.update', '2013-01-23' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The identity of the atom specie(s) representing this atom type.\n     See _atom_type.symbol for further details.' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'symbol' ],
                                  [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                                  [ 'item_', '_type.purpose', 'Encode' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ] ] ],
                              [ 'save_',
                                'atom_type_scat.versus_stol_list',
                                [ [ 'item_', '_definition.id', '_atom_type_scat.versus_stol_list' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_atom_type_scat_versus_stol_list',
                                      '_atom_type.scat_versus_stol_list' ] ],
                                  [ 'item_', '_definition.update', '2013-04-17' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     List of scattering factors as a function of sin theta on lambda.\n     List has the form [\'<stol value>\':\'<scatfac>\', ....] in\n     increments of 0.01, increasing from 0.0.' ],
                                  [ 'item_', '_name.category_id', 'scat' ],
                                  [ 'item_', '_name.object_id', 'versus_stol_list' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'List' ],
                                  [ 'item_', '_type.contents', 'List(Real,Real)' ],
                                  [ 'item_', '_type.dimension', [] ],
                                  [ 'item_', '_units.code', 'none' ] ] ] ] ],
                          [ '@comment', '------ close ATOM_TYPE_SCAT category' ] ] ],
                      [ '@comment', '------ close ATOM_TYPE category' ] ] ],
                  [ '@comment', '------ close ATOM category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'REFINE',
                    [ [ 'item_', '_definition.id', 'REFINE' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-11-20' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to specify information about the\n     refinement of the structural model.' ],
                      [ 'item_', '_name.category_id', 'STRUCTURE' ],
                      [ 'item_', '_name.object_id', 'REFINE' ],
                      [ 'save_',
                        'refine.special_details',
                        [ [ 'item_', '_definition.id', '_refine.special_details' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_refine_special_details' ] ],
                          [ 'item_', '_definition.update', '2012-11-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Details of the refinement not specified by other data items.' ],
                          [ 'item_', '_name.category_id', 'refine' ],
                          [ 'item_', '_name.object_id', 'special_details' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'REFINE_DIFF',
                        [ [ 'item_', '_definition.id', 'REFINE_DIFF' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items which specify the electron density limits\n     in a difference Fourier map after the structure has been refined. The\n     rms value is with respect to the arithmetic mean density, and is derived\n     from summations over each grid point in the asymmetric unit of the cell.' ],
                          [ 'item_', '_name.category_id', 'REFINE' ],
                          [ 'item_', '_name.object_id', 'DIFF' ],
                          [ 'save_',
                            'refine_diff.density_max',
                            [ [ 'item_', '_definition.id', '_refine_diff.density_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_diff_density_max', '_refine.diff_density_max' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Maximum density value in a difference Fourier map.' ],
                              [ 'item_', '_name.category_id', 'refine_diff' ],
                              [ 'item_', '_name.object_id', 'density_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-100.:' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ],
                          [ 'save_',
                            'refine_diff.density_min',
                            [ [ 'item_', '_definition.id', '_refine_diff.density_min' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_diff_density_min', '_refine.diff_density_min' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Miniumum density value in a difference Fourier map.' ],
                              [ 'item_', '_name.category_id', 'refine_diff' ],
                              [ 'item_', '_name.object_id', 'density_min' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', ':100.' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ],
                          [ 'save_',
                            'refine_diff.density_rms',
                            [ [ 'item_', '_definition.id', '_refine_diff.density_rms' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_diff_density_rms', '_refine.diff_density_rms' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Root mean square density value in a difference Fourier map.\n     This value is measured with respect to the arithmetic mean\n     density and is derived from summations over each grid point\n     in the asymmetric unit of the cell. This quantity is useful\n     for assessing the significance of *_min and *_max values,\n     and also for defining suitable contour levels.' ],
                              [ 'item_', '_name.category_id', 'refine_diff' ],
                              [ 'item_', '_name.object_id', 'density_rms' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-100.:100.' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ] ] ],
                      [ '@comment', '------ close REFINE_DIFF category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'REFINE_LS',
                        [ [ 'item_', '_definition.id', 'REFINE_LS' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-11-20' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify information about the\n     refinement of the structural model.' ],
                          [ 'item_', '_name.category_id', 'REFINE' ],
                          [ 'item_', '_name.object_id', 'LS' ],
                          [ 'save_',
                            'refine_ls.abs_structure_details',
                            [ [ 'item_', '_definition.id', '_refine_ls.abs_structure_details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_abs_structure_details',
                                  '_refine.ls_abs_structure_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Details on the absolute structure and how it was determined.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'abs_structure_details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'refine_ls.abs_structure_Flack',
                            [ [ 'item_', '_definition.id', '_refine_ls.abs_structure_Flack' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_abs_structure_Flack',
                                  '_refine.ls_abs_structure_Flack' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The measure of absolute structure as defined by Flack (1983).\n     For centrosymmetric structures, the only permitted value, if the\n     data name is present, is \'inapplicable\', represented by \'.\' .\n     For noncentrosymmetric structures, the value must lie in the\n     99.97% Gaussian confidence interval  -3u =< x =< 1 + 3u and a\n     standard uncertainty (e.s.d.) u must be supplied. The\n     _enumeration.range of 0.0:1.0 is correctly interpreted as\n     meaning (0.0 - 3u) =< x =< (1.0 + 3u).\n     Ref: Flack, H. D. (1983). Acta Cryst. A39, 876-881.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'abs_structure_Flack' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.abs_structure_Rogers',
                            [ [ 'item_', '_definition.id', '_refine_ls.abs_structure_Rogers' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_abs_structure_Rogers',
                                  '_refine.ls_abs_structure_Rogers' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The measure of absolute structure as defined by Rogers (1981).\n     The value must lie in the 99.97% Gaussian confidence interval\n     -1 -3u =< \\h =< 1 + 3u and a standard uncertainty (e.s.d.) u must\n     be supplied. The _enumeration.range of -1.0:1.0 is correctly\n     interpreted as meaning (-1.0 - 3u) =< \\h =< (1.0 + 3u).\n     Ref: Rogers, D. (1981). Acta Cryst. A37, 734-741.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'abs_structure_Rogers' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-1.0:1.0' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.d_res_high',
                            [ [ 'item_', '_definition.id', '_refine_ls.d_res_high' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_d_res_high', '_refine.ls_d_res_high' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Highest resolution for the reflections used in refinement.\n     This corresponds to the smallest interpanar d value.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'd_res_high' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'refine_ls.d_res_low',
                            [ [ 'item_', '_definition.id', '_refine_ls.d_res_low' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_d_res_low', '_refine.ls_d_res_low' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Lowest resolution for the reflections used in refinement.\n     This corresponds to the largest interpanar d value.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'd_res_low' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'refine_ls.extinction_coef',
                            [ [ 'item_', '_definition.id', '_refine_ls.extinction_coef' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_extinction_coef', '_refine.ls_extinction_coef' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The extinction coefficient used to calculate the correction\n     factor applied to the structure-factor data. The nature of the\n     extinction coefficient is given in the definitions of\n     _refine_ls.extinction_expression and _refine_ls.extinction_method.\n     For the \'Zachariasen\' method it is the r* value; for the\n     \'Becker-Coppens type 1 isotropic\' method it is the \'g\' value.\n     For \'Becker-Coppens type 2 isotropic\' corrections it is\n     the \'rho\' value. Note that the magnitude of these values is\n     usually of the order of 10000.\n     Ref:  Becker, P. J. & Coppens, P. (1974). Acta Cryst. A30,\n           129-147, 148-153.\n           Zachariasen, W. H. (1967). Acta Cryst. 23, 558-564.\n           Larson, A. C. (1967). Acta Cryst. 23, 664-665.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'extinction_coef' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '3472(52)', 'Zachariasen coefficient r* = 0.347(5)e+04' ] ] ] ],
                          [ 'save_',
                            'refine_ls.extinction_expression',
                            [ [ 'item_', '_definition.id', '_refine_ls.extinction_expression' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_extinction_expression',
                                  '_refine.ls_extinction_expression' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of or reference to the extinction-correction equation\n     used to apply the data item  _refine_ls.extinction_coef. This\n     information should be sufficient to reproduce the extinction-\n     correction factors applied to the structure factors.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'extinction_expression' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ 'Larson approach',
                                  '      Larson, A. C. (1970). "Crystallographic Computing", edited by\n              F. R. Ahmed. Eq. (22) p. 292.  Copenhagen: Munksgaard.' ] ] ] ],
                          [ 'save_',
                            'refine_ls.extinction_method',
                            [ [ 'item_', '_definition.id', '_refine_ls.extinction_method' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_extinction_method',
                                  '_refine.ls_extinction_method' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the extinction correction method applied with the\n     data item _refine_ls.extinction_coef. This description should\n     include information about the correction method, either \'Becker-\n     Coppens\' or \'Zachariasen\'. The latter is sometimes referred to as\n     the \'Larson\' method even though it employs Zachariasen\'s formula.\n \n     The Becker-Coppens procedure is referred to as \'type 1\' when\n     correcting secondary extinction dominated by the mosaic spread;\n     as \'type 2\' when secondary extinction is dominated by particle\n     size and includes a primary extinction component; and as \'mixed\'\n     when there are types 1 and 2.\n \n     For the Becker-Coppens method it is also necessary to set the\n     mosaic distribution as either \'Gaussian\' or \'Lorentzian\'; and the\n     nature of the extinction as \'isotropic\' or \'anisotropic\'. Note\n     that if either the \'mixed\' or \'anisotropic\' corrections are applied\n     the multiple coefficients cannot be contained in the\n     _refine_ls.extinction_coef and must be listed in *.special_details.\n \n     Ref:  Becker, P. J. & Coppens, P. (1974). Acta Cryst. A30, 129-153.\n           Zachariasen, W. H. (1967). Acta Cryst. 23, 558-564.\n           Larson, A. C. (1967). Acta Cryst. 23, 664-665.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'extinction_method' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Zachariasen', 'B-C type 2 Gaussian isotropic' ] ] ] ],
                          [ 'save_',
                            'refine_ls.F_calc_details',
                            [ [ 'item_', '_definition.id', '_refine_ls.F_calc_details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_F_calc_details' ] ],
                              [ 'item_', '_definition.update', '2013-01-21' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Details concerning the evaluation of the structure factors\n     using the expression given in _refine_ls.F_calc_formula.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'F_calc_details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Gaussian integration using 16 points',
                                  ' Bessel functions expansion up to 5th\n                               order. estimated accuracy of Bessel\n                               function  better than 0.001 electrons' ] ] ] ],
                          [ 'save_',
                            'refine_ls.F_calc_formula',
                            [ [ 'item_', '_definition.id', '_refine_ls.F_calc_formula' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_F_calc_formula' ] ],
                              [ 'item_', '_definition.update', '2013-01-23' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Analytical expression used to calculate the structure factors.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'F_calc_formula' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'refine_ls.F_calc_precision',
                            [ [ 'item_', '_definition.id', '_refine_ls.F_calc_precision' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_F_calc_precision' ] ],
                              [ 'item_', '_definition.update', '2013-01-21' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Estimate of the precision resulting from the numerical\n     approximations made during the evaluation of the structure\n     factors using the expression _refine_ls.F_calc_formula\n     following the method outlined in _refine_ls.F_calc_details.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'F_calc_precision' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '\n         If (_diffrn_radiation.probe == "neutron")  _units.code =  "femtometres"\n    Else If (_diffrn_radiation.probe == "electron") _units.code =  "volts"\n    Else                                            _units.code =  "electrons"' ] ] ] ],
                          [ 'save_',
                            'refine_ls.goodness_of_fit_all',
                            [ [ 'item_', '_definition.id', '_refine_ls.goodness_of_fit_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_goodness_of_fit_all',
                                  '_refine.ls_goodness_of_fit_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Least-squares goodness-of-fit parameter S for all reflections after\n     the final cycle of refinement. Ideally, account should be taken of\n     parameters restrained in the least squares.\n \n              {  sum { w [ Y(meas) - Y(calc) ]^2^ }  }^1/2^\n          S = { ------------------------------------ }\n              {            Nref - Nparam             }\n \n          Y(meas) = the measured coefficients\n                    (see _refine_ls.structure_factor_coef)\n          Y(calc) = the calculated coefficients\n                    (see _refine_ls.structure_factor_coef)\n          w       = the least-squares reflection weight\n                    [1/(u^2^)]\n          u       = standard uncertainty\n          Nref   = the number of reflections used in the refinement\n          Nparam = the number of refined parameters\n          and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'goodness_of_fit_all' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.goodness_of_fit_gt',
                            [ [ 'item_', '_definition.id', '_refine_ls.goodness_of_fit_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_goodness_of_fit_gt',
                                  '_refine_ls_goodness_of_fit_obs',
                                  '_refine.ls_goodness_of_fit_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Least-squares goodness-of-fit parameter S for significantly\n     intense reflections, (i.e. \'observed\' reflections with values\n     greater-than the threshold set in _reflns.threshold_expression),\n     after the final cycle. Ideally, account should be taken of\n     parameters restrained in the least-squares refinement.\n \n              {  sum { w [ Y(meas_gt) - Y(calc) ]^2^ }  }^1/2^\n          S = { --------------------------------------- }\n              {           Nref - Nparam                 }\n \n          Y(meas_gt)  = the \'observed\' coefficients\n                    (see _refine_ls.structure_factor_coef)\n          Y(calc)     = the calculated coefficients\n                    (see _refine_ls.structure_factor_coef)\n          w       = the least-squares reflection weight\n                    [1/(u^2^)]\n          u       = standard uncertainty\n          Nref   = the number of reflections used in the refinement\n          Nparam = the number of refined parameters\n          and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'goodness_of_fit_gt' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.goodness_of_fit_ref',
                            [ [ 'item_', '_definition.id', '_refine_ls.goodness_of_fit_ref' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_goodness_of_fit_ref' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Least-squares goodness-of-fit parameter S for those reflections\n     included in the final cycle of refinement. Account should be\n     taken of restrained parameters.\n \n              {  sum { w [ Y(meas) - Y(calc) ]^2^ }  }^1/2^\n          S = { ------------------------------------ }\n              {            Nref - Nparam             }\n \n          Y(meas) = the measured coefficients\n                    (see _refine_ls.structure_factor_coef)\n          Y(calc) = the calculated coefficients\n                    (see _refine_ls.structure_factor_coef)\n          w       = the least-squares reflection weight\n                    [1/(u^2^)]\n          u       = standard uncertainty\n          Nref   = the number of reflections used in the refinement\n          Nparam = the number of refined parameters\n          and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'goodness_of_fit_ref' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.hydrogen_treatment',
                            [ [ 'item_', '_definition.id', '_refine_ls.hydrogen_treatment' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_hydrogen_treatment',
                                  '_refine.ls_hydrogen_treatment' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying how hydrogen atoms were treated in the refinement.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'hydrogen_treatment' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'refall',
                                  'refined all H-atom parameters',
                                  'refxyz',
                                  'refined H-atom coordinates only',
                                  'refU',
                                  'refined H-atom U\'s only',
                                  'noref',
                                  'no refinement of H-atom parameters',
                                  'constr',
                                  'H-atom parameters constrained',
                                  'hetero',
                                  'H-atom parameters constrained for H on C, all\n               H-atom parameters refined for H on heteroatoms',
                                  'heteroxyz',
                                  'H-atom parameters constrained for H on C, refined\n               H-atom coordinates only for H on heteroatoms',
                                  'heteroU',
                                  'H-atom parameters constrained for H on C, refined\n               H-atom U\'s only for H on heteroatoms',
                                  'heteronoref',
                                  'H-atom parameters constrained for H on C, no\n               refinement of H-atom parameters for H on heteroatoms',
                                  'hetero-mixed',
                                  'H-atom parameters constrained for H on C and some\n               heteroatoms, all H-atom parameters refined\n               for H on remaining heteroatoms',
                                  'heteroxyz-mixed',
                                  'H-atom parameters constrained for H on C and some\n               heteroatoms, refined H-atom coordinates only\n               for H on remaining heteroatoms',
                                  'heteroU-mixed',
                                  'H-atom parameters constrained for H on C and some\n               heteroatoms, refined H-atom U\'s only for H on\n               remaining heteroatoms',
                                  'heteronoref-mixed',
                                  'H-atom parameters constrained for H on C and some\n               heteroatoms, no refinement of H-atom parameters\n               for H on remaining heteroatoms',
                                  'mixed',
                                  'some constrained, some independent',
                                  'undef',
                                  'H-atom parameters not defined' ] ],
                              [ 'item_', '_enumeration.default', 'undef' ] ] ],
                          [ 'save_',
                            'refine_ls.matrix_type',
                            [ [ 'item_', '_definition.id', '_refine_ls.matrix_type' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_matrix_type', '_refine.ls_matrix_type' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code identifying the matrix type used for least-squares derivatives.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'matrix_type' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'full',
                                  'full',
                                  'fullcycle',
                                  'full with fixed elements per cycle',
                                  'atomblock',
                                  'block diagonal per atom',
                                  'userblock',
                                  'user-defined blocks',
                                  'diagonal',
                                  'diagonal elements only',
                                  'sparse',
                                  'selected elements only' ] ],
                              [ 'item_', '_enumeration.default', 'full' ] ] ],
                          [ 'save_',
                            'refine_ls.number_constraints',
                            [ [ 'item_', '_definition.id', '_refine_ls.number_constraints' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_number_constraints',
                                  '_refine.ls_number_constraints' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of constrained (non-refined or dependent) parameters\n     in the least-squares process. These may be due to symmetry or any\n     other constraint process (e.g. rigid-body refinement). See also\n     _atom_site.constraints and _atom_site.refinement_flags. A general\n     description of constraints may appear in _refine.special_details.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'number_constraints' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ],
                              [ 'item_', '_enumeration.default', '0' ] ] ],
                          [ 'save_',
                            'refine_ls.number_parameters',
                            [ [ 'item_', '_definition.id', '_refine_ls.number_parameters' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_number_parameters',
                                  '_refine.ls_number_parameters' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of parameters refined in the least-squares process. If\n     possible this number should include the restrained parameters.\n     The restrained parameters are distinct from the constrained\n     parameters (where one or more parameters are linearly dependent\n     on the refined value of another).  Least-squares restraints\n     often depend on geometry or energy considerations and this\n     makes their direct contribution to this number, and to the\n     goodness-of-fit calculation, difficult to assess.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'number_parameters' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'refine_ls.number_reflns',
                            [ [ 'item_', '_definition.id', '_refine_ls.number_reflns' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_number_reflns', '_refine.ls_number_reflns_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of unique reflections used in the least-squares refinement.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'number_reflns' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '1:' ] ] ],
                          [ 'save_',
                            'refine_ls.number_restraints',
                            [ [ 'item_', '_definition.id', '_refine_ls.number_restraints' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_number_restraints',
                                  '_refine.ls_number_restraints' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Number of restrained parameters in the least-squares refinement. These\n     parameters do not directly dependent on another refined parameter. Often\n     restrained parameters involve geometry or energy dependencies. See also\n     _atom_site.constraints and _atom_site.refinement_flags. A description\n     of refinement constraints may appear in _refine.special_details.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'number_restraints' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '0:' ] ] ],
                          [ 'save_',
                            'refine_ls.R_factor_all',
                            [ [ 'item_', '_definition.id', '_refine_ls.R_factor_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_R_factor_all', '_refine.ls_R_factor_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor for all reflections satisfying the resolution limits\n     specified by _refine_ls.d_res_high and _refine_ls.d_res_low. This is\n     the conventional R factor. See also wR factor definitions.\n \n                   sum | F(meas) - F(calc) |\n               R = ------------------------\n                         sum | F(meas) |\n \n               F(meas) = the measured structure-factor amplitudes\n               F(calc) = the calculated structure-factor amplitudes\n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'R_factor_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.R_factor_gt',
                            [ [ 'item_', '_definition.id', '_refine_ls.R_factor_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_R_factor_obs',
                                  '_refine_ls_R_factor_gt',
                                  '_refine.ls_R_factor_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor for the reflections judged significantly intense\n     (see _reflns.number_gt and _reflns.threshold_expression) and included\n     in the refinement. The reflections also satisfy the resolution limits\n     specified by _refine_ls.d_res_high and _refine_ls.d_res_low. This is\n     the conventional R factor.\n \n                   sum | F(meas_gt) - F(calc) |\n               R = -----------------------------\n                         sum | F(meas_gt) |\n \n               F(meas_gt) = the \'observed\' structure-factor amplitudes\n               F(calc)    = the calculated structure-factor amplitudes\n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'R_factor_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.R_Fsqd_factor',
                            [ [ 'item_', '_definition.id', '_refine_ls.R_Fsqd_factor' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_R_Fsqd_factor', '_refine.ls_R_Fsqd_factor_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor R(Fsqd), calculated on the squared amplitudes of the\n     measured and calculated structure factors, for significantly intense\n     reflections (satisfying _reflns.threshold_expression) and included in\n     the refinement. The reflections also satisfy the resolution limits\n     specified by _refine_ls.d_res_high and _refine_ls.d_res_low.\n \n                          sum | F(meas_gt)^2^ - F(calc)^2^ |\n               R(Fsqd) = ------------------------------------\n                                  sum F(meas_gt)^2^\n \n               F(meas_gt)^2^ = squares of the \'observed\' structure-factor\n               F(calc)^2^    = squares of the calculated structure-factor\n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'R_Fsqd_factor' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.R_I_factor',
                            [ [ 'item_', '_definition.id', '_refine_ls.R_I_factor' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_R_I_factor', '_refine.ls_R_I_factor_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Residual factor R(I) for significantly intense reflections (satisfying\n     _reflns.threshold_expression) and included in the refinement. This is\n     most often calculated in Rietveld refinements of powder data, where it\n     is referred to as R~B~ or R~Bragg~.\n \n                       sum | I(meas_gt) - I(calc) |\n               R(I) =  -----------------------------\n                              sum | I(meas_gt) |\n \n               I(meas_gt) = the net \'observed\' intensities\n               I(calc)    = the net calculated intensities\n               and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'R_I_factor' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.restrained_S_all',
                            [ [ 'item_', '_definition.id', '_refine_ls.restrained_S_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_restrained_S_all', '_refine.ls_restrained_S_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Least-squares goodness-of-fit parameter S\' for all reflections after\n     the final cycle of least squares. This parameter explicitly includes\n     the restraints applied in the least-squares process. See also\n     _refine_ls.goodness_of_fit_all definition.\n \n            {sum { w [ Y(meas) - Y(calc) ]^2^ }                  }^1/2^\n            {         + sum~r~ { w~r~ [ P(calc) - P(targ) ]^2^ } }\n       S\' = { -------------------------------------------------- }\n            {            N~ref~ + N~restr~ - N~param~            }\n \n               Y(meas)  = the measured coefficients\n                          (see _refine_ls.structure_factor_coef)\n               Y(calc)  = the calculated coefficients\n                          (see _refine_ls.structure_factor_coef)\n               w        = the least-squares reflection weight\n                          [1/square of standard uncertainty (e.s.d.)]\n               P(calc)  = the calculated restraint values\n               P(targ)  = the target restraint values\n               w~r~     = the restraint weight\n \n               N~ref~   = the number of reflections used in the refinement\n                        (see _refine_ls.number_reflns)\n               N~restr~ = the number of restraints\n                        (see _refine_ls.number_restraints)\n               N~param~ = the number of refined parameters\n                        (see _refine_ls.number_parameters)\n \n               sum     is taken over the specified reflections\n               sum~r~  is taken over the restraints' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'restrained_S_all' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.restrained_S_gt',
                            [ [ 'item_', '_definition.id', '_refine_ls.restrained_S_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_restrained_S_obs',
                                  '_refine_ls_restrained_S_gt',
                                  '_refine.ls_restrained_S_obs' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Least-squares goodness-of-fit parameter S\' for significantly intense\n     reflections (satisfying _reflns.threshold_expression) after the final\n     cycle of least squares. This parameter explicitly includes the restraints\n     applied. The expression for S\' is given in _refine_ls.restrained_S_all.\n \n            {sum { w [ Y(meas_gt) - Y(calc) ]^2^ }               }^1/2^\n            {         + sum~r~ { w~r~ [ P(calc) - P(targ) ]^2^ } }\n       S\' = { -------------------------------------------------- }\n            {            N~ref~ + N~restr~ - N~param~            }\n \n               Y(meas_gt) = the \'observed\' coefficients\n                          (see _refine_ls.structure_factor_coef)\n               Y(calc)    = the calculated coefficients\n                          (see _refine_ls.structure_factor_coef)\n               w        = the least-squares reflection weight\n                          [1/square of standard uncertainty (e.s.d.)]\n               P(calc)  = the calculated restraint values\n               P(targ)  = the target restraint values\n               w~r~     = the restraint weight\n \n               N~ref~   = the number of reflections used in the refinement\n                        (see _refine_ls.number_reflns)\n               N~restr~ = the number of restraints\n                        (see _refine_ls.number_restraints)\n               N~param~ = the number of refined parameters\n                        (see _refine_ls.number_parameters)\n \n               sum     is taken over the specified reflections\n               sum~r~  is taken over the restraints' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'restrained_S_gt' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.shift_over_su_max',
                            [ [ 'item_', '_definition.id', '_refine_ls.shift_over_su_max' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_shift_over_su_max',
                                  '_refine.ls_shift_over_esd_max',
                                  '_refine_ls_shift/su_max',
                                  '_refine_ls_shift/esd_max' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The largest ratio of the final least-squares parameter shift\n     to the final standard uncertainty (s.u., formerly described\n     as estimated standard deviation, e.s.d.).' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'shift_over_su_max' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.shift_over_su_max_lt',
                            [ [ 'item_', '_definition.id', '_refine_ls.shift_over_su_max_lt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_shift/su_max_lt' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Upper limit for the largest ratio of the final l-s parameter\n     shift divided by the final standard uncertainty. This item is\n     used when the largest value of the shift divided by the final\n     standard uncertainty is too small to measure.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'shift_over_su_max_lt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.shift_over_su_mean',
                            [ [ 'item_', '_definition.id', '_refine_ls.shift_over_su_mean' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_shift_over_su_mean',
                                  '_refine.ls_shift_over_esd_mean',
                                  '_refine_ls_shift/su_mean',
                                  '_refine_ls_shift/esd_mean' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The average ratio of the final least-squares parameter shift\n     to the final standard uncertainty (s.u., formerly described\n     as estimated standard deviation, e.s.d.).' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'shift_over_su_mean' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.shift_over_su_mean_lt',
                            [ [ 'item_', '_definition.id', '_refine_ls.shift_over_su_mean_lt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_shift/su_mean_lt' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Upper limit for the average ratio of the final l-s parameter\n     shift divided by the final standard uncertainty. This item is\n     used when the average value of the shift divided by the final\n     standard uncertainty is too small to measure.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'shift_over_su_mean_lt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.structure_factor_coef',
                            [ [ 'item_', '_definition.id', '_refine_ls.structure_factor_coef' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_structure_factor_coef',
                                  '_refine.ls_structure_factor_coef' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Structure-factor coefficient used in the least-squares process.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'structure_factor_coef' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'F',
                                  'structure factor magnitude',
                                  'Fsqd',
                                  'structure factor squared',
                                  'Inet',
                                  'net intensity' ] ],
                              [ 'item_', '_enumeration.default', 'F' ] ] ],
                          [ 'save_',
                            'refine_ls.weighting_details',
                            [ [ 'item_', '_definition.id', '_refine_ls.weighting_details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_weighting_details',
                                  '_refine.ls_weighting_details' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of special aspects of the weighting scheme used in the\n     least-squares refinement. Used to describe the weighting when the\n     value of _refine_ls.weighting_scheme is specified as \'calc\'.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'weighting_details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '\n        Sigdel model of Konnert-Hendrickson:\n         Sigdel = Afsig +  Bfsig*(sin(\\q)/\\l - 1/6)\n         Afsig  = 22.0, Bfsig = 150.0 at the beginning of refinement.\n         Afsig  = 16.0, Bfsig =  60.0 at the end of refinement.' ] ] ] ],
                          [ 'save_',
                            'refine_ls.weighting_scheme',
                            [ [ 'item_', '_definition.id', '_refine_ls.weighting_scheme' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_weighting_scheme', '_refine.ls_weighting_scheme' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     General description of the weighting scheme used in the least-squares.\n     An enumerated code should be contained in this description.' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'weighting_scheme' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'sigma',
                                  'based on measured s.u.\'s',
                                  'unit',
                                  'unit or no weights applied',
                                  'calc',
                                  'calculated weights applied' ] ],
                              [ 'item_', '_enumeration.default', 'sigma' ] ] ],
                          [ 'save_',
                            'refine_ls.wR_factor_all',
                            [ [ 'item_', '_definition.id', '_refine_ls.wR_factor_all' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_wR_factor_all', '_refine.ls_wR_factor_all' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Weighted residual factors for all reflections satisfying the resolution\n     limits specified by _refine_ls.d_res_high and _refine_ls.d_res_low.\n     See also the _refine_ls.R_factor_all definition.\n \n            ( sum w [ Y(meas) - Y(calc) ]^2^ )^1/2^\n       wR = ( ------------------------------ )\n            (         sum w Y(meas)^2^       )\n \n       Y(meas) = the measured   amplitude _refine_ls.structure_factor_coef\n       Y(calc) = the calculated amplitude _refine_ls.structure_factor_coef\n       w       = the least-squares weight\n       and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'wR_factor_all' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.wR_factor_gt',
                            [ [ 'item_', '_definition.id', '_refine_ls.wR_factor_gt' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_wR_factor_obs',
                                  '_refine.ls_wR_factor_obs',
                                  '_refine_ls_wR_factor_gt' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Weighted residual factors for significantly intense reflections\n     (satisfying @reflns_threshold_expression) included in the refinement.\n     The reflections must also satisfy the resolution limits established by\n     _refine_ls.d_res_high and _refine_ls.d_res_low.\n \n            ( sum w [ Y(meas_gt) - Y(calc) ]^2^  )^1/2^\n       wR = ( ---------------------------------- )\n            (         sum w Y(meas_gt)^2^        )\n \n     Y(meas_gt) = the \'observed\' amplitude _refine_ls.structure_factor_coef\n     Y(calc)    = the calculated amplitude _refine_ls.structure_factor_coef\n       w       = the least-squares weight\n       and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'wR_factor_gt' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ 'save_',
                            'refine_ls.wR_factor_ref',
                            [ [ 'item_', '_definition.id', '_refine_ls.wR_factor_ref' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_refine_ls_wR_factor_ref' ] ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Weighted residual factors for reflections included in the refinement\n     which satisfy the limits specified by _refine_ls.d_res_high and\n     _refine_ls.d_res_low.\n \n            ( sum w [ Y(meas) - Y(calc) ]^2^ )^1/2^\n       wR = ( ------------------------------ )\n            (         sum w Y(meas)^2^       )\n \n       Y(meas) = the measured   amplitude _refine_ls.structure_factor_coef\n       Y(calc) = the calculated amplitude _refine_ls.structure_factor_coef\n       w       = the least-squares weight\n       and the sum is taken over the specified reflections' ],
                              [ 'item_', '_name.category_id', 'refine_ls' ],
                              [ 'item_', '_name.object_id', 'wR_factor_ref' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'none' ] ] ],
                          [ '@comment',
                            '----------------------------------------------------------------------------' ],
                          [ 'save_',
                            'REFINE_LS_CLASS',
                            [ [ 'item_', '_definition.id', 'REFINE_LS_CLASS' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The CATEGORY of data items used to specify information about the\n     refinement of the structural model.' ],
                              [ 'item_', '_name.category_id', 'REFINE_LS' ],
                              [ 'item_', '_name.object_id', 'CLASS' ],
                              [ 'item_', '_category.key_id', '_refine_ls_class.key' ],
                              [ 'save_',
                                'refine_ls_class.key',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.key' ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of REFINE_LS_CLASS items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '              _type.contents = Type_Contents(refine_ls_class.code)',
                                      'Evaluation',
                                      '              _refine_ls_class.key = _refine_ls_class.code' ] ] ] ],
                              [ 'save_',
                                'refine_ls_class.code',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.code' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_code' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Code identifying a certain reflection class.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'code' ],
                                  [ 'item_', '_name.linked_item_id', '_reflns_class.code' ],
                                  [ 'item_', '_type.purpose', 'Link' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_', [ '_description_example.case' ], [ '1', 'm1', 's2' ] ] ] ],
                              [ 'save_',
                                'refine_ls_class.d_res_high',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.d_res_high' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_d_res_high' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Highest resolution for the reflections in this class.\n     This corresponds to the smallest interpanar d value.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'd_res_high' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'angstroms' ] ] ],
                              [ 'save_',
                                'refine_ls_class.d_res_low',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.d_res_low' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_d_res_low' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Lowest resolution for the reflections in this class.\n     This corresponds to the largest interpanar d value.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'd_res_low' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'angstroms' ] ] ],
                              [ 'save_',
                                'refine_ls_class.R_factor_all',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.R_factor_all' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_R_factor_all' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Residual factor for reflections in this class included in the\n     refinement.  See _refine_ls.R_factor_all definition for details.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'R_factor_all' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'refine_ls_class.R_factor_gt',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.R_factor_gt' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_R_factor_gt',
                                      '_refine_ls_class_R_factor_obs' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Residual factor for the reflections in this class judged\n     significantly intense (see _reflns.threshold_expression) and\n     included in refinement. See _refine_ls.R_factor_gt for details.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'R_factor_gt' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'refine_ls_class.R_Fsqd_factor',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.R_Fsqd_factor' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_R_Fsqd_factor' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Residual factor R(F^2^) for reflections in this class judged\n     significantly intense (see _reflns.threshold_expression) and\n     included in refinement. See _refine_ls.R_Fsqd_factor for details.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'R_Fsqd_factor' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'refine_ls_class.R_I_factor',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.R_I_factor' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_R_I_factor' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Residual factor R(I) for reflections in this class judged\n     significantly intense (see _reflns.threshold_expression) and\n     included in refinement. See _refine_ls.R_I_factor for details.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'R_I_factor' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ],
                              [ 'save_',
                                'refine_ls_class.wR_factor_all',
                                [ [ 'item_', '_definition.id', '_refine_ls_class.wR_factor_all' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_refine_ls_class_wR_factor_all' ] ],
                                  [ 'item_', '_definition.update', '2012-11-20' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Weight residual for all reflections in this class judged\n     significantly intense (see _reflns.threshold_expression) and\n     included in refinement. See _refine_ls.wR_factor_all for details.' ],
                                  [ 'item_', '_name.category_id', 'refine_ls_class' ],
                                  [ 'item_', '_name.object_id', 'wR_factor_all' ],
                                  [ 'item_', '_type.purpose', 'Number' ],
                                  [ 'item_', '_type.source', 'Derived' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Real' ],
                                  [ 'item_', '_enumeration.range', '0.0:' ],
                                  [ 'item_', '_units.code', 'none' ] ] ] ] ],
                          [ '@comment', '------ close REFINE_LS_CLASS category' ] ] ],
                      [ '@comment', '------ close REFINE_LS category' ] ] ],
                  [ '@comment', '------ close REFINE category' ] ] ],
              [ '@comment', '------ close STRUCTURE category' ],
              [ 'save_',
                'MODEL',
                [ [ 'item_', '_definition.id', 'MODEL' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Head' ],
                  [ 'item_', '_definition.update', '2012-11-22' ],
                  [ 'item_',
                    '_description.text',
                    '\n    Items in the MODEL Category specify data for the crystal structure\n    postulated and modelled from the atomic coordinates derived and\n    refined from the diffraction information. The structural model is\n    described principally in terms of the geometry of the \'connected\'\n    atom sites and the crystal symmetry in which they reside.' ],
                  [ 'item_', '_name.category_id', 'CIF_CORE' ],
                  [ 'item_', '_name.object_id', 'MODEL' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'GEOM',
                    [ [ 'item_', '_definition.id', 'GEOM' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-11-22' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to specify the geometry\n     of the structural model as derived from the atomic sites.\n     The geometry is expressed in terms of the interatomic\n     angles (GEOM_ANGLE data), covalent bond distances\n     (GEOM_BOND data), contact distances (GEOM_CONTACT data),\n     hydrogen bonds (GEOM_HBOND data) and torsion geometry\n     (GEOM_TORSION data).\n     Geometry data are usually redundant, in that they can be\n     calculated from other more fundamental quantities in the data\n     block. However, they serve the dual purposes of providing a\n     check on the correctness of both sets of data and of enabling\n     the most important geometric data to be identified for\n     publication by setting the appropriate publication flag.' ],
                      [ 'item_', '_name.category_id', 'MODEL' ],
                      [ 'item_', '_name.object_id', 'GEOM' ],
                      [ 'save_',
                        'geom.bond_distance_incr',
                        [ [ 'item_', '_definition.id', '_geom.bond_distance_incr' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Increment added to the bond radii for the atomic species to\n     specify the maximum permitted "bonded" distance between two\n     atom sites.' ],
                          [ 'item_', '_name.category_id', 'geom' ],
                          [ 'item_', '_name.object_id', 'bond_distance_incr' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.2' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'geom.bond_distance_min',
                        [ [ 'item_', '_definition.id', '_geom.bond_distance_min' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Minimum permitted "bonded" distance between two atom sites.' ],
                          [ 'item_', '_name.category_id', 'geom' ],
                          [ 'item_', '_name.object_id', 'bond_distance_min' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.2' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'geom.contact_distance_incr',
                        [ [ 'item_', '_definition.id', '_geom.contact_distance_incr' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Increment added to the bond radii for the atomic species to\n     specify the maximum permitted "contact" distance between two\n     "non-bonded" atom sites.' ],
                          [ 'item_', '_name.category_id', 'geom' ],
                          [ 'item_', '_name.object_id', 'contact_distance_incr' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.2' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'geom.contact_distance_min',
                        [ [ 'item_', '_definition.id', '_geom.contact_distance_min' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Minimum permitted "contact" distance between two "non-bonded" atom sites.' ],
                          [ 'item_', '_name.category_id', 'geom' ],
                          [ 'item_', '_name.object_id', 'contact_distance_min' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.default', '0.2' ],
                          [ 'item_', '_units.code', 'angstroms' ] ] ],
                      [ 'save_',
                        'geom.special_details',
                        [ [ 'item_', '_definition.id', '_geom.special_details' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_geom_special_details', '_geom.details' ] ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Description of geometry information not covered by the existing data\n     names in the geometry categories, such as least-squares planes.' ],
                          [ 'item_', '_name.category_id', 'geom' ],
                          [ 'item_', '_name.object_id', 'special_details' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'GEOM_ANGLE',
                        [ [ 'item_', '_definition.id', 'GEOM_ANGLE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify the geometry angles in the\n     structural model as derived from the atomic sites.' ],
                          [ 'item_', '_name.category_id', 'GEOM' ],
                          [ 'item_', '_name.object_id', 'ANGLE' ],
                          [ 'item_', '_category.key_id', '_geom_angle.key' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     dmin =  _geom.bond_distance_min\n \n     Loop  m1  as  model_site  :i  {   # loop vertex model site\n \n        rad1  =   m1.radius_bond + _geom.bond_distance_incr\n \n        Loop  m2  as  model_site  :j  {  # loop first target site\n \n           If (i==j or m1.mole_index != m2.mole_index) Next\n           v1 =  m2.Cartn_xyz - m1.Cartn_xyz\n           d1 =  Norm (v1)\n \n           If (d1<dmin or d1>(rad1+m2.radius_bond))  Next\n \n           rad2  =   m2.radius_bond + _geom.bond_distance_incr\n \n           Loop  m3  as  model_site  :k>j  {  # loop second target site\n \n              If (i==k or m1.mole_index != m3.mole_index) Next\n              v2 =  m3.Cartn_xyz - m1.Cartn_xyz\n              d2 =  Norm (v2)\n \n              If (d2<dmin or d2>(rad2+m3.radius_bond)) Next\n \n              angle =  Acosd ( v1*v2 / (d1*d2) )\n \n              geom_angle( .id        =  List ( m2.id, m1.id, m3.id ),\n                          .distances =  List ( d1, d2 ),\n                          .value     =  angle )\n     }   }   }' ] ],
                          [ 'save_',
                            'geom_angle.key',
                            [ [ 'item_', '_definition.id', '_geom_angle.key' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of GEOM_ANGLE items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(geom_angle.id)',
                                  'Evaluation',
                                  '              _geom_angle.key = _geom_angle.id' ] ] ] ],
                          [ 'save_',
                            'geom_angle.atom_site_label_1',
                            [ [ 'item_', '_definition.id', '_geom_angle.atom_site_label_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_atom_site_label_1',
                                  '_geom_angle.atom_site_id_1' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_1' ] ] ],
                          [ 'save_',
                            'geom_angle.atom_site_label_2',
                            [ [ 'item_', '_definition.id', '_geom_angle.atom_site_label_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_atom_site_label_2',
                                  '_geom_angle.atom_site_id_2' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_2' ] ] ],
                          [ 'save_',
                            'geom_angle.atom_site_label_3',
                            [ [ 'item_', '_definition.id', '_geom_angle.atom_site_label_3' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_atom_site_label_3',
                                  '_geom_angle.atom_site_id_3' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_3' ] ] ],
                          [ 'save_',
                            'geom_angle.distances',
                            [ [ 'item_', '_definition.id', '_geom_angle.distances' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The pair of distances between sites 1 - 2 and 2 - 3.' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'distances' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '2' ] ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'geom_angle.id',
                            [ [ 'item_', '_definition.id', '_geom_angle.id' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site labels and symmetry operators as pairs for each of the\n     three atom sites which identify the angle. The second label-symop\n     pair in the list identifies the site at the apex of the angle.' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'List(Code,Symop)' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  geom_angle\n \n         _geom_angle.id =  [[ a.atom_site_label_1, a.site_symmetry_1 ],\n                            [ a.atom_site_label_2, a.site_symmetry_2 ],\n                            [ a.atom_site_label_3, a.site_symmetry_3 ]]' ] ] ] ],
                          [ 'save_',
                            'geom_angle.publ_flag',
                            [ [ 'item_', '_definition.id', '_geom_angle.publ_flag' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_publ_flag' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code signals if the angle is referred to in a publication or\n     should be placed in a table of significant angles.' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'publ_flag' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'no',
                                  'do not include angle in special list',
                                  'n',
                                  'abbreviation for "no"',
                                  'yes',
                                  'do include angle in special list',
                                  'y',
                                  'abbreviation for "yes"' ] ],
                              [ 'item_', '_enumeration.default', 'no' ] ] ],
                          [ 'save_',
                            'geom_angle.site_symmetry_1',
                            [ [ 'item_', '_definition.id', '_geom_angle.site_symmetry_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_site_symmetry_1' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_1' ] ] ],
                          [ 'save_',
                            'geom_angle.site_symmetry_2',
                            [ [ 'item_', '_definition.id', '_geom_angle.site_symmetry_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_site_symmetry_2' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_2' ] ] ],
                          [ 'save_',
                            'geom_angle.site_symmetry_3',
                            [ [ 'item_', '_definition.id', '_geom_angle.site_symmetry_3' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_angle_site_symmetry_3' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_3' ] ] ],
                          [ 'save_',
                            'geom_angle.value',
                            [ [ 'item_', '_definition.id', '_geom_angle.value' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_geom_angle' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Angle defined by the sites identified by _geom_angle.id' ],
                              [ 'item_', '_name.category_id', 'angle' ],
                              [ 'item_', '_name.object_id', 'value' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With a as geom_angle\n \n     xc = List()\n \n     For [label,symop] in  a.id   {\n \n         xf   =   SymEquiv(symop,  _atom_site[label].fract_xyz)\n \n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n      }\n         v1,v2  =  xc[0]-xc[1], xc[2]-xc[1]\n \n      _geom_angle.value =  Acosd ( v1 * v2 / ( Norm (v1) * Norm (v2) ) )' ] ] ] ] ] ],
                      [ '@comment', '----------- close of GEOM_ANGLE category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'GEOM_BOND',
                        [ [ 'item_', '_definition.id', 'GEOM_BOND' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify the geometry bonds in the\n     structural model as derived from the atomic sites.' ],
                          [ 'item_', '_name.category_id', 'GEOM' ],
                          [ 'item_', '_name.object_id', 'BOND' ],
                          [ 'item_', '_category.key_id', '_geom_bond.key' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     dmin =  _geom.bond_distance_min\n \n     Loop  m1  as  model_site  :i  {\n \n        rad   =   m1.radius_bond + _geom.bond_distance_incr\n \n        Loop  m2  as  model_site  :j  {\n \n           If (i==j or m1.mole_index != m2.mole_index) Next\n \n           d =  Norm (m1.Cartn_xyz - m2.Cartn_xyz)\n \n           If (d<dmin or d>(rad+m2.radius_bond)) Next\n \n           geom_bond( .id        =  List ( m1.id, m2.id ),\n                      .distance  =  d  )\n      }   }' ] ],
                          [ 'save_',
                            'geom_bond.key',
                            [ [ 'item_', '_definition.id', '_geom_bond.key' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of GEOM_BOND items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(geom_bond.id)',
                                  'Evaluation',
                                  '              _geom_bond.key = _geom_bond.id' ] ] ] ],
                          [ 'save_',
                            'geom_bond.atom_site_label_1',
                            [ [ 'item_', '_definition.id', '_geom_bond.atom_site_label_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_atom_site_label_1', '_geom_bond.atom_site_id_1' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_1' ] ] ],
                          [ 'save_',
                            'geom_bond.atom_site_label_2',
                            [ [ 'item_', '_definition.id', '_geom_bond.atom_site_label_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_atom_site_label_2', '_geom_bond.atom_site_id_2' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_2' ] ] ],
                          [ 'save_',
                            'geom_bond.distance',
                            [ [ 'item_', '_definition.id', '_geom_bond.distance' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_distance', '_geom_bond.dist' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Intramolecular bond distance between the sites identified\n     by _geom_bond.id' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'distance' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With b as geom_bond\n \n     xc = List()\n \n     For [label,symop] in  b.id   {\n \n         xf   =   SymEquiv(symop, _atom_site[label].fract_xyz)\n \n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n      }\n      _geom_bond.distance =  Norm ( xc[0] - xc[1] )' ] ] ] ],
                          [ 'save_',
                            'geom_bond.valence',
                            [ [ 'item_', '_definition.id', '_geom_bond.valence' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_geom_bond_valence' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Bond valence calculated from the bond distance.' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'valence' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'electrons' ] ] ],
                          [ 'save_',
                            'geom_bond.id',
                            [ [ 'item_', '_definition.id', '_geom_bond.id' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Identity of bond distance in terms of the atom site labels and\n     symmetry operators as pairs for each of the two "bonded" atom sites.' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'List(Code,Symop)' ],
                              [ 'item_', '_type.dimension', [ '2' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  geom_bond\n \n           _geom_bond.id =  [[ a.atom_site_label_1, a.site_symmetry_1 ],\n                             [ a.atom_site_label_2, a.site_symmetry_2 ]]' ] ] ] ],
                          [ 'save_',
                            'geom_bond.publ_flag',
                            [ [ 'item_', '_definition.id', '_geom_bond.publ_flag' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_publ_flag' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This code signals whether the angle is referred to in a\n     publication or should be placed in a table of significant angles.' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'publ_flag' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'no',
                                  'do not include bond in special list',
                                  'n',
                                  'abbreviation for "no"',
                                  'yes',
                                  'do include bond in special list',
                                  'y',
                                  'abbreviation for "yes"' ] ],
                              [ 'item_', '_enumeration.default', 'no' ] ] ],
                          [ 'save_',
                            'geom_bond.multiplicity',
                            [ [ 'item_', '_definition.id', '_geom_bond.multiplicity' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_multiplicity' ] ],
                              [ 'item_', '_definition.update', '2013-01-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The number of times the given bond appears in the environment\n     of the atoms labelled _geom_bond.atom_site_label_1. In cases\n     where the full list of bonds is given, one of the series of\n     equivalent bonds may be assigned the appropriate multiplicity\n     while the others are assigned a value of 0.' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'multiplicity' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Count' ],
                              [ 'item_', '_enumeration.range', '1:' ] ] ],
                          [ 'save_',
                            'geom_bond.site_symmetry_1',
                            [ [ 'item_', '_definition.id', '_geom_bond.site_symmetry_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_site_symmetry_1' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_1' ] ] ],
                          [ 'save_',
                            'geom_bond.site_symmetry_2',
                            [ [ 'item_', '_definition.id', '_geom_bond.site_symmetry_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_bond_site_symmetry_2' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'bond' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_2' ] ] ] ] ],
                      [ '@comment', '----------- close of GEOM_BOND category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'GEOM_CONTACT',
                        [ [ 'item_', '_definition.id', 'GEOM_CONTACT' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify the interatomic\n     contact distances in the structural model.' ],
                          [ 'item_', '_name.category_id', 'GEOM' ],
                          [ 'item_', '_name.object_id', 'CONTACT' ],
                          [ 'item_', '_category.key_id', '_geom_contact.key' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     Loop  m1  as  model_site  {\n \n        rb  =   m1.radius_bond    + _geom.bond_distance_incr\n        rc  =   m1.radius_contact + _geom.contact_distance_incr\n \n        Loop  m2  as  model_site  {\n \n           If (m2.id[1] != \'1_555\')  Next\n           radb  =   rb + m2.radius_bond\n           radc  =   rc + m2.radius_contact\n           label =   m2.id[0]\n \n           Loop  s  as  symmetry_equiv  :ns   {\n \n              axyz      =   s.R * m2.fract_xyz + s.T\n \n              Do i = -2,2 { Do j = -2,2 { Do k = -2,2 { # cell translations\n \n                 tran  =   List ([i,j,k])\n                 bxyz  =   axyz + tran\n                 cxyz  =  _atom_sites_Cartn_transform.matrix * bxyz\n                 d     =   Norm (cxyz - m1.Cartn_xyz)\n \n                 If (d < radb or d > radc) Next\n \n                 id        =  List( m1.id, List( label, Symop(ns+1,tran) ) )\n \n                 geom_contact( .id        =  id,\n                               .distance  =  d  )\n     }  }  }  }  }  }' ] ],
                          [ 'save_',
                            'geom_contact.key',
                            [ [ 'item_', '_definition.id', '_geom_contact.key' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of GEOM_CONTACT items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(geom_contact.id)',
                                  'Evaluation',
                                  '              _geom_contact.key = _geom_contact.id' ] ] ] ],
                          [ 'save_',
                            'geom_contact.atom_site_label_1',
                            [ [ 'item_', '_definition.id', '_geom_contact.atom_site_label_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_contact_atom_site_label_1',
                                  '_geom_contact.atom_site_id_1' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_1' ] ] ],
                          [ 'save_',
                            'geom_contact.atom_site_label_2',
                            [ [ 'item_', '_definition.id', '_geom_contact.atom_site_label_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_contact_atom_site_label_2',
                                  '_geom_contact.atom_site_id_2' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_2' ] ] ],
                          [ 'save_',
                            'geom_contact.distance',
                            [ [ 'item_', '_definition.id', '_geom_contact.distance' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_contact_distance', '_geom_contact.dist' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Intermolecular distance between the atomic sites identifyed\n     by _geom_contact.id' ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'distance' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With c as geom_contact\n \n     xc = List()\n \n     For [label,symop] in  c.id   {\n \n         xf   =   SymEquiv(symop, _atom_site[label].fract_xyz)\n \n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n     }\n     _geom_contact.distance =  Norm ( xc[0] - xc[1] )' ] ] ] ],
                          [ 'save_',
                            'geom_contact.id',
                            [ [ 'item_', '_definition.id', '_geom_contact.id' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site labels and symmetry operators as pairs for each of the\n     two atom sites which define the contact bond.' ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'List(Code,Symop)' ],
                              [ 'item_', '_type.dimension', [ '2' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  geom_contact\n \n          _geom_contact.id =  [[ a.atom_site_label_1, a.site_symmetry_1 ],\n                               [ a.atom_site_label_2, a.site_symmetry_2 ]]' ] ] ] ],
                          [ 'save_',
                            'geom_contact.publ_flag',
                            [ [ 'item_', '_definition.id', '_geom_contact.publ_flag' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_contact_publ_flag' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This code signals whether the contact distance is referred to\n     in a publication or should be placed in a list of significant\n     contact distances.' ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'publ_flag' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'no',
                                  'do not include distance in special list',
                                  'n',
                                  'abbreviation for "no"',
                                  'yes',
                                  'do include distance in special list',
                                  'y',
                                  'abbreviation for "yes"' ] ],
                              [ 'item_', '_enumeration.default', 'no' ] ] ],
                          [ 'save_',
                            'geom_contact.site_symmetry_1',
                            [ [ 'item_', '_definition.id', '_geom_contact.site_symmetry_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_contact_site_symmetry_1' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_1' ] ] ],
                          [ 'save_',
                            'geom_contact.site_symmetry_2',
                            [ [ 'item_', '_definition.id', '_geom_contact.site_symmetry_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_contact_site_symmetry_2' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'contact' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_2' ] ] ] ] ],
                      [ '@comment', '----------- close of GEOM_CONTACT category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'GEOM_HBOND',
                        [ [ 'item_', '_definition.id', 'GEOM_HBOND' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify the hydrogen bond\n     distances in the structural model as derived from atomic sites.' ],
                          [ 'item_', '_name.category_id', 'GEOM' ],
                          [ 'item_', '_name.object_id', 'HBOND' ],
                          [ 'item_', '_category.key_id', '_geom_hbond.key' ],
                          [ 'save_',
                            'geom_hbond.key',
                            [ [ 'item_', '_definition.id', '_geom_hbond.key' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of GEOM_HBOND items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(geom_hbond.id)',
                                  'Evaluation',
                                  '              _geom_hbond.key = _geom_hbond.id' ] ] ] ],
                          [ 'save_',
                            'geom_hbond.angle_DHA',
                            [ [ 'item_', '_definition.id', '_geom_hbond.angle_DHA' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_angle_DHA' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Angle subtended by the sites identifyed in _geom_hbond.id.\n     The hydrogen at site H is at the apex of the angle.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'angle_DHA' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With h as geom_hbond\n \n     xc = List()\n \n     For [label,symop] in  h.id   {\n \n         xf   =   SymEquiv(symop, _atom_site[label].fract_xyz)\n \n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n      }\n         v1,v2  =  xc[0]-xc[1], xc[2]-xc[1]\n \n     _geom_hbond.angle_DHA  =  Acosd ( v1 * v2 / ( Norm (v1) * Norm (v2) ) )' ] ] ] ],
                          [ 'save_',
                            'geom_hbond.atom_site_label_A',
                            [ [ 'item_', '_definition.id', '_geom_hbond.atom_site_label_A' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_atom_site_label_A',
                                  '_geom_hbond.atom_site_id_A' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_A' ] ] ],
                          [ 'save_',
                            'geom_hbond.atom_site_label_D',
                            [ [ 'item_', '_definition.id', '_geom_hbond.atom_site_label_D' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_atom_site_label_D',
                                  '_geom_hbond.atom_site_id_D' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_D' ] ] ],
                          [ 'save_',
                            'geom_hbond.atom_site_label_H',
                            [ [ 'item_', '_definition.id', '_geom_hbond.atom_site_label_H' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_atom_site_label_H',
                                  '_geom_hbond.atom_site_id_H' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_H' ] ] ],
                          [ 'save_',
                            'geom_hbond.distance_DH',
                            [ [ 'item_', '_definition.id', '_geom_hbond.distance_DH' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_distance_DH', '_geom_hbond.dist_DH' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the distance between the\n     three atom sites identified by _geom_hbond.id.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'distance_DH' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     xc = List()\n \n     Do i=0,1  {\n         l,s  =   _geom_hbond.id [i]\n         xf   =   SymEquiv(s, _atom_site[l].fract_xyz)\n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n     }\n      _geom_hbond.distance_DH =  Norm ( xc[0] - xc[1] )' ] ] ] ],
                          [ 'save_',
                            'geom_hbond.distance_HA',
                            [ [ 'item_', '_definition.id', '_geom_hbond.distance_HA' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_distance_HA', '_geom_hbond.dist_HA' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the distance between the\n     three atom sites identified by _geom_hbond.id.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'distance_HA' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     xc = List()\n \n     Do i=1,2  {\n         l,s  =   _geom_hbond.id [i]\n         xf   =   SymEquiv(s, _atom_site[l].fract_xyz)\n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n     }\n      _geom_hbond.distance_HA =  Norm ( xc[0] - xc[1] )' ] ] ] ],
                          [ 'save_',
                            'geom_hbond.distance_DA',
                            [ [ 'item_', '_definition.id', '_geom_hbond.distance_DA' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_distance_DA', '_geom_hbond.dist_DA' ] ],
                              [ 'item_', '_definition.update', '2012-12-14' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the distance between the\n     three atom sites identified by _geom_hbond.id.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'distance_DA' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.0:' ],
                              [ 'item_', '_units.code', 'angstroms' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     xc = List()\n \n     Do i=0,2,2  {\n         l,s  =   _geom_hbond.id [i]\n         xf   =   SymEquiv(s, _atom_site[l].fract_xyz)\n         xc ++=  _atom_sites_Cartn_transform.matrix * xf\n      }\n      _geom_hbond.distance_DA =  Norm ( xc[0] - xc[1] )' ] ] ] ],
                          [ 'save_',
                            'geom_hbond.id',
                            [ [ 'item_', '_definition.id', '_geom_hbond.id' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site labels and symmetry operators as pairs for each of the\n     three atom sites which define the hydrogen angle and distances.\n     Site H is at the apex of the angle.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'List(Code,Symop)' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  geom_hbond\n \n         _geom_hbond.id =  [[ a.atom_site_label_D, a.site_symmetry_D ],\n                            [ a.atom_site_label_H, a.site_symmetry_H ],\n                            [ a.atom_site_label_A, a.site_symmetry_A ]]' ] ] ] ],
                          [ 'save_',
                            'geom_hbond.publ_flag',
                            [ [ 'item_', '_definition.id', '_geom_hbond.publ_flag' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_publ_flag' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This code signals whether the hydrogen-bond information\n     is referred to in a publication or should be placed in a\n     table of significant hydrogen-bond geometry.' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'publ_flag' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'no',
                                  'do not include bond in special list',
                                  'n',
                                  'abbreviation for "no"',
                                  'yes',
                                  'do include bond in special list',
                                  'y',
                                  'abbreviation for "yes"' ] ],
                              [ 'item_', '_enumeration.default', 'no' ] ] ],
                          [ 'save_',
                            'geom_hbond.site_symmetry_A',
                            [ [ 'item_', '_definition.id', '_geom_hbond.site_symmetry_A' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_site_symmetry_A' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_A' ] ] ],
                          [ 'save_',
                            'geom_hbond.site_symmetry_D',
                            [ [ 'item_', '_definition.id', '_geom_hbond.site_symmetry_D' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_site_symmetry_D' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_D' ] ] ],
                          [ 'save_',
                            'geom_hbond.site_symmetry_H',
                            [ [ 'item_', '_definition.id', '_geom_hbond.site_symmetry_H' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_hbond_site_symmetry_H' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'hbond' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_H' ] ] ] ] ],
                      [ '@comment', '----------- close of GEOM_HBOND category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'GEOM_TORSION',
                        [ [ 'item_', '_definition.id', 'GEOM_TORSION' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2013-03-14' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to specify the torsion angles in the\n     structural model as derived from the atomic sites.' ],
                          [ 'item_', '_name.category_id', 'GEOM' ],
                          [ 'item_', '_name.object_id', 'TORSION' ],
                          [ 'item_', '_category.key_id', '_geom_torsion.key' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     dmin =  _geom.bond_distance_min\n \n     Loop  m1  as  model_site  :i  {\n \n        rad1  =   m1.radius_bond + _geom.bond_distance_incr\n \n        Loop  m2  as  model_site  :j  {\n \n           If (i==j or m2.mole_index!=m1.mole_index) Next\n           v21 =  m1.Cartn_xyz - m2.Cartn_xyz\n           d21 =  Norm (v21)\n \n           If (d21 < dmin or d21 > (rad1+m2.radius_bond)) Next\n           rad2  =   m2.radius_bond + _geom.bond_distance_incr\n \n           Loop  m3  as  model_site  :k  {\n \n              If (k==i or k==j or m3.mole_index!=m2.mole_index) Next\n              v23 =  m3.Cartn_xyz - m2.Cartn_xyz\n              d23 =  Norm (v23)\n \n              If (d23 < dmin or d23 > (rad2+m3.radius_bond)) Next\n              rad3  =   m3.radius_bond + _geom.bond_distance_incr\n \n              Loop  m4  as  model_site  :l  {\n \n                 If (l==k or l==j or l==i or m4.mole_index!=m3.mole_index) Next\n                 v34 =  m4.Cartn_xyz - m3.Cartn_xyz\n                 d34 =  Norm (v34)\n \n                 If (d34 < dmin or d34 > (rad3+m4.radius_bond)) Next\n \n                 u1    =   v21 ^ v23\n                 u2    =   v34 ^ v23\n \n                 angle =  Acosd ( u1 * u2 / ( Norm(u1) * Norm(u2) ) )\n                 If ( (u1^u2)*v23 < 0 ) angle = -angle\n##############   If ( (u1^u2)*v23 > 0 ) angle = -angle\n \n                 geom_torsion( .id        =  List ( m1.id,m2.id,m3.id,m4.id ),\n                               .distances =  List ( d21,d23,d34 ),\n                               .angle     =  angle )\n     }   }   }    }' ] ],
                          [ 'save_',
                            'geom_torsion.key',
                            [ [ 'item_', '_definition.id', '_geom_torsion.key' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of GEOM_TORSION items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(geom_torsion.id)',
                                  'Evaluation',
                                  '              _geom_torsion.key = _geom_torsion.id' ] ] ] ],
                          [ 'save_',
                            'geom_torsion.atom_site_label_1',
                            [ [ 'item_', '_definition.id', '_geom_torsion.atom_site_label_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_atom_site_label_1',
                                  '_geom_torsion.atom_site_id_1' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_1' ] ] ],
                          [ 'save_',
                            'geom_torsion.atom_site_label_2',
                            [ [ 'item_', '_definition.id', '_geom_torsion.atom_site_label_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_atom_site_label_2',
                                  '_geom_torsion.atom_site_id_2' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_2' ] ] ],
                          [ 'save_',
                            'geom_torsion.atom_site_label_3',
                            [ [ 'item_', '_definition.id', '_geom_torsion.atom_site_label_3' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_atom_site_label_3',
                                  '_geom_torsion.atom_site_id_3' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_3' ] ] ],
                          [ 'save_',
                            'geom_torsion.atom_site_label_4',
                            [ [ 'item_', '_definition.id', '_geom_torsion.atom_site_label_4' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_atom_site_label_4',
                                  '_geom_torsion.atom_site_id_4' ] ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     This label is a unique identifier for a particular site in the\n     asymmetric unit of the crystal unit cell. It is made up of\n     components, _atom_site.label_component_0 to *_6, which may be\n     specified as separate data items. Component 0 usually matches one\n     of the specified _atom_type.symbol codes. This is not mandatory\n     if an _atom_site.type_symbol item is included in the atom site\n     list. The _atom_site.type_symbol always takes precedence over\n     an _atom_site.label in the identification of the atom type. The\n     label components 1 to 6 are optional, and normally only\n     components 0 and 1 are used. Note that components 0 and 1 are\n     concatenated, while all other components, if specified, are\n     separated by an underline character. Underline separators are\n     only used if higher-order components exist. If an intermediate\n     component is not used it may be omitted provided the underline\n     separators are inserted. For example the label \'C233__ggg\' is\n     acceptable and represents the components C, 233, \'\', and ggg.\n     Each label may have a different number of components.' ],
                              [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'C12',
                                  'Ca3g28',
                                  'Fe3+17',
                                  'H*251',
                                  'C_a_phe_83_a_0',
                                  'Zn_Zn_301_A_0' ] ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'atom_site_label_4' ] ] ],
                          [ 'save_',
                            'geom_torsion.distances',
                            [ [ 'item_', '_definition.id', '_geom_torsion.distances' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Distances between sites 1 - 2, 2 - 3 and 3 - 4.' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'distances' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'item_', '_units.code', 'angstroms' ] ] ],
                          [ 'save_',
                            'geom_torsion.id',
                            [ [ 'item_', '_definition.id', '_geom_torsion.id' ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom site labels and symmetry operators as pairs for each of the\n     four atom sites which define the torsion angle.' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'List(Code,Symop)' ],
                              [ 'item_', '_type.dimension', [ '4' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With  a  as  geom_torsion\n \n         _geom_torsion.id =  [[ a.atom_site_label_1, a.site_symmetry_1 ],\n                              [ a.atom_site_label_2, a.site_symmetry_2 ],\n                              [ a.atom_site_label_3, a.site_symmetry_3 ],\n                              [ a.atom_site_label_4, a.site_symmetry_4 ]]' ] ] ] ],
                          [ 'save_',
                            'geom_torsion.publ_flag',
                            [ [ 'item_', '_definition.id', '_geom_torsion.publ_flag' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_publ_flag' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code signals if the torsion angle is required for publication.' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'publ_flag' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'Yes', 'Publish', 'No', 'Do not publish' ] ],
                              [ 'item_', '_enumeration.default', 'No' ] ] ],
                          [ 'save_',
                            'geom_torsion.angle',
                            [ [ 'item_', '_definition.id', '_geom_torsion.angle' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion', '_geom_torsion.value' ] ],
                              [ 'item_', '_definition.update', '2012-11-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Angle defined by the sites identifyed in _geom_torsion.id.\n     The torsion-angle definition should be that of Klyne and Prelog.\n     The vector direction *_label_2 to *_label_3 is the viewing\n     direction, and the torsion angle is the angle of twist required\n     to superimpose the projection of the vector between site 2 and\n     site 1 onto the projection of the vector between site 3 and\n     site 4. Clockwise torsions are positive, anticlockwise torsions\n     are negative.\n     Ref: Klyne, W. & Prelog, V. (1960). Experientia, 16, 521-523.' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'angle' ],
                              [ 'item_', '_type.purpose', 'Measurand' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '-180.:180.' ],
                              [ 'item_', '_units.code', 'degrees' ] ] ],
                          [ 'save_',
                            'geom_torsion.site_symmetry_1',
                            [ [ 'item_', '_definition.id', '_geom_torsion.site_symmetry_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_site_symmetry_1' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_1' ] ] ],
                          [ 'save_',
                            'geom_torsion.site_symmetry_2',
                            [ [ 'item_', '_definition.id', '_geom_torsion.site_symmetry_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_site_symmetry_2' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_2' ] ] ],
                          [ 'save_',
                            'geom_torsion.site_symmetry_3',
                            [ [ 'item_', '_definition.id', '_geom_torsion.site_symmetry_3' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_site_symmetry_3' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_3' ] ] ],
                          [ 'save_',
                            'geom_torsion.site_symmetry_4',
                            [ [ 'item_', '_definition.id', '_geom_torsion.site_symmetry_4' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_geom_torsion_site_symmetry_4' ] ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                              [ 'item_', '_type.purpose', 'Composite' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Symop' ],
                              [ 'loop_',
                                [ '_description_example.case', '_description_example.detail' ],
                                [ '4',
                                  '4th symmetry operation applied',
                                  '7_645',
                                  '7th symm. posn.; +a on x; -b on y' ] ],
                              [ 'item_', '_enumeration.default', '1_555' ],
                              [ 'item_', '_name.category_id', 'torsion' ],
                              [ 'item_', '_name.object_id', 'site_symmetry_4' ] ] ] ] ],
                      [ '@comment', '----------- close of GEOM_TORSION category' ] ] ],
                  [ '@comment', '----------- close of GEOM category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'VALENCE',
                    [ [ 'item_', '_definition.id', 'VALENCE' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-12-13' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of items used to specify bond valence parameters\n     used to calculate bond valences from bond lengths.' ],
                      [ 'item_', '_name.category_id', 'MODEL' ],
                      [ 'item_', '_name.object_id', 'VALENCE' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'VALENCE_PARAM',
                        [ [ 'item_', '_definition.id', 'VALENCE_PARAM' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of items for listing bond valences.' ],
                          [ 'item_', '_name.category_id', 'VALENCE' ],
                          [ 'item_', '_name.object_id', 'PARAM' ],
                          [ 'item_', '_category.key_id', '_valence_param.key' ],
                          [ 'save_',
                            'valence_param.key',
                            [ [ 'item_', '_definition.id', '_valence_param.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Unique key to looped list of VALENCE_PARAM items.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(valence_param.id)',
                                  'Evaluation',
                                  '              _valence_param.key = _valence_param.id' ] ] ] ],
                          [ 'save_',
                            'valence_param.id',
                            [ [ 'item_', '_definition.id', '_valence_param.id' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_valence_param_id' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Unique index loop number of the valence parameter loop.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '1:' ] ] ],
                          [ 'save_',
                            'valence_param.ref_id',
                            [ [ 'item_', '_definition.id', '_valence_param.ref_id' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_param_ref_id' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code linking parameters to the key valence_ref.id key\n     in the reference list in category VALENCE_REF.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'ref_id' ],
                              [ 'item_', '_name.linked_item_id', '_valence_ref.id' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'valence_param.atom_1',
                            [ [ 'item_', '_definition.id', '_valence_param.atom_1' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_param_atom_1' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom type symbol for atom 1 forming a bond whose\n     valence parameters are given in this category.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'atom_1' ],
                              [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'valence_param.atom_2',
                            [ [ 'item_', '_definition.id', '_valence_param.atom_2' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_param_atom_2' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Atom type symbol for atom 2 forming a bond whose\n     valence parameters are given in this category.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'atom_2' ],
                              [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'valence_param.atom_1_valence',
                            [ [ 'item_', '_definition.id', '_valence_param.atom_1_valence' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_param_atom_1_valence' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The valence (formal charge) of the atom 1 whose bond\n     valence parameters are given in this category.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'atom_1_valence' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'coulomb' ] ] ],
                          [ 'save_',
                            'valence_param.atom_2_valence',
                            [ [ 'item_', '_definition.id', '_valence_param.atom_2_valence' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_param_atom_2_valence' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The valence (formal charge) of the atom 2 whose bond\n     valence parameters are given in this category.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'atom_2_valence' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.:' ],
                              [ 'item_', '_units.code', 'coulomb' ] ] ],
                          [ 'save_',
                            'valence_param.B',
                            [ [ 'item_', '_definition.id', '_valence_param.B' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_valence_param_B' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The bond valence parameter B used in the expression\n     s = exp[(Ro - R)/B] where s is the valence of bond length R.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'B' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '0.1:' ],
                              [ 'item_', '_units.code', 'Angstroms' ] ] ],
                          [ 'save_',
                            'valence_param.Ro',
                            [ [ 'item_', '_definition.id', '_valence_param.Ro' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_valence_param_Ro' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The bond valence parameter Ro used in the expression\n     s = exp[(Ro - R)/B] where s is the valence of bond length R.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'Ro' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Real' ],
                              [ 'item_', '_enumeration.range', '1.:' ],
                              [ 'item_', '_units.code', 'Angstroms' ] ] ],
                          [ 'save_',
                            'valence_param.details',
                            [ [ 'item_', '_definition.id', '_valence_param.details' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_param_details' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Details of valence parameters of stated bond.' ],
                              [ 'item_', '_name.category_id', 'param' ],
                              [ 'item_', '_name.object_id', 'details' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '----------- close of VALENCE_PARAM category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'VALENCE_REF',
                        [ [ 'item_', '_definition.id', 'VALENCE_REF' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of items for listing valence references.' ],
                          [ 'item_', '_name.category_id', 'VALENCE' ],
                          [ 'item_', '_name.object_id', 'REF' ],
                          [ 'item_', '_category.key_id', '_valence_ref.key' ],
                          [ 'save_',
                            'valence_ref.key',
                            [ [ 'item_', '_definition.id', '_valence_ref.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Unique key to looped list of VALENCE_REF items.' ],
                              [ 'item_', '_name.category_id', 'ref' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(valence_ref.id)',
                                  'Evaluation',
                                  '              _valence_ref.key = _valence_ref.id' ] ] ] ],
                          [ 'save_',
                            'valence_ref.id',
                            [ [ 'item_', '_definition.id', '_valence_ref.id' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_valence_ref_id' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Unique loop code of the valence references.' ],
                              [ 'item_', '_name.category_id', 'ref' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'valence_ref.reference',
                            [ [ 'item_', '_definition.id', '_valence_ref.reference' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_valence_ref_reference' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Literature reference from which the valence parameters\n     identified by _valence_param.id were taken' ],
                              [ 'item_', '_name.category_id', 'ref' ],
                              [ 'item_', '_name.object_id', 'reference' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '----------- close of VALENCE_REF category' ] ] ],
                  [ '@comment', '----------- close of VALENCE category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'MODEL_SITE',
                    [ [ 'item_', '_definition.id', 'MODEL_SITE' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Loop' ],
                      [ 'item_', '_definition.update', '2012-11-22' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to describe atomic sites and\n     connections in the proposed atomic model.' ],
                      [ 'item_', '_name.category_id', 'MODEL' ],
                      [ 'item_', '_name.object_id', 'SITE' ],
                      [ 'item_', '_category.key_id', '_model_site.key' ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n# Store unique sites as a local list\n \n     atomlist  = List()\n     Loop  a  as  atom_site  {\n        axyz       =    a.fract_xyz\n        cxyz       =   _atom_sites_Cartn_transform.matrix * axyz\n        radb       =   _atom_type[a.type_symbol].radius_bond\n        radc       =   _atom_type[a.type_symbol].radius_contact\n        ls         =   List ( a.label, "1_555" )\n        atomlist ++=   [ls, axyz, cxyz, radb, radc, 0]\n     }\n \n# Store closest connected sites as a list\n \n     molelist  = List()\n     dmin     =  _geom.bond_distance_min\n     m        =  0\n     n        =  0\n \n     For [ls1,a1,c1,rb1,rc1,m1] in atomlist  {\n         If (m1 != 0) Next\n         m         +=  1\n         n         +=  1\n         molelist ++=  [ls1,a1,c1,rb1,rc1,n,m]\n         atomlist --=  [ls1,a1,c1,rb1,rc1,m]\n \n         Repeat  {\n             connect =  "no"\n \n             For [ls2,a2,c2,rb2,rc2,n2,m2] in molelist  {\n                 If (m2 != m) Next\n \n                 For [ls3,a3,c3,rb3,rc3,m3] in atomlist  {\n                     dmax  =  rb2 + rb3 + _geom.bond_distance_incr\n \n                     Loop  s  as  symmetry_equiv  :ns   {\n \n                         axyz      =   s.R * a3 + s.T\n                         bxyz,tran =   Closest (axyz, a2)\n                         cxyz      =  _atom_sites_Cartn_transform.matrix *bxyz\n                         d         =   Norm (cxyz - c2)\n \n                        If (d > dmin and d < dmax)          {\n                            ls  =   List ( ls3[0], Symop(ns+1, tran) )\n \n                            If (ls not in Strip(molelist,0))    {\n                                n         +=  1\n                                molelist ++=  [ls,bxyz,cxyz,rb3,rc3,n,m]\n                                atomlist --=  [ls3,a3,c3,rb3,rc3,m]\n                                connect    =  "yes"\n         }   }   }   }   }\n        If (connect == "no") Break\n     }  }\n \n# Store connected molecular sites as MODEL_SITE list\n \n     For [ls,ax,cx,rb,rc,n,m] in molelist  {\n \n        model_site( .id              =  ls,\n                    .fract_xyz       =  ax,\n                    .Cartn_xyz       =  cx,\n                    .radius_bond     =  rb,\n                    .radius_contact  =  rc,\n                    .index           =  n,\n                    .mole_index      =  m  )\n      }' ] ],
                      [ 'save_',
                        'model_site.key',
                        [ [ 'item_', '_definition.id', '_model_site.key' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Value is a unique key to a set of MODEL_SITE items\n     in a looped list.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'key' ],
                          [ 'item_', '_type.purpose', 'Key' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Implied' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '              _type.contents = Type_Contents(model_site.id)',
                              'Evaluation',
                              '              _model_site.key = _model_site.id' ] ] ] ],
                      [ 'save_',
                        'model_site.display_colour',
                        [ [ 'item_', '_definition.id', '_model_site.display_colour' ],
                          [ 'item_', '_definition.update', '2013-01-23' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Display colour code assigned to this atom site. Note that the\n     possible colours are enumerated in the colour_RBG list, and\n     the default code is enumerated in the colour_hue list.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'display_colour' ],
                          [ 'item_', '_type.purpose', 'State' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_enumeration_set.state', '_enumeration_set.detail' ],
                            [ 'black',
                              '[ 000, 000, 000 ]',
                              'white',
                              '[ 255, 255, 255 ]',
                              'grey',
                              '[ 192, 192, 192 ]',
                              'grey_light',
                              '[ 211, 211, 211 ]',
                              'grey_slate',
                              '[ 112, 128, 144 ]',
                              'blue',
                              '[ 000, 000, 255 ]',
                              'blue_light',
                              '[ 176, 224, 230 ]',
                              'blue_medium',
                              '[ 000, 000, 205 ]',
                              'blue_dark',
                              '[ 025, 025, 112 ]',
                              'blue_navy',
                              '[ 000, 000, 128 ]',
                              'blue_royal',
                              '[ 065, 105, 225 ]',
                              'blue_sky',
                              '[ 135, 206, 235 ]',
                              'blue_steel',
                              '[ 070, 130, 180 ]',
                              'turquoise',
                              '[ 064, 224, 208 ]',
                              'cyan',
                              '[ 000, 255, 255 ]',
                              'cyan_light',
                              '[ 224, 255, 255 ]',
                              'green',
                              '[ 000, 255, 000 ]',
                              'green_light',
                              '[ 152, 251, 152 ]',
                              'green_dark',
                              '[ 000, 100, 000 ]',
                              'green_sea',
                              '[ 046, 139, 087 ]',
                              'green_lime',
                              '[ 050, 205, 050 ]',
                              'green_olive',
                              '[ 107, 142, 035 ]',
                              'green_khaki',
                              '[ 240, 230, 140 ]',
                              'yellow',
                              '[ 255, 255, 000 ]',
                              'yellow_light',
                              '[ 255, 255, 224 ]',
                              'yellow_gold',
                              '[ 255, 215, 000 ]',
                              'brown',
                              '[ 165, 042, 042 ]',
                              'brown_sienna',
                              '[ 160, 082, 045 ]',
                              'brown_beige',
                              '[ 245, 245, 220 ]',
                              'brown_tan',
                              '[ 210, 180, 140 ]',
                              'salmon',
                              '[ 250, 128, 114 ]',
                              'salmon_light',
                              '[ 255, 160, 122 ]',
                              'salmon_dark',
                              '[ 233, 150, 122 ]',
                              'orange',
                              '[ 255, 165, 000 ]',
                              'orange_dark',
                              '[ 255, 140, 000 ]',
                              'red',
                              '[ 255, 000, 000 ]',
                              'red_coral',
                              '[ 255, 127, 080 ]',
                              'red_tomato',
                              '[ 255, 099, 071 ]',
                              'red_orange',
                              '[ 255, 069, 000 ]',
                              'red_violet',
                              '[ 219, 112, 147 ]',
                              'red_maroon',
                              '[ 176, 048, 096 ]',
                              'pink',
                              '[ 255, 192, 203 ]',
                              'pink_light',
                              '[ 255, 182, 193 ]',
                              'pink_deep',
                              '[ 255, 020, 147 ]',
                              'pink_hot',
                              '[ 255, 105, 180 ]',
                              'violet',
                              '[ 238, 130, 238 ]',
                              'violet_red',
                              '[ 208, 032, 144 ]',
                              'violet_magenta',
                              '[ 255, 000, 255 ]',
                              'violet_dark',
                              '[ 148, 000, 211 ]',
                              'violet_blue',
                              '[ 138, 043, 226 ]' ] ],
                          [ 'loop_',
                            [ '_enumeration_default.index', '_enumeration_default.value' ],
                            [ 'H',
                              'white',
                              'D',
                              'blue_light',
                              'H1-',
                              'white',
                              'He',
                              'unknown',
                              'Li',
                              'unknown',
                              'Li1+',
                              'unknown',
                              'Be',
                              'unknown',
                              'Be2+',
                              'unknown',
                              'B',
                              'unknown',
                              'C',
                              'steel_grey',
                              'N',
                              'blue',
                              'O',
                              'red',
                              'O1-',
                              'red',
                              'F',
                              'green',
                              'F1-',
                              'green',
                              'Ne',
                              'unknown',
                              'Na',
                              'magenta',
                              'Na1+',
                              'magenta',
                              'Mg',
                              'magenta',
                              'Mg2+',
                              'magenta',
                              'Al',
                              'magenta',
                              'Al3+',
                              'magenta',
                              'Si',
                              'unknown',
                              'Si4+',
                              'unknown',
                              'P',
                              'magenta',
                              'S',
                              'yellow',
                              'Cl',
                              'green',
                              'Cl1-',
                              'green',
                              'Ar',
                              'unknown',
                              'K',
                              'magenta',
                              'K1+',
                              'magenta',
                              'Ca',
                              'magenta',
                              'Ca2+',
                              'magenta',
                              'Sc',
                              'unknown',
                              'Sc3+',
                              'unknown',
                              'Ti',
                              'magenta',
                              'Ti2+',
                              'magenta',
                              'Ti3+',
                              'magenta',
                              'Ti4+',
                              'magenta',
                              'V',
                              'magenta',
                              'V2+',
                              'magenta',
                              'V3+',
                              'magenta',
                              'V5+',
                              'magenta',
                              'Cr',
                              'magenta',
                              'Cr2+',
                              'magenta',
                              'Cr3+',
                              'magenta',
                              'Mn',
                              'magenta',
                              'Mn2+',
                              'magenta',
                              'Mn3+',
                              'magenta',
                              'Mn4+',
                              'magenta',
                              'Fe',
                              'magenta',
                              'Fe2+',
                              'magenta',
                              'Fe3+',
                              'magenta',
                              'Co',
                              'magenta',
                              'Co2+',
                              'magenta',
                              'Co3+',
                              'magenta',
                              'Ni',
                              'magenta',
                              'Ni2+',
                              'magenta',
                              'Ni3+',
                              'magenta',
                              'Cu',
                              'magenta',
                              'Cu1+',
                              'magenta',
                              'Cu2+',
                              'magenta',
                              'Zn',
                              'magenta',
                              'Zn2+',
                              'magenta',
                              'Ga',
                              'magenta',
                              'Ga3+',
                              'magenta',
                              'Ge',
                              'magenta',
                              'Ge4+',
                              'magenta',
                              'As',
                              'magenta',
                              'Se',
                              'yellow',
                              'Br',
                              'green',
                              'Br1-',
                              'green',
                              'Kr',
                              'unknown',
                              'Rb',
                              'unknown',
                              'Rb1+',
                              'unknown',
                              'Sr',
                              'unknown',
                              'Sr2+',
                              'unknown',
                              'Y',
                              'unknown',
                              'Y3+',
                              'unknown',
                              'Zr',
                              'unknown',
                              'Zr4+',
                              'unknown',
                              'Nb',
                              'unknown',
                              'Nb3+',
                              'unknown',
                              'Nb5+',
                              'unknown',
                              'Mo',
                              'unknown',
                              'Mo3+',
                              'magenta',
                              'Mo5+',
                              'magenta',
                              'Mo6+',
                              'magenta',
                              'Tc',
                              'unknown',
                              'Ru',
                              'unknown',
                              'Ru3+',
                              'unknown',
                              'Ru4+',
                              'unknown',
                              'Rh',
                              'unknown',
                              'Rh3+',
                              'unknown',
                              'Rh4+',
                              'unknown',
                              'Pd',
                              'unknown',
                              'Pd2+',
                              'unknown',
                              'Pd4+',
                              'unknown',
                              'Ag',
                              'magenta',
                              'Ag1+',
                              'magenta',
                              'Ag2+',
                              'magenta',
                              'Cd',
                              'magenta',
                              'Cd2+',
                              'magenta',
                              'In',
                              'unknown',
                              'In3+',
                              'unknown',
                              'Sn',
                              'magenta',
                              'Sn2+',
                              'magenta',
                              'Sn4+',
                              'magenta',
                              'Sb',
                              'magenta',
                              'Sb3+',
                              'magenta',
                              'Sb5+',
                              'magenta',
                              'Te',
                              'unknown',
                              'I',
                              'green',
                              'I1-',
                              'green',
                              'Xe',
                              'unknown',
                              'Cs',
                              'unknown',
                              'Cs1+',
                              'unknown',
                              'Ba',
                              'unknown',
                              'Ba2+',
                              'unknown',
                              'La',
                              'unknown',
                              'La3+',
                              'unknown',
                              'Ce',
                              'unknown',
                              'Ce3+',
                              'unknown',
                              'Ce4+',
                              'unknown',
                              'Pr',
                              'unknown',
                              'Pr3+',
                              'unknown',
                              'Pr4+',
                              'unknown',
                              'Nd',
                              'unknown',
                              'Nd3+',
                              'unknown',
                              'Pm',
                              'unknown',
                              'Sm',
                              'unknown',
                              'Sm3+',
                              'unknown',
                              'Eu',
                              'unknown',
                              'Eu2+',
                              'unknown',
                              'Eu3+',
                              'unknown',
                              'Gd',
                              'unknown',
                              'Gd3+',
                              'unknown',
                              'Tb',
                              'unknown',
                              'Tb3+',
                              'unknown',
                              'Dy',
                              'unknown',
                              'Dy3+',
                              'unknown',
                              'Ho',
                              'unknown',
                              'Ho3+',
                              'unknown',
                              'Er',
                              'unknown',
                              'Er3+',
                              'unknown',
                              'Tm',
                              'unknown',
                              'Tm3+',
                              'unknown',
                              'Yb',
                              'unknown',
                              'Yb2+',
                              'unknown',
                              'Yb3+',
                              'unknown',
                              'Lu',
                              'unknown',
                              'Lu3+',
                              'unknown',
                              'Hf',
                              'unknown',
                              'Hf4+',
                              'unknown',
                              'Ta',
                              'unknown',
                              'Ta5+',
                              'unknown',
                              'W',
                              'unknown',
                              'W6+',
                              'unknown',
                              'Re',
                              'unknown',
                              'Os',
                              'unknown',
                              'Os4+',
                              'unknown',
                              'Ir',
                              'unknown',
                              'Ir3+',
                              'unknown',
                              'Ir4+',
                              'unknown',
                              'Pt',
                              'magenta',
                              'Pt2+',
                              'magenta',
                              'Pt4+',
                              'magenta',
                              'Au',
                              'magenta',
                              'Au1+',
                              'magenta',
                              'Au3+',
                              'magenta',
                              'Hg',
                              'magenta',
                              'Hg1+',
                              'magenta',
                              'Hg2+',
                              'magenta',
                              'Tl',
                              'unknown',
                              'TL1+',
                              'unknown',
                              'Tl3+',
                              'unknown',
                              'Pb',
                              'magenta',
                              'Pb2+',
                              'magenta',
                              'Pb4+',
                              'magenta',
                              'Bi',
                              'magenta',
                              'Bi3+',
                              'magenta',
                              'Bi5+',
                              'magenta',
                              'Po',
                              'unknown',
                              'At',
                              'unknown',
                              'Rn',
                              'unknown',
                              'Fr',
                              'unknown',
                              'Ra',
                              'unknown',
                              'Ra2+',
                              'unknown',
                              'Ac',
                              'unknown',
                              'Ac3+',
                              'unknown',
                              'Th',
                              'unknown',
                              'Th4+',
                              'unknown',
                              'Pa',
                              'unknown',
                              'U',
                              'unknown',
                              'U3+',
                              'unknown',
                              'U4+',
                              'unknown',
                              'U6+',
                              'unknown',
                              'Np',
                              'unknown',
                              'Np3+',
                              'unknown',
                              'Np4+',
                              'unknown',
                              'Np6+',
                              'unknown',
                              'Pu',
                              'unknown',
                              'Pu3+',
                              'unknown',
                              'Pu4+',
                              'unknown',
                              'Pu6+',
                              'unknown',
                              'Am',
                              'unknown',
                              'Cm',
                              'unknown',
                              'Bk',
                              'unknown',
                              'Cf',
                              'unknown' ] ],
                          [ 'item_',
                            '_enumeration.def_index_id',
                            '_model_site.type_symbol' ] ] ],
                      [ 'save_',
                        'model_site.radius_bond',
                        [ [ 'item_', '_definition.id', '_model_site.radius_bond' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Atomic radius of atom located at this site.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'radius_bond' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '0.1:' ],
                          [ 'item_', '_units.code', 'angstroms' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With  m  as  model_site\n \n    _model_site.radius_bond =  _atom_type[m.type_symbol].radius_bond' ] ] ] ],
                      [ 'save_',
                        'model_site.adp_matrix_beta',
                        [ [ 'item_', '_definition.id', '_model_site.adp_matrix_beta' ],
                          [ 'item_', '_definition.update', '2013-03-08' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Matrix of dimensionless anisotropic atomic displacement parameters.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'adp_matrix_beta' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Matrix' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_type.dimension', [ '3', '3' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     [label,symop] =   _model_site.id\n \n     a = atom_site[label]\n     s = symmetry_equiv[SymKey(symop)]\n \n     _model_site.adp_matrix_beta =  s.R * a.tensor_beta * s.RT' ] ] ] ],
                      [ 'save_',
                        'model_site.adp_eigen_system',
                        [ [ 'item_', '_definition.id', '_model_site.adp_eigen_system' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The set of three adp eigenvales and associated eigenvectors\n     in the form of 4 element List. Each list has the form\n \n                   (val, vecX, vecY, vecZ)\n \n     where the vector elements are direction cosines to the orthogonal\n     axes X,Y,Z. The lists are sorted in descending magnitude of val.\n     That is, the list with the largest val is first, and the smallest\n     val is last.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'adp_eigen_system' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'List' ],
                          [ 'item_', '_type.contents', 'List(Real,Real,Real,Real)' ],
                          [ 'item_', '_type.dimension', [ '3' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n      A    =  _cell.orthogonal_matrix\n      U    =  A * _model_site.adp_matrix_beta * Transpose(A) /(2*Pi**2)\n \n      _model_site.adp_eigen_system  =  Eigen( U )\n ' ] ] ] ],
                      [ 'save_',
                        'model_site.radius_contact',
                        [ [ 'item_', '_definition.id', '_model_site.radius_contact' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Atomic contact radius of atom specie located at this site.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'radius_contact' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_enumeration.range', '1.:' ],
                          [ 'item_', '_units.code', 'angstroms' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With  m  as  model_site\n \n    _model_site.radius_contact =  _atom_type[m.type_symbol].radius_contact' ] ] ] ],
                      [ 'save_',
                        'model_site.Cartn_xyz',
                        [ [ 'item_', '_definition.id', '_model_site.Cartn_xyz' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Vector of Cartesian (orthogonal angstrom) atom site coordinates.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'Cartn_xyz' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Matrix' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_type.dimension', [ '3' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With  m  as  model_site\n \n    _model_site.Cartn_xyz =  _atom_sites_Cartn_transform.matrix * m.fract_xyz' ] ] ] ],
                      [ 'save_',
                        'model_site.fract_xyz',
                        [ [ 'item_', '_definition.id', '_model_site.fract_xyz' ],
                          [ 'item_', '_definition.update', '2012-12-14' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Vector of fractional atom site coordinates.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'fract_xyz' ],
                          [ 'item_', '_type.purpose', 'Measurand' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Matrix' ],
                          [ 'item_', '_type.contents', 'Real' ],
                          [ 'item_', '_type.dimension', [ '3' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n        With  m  as  model_site\n \n                      xyz =  _atom_site[m.label].fract_xyz\n \n    _model_site.fract_xyz =  SymEquiv(m.symop, xyz)' ] ] ] ],
                      [ 'save_',
                        'model_site.id',
                        [ [ 'item_', '_definition.id', '_model_site.id' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Identifier of model site in terms of the atom site label and\n     symmetry operator.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'id' ],
                          [ 'item_', '_type.purpose', 'Composite' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'List' ],
                          [ 'item_', '_type.contents', 'Code,Symop' ],
                          [ 'item_', '_type.dimension', [ '1' ] ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n     With m as model_site\n \n      _model_site.id =   List ( m.label, m.symop )' ] ] ] ],
                      [ 'save_',
                        'model_site.index',
                        [ [ 'item_', '_definition.id', '_model_site.index' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Index number of an atomic site in the connected molecule.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'index' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'model_site.label',
                        [ [ 'item_', '_definition.id', '_model_site.label' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifies a site in the atom_site category of data.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'label' ],
                          [ 'item_', '_name.linked_item_id', '_atom_site.label' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n      _model_site.label =   _model_site.id [0]' ] ] ] ],
                      [ 'save_',
                        'model_site.mole_index',
                        [ [ 'item_', '_definition.id', '_model_site.mole_index' ],
                          [ 'item_', '_definition.update', '2013-03-09' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Index number of a distinct molecules in the cell, not related by\n     symmetry.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'mole_index' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.default', '1' ] ] ],
                      [ 'save_',
                        'model_site.symop',
                        [ [ 'item_', '_definition.id', '_model_site.symop' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The set of data items which specify the symmetry operation codes\n     which must be applied to the atom sites involved in the geometry angle.\n \n     The symmetry code of each atom site as the symmetry-equivalent position\n     number \'n\' and the cell translation number \'klm\'. These numbers are\n     combined to form the code \'n klm\' or n_klm.\n \n     The character string n_klm is composed as follows:\n \n         n refers to the symmetry operation that is applied to the\n         coordinates stored in _atom_site.fract_xyz. It must match a\n         number given in _symmetry_equiv.pos_site_id.\n \n         k, l and m refer to the translations that are subsequently\n         applied to the symmetry transformed coordinates to generate\n         the atom used in calculating the angle. These translations\n         (x,y,z) are related to (k,l,m) by the relations\n              k = 5 + x\n              l = 5 + y\n              m = 5 + z' ],
                          [ 'item_', '_type.purpose', 'Composite' ],
                          [ 'item_', '_type.source', 'Derived' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Symop' ],
                          [ 'loop_',
                            [ '_description_example.case', '_description_example.detail' ],
                            [ '4',
                              '4th symmetry operation applied',
                              '7_645',
                              '7th symm. posn.; +a on x; -b on y' ] ],
                          [ 'item_', '_enumeration.default', '1_555' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'symop' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n      _model_site.symop =   _model_site.id [1]' ] ] ] ],
                      [ 'save_',
                        'model_site.type_symbol',
                        [ [ 'item_', '_definition.id', '_model_site.type_symbol' ],
                          [ 'item_', '_definition.update', '2012-11-22' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code to identify the atom specie(s) occupying this site.' ],
                          [ 'item_', '_name.category_id', 'site' ],
                          [ 'item_', '_name.object_id', 'type_symbol' ],
                          [ 'item_', '_name.linked_item_id', '_atom_type.symbol' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Evaluation',
                              '\n    _model_site.type_symbol  =   AtomType ( _model_site.label )' ] ] ] ] ] ],
                  [ '@comment', '----------- close of MODEL_SITE category' ] ] ],
              [ '@comment', '----------- close of MODEL category' ],
              [ 'save_',
                'PUBLICATION',
                [ [ 'item_', '_definition.id', 'PUBLICATION' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Head' ],
                  [ 'item_', '_definition.update', '2012-05-07' ],
                  [ 'item_',
                    '_description.text',
                    '\n    The DICTIONARY group encompassing the CORE PUBLICATION data items defined\n    and used with in the Crystallographic Information Framework (CIF).' ],
                  [ 'item_', '_name.category_id', 'CIF_CORE' ],
                  [ 'item_', '_name.object_id', 'PUBLICATION' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'PUBL',
                    [ [ 'item_', '_definition.id', 'PUBL' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-05-07' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Data items in the PUBL category are used when submitting a\n     manuscript for publication. They refer either to the paper as\n     a whole, or to specific named elements within a paper (such as\n     the title and abstract, or the Comment and Experimental\n     sections of Acta Crystallographica Section C). The data items\n     in the PUBL_BODY category should be used for the textual\n     content of other submissions. Typically, each journal will\n     supply a list of the specific items it requires in its Notes\n     for Authors.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'PUBL' ],
                      [ 'save_',
                        'publ.contact_letter',
                        [ [ 'item_', '_definition.id', '_publ.contact_letter' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_publ_contact_letter' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     A letter submitted to the journal editor by the contact author.' ],
                          [ 'item_', '_name.category_id', 'publ' ],
                          [ 'item_', '_name.object_id', 'contact_letter' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'PUBL_MANUSCRIPT',
                        [ [ 'item_', '_definition.id', 'PUBL_MANUSCRIPT' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of items describing the publication manuscript.' ],
                          [ 'item_', '_name.category_id', 'PUBL' ],
                          [ 'item_', '_name.object_id', 'MANUSCRIPT' ],
                          [ 'save_',
                            'publ_manuscript.creation',
                            [ [ 'item_', '_definition.id', '_publ_manuscript.creation' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_manuscript_creation' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A description of the wordprocessor package and computer used to\n     create the manuscript stored as publ_manuscript.processed.' ],
                              [ 'item_', '_name.category_id', 'manuscript' ],
                              [ 'item_', '_name.object_id', 'creation' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_manuscript.processed',
                            [ [ 'item_', '_definition.id', '_publ_manuscript.processed' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_manuscript_processed' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The full manuscript of a paper (excluding possibly the figures\n     and the tables) output in ASCII characters from a word processor.\n     Information about the generation of this data item must be\n     specified in the data item _publ_manuscript.creation.' ],
                              [ 'item_', '_name.category_id', 'manuscript' ],
                              [ 'item_', '_name.object_id', 'processed' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_manuscript.text',
                            [ [ 'item_', '_definition.id', '_publ_manuscript.text' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_manuscript_text' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The full manuscript of a paper (excluding figures and possibly\n     the tables) output as standard ASCII text.' ],
                              [ 'item_', '_name.category_id', 'manuscript' ],
                              [ 'item_', '_name.object_id', 'text' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ '@comment',
                            '============================================================================' ],
                          [ 'save_',
                            'PUBL_MANUSCRIPT_INCL_EXTRA',
                            [ [ 'item_', '_definition.id', 'PUBL_MANUSCRIPT_INCL_EXTRA' ],
                              [ 'item_', '_definition.scope', 'Category' ],
                              [ 'item_', '_definition.class', 'Loop' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Category of data items that allow the authors of a manuscript to\n     submit for publication data names that should be added to the\n     standard request list employed by journal printing software.\n     Although these fields are primarily intended to identify CIF data\n     items that the author wishes to include in a published paper, they\n     can also be used to identify data names created so that non-CIF items\n     can be included in the publication. Note that *.item names MUST be\n     enclosed in single quotes.' ],
                              [ 'item_', '_name.category_id', 'PUBL_MANUSCRIPT' ],
                              [ 'item_', '_name.object_id', 'INCL_EXTRA' ],
                              [ 'item_',
                                '_category.key_id',
                                '_publ_manuscript_incl_extra.key' ],
                              [ 'save_',
                                'publ_manuscript_incl_extra.key',
                                [ [ 'item_', '_definition.id', '_publ_manuscript_incl_extra.key' ],
                                  [ 'item_', '_definition.update', '2012-12-13' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Value is a unique key to a set of PUBL_MANUSCRIPT_INCL_EXTRA items\n     in a looped list.' ],
                                  [ 'item_', '_name.category_id', 'publ_manuscript_incl_extra' ],
                                  [ 'item_', '_name.object_id', 'key' ],
                                  [ 'item_', '_type.purpose', 'Key' ],
                                  [ 'item_', '_type.source', 'Related' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Implied' ],
                                  [ 'loop_',
                                    [ '_method.purpose', '_method.expression' ],
                                    [ 'Definition',
                                      '    _type.contents = Type_Contents(publ_manuscript_incl_extra.item)',
                                      'Evaluation',
                                      '    _publ_manuscript_incl_extra.key = _publ_manuscript_incl_extra.item' ] ] ] ],
                              [ 'save_',
                                'publ_manuscript_incl_extra.item',
                                [ [ 'item_', '_definition.id', '_publ_manuscript_incl_extra.item' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_publ_manuscript_incl_extra_item' ] ],
                                  [ 'item_', '_definition.update', '2012-12-13' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     The data name (i.e. Tag) of a specific data item included in the\n     manuscript which is not normally requested by the journal. The values\n     of this item are the extra data names (which MUST be enclosed\n     in single quotes) that will be added to the journal request list.' ],
                                  [ 'item_', '_name.category_id', 'incl_extra' ],
                                  [ 'item_', '_name.object_id', 'item' ],
                                  [ 'item_', '_type.purpose', 'Link' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Tag' ] ] ],
                              [ 'save_',
                                'publ_manuscript_incl_extra.info',
                                [ [ 'item_', '_definition.id', '_publ_manuscript_incl_extra.info' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_publ_manuscript_incl_extra_info' ] ],
                                  [ 'item_', '_definition.update', '2012-12-13' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     A short note indicating the reason why the author wishes the\n     corresponding data item marked for inclusion in the journal\n     request list to be published.' ],
                                  [ 'item_', '_name.category_id', 'incl_extra' ],
                                  [ 'item_', '_name.object_id', 'info' ],
                                  [ 'item_', '_type.purpose', 'Describe' ],
                                  [ 'item_', '_type.source', 'Recorded' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Text' ] ] ],
                              [ 'save_',
                                'publ_manuscript_incl_extra.defn',
                                [ [ 'item_', '_definition.id', '_publ_manuscript_incl_extra.defn' ],
                                  [ 'loop_',
                                    [ '_alias.definition_id' ],
                                    [ '_publ_manuscript_incl_extra_defn' ] ],
                                  [ 'item_', '_definition.update', '2012-12-13' ],
                                  [ 'item_',
                                    '_description.text',
                                    '\n     Yes/No flags whether the corresponding data item marked for inclusion\n     in a journal request list is a standard CIF definition or not.' ],
                                  [ 'item_', '_name.category_id', 'incl_extra' ],
                                  [ 'item_', '_name.object_id', 'defn' ],
                                  [ 'item_', '_type.purpose', 'State' ],
                                  [ 'item_', '_type.source', 'Assigned' ],
                                  [ 'item_', '_type.container', 'Single' ],
                                  [ 'item_', '_type.contents', 'Code' ],
                                  [ 'loop_',
                                    [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                    [ 'yes',
                                      'include item in journal request list',
                                      'y',
                                      'include item in journal request list',
                                      'no',
                                      'exclude item in journal request list',
                                      'n',
                                      'exclude item in journal request list' ] ],
                                  [ 'item_', '_enumeration.default', 'yes' ] ] ] ] ],
                          [ '@comment',
                            '-------- close the PUBL_MANUSCRIPT_INCL_EXTRA category' ] ] ],
                      [ '@comment', '-------- close the PUBL_MANUSCRIPT category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'PUBL_REQUESTED',
                        [ [ 'item_', '_definition.id', 'PUBL_REQUESTED' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     CATEGORY of data items that enable the author to make\n     specific requests to the journal office for processing.' ],
                          [ 'item_', '_name.category_id', 'PUBL' ],
                          [ 'item_', '_name.object_id', 'REQUESTED' ],
                          [ 'save_',
                            'publ_requested.category',
                            [ [ 'item_', '_definition.id', '_publ_requested.category' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_requested_category' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The category of paper submitted. For submission to Acta\n     Crystallographica Section C or Acta Crystallographica\n     Section E, ONLY those codes indicated for use with those\n     journals should be used.' ],
                              [ 'item_', '_name.category_id', 'requested' ],
                              [ 'item_', '_name.object_id', 'category' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'FA',
                                  'Full article',
                                  'FI',
                                  'Full submission - inorganic (Acta C)',
                                  'FO',
                                  'Full submission - organic (Acta C)',
                                  'FM',
                                  'Full submission - metal-organic (Acta C)',
                                  'CI',
                                  'CIF-access paper - inorganic (Acta C)',
                                  'CO',
                                  'CIF-access paper - organic (Acta C)',
                                  'CM',
                                  'CIF-access paper - metal-organic (Acta C)',
                                  'EI',
                                  'Electronic submission - inorganic (Acta E)',
                                  'EO',
                                  'Electronic submission - organic (Acta E)',
                                  'EM',
                                  'Electronic submission - metal-organic (Acta E)',
                                  'AD',
                                  'Addenda & Errata (Acta C, Acta E)',
                                  'SC',
                                  'Short Communication' ] ],
                              [ 'item_', '_enumeration.default', 'FA' ] ] ],
                          [ 'save_',
                            'publ_requested.coeditor_name',
                            [ [ 'item_', '_definition.id', '_publ_requested.coeditor_name' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_requested_coeditor_name' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The name of the Co-editor whom the authors would like to\n     process the submitted manuscript.' ],
                              [ 'item_', '_name.category_id', 'requested' ],
                              [ 'item_', '_name.object_id', 'coeditor_name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_requested.journal',
                            [ [ 'item_', '_definition.id', '_publ_requested.journal' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_requested_journal' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Name of the journal to which the manuscript is being submitted.' ],
                              [ 'item_', '_name.category_id', 'requested' ],
                              [ 'item_', '_name.object_id', 'journal' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '-------- close the PUBL_REQUESTED category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'PUBL_SECTION',
                        [ [ 'item_', '_definition.id', 'PUBL_SECTION' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Manuscript section data if submitted in parts. see also\n     _publ_manuscript.text and _publ_manuscript.processed.\n     The _publ_section.exptl_prep, _publ_section.exptl_refinement\n     and _publ_section.exptl_solution items are preferred for\n     separating the chemical preparation, refinement and structure\n     solution aspects of the experimental description.' ],
                          [ 'item_', '_name.category_id', 'PUBL' ],
                          [ 'item_', '_name.object_id', 'SECTION' ],
                          [ 'save_',
                            'publ_section.title',
                            [ [ 'item_', '_definition.id', '_publ_section.title' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_title' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The full title of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'title' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.title_footnote',
                            [ [ 'item_', '_definition.id', '_publ_section.title_footnote' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_title_footnote' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Footnote (if any) to the title of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'title_footnote' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.synopsis',
                            [ [ 'item_', '_definition.id', '_publ_section.synopsis' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_synopsis' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The synopsis of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'synopsis' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.abstract',
                            [ [ 'item_', '_definition.id', '_publ_section.abstract' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_abstract' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The abstract of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'abstract' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.comment',
                            [ [ 'item_', '_definition.id', '_publ_section.comment' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_comment' ] ],
                              [ 'item_', '_definition.update', '2013-02-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The comment section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'comment' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.introduction',
                            [ [ 'item_', '_definition.id', '_publ_section.introduction' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_introduction' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The introduction section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'introduction' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.experimental',
                            [ [ 'item_', '_definition.id', '_publ_section.experimental' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_experimental' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The experimental section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'experimental' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.exptl_prep',
                            [ [ 'item_', '_definition.id', '_publ_section.exptl_prep' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_exptl_prep' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The experimental preparation section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'exptl_prep' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.exptl_refinement',
                            [ [ 'item_', '_definition.id', '_publ_section.exptl_refinement' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_exptl_refinement' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The experimental refinement section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'exptl_refinement' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.exptl_solution',
                            [ [ 'item_', '_definition.id', '_publ_section.exptl_solution' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_exptl_solution' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The experimental solution section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'exptl_solution' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.discussion',
                            [ [ 'item_', '_definition.id', '_publ_section.discussion' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_discussion' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The discussion section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'discussion' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.acknowledgements',
                            [ [ 'item_', '_definition.id', '_publ_section.acknowledgements' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_acknowledgements' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The acknowledgements section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'acknowledgements' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.references',
                            [ [ 'item_', '_definition.id', '_publ_section.references' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_references' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The references section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'references' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.related_literature',
                            [ [ 'item_', '_definition.id', '_publ_section.related_literature' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_related_literature' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The related literature section of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'related_literature' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.figure_captions',
                            [ [ 'item_', '_definition.id', '_publ_section.figure_captions' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_figure_captions' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The figure captions of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'figure_captions' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.table_legends',
                            [ [ 'item_', '_definition.id', '_publ_section.table_legends' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_table_legends' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The table legends of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'table_legends' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_section.keywords',
                            [ [ 'item_', '_definition.id', '_publ_section.keywords' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_section_keywords' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n    The keywords of the submitted paper.' ],
                              [ 'item_', '_name.category_id', 'section' ],
                              [ 'item_', '_name.object_id', 'keywords' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '-------- close the PUBL_SECTION category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'PUBL_BODY',
                        [ [ 'item_', '_definition.id', 'PUBL_BODY' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Data items in the PUBL_BODY category permit labelling of\n     different text sections within the body of a submitted paper.\n     Note that these should not be used in a paper which has\n     a standard format with sections tagged by specific data names\n     (such as in Acta Crystallographica Section C). Typically,\n     each journal will supply a list of the specific items it\n     requires in its Notes for Authors.' ],
                          [ 'item_', '_name.category_id', 'PUBL' ],
                          [ 'item_', '_name.object_id', 'BODY' ],
                          [ 'item_', '_category.key_id', '_publ_author.key' ],
                          [ 'save_',
                            'publ_body.key',
                            [ [ 'item_', '_definition.id', '_publ_body.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of PUBL_BODY items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'publ_body' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '                     _type.contents = Type_Contents(publ_body.label)',
                                  'Evaluation',
                                  '                     _publ_body.key = _publ_body.label' ] ] ] ],
                          [ 'save_',
                            'publ_body.label',
                            [ [ 'item_', '_definition.id', '_publ_body.label' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_publ_body_label' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Unigue identifier for each part of the body of the paper.' ],
                              [ 'item_', '_name.category_id', 'body' ],
                              [ 'item_', '_name.object_id', 'label' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '1', '1.1', '2.1.3' ] ] ] ],
                          [ 'save_',
                            'publ_body.element',
                            [ [ 'item_', '_definition.id', '_publ_body.element' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_publ_body_element' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The functional role of the associated text section.' ],
                              [ 'item_', '_name.category_id', 'body' ],
                              [ 'item_', '_name.object_id', 'element' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state' ],
                                [ 'section',
                                  'subsection',
                                  'subsubsection',
                                  'appendix',
                                  'footnote' ] ],
                              [ 'item_', '_enumeration.default', 'section' ] ] ],
                          [ 'save_',
                            'publ_body.contents',
                            [ [ 'item_', '_definition.id', '_publ_body.contents' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_body_contents' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     A text section of a submitted paper.' ],
                              [ 'item_', '_name.category_id', 'body' ],
                              [ 'item_', '_name.object_id', 'contents' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_body.title',
                            [ [ 'item_', '_definition.id', '_publ_body.title' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_publ_body_title' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Title of the associated section of text.' ],
                              [ 'item_', '_name.category_id', 'body' ],
                              [ 'item_', '_name.object_id', 'title' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_body.format',
                            [ [ 'item_', '_definition.id', '_publ_body.format' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_publ_body_format' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Enumerated state indicating the appropriate typesetting\n     conventions for accented characters and special symbols\n     in the text section.' ],
                              [ 'item_', '_name.category_id', 'body' ],
                              [ 'item_', '_name.object_id', 'format' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'ascii',
                                  'no coding for special symbols',
                                  'cif',
                                  'CIF convention',
                                  'latex',
                                  'LaTeX',
                                  'rtf',
                                  'Rich Text Format',
                                  'sgml',
                                  'SGML (ISO 8879)',
                                  'tex',
                                  'TeX',
                                  'troff',
                                  'troff or nroff' ] ],
                              [ 'item_', '_enumeration.default', 'cif' ] ] ] ] ],
                      [ '@comment', '-------- close the PUBL_BODY category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'PUBL_AUTHOR',
                        [ [ 'item_', '_definition.id', 'PUBL_AUTHOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of data items recording the author information.' ],
                          [ 'item_', '_name.category_id', 'PUBL' ],
                          [ 'item_', '_name.object_id', 'AUTHOR' ],
                          [ 'item_', '_category.key_id', '_publ_author.key' ],
                          [ 'save_',
                            'publ_author.key',
                            [ [ 'item_', '_definition.id', '_publ_author.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of PUBL_AUTHOR items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'publ_author' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '                     _type.contents = Type_Contents(publ_author.name)',
                                  'Evaluation',
                                  '                     _publ_author.key = _publ_author.name' ] ] ] ],
                          [ 'save_',
                            'publ_author.name',
                            [ [ 'item_', '_definition.id', '_publ_author.name' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_publ_author_name' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The name of a publication author. If there are multiple authors,\n     this will be looped with _publ_author.address. The family\n     name(s), followed by a comma and including any dynastic\n     components, precedes the first names or initials.' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Bleary, Percival R.',
                                  'O\'Neil, F.K.',
                                  'Van den Bossche, G.',
                                  'Yang, D.-L.',
                                  'Simonov, Yu.A',
                                  'M\\"uller, H.A.',
                                  'Ross II, C.R.' ] ] ] ],
                          [ 'save_',
                            'publ_author.address',
                            [ [ 'item_', '_definition.id', '_publ_author.address' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_author_address' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The address of a publication author. If there is more than one\n     author, this will be looped with _publ_author_name.' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'address' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '                       Department\n                        Institute\n                        Street\n                        City and postcode\n                        COUNTRY' ] ] ] ],
                          [ 'save_',
                            'publ_author.email',
                            [ [ 'item_', '_definition.id', '_publ_author.email' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_publ_author_email' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The e-mail address of a publication author. If there is more\n     than one author, this will be looped with _publ_author_name.\n     The format of e-mail addresses is given in Section 3.4, Address\n     Specification, of  Internet Message Format, RFC 2822, P. Resnick\n     (Editor), Network Standards Group, April 2001.' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'email' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_author.footnote',
                            [ [ 'item_', '_definition.id', '_publ_author.footnote' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_author_footnote' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n    A footnote accompanying an author\'s name in the list of authors\n    of a paper. Typically indicates sabbatical address, additional\n    affiliations or date of decease.' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'footnote' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_author.id_iucr',
                            [ [ 'item_', '_definition.id', '_publ_author.id_iucr' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_author_id_iucr' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Identifier in the IUCr contact database of a publication\n     author.  This identifier may be available from the World\n     Directory of Crystallographers (http://wdc.iucr.org).' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'id_iucr' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
                      [ '@comment', '-------- close the PUBL_AUTHOR category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'PUBL_CONTACT_AUTHOR',
                        [ [ 'item_', '_definition.id', 'PUBL_CONTACT_AUTHOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of items describing contact author(s) details.' ],
                          [ 'item_', '_name.category_id', 'PUBL' ],
                          [ 'item_', '_name.object_id', 'CONTACT_AUTHOR' ],
                          [ 'item_', '_category.key_id', '_publ_contact_author.key' ],
                          [ 'save_',
                            'publ_contact_author.key',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of PUBL_CONTACT_AUTHOR items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'publ_contact_author' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '           _type.contents = Type_Contents(publ_contact_author.name)',
                                  'Evaluation',
                                  '           _publ_contact_author.key = _publ_contact_author.name' ] ] ] ],
                          [ 'save_',
                            'publ_contact_author.name',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.name' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_contact_author_name', '_publ_contact_author' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The name of the author(s) submitting the manuscript and\n     data block. This is the person contacted by the journal\n     editorial staff.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Professor George Ferguson' ] ] ] ],
                          [ 'save_',
                            'publ_contact_author.address',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.address' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_contact_author_address' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The address of the author submitting the manuscript and\n     data block. This is the person contacted by the journal\n     editorial staff.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'address' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '                       Department of Chemistry and Biochemistry\n                        University of Guelph\n                        Ontario\n                        Canada\n                        N1G 2W1' ] ] ] ],
                          [ 'save_',
                            'publ_contact_author.email',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.email' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_contact_author_email' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     E-mail address in a form recognizable to international networks.\n     The format of e-mail addresses is given in Section 3.4, Address\n     Specification, of  Internet Message Format, RFC 2822, P. Resnick\n     (Editor), Network Standards Group, April 2001.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'email' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_contact_author.phone',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.phone' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_contact_author_phone' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Telephone number of author submitting the manuscript and data block.\n     The recommended style is the international dialing prefix,\n     followed by the area code in parentheses, followed by the\n     local number and any extension number prefixed by \'x\', with\n     no spaces. The earlier convention of including the international\n     dialing prefix in parentheses is no longer recommended.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'phone' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '12(34)9477330', '12()349477330', '12(34)9477330x5543' ] ] ] ],
                          [ 'save_',
                            'publ_contact_author.fax',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.fax' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_contact_author_fax' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Facsimile telephone number of the author submitting the manuscript\n     and data block.\n     The recommended style is the international dialing prefix, followed\n     by the area code in parentheses, followed by the local number with\n     no spaces. The earlier convention of including the international\n     dialing prefix in parentheses is no longer recommended.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'fax' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'publ_contact_author.id_iucr',
                            [ [ 'item_', '_definition.id', '_publ_contact_author.id_iucr' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_publ_contact_author_id_iucr' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Identifier in the IUCr contact database of the author submitting\n     the manuscript and datablock. This identifier may be available\n     from the World Directory of Crystallographers (http://wdc.iucr.org).' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'id_iucr' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment',
                        '--------- close the PUBL_CONTACT_AUTHOR category' ] ] ],
                  [ '@comment', '--------- close the PUBL category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'JOURNAL',
                    [ [ 'item_', '_definition.id', 'JOURNAL' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-12-11' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Category of items recording details about the book-keeping\n     by the journal staff when processing a CIF submitted for\n     publication.  The creator of a CIF will not normally specify\n     these data items.  The data names are not defined in the\n     dictionary because they are for journal use only.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'JOURNAL' ],
                      [ 'save_',
                        'journal.coden_ASTM',
                        [ [ 'item_', '_definition.id', '_journal.coden_ASTM' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_coden_ASTM' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     ASTM code assigned to journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'coden_ASTM' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.coden_Cambridge',
                        [ [ 'item_', '_definition.id', '_journal.coden_Cambridge' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_coden_Cambridge' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Cambridge Cryst. Data Centre code assigned to journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'coden_Cambridge' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.validation_number',
                        [ [ 'item_', '_definition.id', '_journal.validation_number' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_data_validation_number' ] ],
                          [ 'item_', '_definition.update', '2013-01-23' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Data validation number assigned to journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'validation_number' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.issue',
                        [ [ 'item_', '_definition.id', '_journal.issue' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_issue' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Issue identifier within the journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'issue' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.language',
                        [ [ 'item_', '_definition.id', '_journal.language' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_language' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Language of the publication.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'language' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'journal.name_full',
                        [ [ 'item_', '_definition.id', '_journal.name_full' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_name_full' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Full name of the journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'name_full' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'journal.page_first',
                        [ [ 'item_', '_definition.id', '_journal.page_first' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_page_first' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     First page of the publication in the journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'page_first' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.default', '1' ] ] ],
                      [ 'save_',
                        'journal.page_last',
                        [ [ 'item_', '_definition.id', '_journal.page_last' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_page_last' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Last page of the publication in the journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'page_last' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'journal.paper_category',
                        [ [ 'item_', '_definition.id', '_journal.paper_category' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_paper_category' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of the publication in the journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'paper_category' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.paper_doi',
                        [ [ 'item_', '_definition.id', '_journal.paper_doi' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_paper_doi' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     DOI of the publication in the journal.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'paper_doi' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.suppl_publ_number',
                        [ [ 'item_', '_definition.id', '_journal.suppl_publ_number' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_suppl_publ_number' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Number of supplementary publication.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'suppl_publ_number' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'journal.suppl_publ_pages',
                        [ [ 'item_', '_definition.id', '_journal.suppl_publ_pages' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_journal_suppl_publ_pages' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Number of pages in the supplementary publication.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'suppl_publ_pages' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'journal.volume',
                        [ [ 'item_', '_definition.id', '_journal.volume' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_volume' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Volume number of the publication.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'volume' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'journal.year',
                        [ [ 'item_', '_definition.id', '_journal.year' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_journal_year' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Year of the publication.' ],
                          [ 'item_', '_name.category_id', 'journal' ],
                          [ 'item_', '_name.object_id', 'year' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Integer' ],
                          [ 'item_', '_enumeration.range', '1700:2100' ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'JOURNAL_COEDITOR',
                        [ [ 'item_', '_definition.id', 'JOURNAL_COEDITOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of items recording co-editor details.' ],
                          [ 'item_', '_name.category_id', 'JOURNAL' ],
                          [ 'item_', '_name.object_id', 'COEDITOR' ],
                          [ 'save_',
                            'journal_coeditor.code',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_code' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The coeditor identifier.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'journal_coeditor.name',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.name' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_name' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The name of the coeditor.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_coeditor.address',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.address' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_address' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The postal address of the coeditor.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'address' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_coeditor.email',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.email' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_email' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The email address of the coeditor.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'email' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_coeditor.phone',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.phone' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_phone' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The phone number of the coeditor.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'phone' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'text' ] ] ],
                          [ 'save_',
                            'journal_coeditor.fax',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.fax' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_fax' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The fax number of the coeditor.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'fax' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'text' ] ] ],
                          [ 'save_',
                            'journal_coeditor.notes',
                            [ [ 'item_', '_definition.id', '_journal_coeditor.notes' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_coeditor_notes' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Notes on coeditor interaction wrt this publication.' ],
                              [ 'item_', '_name.category_id', 'coeditor' ],
                              [ 'item_', '_name.object_id', 'notes' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '--------- close the JOURNAL_COEDITOR category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'JOURNAL_DATE',
                        [ [ 'item_', '_definition.id', 'JOURNAL_DATE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of items recording dates of publication processing.' ],
                          [ 'item_', '_name.category_id', 'JOURNAL' ],
                          [ 'item_', '_name.object_id', 'DATE' ],
                          [ 'save_',
                            'journal_date.accepted',
                            [ [ 'item_', '_definition.id', '_journal_date.accepted' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_accepted' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication was accepted.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'accepted' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.from_coeditor',
                            [ [ 'item_', '_definition.id', '_journal_date.from_coeditor' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_from_coeditor' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication recieved from coeditor.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'from_coeditor' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.to_coeditor',
                            [ [ 'item_', '_definition.id', '_journal_date.to_coeditor' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_to_coeditor' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication sent to the coeditor.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'to_coeditor' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.printers_final',
                            [ [ 'item_', '_definition.id', '_journal_date.printers_final' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_printers_final' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication last sent to the printers.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'printers_final' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.printers_first',
                            [ [ 'item_', '_definition.id', '_journal_date.printers_first' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_printers_first' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication first sent to the printers.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'printers_first' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.proofs_in',
                            [ [ 'item_', '_definition.id', '_journal_date.proofs_in' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_proofs_in' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication proofs recieved.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'proofs_in' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.proofs_out',
                            [ [ 'item_', '_definition.id', '_journal_date.proofs_out' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_proofs_out' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date the publication proofs sent out.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'proofs_out' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.recd_copyright',
                            [ [ 'item_', '_definition.id', '_journal_date.recd_copyright' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_recd_copyright' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date completed copyright recieved.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'recd_copyright' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.recd_electronic',
                            [ [ 'item_', '_definition.id', '_journal_date.recd_electronic' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_recd_electronic' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date publication recieved electronically.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'recd_electronic' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ],
                          [ 'save_',
                            'journal_date.recd_hard_copy',
                            [ [ 'item_', '_definition.id', '_journal_date.recd_hard_copy' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_date_recd_hard_copy' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Date publication recieved as hard copy.' ],
                              [ 'item_', '_name.category_id', 'date' ],
                              [ 'item_', '_name.object_id', 'recd_hard_copy' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Date' ] ] ] ] ],
                      [ '@comment', '--------- close the JOURNAL_DATE category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'JOURNAL_TECHEDITOR',
                        [ [ 'item_', '_definition.id', 'JOURNAL_TECHEDITOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of items recording details of the technical editor\n     processing this publication.' ],
                          [ 'item_', '_name.category_id', 'JOURNAL' ],
                          [ 'item_', '_name.object_id', 'TECHEDITOR' ],
                          [ 'save_',
                            'journal_techeditor.code',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_code' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'journal_techeditor.name',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.name' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_name' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Name of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_techeditor.address',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.address' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_address' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Postal address of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'address' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_techeditor.email',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.email' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_email' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Email address of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'email' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_techeditor.phone',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.phone' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_phone' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Phone number of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'phone' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_techeditor.fax',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.fax' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_fax' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Fax number of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'fax' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_techeditor.notes',
                            [ [ 'item_', '_definition.id', '_journal_techeditor.notes' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_techeditor_notes' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Notes of the technical editor for this publication.' ],
                              [ 'item_', '_name.category_id', 'techeditor' ],
                              [ 'item_', '_name.object_id', 'notes' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment',
                        '--------- close the JOURNAL_TECHEDITOR category' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'JOURNAL_INDEX',
                        [ [ 'item_', '_definition.id', 'JOURNAL_INDEX' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Category of items describing publication indices.' ],
                          [ 'item_', '_name.category_id', 'JOURNAL' ],
                          [ 'item_', '_name.object_id', 'INDEX' ],
                          [ 'item_', '_category.key_id', '_journal_index.key' ],
                          [ 'save_',
                            'journal_index.key',
                            [ [ 'item_', '_definition.id', '_journal_index.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of JOURNAL_INDEX items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'index' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '                     _type.contents = Type_Contents(journal_index.id)',
                                  'Evaluation',
                                  '                     _journal_index.key = _journal_index.id' ] ] ] ],
                          [ 'save_',
                            'journal_index.id',
                            [ [ 'item_', '_definition.id', '_journal_index.id' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_journal_index_id' ] ],
                              [ 'item_', '_definition.update', '2013-01-23' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Index number identifier of the JOURNAL_INDEX category.' ],
                              [ 'item_', '_name.category_id', 'journal_index' ],
                              [ 'item_', '_name.object_id', 'id' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '1:' ] ] ],
                          [ 'save_',
                            'journal_index.subterm',
                            [ [ 'item_', '_definition.id', '_journal_index.subterm' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_index_subterm' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Sub-term index assigned for the publication.' ],
                              [ 'item_', '_name.category_id', 'journal_index' ],
                              [ 'item_', '_name.object_id', 'subterm' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_index.term',
                            [ [ 'item_', '_definition.id', '_journal_index.term' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_index_term' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Term index assigned for the publication.' ],
                              [ 'item_', '_name.category_id', 'journal_index' ],
                              [ 'item_', '_name.object_id', 'term' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'journal_index.type',
                            [ [ 'item_', '_definition.id', '_journal_index.type' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_journal_index_type' ] ],
                              [ 'item_', '_definition.update', '2012-12-11' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Type of index assigned for the publication.' ],
                              [ 'item_', '_name.category_id', 'journal_index' ],
                              [ 'item_', '_name.object_id', 'type' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'O',
                                  '???????? formula ??????????????',
                                  'S',
                                  '???????? structure description ???????' ] ],
                              [ 'item_', '_enumeration.default', 'O' ] ] ] ] ],
                      [ '@comment', '--------- close the JOURNAL_INDEX category' ] ] ],
                  [ '@comment', '--------- close the JOURNAL category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'CITATION',
                    [ [ 'item_', '_definition.id', 'CITATION' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Loop' ],
                      [ 'item_', '_definition.update', '2012-12-11' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Category of items describing literature cited in the publication.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'CITATION' ],
                      [ 'item_', '_category.key_id', '_citation.key' ],
                      [ 'save_',
                        'citation.key',
                        [ [ 'item_', '_definition.id', '_citation.key' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Value is a unique key to a set of CITATION items\n     in a looped list.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'key' ],
                          [ 'item_', '_type.purpose', 'Key' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Implied' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '                     _type.contents = Type_Contents(citation.id)',
                              'Evaluation',
                              '                     _citation.key = _citation.id' ] ] ] ],
                      [ 'save_',
                        'citation.id',
                        [ [ 'item_', '_definition.id', '_citation.id' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_citation_id' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Unique identifier to the CITATION list. A value of \'primary\'\n     should be used to indicate the citation that the author(s)\n     consider to be the most pertinent to the contents of the data\n     block.  Note that this item need not be a number;  it can be\n     any unique identifier.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'id' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'primary', '1', '2', '3' ] ] ] ],
                      [ 'save_',
                        'citation.abstract',
                        [ [ 'item_', '_definition.id', '_citation.abstract' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_citation_abstract' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Abstract for the citation. This is used most when the\n     citation is extracted from a bibliographic database that\n     contains full text or abstract information.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'abstract' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.abstract_id_CAS',
                        [ [ 'item_', '_definition.id', '_citation.abstract_id_CAS' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_abstract_id_CAS' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Chemical Abstracts Service (CAS) abstract identifier.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'abstract_id_CAS' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.page_first',
                        [ [ 'item_', '_definition.id', '_citation.page_first' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_page_first' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     First page of citation; relevant for articles and book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'page_first' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'citation.page_last',
                        [ [ 'item_', '_definition.id', '_citation.page_last' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_page_last' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Last page of citation; relevant for articles and book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'page_last' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'citation.special_details',
                        [ [ 'item_', '_definition.id', '_citation.special_details' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_special_details' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Special aspects of the relationship of the data block contents\n     to the literature item cited.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'special_details' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.title',
                        [ [ 'item_', '_definition.id', '_citation.title' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_citation_title' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Title of citation; relevant for articles and book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'title' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.year',
                        [ [ 'item_', '_definition.id', '_citation.year' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_citation_year' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Year of citation; relevant for articles and book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'year' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.coordinate_linkage',
                        [ [ 'item_', '_definition.id', '_citation.coordinate_linkage' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_coordinate_linkage' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code specifies whether this citation is concerned with precisely\n     the set of coordinates given in the data block. If, for instance,\n     the publication described the same structure, but the coordinates\n     had undergone further refinement prior to creation of the data\n     block, the value of this data item would be \'no\'.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'coordinate_linkage' ],
                          [ 'item_', '_type.purpose', 'State' ],
                          [ 'item_', '_type.source', 'Assigned' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_enumeration_set.state', '_enumeration_set.detail' ],
                            [ 'no',
                              'citation unrelated to current coordinates',
                              'n',
                              'abbreviation for "no"',
                              'yes',
                              'citation related to current coordinates',
                              'y',
                              'abbreviation for "yes"' ] ],
                          [ 'item_', '_enumeration.default', 'yes' ] ] ],
                      [ 'save_',
                        'citation.country',
                        [ [ 'item_', '_definition.id', '_citation.country' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_citation_country' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Country of publication; for journal articles and book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'country' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.database_id_CSD',
                        [ [ 'item_', '_definition.id', '_citation.database_id_CSD' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_database_id_CSD' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Identifier (\'refcode\') of the database record in the Cambridge\n     Structural Database containing details of the cited structure.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'database_id_CSD' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation.database_id_Medline',
                        [ [ 'item_', '_definition.id', '_citation.database_id_Medline' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_database_id_Medline' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\ni    Medline accession number categorizing a bibliographic entry.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'database_id_Medline' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation.book_id_ISBN',
                        [ [ 'item_', '_definition.id', '_citation.book_id_ISBN' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_book_id_ISBN' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     International Standard Book Number (ISBN) for book chap. cited.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'book_id_ISBN' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.book_publisher',
                        [ [ 'item_', '_definition.id', '_citation.book_publisher' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_book_publisher' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Publisher of the citation; relevant for book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'book_publisher' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.book_publisher_city',
                        [ [ 'item_', '_definition.id', '_citation.book_publisher_city' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_book_publisher_city' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Location of publisher of the citation; relevant for book chapters.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'book_publisher_city' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.book_title',
                        [ [ 'item_', '_definition.id', '_citation.book_title' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_book_title' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Title of the book in which the citation appeared.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'book_title' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'citation.journal_abbrev',
                        [ [ 'item_', '_definition.id', '_citation.journal_abbrev' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_abbrev' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Abbreviated name of the journal cited as given in the Chemical\n     Abstracts Service Source Index.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_abbrev' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_', [ '_description_example.case' ], [ 'J. Mol. Biol.' ] ] ] ],
                      [ 'save_',
                        'citation.journal_full',
                        [ [ 'item_', '_definition.id', '_citation.journal_full' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_full' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Full name of the journal cited; relevant for journal articles.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_full' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'Journal of Molecular Biology' ] ] ] ],
                      [ 'save_',
                        'citation.journal_id_ASTM',
                        [ [ 'item_', '_definition.id', '_citation.journal_id_ASTM' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_id_ASTM' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     American Society for the Testing of Materials (ASTM) code assigned\n     to the journal cited (also referred to as the CODEN designator of\n     the Chemical Abstracts Service); relevant for journal articles.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_id_ASTM' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation.journal_id_CSD',
                        [ [ 'item_', '_definition.id', '_citation.journal_id_CSD' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_id_CSD' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The Cambridge Structural Database (CSD) code assigned to the\n     journal cited; relevant for journal articles. This is also the\n     system used at the Protein Data Bank (PDB).' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_id_CSD' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_', [ '_description_example.case' ], [ '0070' ] ] ] ],
                      [ 'save_',
                        'citation.journal_id_ISSN',
                        [ [ 'item_', '_definition.id', '_citation.journal_id_ISSN' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_id_ISSN' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The International Standard Serial Number (ISSN) code assigned to\n     the journal cited;  relevant for journal articles.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_id_ISSN' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation.journal_issue',
                        [ [ 'item_', '_definition.id', '_citation.journal_issue' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_issue' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Issue number of the journal cited;  relevant for articles.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_issue' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:' ],
                          [ 'loop_', [ '_description_example.case' ], [ '2' ] ] ] ],
                      [ 'save_',
                        'citation.journal_volume',
                        [ [ 'item_', '_definition.id', '_citation.journal_volume' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_journal_volume' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Volume number of the journal cited;  relevant for articles.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'journal_volume' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:' ],
                          [ 'loop_', [ '_description_example.case' ], [ '174' ] ] ] ],
                      [ 'save_',
                        'citation.language',
                        [ [ 'item_', '_definition.id', '_citation.language' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_citation_language' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Language in which the citation appears.' ],
                          [ 'item_', '_name.category_id', 'citation' ],
                          [ 'item_', '_name.object_id', 'language' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_', [ '_description_example.case' ], [ 'German' ] ] ] ] ] ],
                  [ '@comment', '--------- close the CITATION category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'CITATION_AUTHOR',
                    [ [ 'item_', '_definition.id', 'CITATION_AUTHOR' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Loop' ],
                      [ 'item_', '_definition.update', '2012-12-11' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Category of items describing citation author(s) details.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'CITATION_AUTHOR' ],
                      [ 'item_', '_category.key_id', '_citation_author.key' ],
                      [ 'save_',
                        'citation_author.key',
                        [ [ 'item_', '_definition.id', '_citation_author.key' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Value is a unique key to a set of CITATION_AUTHOR items\n     in a looped list.' ],
                          [ 'item_', '_name.category_id', 'citation_author' ],
                          [ 'item_', '_name.object_id', 'key' ],
                          [ 'item_', '_type.purpose', 'Key' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Implied' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '             _type.contents = Type_Contents(citation_author.ordinal)',
                              'Evaluation',
                              '             _citation_author.key = _citation_author.ordinal' ] ] ] ],
                      [ 'save_',
                        'citation_author.ordinal',
                        [ [ 'item_', '_definition.id', '_citation_author.ordinal' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_author_ordinal' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Ordinal code specifies the order of the author\'s name in the list\n     of authors of the citation.' ],
                          [ 'item_', '_name.category_id', 'citation_author' ],
                          [ 'item_', '_name.object_id', 'ordinal' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation_author.citation_id',
                        [ [ 'item_', '_definition.id', '_citation_author.citation_id' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_author_citation_id' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifier in the CITATION data list. The value of must match\n     an identifier specified in the CITATION list.' ],
                          [ 'item_', '_name.category_id', 'citation_author' ],
                          [ 'item_', '_name.object_id', 'citation_id' ],
                          [ 'item_', '_name.linked_item_id', '_citation.id' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation_author.name',
                        [ [ 'item_', '_definition.id', '_citation_author.name' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_author_name' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Name of citation author; relevant for articles and book chapters.\n     The family name(s), followed by a comma and including any\n     dynastic components, precedes the first name(s) or initial(s).' ],
                          [ 'item_', '_name.category_id', 'citation_author' ],
                          [ 'item_', '_name.object_id', 'name' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'Bleary, Percival R.',
                              'O\'Neil, F.K.',
                              'Van den Bossche, G.',
                              'Yang, D.-L.',
                              'Simonov, Yu.A',
                              'M\\"uller, H.A.',
                              'Ross II, C.R.' ] ] ] ] ] ],
                  [ '@comment', '--------- close the CITATION_AUTHOR category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'CITATION_EDITOR',
                    [ [ 'item_', '_definition.id', 'CITATION_EDITOR' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Loop' ],
                      [ 'item_', '_definition.update', '2012-12-11' ],
                      [ 'item_',
                        '_description.text',
                        '\n     Category of items describing citation editor(s) details.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'CITATION_EDITOR' ],
                      [ 'item_', '_category.key_id', '_citation_editor.key' ],
                      [ 'save_',
                        'citation_editor.key',
                        [ [ 'item_', '_definition.id', '_citation_editor.key' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Value is a unique key to a set of CITATION_EDITOR items\n     in a looped list.' ],
                          [ 'item_', '_name.category_id', 'citation_editor' ],
                          [ 'item_', '_name.object_id', 'key' ],
                          [ 'item_', '_type.purpose', 'Key' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Implied' ],
                          [ 'loop_',
                            [ '_method.purpose', '_method.expression' ],
                            [ 'Definition',
                              '             _type.contents = Type_Contents(citation_editor.id)',
                              'Evaluation',
                              '             _citation_editor.key = _citation_editor.id' ] ] ] ],
                      [ 'save_',
                        'citation_editor.id',
                        [ [ 'item_', '_definition.id', '_citation_editor.id' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_editor_ordinal' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Index number identifier of the CITATION_EDITOR category.' ],
                          [ 'item_', '_name.category_id', 'citation_editor' ],
                          [ 'item_', '_name.object_id', 'id' ],
                          [ 'item_', '_type.purpose', 'Number' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Index' ],
                          [ 'item_', '_enumeration.range', '1:' ] ] ],
                      [ 'save_',
                        'citation_editor.citation_id',
                        [ [ 'item_', '_definition.id', '_citation_editor.citation_id' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_editor_citation_id' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Code identifier in the CITATION list. The value must match an\n     identifier specified by _citation.id in the CITATION list.' ],
                          [ 'item_', '_name.category_id', 'citation_editor' ],
                          [ 'item_', '_name.object_id', 'citation_id' ],
                          [ 'item_', '_name.linked_item_id', '_citation.id' ],
                          [ 'item_', '_type.purpose', 'Link' ],
                          [ 'item_', '_type.source', 'Related' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'citation_editor.name',
                        [ [ 'item_', '_definition.id', '_citation_editor.name' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_citation_editor', '_citation_editor_name' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Name of citation editor; relevant for book chapters.\n     The family name(s), followed by a comma and including any\n     dynastic components, precedes the first name(s) or initial(s).' ],
                          [ 'item_', '_name.category_id', 'citation_editor' ],
                          [ 'item_', '_name.object_id', 'name' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'Bleary, Percival R.',
                              'O\'Neil, F.K.',
                              'Van den Bossche, G.',
                              'Yang, D.-L.',
                              'Simonov, Yu.A',
                              'M\\"uller, H.A.',
                              'Ross II, C.R.' ] ] ] ] ] ],
                  [ '@comment', '--------- close the CITATION_EDITOR category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'DATABASE',
                    [ [ 'item_', '_definition.id', 'DATABASE' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-12-13' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items recording database deposition.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'DATABASE' ],
                      [ 'save_',
                        'database.CSD_history',
                        [ [ 'item_', '_definition.id', '_database.CSD_history' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_database_CSD_history' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The history of changes made by the Cambridge Crystallographic Data\n     Centre and incorporated into the Cambridge Structural Database (CSD).' ],
                          [ 'item_', '_name.category_id', 'database' ],
                          [ 'item_', '_name.object_id', 'CSD_history' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'database.journal_CSD',
                        [ [ 'item_', '_definition.id', '_database.journal_CSD' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_database_journal_CSD' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The journal code used in the Cambridge Structural Database.' ],
                          [ 'item_', '_name.category_id', 'database' ],
                          [ 'item_', '_name.object_id', 'journal_CSD' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ 'save_',
                        'database.journal_ASTM',
                        [ [ 'item_', '_definition.id', '_database.journal_ASTM' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_database_journal_ASTM' ] ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     ASTM CODEN designator for a journal as given in the Chemical\n     Source List maintained by the Chemical Abstracts Service.' ],
                          [ 'item_', '_name.category_id', 'database' ],
                          [ 'item_', '_name.object_id', 'journal_ASTM' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ] ] ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DATABASE_CODE',
                        [ [ 'item_', '_definition.id', 'DATABASE_CODE' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-12-13' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items recording database deposition. These data items\n     are assigned by database managers and should only appear in a CIF if they\n     originate from that source.' ],
                          [ 'item_', '_name.category_id', 'DATABASE' ],
                          [ 'item_', '_name.object_id', 'CODE' ],
                          [ 'save_',
                            'database_code.CAS',
                            [ [ 'item_', '_definition.id', '_database_code.CAS' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_CAS' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned by the Chemical Abstracts Service.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'CAS' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.COD',
                            [ [ 'item_', '_definition.id', '_database_code.COD' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_COD' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned by Crystallography Open Database (COD).' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'COD' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.CSD',
                            [ [ 'item_', '_definition.id', '_database_code.CSD' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_CSD' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned by the Cambridge Structural Database.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'CSD' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.ICSD',
                            [ [ 'item_', '_definition.id', '_database_code.ICSD' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_database_code_ICSD' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned by the Inorganic Crystal Structure Database.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'ICSD' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.MDF',
                            [ [ 'item_', '_definition.id', '_database_code.MDF' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_MDF' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned in the Metals Data File.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'MDF' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.NBS',
                            [ [ 'item_', '_definition.id', '_database_code.NBS' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_NBS' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned by the NBS (NIST) Crystal Data Database.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'NBS' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.PDB',
                            [ [ 'item_', '_definition.id', '_database_code.PDB' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_PDB' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned by the Protein Data Base.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'PDB' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.PDF',
                            [ [ 'item_', '_definition.id', '_database_code.PDF' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_database_code_PDF' ] ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code assigned in the Powder Diffraction File.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'PDF' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.depnum_ccdc_archive',
                            [ [ 'item_',
                                '_definition.id',
                                '_database_code.depnum_ccdc_archive' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_database_code_depnum_ccdc_archive' ] ],
                              [ 'item_', '_definition.update', '2013-01-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Deposition numbers assigned by the Cambridge Crystallographic\n     Data Centre (CCDC) to files containing structural information\n     archived by the CCDC.' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'depnum_ccdc_archive' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.depnum_ccdc_fiz',
                            [ [ 'item_', '_definition.id', '_database_code.depnum_ccdc_fiz' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_database_code_depnum_ccdc_fiz' ] ],
                              [ 'item_', '_definition.update', '2013-01-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Deposition numbers assigned by the Fachinformationszentrum\n     Karlsruhe (FIZ) to files containing structural information\n     archived by the Cambridge Crystallographic Data Centre (CCDC).' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'depnum_ccdc_fiz' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'database_code.depnum_ccdc_journal',
                            [ [ 'item_',
                                '_definition.id',
                                '_database_code.depnum_ccdc_journal' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_database_code_depnum_ccdc_journal' ] ],
                              [ 'item_', '_definition.update', '2013-01-22' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Deposition numbers assigned by various journals to files\n     containing structural information archived by the Cambridge\n     Crystallographic Data Centre (CCDC).' ],
                              [ 'item_', '_name.category_id', 'code' ],
                              [ 'item_', '_name.object_id', 'depnum_ccdc_journal' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ] ] ],
                      [ '@comment', '--------- close the DATABASE_CODE category' ] ] ],
                  [ '@comment', '--------- close the DATABASE category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'AUDIT',
                    [ [ 'item_', '_definition.id', 'AUDIT' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-05-07' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to record details about the\n     creation and subsequent updating of the data block.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'AUDIT' ],
                      [ 'save_',
                        'audit.creation_date',
                        [ [ 'item_', '_definition.id', '_audit.creation_date' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_audit_creation_date' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The date dd-mm-yyyy of each revision to the data.' ],
                          [ 'item_', '_name.category_id', 'audit' ],
                          [ 'item_', '_name.object_id', 'creation_date' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Date' ],
                          [ 'loop_', [ '_description_example.case' ], [ '1991-03-20' ] ] ] ],
                      [ 'save_',
                        'audit.update_record',
                        [ [ 'item_', '_definition.id', '_audit.update_record' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_audit_update_record' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     A description of the revision applied to the data.' ],
                          [ 'item_', '_name.category_id', 'audit' ],
                          [ 'item_', '_name.object_id', 'update_record' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ '1990-07-15 Updated by Co-editor' ] ] ] ],
                      [ 'save_',
                        'audit.block_code',
                        [ [ 'item_', '_definition.id', '_audit.block_code' ],
                          [ 'loop_', [ '_alias.definition_id' ], [ '_audit_block_code' ] ],
                          [ 'item_', '_definition.update', '2013-04-10' ],
                          [ 'item_',
                            '_description.text',
                            '\n     A unique block_code identifier for each revision.' ],
                          [ 'item_', '_name.category_id', 'audit' ],
                          [ 'item_', '_name.object_id', 'block_code' ],
                          [ 'item_', '_type.purpose', 'Encode' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Code' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'TOZ_1991-03-20' ] ] ] ],
                      [ 'save_',
                        'audit.creation_method',
                        [ [ 'item_', '_definition.id', '_audit.creation_method' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_audit_creation_method' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     A description of how the revision was applied to the data.' ],
                          [ 'item_', '_name.category_id', 'audit' ],
                          [ 'item_', '_name.object_id', 'creation_method' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'spawned by the program QBEE' ] ] ] ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'AUDIT_AUTHOR',
                        [ [ 'item_', '_definition.id', 'AUDIT_AUTHOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used for author(s) details.' ],
                          [ 'item_', '_name.category_id', 'AUDIT' ],
                          [ 'item_', '_name.object_id', 'AUTHOR' ],
                          [ 'item_', '_category.key_id', '_audit_author.key' ],
                          [ 'save_',
                            'audit_author.key',
                            [ [ 'item_', '_definition.id', '_audit_author.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of AUDIT_AUTHOR items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'audit_author' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '           _type.contents = Type_Contents(audit_author.name)',
                                  'Evaluation',
                                  '           _audit_author.key = _audit_author.name' ] ] ] ],
                          [ 'save_',
                            'audit_author.name',
                            [ [ 'item_', '_definition.id', '_audit_author.name' ],
                              [ 'loop_', [ '_alias.definition_id' ], [ '_audit_author_name' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The name of an author of this data block. If there are multiple\n     authors, _audit_author.name is looped with _audit_author.address.\n     The family name(s), followed by a comma and including any\n     dynastic components, precedes the first name(s) or initial(s).\n ' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Bleary, Percival R.',
                                  'O\'Neil, F.K.',
                                  'Van den Bossche, G.',
                                  'Yang, D.-L.',
                                  'Simonov, Yu.A.',
                                  'M\\"uller, H.A.',
                                  'Ross II, C.R.' ] ] ] ],
                          [ 'save_',
                            'audit_author.address',
                            [ [ 'item_', '_definition.id', '_audit_author.address' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_author_address' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The address of an author of this data block. If there are\n     multiple authors, _audit_author_address is looped with\n     _audit_author.name.' ],
                              [ 'item_', '_name.category_id', 'author' ],
                              [ 'item_', '_name.object_id', 'address' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Department\n                                 Institute\n                                 Street\n                                 City and postcode\n                                 COUNTRY ' ] ] ] ] ] ],
                      [ '@comment', '--------- close the AUDIT_AUTHOR category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'AUDIT_CONFORM',
                        [ [ 'item_', '_definition.id', 'AUDIT_CONFORM' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Set' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used describe dictionary versions\n     by which data names in the current data block are conformant.' ],
                          [ 'item_', '_name.category_id', 'AUDIT' ],
                          [ 'item_', '_name.object_id', 'CONFORM' ],
                          [ 'save_',
                            'audit_conform.dict_name',
                            [ [ 'item_', '_definition.id', '_audit_conform.dict_name' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_conform_dict_name' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Name identifying highest-level data dictionary defining\n     data names used in this file.' ],
                              [ 'item_', '_name.category_id', 'conform' ],
                              [ 'item_', '_name.object_id', 'dict_name' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ],
                          [ 'save_',
                            'audit_conform.dict_version',
                            [ [ 'item_', '_definition.id', '_audit_conform.dict_version' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_conform_dict_version' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Code for the version of data dictionary defining data names\n     used in this file.' ],
                              [ 'item_', '_name.category_id', 'conform' ],
                              [ 'item_', '_name.object_id', 'dict_version' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'audit_conform.dict_location',
                            [ [ 'item_', '_definition.id', '_audit_conform.dict_location' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_conform_dict_location' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     File name or uniform resource locator (URL) where the\n     conformant data dictionary resides.' ],
                              [ 'item_', '_name.category_id', 'conform' ],
                              [ 'item_', '_name.object_id', 'dict_location' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '--------- close the AUDIT_CONFORM category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'AUDIT_CONTACT_AUTHOR',
                        [ [ 'item_', '_definition.id', 'AUDIT_CONTACT_AUTHOR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used for contact author(s) details.' ],
                          [ 'item_', '_name.category_id', 'AUDIT' ],
                          [ 'item_', '_name.object_id', 'CONTACT_AUTHOR' ],
                          [ 'item_', '_category.key_id', '_audit_contact_author.key' ],
                          [ 'save_',
                            'audit_contact_author.key',
                            [ [ 'item_', '_definition.id', '_audit_contact_author.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of AUDIT_CONTACT_AUTHOR items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'audit_contact_author' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '      _type.contents = Type_Contents(audit_contact_author.name)',
                                  'Evaluation',
                                  '      _audit_contact_author.key = _audit_contact_author.name' ] ] ] ],
                          [ 'save_',
                            'audit_contact_author.name',
                            [ [ 'item_', '_definition.id', '_audit_contact_author.name' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_contact_author_name', '_audit_contact_author' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The name of the author of the data block to whom correspondence\n     should be addressed. The family name(s), followed by a comma and\n     including any dynastic components, precedes the first name(s) or\n     initial(s).' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'name' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'Bleary, Percival R.', 'O\'Neil, F.K.', 'Van den Bossche, G.' ] ] ] ],
                          [ 'save_',
                            'audit_contact_author.address',
                            [ [ 'item_', '_definition.id', '_audit_contact_author.address' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_contact_author_address' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The mailing address of the author of the data block to whom\n     correspondence should be addressed.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'address' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '                               Department\n                                Institute\n                                Street\n                                City and postcode\n                                COUNTRY' ] ] ] ],
                          [ 'save_',
                            'audit_contact_author.email',
                            [ [ 'item_', '_definition.id', '_audit_contact_author.email' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_contact_author_email' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The electronic mail address of the author of the data block\n     to whom correspondence should be addressed, in a form\n     recognizable to international networks. The format of e-mail\n     addresses is given in Section 3.4, Address Specification, of\n     Internet Message Format, RFC 2822, P. Resnick (Editor),\n     Network Standards Group, April 2001.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'email' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ 'name@host.domain.country', 'bm@iucr.org' ] ] ] ],
                          [ 'save_',
                            'audit_contact_author.phone',
                            [ [ 'item_', '_definition.id', '_audit_contact_author.phone' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_contact_author_phone' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Telephone number of author submitting the manuscript and data block.\n     The recommended style is the international dialing prefix,\n     followed by the area code in parentheses, followed by the\n     local number and any extension number prefixed by \'x\', with\n     no spaces. The earlier convention of including the international\n     dialing prefix in parentheses is no longer recommended.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'phone' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '12(34)9477330', '12()349477330', '12(34)9477330x5543' ] ] ] ],
                          [ 'save_',
                            'audit_contact_author.fax',
                            [ [ 'item_', '_definition.id', '_audit_contact_author.fax' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_contact_author_fax' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Facsimile telephone number of the author submitting the manuscript\n     and data block.\n     The recommended style is the international dialing prefix, followed\n     by the area code in parentheses, followed by the local number with\n     no spaces. The earlier convention of including the international\n     dialing prefix in parentheses is no longer recommended.' ],
                              [ 'item_', '_name.category_id', 'contact_author' ],
                              [ 'item_', '_name.object_id', 'fax' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ],
                              [ 'loop_',
                                [ '_description_example.case' ],
                                [ '12(34)9477334', '12()349477334' ] ] ] ] ] ],
                      [ '@comment',
                        '--------- close the AUDIT_CONTACT_AUTHOR category' ],
                      [ '@comment',
                        '============================================================================' ],
                      [ 'save_',
                        'AUDIT_LINK',
                        [ [ 'item_', '_definition.id', 'AUDIT_LINK' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to record details about the\n     relationships between data blocks in the current CIF.' ],
                          [ 'item_', '_name.category_id', 'AUDIT' ],
                          [ 'item_', '_name.object_id', 'LINK' ],
                          [ 'item_', '_category.key_id', '_audit_link.key' ],
                          [ 'save_',
                            'audit_link.key',
                            [ [ 'item_', '_definition.id', '_audit_link.key' ],
                              [ 'item_', '_definition.update', '2012-12-13' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of AUDIT_LINK items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'audit_link' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '               _type.contents = Type_Contents(audit_link.block_code)',
                                  'Evaluation',
                                  '               _audit_link.key = _audit_link.block_code' ] ] ] ],
                          [ 'save_',
                            'audit_link.block_code',
                            [ [ 'item_', '_definition.id', '_audit_link.block_code' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_link_block_code' ] ],
                              [ 'item_', '_definition.update', '2013-04-18' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The value of _audit.block_code associated with a data block\n     in the current file related to the current data block. The\n     special value \'.\' may be used to refer to the current data\n     block for completeness.' ],
                              [ 'item_', '_name.category_id', 'link' ],
                              [ 'item_', '_name.object_id', 'block_code' ],
                              [ 'item_', '_type.purpose', 'Encode' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ] ] ],
                          [ 'save_',
                            'audit_link.block_description',
                            [ [ 'item_', '_definition.id', '_audit_link.block_description' ],
                              [ 'loop_',
                                [ '_alias.definition_id' ],
                                [ '_audit_link_block_description' ] ],
                              [ 'item_', '_definition.update', '2012-11-29' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Description of the relationship of the referenced data block\n     to the current one.' ],
                              [ 'item_', '_name.category_id', 'link' ],
                              [ 'item_', '_name.object_id', 'block_description' ],
                              [ 'item_', '_type.purpose', 'Describe' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                      [ '@comment', '--------- close the AUDIT_LINK category' ] ] ],
                  [ '@comment', '--------- close the AUDIT category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'COMPUTING',
                    [ [ 'item_', '_definition.id', 'COMPUTING' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-05-07' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to record details of the\n     computer programs used in the crystal structure analysis.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'COMPUTING' ],
                      [ 'save_',
                        'computing.diffrn_collection',
                        [ [ 'item_', '_definition.id', '_computing.diffrn_collection' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_data_collection' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Description of software used to measure diffraction data.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'diffrn_collection' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'CAD-4 (Enraf-Nonius, 1989)' ] ] ] ],
                      [ 'save_',
                        'computing.diffrn_reduction',
                        [ [ 'item_', '_definition.id', '_computing.diffrn_reduction' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_data_reduction' ] ],
                          [ 'item_', '_definition.update', '2012-12-11' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Description of software used to convert diffraction data\n     to measured structure factors.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'diffrn_reduction' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'DIFDAT, SORTRF, ADDREF (Hall & Stewart, 1990)' ] ] ] ],
                      [ 'save_',
                        'computing.cell_refinement',
                        [ [ 'item_', '_definition.id', '_computing.cell_refinement' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_cell_refinement' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Brief description of software used for cell_refinement.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'cell_refinement' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'CAD-4 (Enraf-Nonius, 1989)' ] ] ] ],
                      [ 'save_',
                        'computing.structure_solution',
                        [ [ 'item_', '_definition.id', '_computing.structure_solution' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_structure_solution' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Brief description of software used for structure_solution.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'structure_solution' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'SHELXS86 (Sheldrick, 1990)' ] ] ] ],
                      [ 'save_',
                        'computing.structure_refinement',
                        [ [ 'item_', '_definition.id', '_computing.structure_refinement' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_structure_refinement' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Brief description of software used for structure_refinement.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'structure_refinement' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ],
                          [ 'loop_',
                            [ '_description_example.case' ],
                            [ 'SHELXL93 (Sheldrick, 1993)' ] ] ] ],
                      [ 'save_',
                        'computing.molecular_graphics',
                        [ [ 'item_', '_definition.id', '_computing.molecular_graphics' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_molecular_graphics' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Brief description of software used for molecular_graphics.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'molecular_graphics' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ],
                      [ 'save_',
                        'computing.publication_material',
                        [ [ 'item_', '_definition.id', '_computing.publication_material' ],
                          [ 'loop_',
                            [ '_alias.definition_id' ],
                            [ '_computing_publication_material' ] ],
                          [ 'item_', '_definition.update', '2012-11-29' ],
                          [ 'item_',
                            '_description.text',
                            '\n     Brief description of software used for publication_material.' ],
                          [ 'item_', '_name.category_id', 'computing' ],
                          [ 'item_', '_name.object_id', 'publication_material' ],
                          [ 'item_', '_type.purpose', 'Describe' ],
                          [ 'item_', '_type.source', 'Recorded' ],
                          [ 'item_', '_type.container', 'Single' ],
                          [ 'item_', '_type.contents', 'Text' ] ] ] ] ],
                  [ '@comment', '--------- close the COMPUTING category' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'DISPLAY',
                    [ [ 'item_', '_definition.id', 'DISPLAY' ],
                      [ 'item_', '_definition.scope', 'Category' ],
                      [ 'item_', '_definition.class', 'Set' ],
                      [ 'item_', '_definition.update', '2012-05-07' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The CATEGORY of data items used to enumerate the display\n     parameters used in the discipline.' ],
                      [ 'item_', '_name.category_id', 'PUBLICATION' ],
                      [ 'item_', '_name.object_id', 'DISPLAY' ],
                      [ '@comment',
                        '----------------------------------------------------------------------------' ],
                      [ 'save_',
                        'DISPLAY_COLOUR',
                        [ [ 'item_', '_definition.id', 'DISPLAY_COLOUR' ],
                          [ 'item_', '_definition.scope', 'Category' ],
                          [ 'item_', '_definition.class', 'Loop' ],
                          [ 'item_', '_definition.update', '2012-05-07' ],
                          [ 'item_',
                            '_description.text',
                            '\n     The CATEGORY of data items used to enumerate the display\n     colour codes used in the discipline.' ],
                          [ 'item_', '_name.category_id', 'DISPLAY' ],
                          [ 'item_', '_name.object_id', 'COLOUR' ],
                          [ 'item_', '_category.key_id', '_display_colour.key' ],
                          [ 'save_',
                            'display_colour.key',
                            [ [ 'item_', '_definition.id', '_display_colour.key' ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Value is a unique key to a set of DISPLAY_COLOUR items\n     in a looped list.' ],
                              [ 'item_', '_name.category_id', 'colour' ],
                              [ 'item_', '_name.object_id', 'key' ],
                              [ 'item_', '_type.purpose', 'Key' ],
                              [ 'item_', '_type.source', 'Related' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Implied' ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Definition',
                                  '              _type.contents = Type_Contents(display_colour.hue)',
                                  'Evaluation',
                                  '              _display_colour.key = _display_colour.hue' ] ] ] ],
                          [ 'save_',
                            'display_colour.hue',
                            [ [ 'item_', '_definition.id', '_display_colour.hue' ],
                              [ 'item_', '_definition.update', '2012-05-07' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Colour hue as an enumerated code.' ],
                              [ 'item_', '_name.category_id', 'colour' ],
                              [ 'item_', '_name.object_id', 'hue' ],
                              [ 'item_', '_type.purpose', 'State' ],
                              [ 'item_', '_type.source', 'Assigned' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Code' ],
                              [ 'loop_',
                                [ '_enumeration_set.state', '_enumeration_set.detail' ],
                                [ 'black',
                                  '[ 000, 000, 000 ]',
                                  'white',
                                  '[ 255, 255, 255 ]',
                                  'grey',
                                  '[ 192, 192, 192 ]',
                                  'grey_light',
                                  '[ 211, 211, 211 ]',
                                  'grey_slate',
                                  '[ 112, 128, 144 ]',
                                  'blue',
                                  '[ 000, 000, 255 ]',
                                  'blue_light',
                                  '[ 176, 224, 230 ]',
                                  'blue_medium',
                                  '[ 000, 000, 205 ]',
                                  'blue_dark',
                                  '[ 025, 025, 112 ]',
                                  'blue_navy',
                                  '[ 000, 000, 128 ]',
                                  'blue_royal',
                                  '[ 065, 105, 225 ]',
                                  'blue_sky',
                                  '[ 135, 206, 235 ]',
                                  'blue_steel',
                                  '[ 070, 130, 180 ]',
                                  'turquoise',
                                  '[ 064, 224, 208 ]',
                                  'cyan',
                                  '[ 000, 255, 255 ]',
                                  'cyan_light',
                                  '[ 224, 255, 255 ]',
                                  'green',
                                  '[ 000, 255, 000 ]',
                                  'green_light',
                                  '[ 152, 251, 152 ]',
                                  'green_dark',
                                  '[ 000, 100, 000 ]',
                                  'green_sea',
                                  '[ 046, 139, 087 ]',
                                  'green_lime',
                                  '[ 050, 205, 050 ]',
                                  'green_olive',
                                  '[ 107, 142, 035 ]',
                                  'green_khaki',
                                  '[ 240, 230, 140 ]',
                                  'yellow',
                                  '[ 255, 255, 000 ]',
                                  'yellow_light',
                                  '[ 255, 255, 224 ]',
                                  'yellow_gold',
                                  '[ 255, 215, 000 ]',
                                  'brown',
                                  '[ 165, 042, 042 ]',
                                  'brown_sienna',
                                  '[ 160, 082, 045 ]',
                                  'brown_beige',
                                  '[ 245, 245, 220 ]',
                                  'brown_tan',
                                  '[ 210, 180, 140 ]',
                                  'salmon',
                                  '[ 250, 128, 114 ]',
                                  'salmon_light',
                                  '[ 255, 160, 122 ]',
                                  'salmon_dark',
                                  '[ 233, 150, 122 ]',
                                  'orange',
                                  '[ 255, 165, 000 ]',
                                  'orange_dark',
                                  '[ 255, 140, 000 ]',
                                  'red',
                                  '[ 255, 000, 000 ]',
                                  'red_coral',
                                  '[ 255, 127, 080 ]',
                                  'red_tomato',
                                  '[ 255, 099, 071 ]',
                                  'red_orange',
                                  '[ 255, 069, 000 ]',
                                  'red_violet',
                                  '[ 219, 112, 147 ]',
                                  'red_maroon',
                                  '[ 176, 048, 096 ]',
                                  'pink',
                                  '[ 255, 192, 203 ]',
                                  'pink_light',
                                  '[ 255, 182, 193 ]',
                                  'pink_deep',
                                  '[ 255, 020, 147 ]',
                                  'pink_hot',
                                  '[ 255, 105, 180 ]',
                                  'violet',
                                  '[ 238, 130, 238 ]',
                                  'violet_red',
                                  '[ 208, 032, 144 ]',
                                  'violet_magenta',
                                  '[ 255, 000, 255 ]',
                                  'violet_dark',
                                  '[ 148, 000, 211 ]',
                                  'violet_blue',
                                  '[ 138, 043, 226 ]' ] ],
                              [ 'item_', '_enumeration.default', 'black' ] ] ],
                          [ 'save_',
                            'display_colour.RGB',
                            [ [ 'item_', '_definition.id', '_display_colour.RGB' ],
                              [ 'item_', '_definition.update', '2012-11-20' ],
                              [ 'item_',
                                '_description.text',
                                '\n     The red-green-blue intensities, bases 256, for each colour code.' ],
                              [ 'item_', '_name.category_id', 'colour' ],
                              [ 'item_', '_name.object_id', 'RGB' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Derived' ],
                              [ 'item_', '_type.container', 'List' ],
                              [ 'item_', '_type.contents', 'Integer' ],
                              [ 'item_', '_type.dimension', [ '3' ] ],
                              [ 'loop_',
                                [ '_method.purpose', '_method.expression' ],
                                [ 'Evaluation',
                                  '\n     With c  as  display_colour\n \n                _display_colour.RGB  =  [ c.red, c.green, c.blue ]' ] ] ] ],
                          [ 'save_',
                            'display_colour.red',
                            [ [ 'item_', '_definition.id', '_display_colour.red' ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Integer value between 0 and 255 giving the intensity of a\n     specific colour component (red, green or blue) for the RBG\n     display colour code.\n ' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '0:255' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'colour' ],
                              [ 'item_', '_name.object_id', 'red' ] ] ],
                          [ 'save_',
                            'display_colour.green',
                            [ [ 'item_', '_definition.id', '_display_colour.green' ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Integer value between 0 and 255 giving the intensity of a\n     specific colour component (red, green or blue) for the RBG\n     display colour code.\n ' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '0:255' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'colour' ],
                              [ 'item_', '_name.object_id', 'green' ] ] ],
                          [ 'save_',
                            'display_colour.blue',
                            [ [ 'item_', '_definition.id', '_display_colour.blue' ],
                              [ 'item_', '_definition.update', '2012-10-16' ],
                              [ 'item_',
                                '_description.text',
                                '\n     Integer value between 0 and 255 giving the intensity of a\n     specific colour component (red, green or blue) for the RBG\n     display colour code.\n ' ],
                              [ 'item_', '_type.purpose', 'Number' ],
                              [ 'item_', '_type.source', 'Recorded' ],
                              [ 'item_', '_type.container', 'Single' ],
                              [ 'item_', '_type.contents', 'Index' ],
                              [ 'item_', '_enumeration.range', '0:255' ],
                              [ 'item_', '_units.code', 'none' ],
                              [ 'item_', '_name.category_id', 'colour' ],
                              [ 'item_', '_name.object_id', 'blue' ] ] ] ] ],
                      [ '@comment', '----------- close of DISPLAY_COLOUR category' ] ] ],
                  [ '@comment', '----------- close of DISPLAY category' ] ] ],
              [ '@comment', '----------- close of PUBLICATION category' ],
              [ 'save_',
                'FUNCTION',
                [ [ 'item_', '_definition.id', 'FUNCTION' ],
                  [ 'item_', '_definition.scope', 'Category' ],
                  [ 'item_', '_definition.class', 'Functions' ],
                  [ 'item_', '_definition.update', '2012-12-18' ],
                  [ 'item_',
                    '_description.text',
                    '\n    The crystallographic functions the invoked in the definition\n    methods of CORE STRUCTURE data items defined and used with in\n    the Crystallographic Information Framework (CIF).' ],
                  [ 'item_', '_name.category_id', 'CIF_CORE' ],
                  [ 'item_', '_name.object_id', 'FUNCTION' ],
                  [ '@comment',
                    '============================================================================' ],
                  [ 'save_',
                    'function.AtomType',
                    [ [ 'item_', '_definition.id', '_function.AtomType' ],
                      [ 'item_', '_definition.update', '2013-04-17' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                   r  =  AtomType( s )\n \n     returns an atom type symbol (element name) from the atom site label.' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'AtomType' ],
                      [ 'item_', '_type.purpose', 'Encode' ],
                      [ 'item_', '_type.source', 'Assigned' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Code' ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function AtomType( s :[Single, Code])  {  # atom label\n \n        m = Len(s)\n        n = 1\n        If (m > 1 and s[1] not in \'0123456789\') n = 2\n        If (m > 2 and s[2]     in \'+-\'        ) n = 3\n        If (m > 3 and s[3]     in \'+-\'        ) n = 4\n \n                 AtomType =  s[0:n]\n     }' ] ] ] ],
                  [ 'save_',
                    'function.Closest',
                    [ [ 'item_', '_definition.id', '_function.Closest' ],
                      [ 'item_', '_definition.update', '2012-10-16' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                   u, d  =  Closest( v, u )\n \n     returns the real coordinate vector U which is the closest cell-\n     translated occurence of the vector V to the vector W.  D is the\n     cell translation vector required to move V to U.' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'Closest' ],
                      [ 'item_', '_type.purpose', 'Number' ],
                      [ 'item_', '_type.source', 'Derived' ],
                      [ 'item_', '_type.container', 'List' ],
                      [ 'item_', '_type.contents', 'Matrix(Real,Real,Real)' ],
                      [ 'item_', '_type.dimension', [ '2' ] ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function Closest( v :[Matrix, Real],   # coord vector to be cell translated\n                       w :[Matrix, Real]) { # target vector\n \n            d  =  v - w\n            t  =  Int( Mod( 99.5 + d, 1.0 ) - d )\n \n            Closest = List ( v+t, t )\n     }' ] ] ] ],
                  [ 'save_',
                    'function.SeitzFromJones',
                    [ [ 'item_', '_definition.id', '_function.SeitzFromJones' ],
                      [ 'item_', '_definition.update', '2013-04-24' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                   s  =  SeitzFromJones( j )\n \n     returns a 4x4 Seitz matrix from the Jones faithful representation of\n     the equivalent position which is a character string e.g. 1/2+x,-x,z.' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'SeitzFromJones' ],
                      [ 'item_', '_type.purpose', 'Number' ],
                      [ 'item_', '_type.source', 'Derived' ],
                      [ 'item_', '_type.container', 'Matrix' ],
                      [ 'item_', '_type.contents', 'Real' ],
                      [ 'item_', '_type.dimension', [ '4', '4' ] ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function SeitzFromJones( j :[Single, Text])  { # Jones symmetry notation\n \n      joneschrs = "123456xyz/,+- "\n      s         = [[0,0,0,0],[0,0,0,0],[0,0,0,0],[0,0,0,1]]\n      axis      = 0\n      sign      = 1\n      inum      = 0\n \n      do i=0,Len(j)-1    {\n          c = j[i]\n          If (c not in joneschrs) print \'illegal char in symmetry xyz\'\n \n          If      (c == \' \') Next\n          If      (c == \',\') {\n                             axis     += 1\n                             inum      = 0\n                             sign      = 1\n          }\n          Else If (c == \'+\') sign      = +1\n          Else If (c == \'-\') sign      = -1\n          Else If (c == \'x\') s[axis,0] = sign\n          Else If (c == \'y\') s[axis,1] = sign\n          Else If (c == \'z\') s[axis,2] = sign\n          Else   {\n               If (inum == 0)   m  = AtoI(c)\n               If (inum == 1 and c != \'/\') print \'illegal num in symmetry xyz\'\n               If (inum == 2)   {\n                                n  = AtoI(c)\n                     If(n == 5) print \'illegal translation in symmetry xyz\'\n                     s[axis,3] = Mod(10.+ Float(sign*m)/Float(n), 1.)\n                     sign      = 1\n               }\n               inum += 1\n       }  }\n                          SeitzFromJones = s\n    }' ] ] ] ],
                  [ 'save_',
                    'function.SymEquiv',
                    [ [ 'item_', '_definition.id', '_function.SymEquiv' ],
                      [ 'item_', '_definition.update', '2012-12-14' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                     xyz\' =  SymEquiv( symop, xyz )\n \n     returns a fractional coordinate vector xyz\' which is input vector\n     xyz transformed by the input symop \'n_pqr\' applied to the symmetry\n     equivalent matrix extracted from the category symmetry_equiv.' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'SymEquiv' ],
                      [ 'item_', '_type.purpose', 'Number' ],
                      [ 'item_', '_type.source', 'Derived' ],
                      [ 'item_', '_type.container', 'Matrix' ],
                      [ 'item_', '_type.contents', 'Real' ],
                      [ 'item_', '_type.dimension', [ '3' ] ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function SymEquiv( c :[Single, Symop],    # symop string n_pqr\n                        x :[Matrix, Real]   )  # fract coordinate vector\n     {\n             s = symmetry_equiv [ SymKey( c ) ]\n             SymEquiv = s.R * x + s.T + SymLat( c )\n     }' ] ] ] ],
                  [ 'save_',
                    'function.SymKey',
                    [ [ 'item_', '_definition.id', '_function.SymKey' ],
                      [ 'item_', '_definition.update', '2012-12-17' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                   m  =  SymKey( s )\n \n     returns an integer index to the Seitz matrices from the character\n     string of the form \'n_pqr\'.' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'SymKey' ],
                      [ 'item_', '_type.purpose', 'Number' ],
                      [ 'item_', '_type.source', 'Derived' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Index' ],
                      [ 'item_', '_enumeration.range', '1:192' ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function SymKey( s :[Single, Symop])  {  # symop string\n \n            If (s == \'.\')   n = 1\n            Else            n = AtoI(s[0])\n \n                 SymKey =  n       # index from 1\n     }' ] ] ] ],
                  [ 'save_',
                    'function.SymLat',
                    [ [ 'item_', '_definition.id', '_function.SymLat' ],
                      [ 'item_', '_definition.update', '2013-03-10' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                   v  =  SymLat( s )\n \n     returns a vector of the cell translations applied to the coordinates\n     from the character string of the form \'n_pqr\'. i.e. p-5, q-5, r-5.' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'SymLat' ],
                      [ 'item_', '_type.purpose', 'Number' ],
                      [ 'item_', '_type.source', 'Derived' ],
                      [ 'item_', '_type.container', 'Matrix' ],
                      [ 'item_', '_type.contents', 'Integer' ],
                      [ 'item_', '_type.dimension', [ '3' ] ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function SymLat( s :[Single, Symop])  {  # symop string\n \n##########  If (s[1] == \' \')  v = [ 5, 5, 5 ]\n            If (s[0] == \' \')  v = [ 5, 5, 5 ]\n            Else              v = [ AtoI(s[2]), AtoI(s[3]), AtoI(s[4]) ]\n \n                  SymLat  =  v - 5\n     }' ] ] ] ],
                  [ 'save_',
                    'function.Symop',
                    [ [ 'item_', '_definition.id', '_function.Symop' ],
                      [ 'item_', '_definition.update', '2006-06-30' ],
                      [ 'item_',
                        '_description.text',
                        '\n     The function\n                   s  =  Symop( n, t )\n \n     returns a character string of the form \'n_pqr\' where n is the\n     symmetry equivalent site number and [p,q,r] is the cell translation\n     vector PLUS [5,5,5].' ],
                      [ 'item_', '_name.category_id', 'function' ],
                      [ 'item_', '_name.object_id', 'Symop' ],
                      [ 'item_', '_type.purpose', 'Composite' ],
                      [ 'item_', '_type.source', 'Derived' ],
                      [ 'item_', '_type.container', 'Single' ],
                      [ 'item_', '_type.contents', 'Symop' ],
                      [ 'loop_',
                        [ '_method.purpose', '_method.expression' ],
                        [ 'Evaluation',
                          '\n     Function Symop( n  :[Single, Integer],   # symmetry equivalent site number\n                     t  :[List  , Integer]) { # cell translation vector\n \n            d  =  t + 5\n         Symop =  `n` + \'_\' + `d[0]` + `d[1]` + `d[2]`\n     }' ] ] ] ] ] ],
              [ '@comment', '----------- close of FUNCTION category' ] ] ],
          [ '@comment', '---------- close of CIF_CORE category' ],
          [ '@comment',
            '## {"save":\'CIF_CHEM\',"file":\'cif_chem.dic\',"mode":\'full\'}, # chemical crys' ],
          [ '@comment',
            '## {"save":\'CIF_MMOL\',"file":\'cif_mmol.dic\',"mode":\'full\'}, # biological' ],
          [ '@comment',
            '## {"save":\'CIF_POWD\',"file":\'cif_powd.dic\',"mode":\'full\'}, # powder diffr' ],
          [ '@comment',
            '## {"save":\'CIF_RHOD\',"file":\'cif_rhod.dic\',"mode":\'full\'}] # charge dens' ] ] ],
      [ '@comment', '---------- close CIF_DIC category' ],
      [ '@comment',
        '=============================================================================' ],
      [ '@comment', '  This dictionary\'s creation history.' ],
      [ '@comment',
        '=============================================================================' ],
      [ 'loop_',
        [ '_dictionary_audit.version',
          '_dictionary_audit.date',
          '_dictionary_audit.revision' ],
        [ '1.0.0',
          '2005-12-12',
          '\n   Initial version created from the CORE_3 version 3.5.02.',
          '1.0.01',
          '2006-02-06',
          '\n   Place import_dictionary.id values into a tuple.',
          '1.1.01',
          '2006-02-06',
          '\n   Remove dictionary attributes from a save frames.\n   Add dictionary id to the import tuple.',
          '1.1.02',
          '2006-02-13',
          '\n   Change _import_dictionary.id from a loop_ to a tuple.',
          '1.2.01',
          '2006-02-21',
          '\n   Basic change in dictionary structure where the dictionary data block now\n   contains a saveframe defining the category of the DICTIONRY to which\n   contained data categories are linked. It differs from other CATEGORY\n   definitions in that its name is NOT part of the child data tags.\n   This change allows imported dictionaries to be inserted without their\n   data block header or non-savedframed attributes.',
          '1.2.02',
          '2006-06-30',
          '\n   Apply the latest attribute changes as per DDL 3.6.06',
          '1.2.03',
          '2006-11-13',
          '\n   Removed method and context imports',
          '1.2.04',
          '2008-02-12',
          '\n   Updated the IMPORT values as per ddl.dic 3.07.09',
          '1.2.05',
          '2008-05-18',
          '\n   Changed looped list of imports to _import_list.id syntax.',
          '1.2.06',
          '2008-05-18',
          '\n   Changed hange definition scope of Head category to "Dictionary"',
          '1.3.01',
          '2011-06-07',
          '\n   Place all import lists into [[......]]',
          '1.3.02',
          '2011-08-10',
          '\n   Apply all of the DDLm 3.08 changes',
          '1.4.01',
          '2012-01-25',
          '\n   For import.get change the key "fram" to "save".',
          '1.4.02',
          '2013-03-08',
          '\n   Changes arising from remediation using the program ALIGN.',
          '1.4.03',
          '2013-04-11',
          '\n   Changes arising from remediation using the program ALIGN.\n   Changes arising from type state changes to ddl.dic',
          '1.4.04',
          '2013-04-15',
          '\n   Changes to the types via the templ_attr.cif defns',
          '1.4.05',
          '2013-04-24',
          '\n   Changed type.source \'Quantity\' to \'Numerical\' or \'Encode\'\n   Removed \'Pairs\' from type.contents; replaced with "Real", "Code", etc.' ] ] ] ] ]

  ; }

if (typeof require !== 'undefined' && typeof exports !== 'undefined') {
   exports.cif_dict = cif_dict;
}
